﻿Module SQL_倉儲系統管理
    '---------------------物料資料庫-----------------------------------------------------------------------------------------------------------------
    Friend Sub SQL__物料資料庫清單()
        SQL1 = "SELECT 料號, 頁碼, 品名, 成本, 售價, 件數, 尺寸, 材質, 圖片編碼, 備註, 最低庫存量, 停用, 停用 AS 選擇 FROM 物料資料庫"
        PA1 = " ORDER BY 
                      LEFT(頁碼, LEN(頁碼) - CHARINDEX('-', REVERSE(頁碼))), 
                      CASE 
                           WHEN CHARINDEX('-', 頁碼) > 0 AND ISNUMERIC(SUBSTRING(頁碼, CHARINDEX('-', 頁碼) + 1, LEN(頁碼))) = 1 
                           THEN CAST(SUBSTRING(頁碼, CHARINDEX('-', 頁碼) + 1, LEN(頁碼)) AS INT)
                           ELSE 0
                      END"
        PA2 = " WHERE  (料號 LIKE N'%" & PA & "%' OR 頁碼 LIKE N'%" & PA & "%' OR 品名 LIKE N'%" & PA & "%' OR 
                           成本 LIKE N'%" & PA & "%' OR 售價 LIKE N'%" & PA & "%' OR 件數 LIKE N'%" & PA & "%' OR 
                           尺寸 LIKE N'%" & PA & "%' OR 材質 LIKE N'%" & PA & "%' OR 備註 LIKE N'%" & PA & "%')"
        PA3 = " WHERE  頁碼 LIKE N'%" & PA & "%'"
        ConnOpen()
        If PA = "" And NU1 = True And NU2 = False Then : SQL1 &= " WHERE 料號 NOT LIKE N'' " & SQL2 & PA1
        ElseIf PA <> "" And NU1 = True And NU2 = False Then : SQL1 = SQL1 & PA2 & SQL2 & PA1
        ElseIf PA <> "" And NU1 = False And NU2 = True Then : SQL1 = SQL1 & PA3 & SQL2 & PA1 : End If
        CmdSet_For_DGV()
    End Sub
    Friend Sub SQL_廠商的物料清單(編號 As String)
        ConnOpen()
        SQL1 = "SELECT    供應商資料表.簡稱, 物料資料庫.品名, 供應商銷售物料明細.成本, 供應商銷售物料明細.售價, 供應商銷售物料明細.選擇, 供應商銷售物料明細.料號
                FROM      供應商資料表  INNER JOIN
                          供應商銷售物料明細 ON 供應商資料表.編號 = 供應商銷售物料明細.廠商編號 LEFT OUTER JOIN
                          物料資料庫 ON 物料資料庫.料號 = 供應商銷售物料明細.料號
                WHERE    (供應商資料表.編號 LIKE N'" & 編號 & "')
                ORDER BY  物料資料庫.頁碼"
        CmdSet_For_DGV()
    End Sub
    Friend Sub SQL_未配置圖片的物料清單()
        ConnOpen()
        SQL1 = "SELECT   物料資料庫.料號 FROM 物料資料庫 LEFT OUTER JOIN  物料圖庫 ON 物料資料庫.料號 = 物料圖庫.圖片編碼 WHERE (物料圖庫.圖片編碼 IS NULL) ORDER BY 物料資料庫.料號 DESC"
        CmdSet_For_DGV()
    End Sub
    Friend Sub SQL_物料是否有加指定過供應商判斷(廠商編號 As String, 料號 As String)
        ConnOpen()
        SQL1 = "SELECT  廠商編號, 料號
                FROM    供應商銷售物料明細
                WHERE  (廠商編號 LIKE N'" & 廠商編號 & "') AND (料號 LIKE N'" & 料號 & "')"
        CmdSet_For_dr()
    End Sub
    Friend Sub SQL_物料指定廠商新增(廠商編號 As String, 料號 As String, 成本 As String, 售價 As String)
        ConnOpen()
        SQL1 = "INSERT INTO 供應商銷售物料明細 (廠商編號, 料號, 成本, 售價) VALUES (N'" & 廠商編號 & "', N'" & 料號 & "', N'" & 成本 & "', N'" & 售價 & "')"
        CmdSet_For_dr()
    End Sub
    Friend Sub SQL_物料指定廠商修改(廠商編號 As String, 料號 As String, 成本 As String, 售價 As String)
        ConnOpen()
        SQL1 = "UPDATE 供應商銷售物料明細 SET 成本 = N'" & 成本 & "', 售價 = N'" & 售價 & "' WHERE 廠商編號 LIKE N'" & 廠商編號 & "' AND 料號 LIKE N'" & 料號 & "'"
        CmdSet_For_dr()
    End Sub
    Friend Sub SQL_物料指定廠商刪除(廠商編號 As String, 料號 As String)
        ConnOpen() : SQL1 = "DELETE 供應商銷售物料明細 WHERE 廠商編號 LIKE N'" & 廠商編號 & "' AND 料號 LIKE N'" & 料號 & "'" : CmdSet_For_dr()
    End Sub
    Friend Sub SQL_物料圖庫_圖片顯示()
        ConnOpen() : SQL1 = "SELECT 圖片 FROM 物料圖庫 WHERE 圖片編碼 LIKE N'" & PA & "'" : CmdSet_For_dr()
    End Sub
    Friend Sub SQL_物料圖庫_圖片下載()
        ConnOpen() : SQL1 = "SELECT 圖片 FROM 物料圖庫 WHERE 圖片編碼 LIKE N'" & 物料資料庫.圖片編碼_tb.Text & "'" : CmdSet_For_DGV()
    End Sub
    Friend Sub SQL_物料圖庫_圖片刪除()
        ConnOpen() : SQL1 = "DELETE FROM 物料圖庫 WHERE (圖片編碼 = N'" & PA & "')" : CmdSet_For_dr()
    End Sub
    Friend Sub SQL_物料圖庫_圖片刪除後圖片編號取消()
        ConnOpen() : SQL1 = "UPDATE 物料資料庫 SET  圖片編碼 = N'' WHERE (料號 LIKE N'" & 物料資料庫.圖片編碼_tb.Text & "')" : CmdSet_For_dr()
    End Sub
    Friend Sub SQL_物料圖庫_圖片新增時圖片編號註冊()
        ConnOpen() : SQL1 = "UPDATE 物料資料庫 SET  圖片編碼 = N'" & 物料資料庫.圖片用料號_tb.Text & "' WHERE (料號 LIKE N'" & 物料資料庫.圖片用料號_tb.Text & "')" : CmdSet_For_dr()
    End Sub
    Friend Sub SQL_物料圖庫_圖片新增()
        ConnOpen()
        SQL1 = "INSERT INTO 物料圖庫 (圖片編碼, 圖片) SELECT '" & 物料資料庫.圖片用料號_tb.Text &
                   "', BULKCOLUMN FROM OPENROWSET ( BULK '" & FTP物理位置 & AA(1) & "\" & 物料資料庫.檔案名稱_tb.Text & "', SINGLE_BLOB) AS EMPLOYEEPICTURE"
        CmdSet_For_dr()
    End Sub
    Friend Sub SQL_物料圖庫_圖片修改()
        ConnOpen()
        SQL1 = "UPDATE 物料圖庫 SET 圖片 = BULKCOLUMN FROM OPENROWSET (BULK '" & FTP物理位置 & AA(1) & "\" & 物料資料庫.檔案名稱_tb.Text & "', SINGLE_BLOB) AS EMPLOYEEPICTURE 
                WHERE (圖片編碼 = N'" & 物料資料庫.圖片編碼_tb.Text & "')"
        CmdSet_For_dr()
    End Sub
    Friend Sub SQL_物料圖庫流水號最後一筆()
        ConnOpen() : SQL1 = "SELECT TOP (1) 料號 FROM 物料資料庫 ORDER BY 料號 DESC" : CmdSet_For_dr()
    End Sub
    Friend Sub SQL_物料料號確認()
        ConnOpen() : SQL1 = "SELECT 料號 FROM 物料資料庫 WHERE 料號 LIKE N'" & PA & "'" : CmdSet_For_dr()
    End Sub
    Friend Sub SQL_物料資料庫新增()
        ConnOpen()
        SQL1 = "INSERT INTO 物料資料庫 (料號, 頁碼, 品名, 成本, 售價, 件數, 尺寸, 材質, 圖片編碼, 備註, 停用) 
                VALUES (N'" & 物料資料庫.料號_tb.Text & "',N'" & 物料資料庫.頁碼_tb.Text & "',N'" & 物料資料庫.品名_tb.Text & "',N'" & 物料資料庫.成本_nud.Value &
                     "',N'" & 物料資料庫.售價_nud.Value & "',N'" & 物料資料庫.件數_nud.Value & "',N'" & 物料資料庫.尺寸_tb.Text & "',N'" & 物料資料庫.材質_tb.Text &
                     "',N'" & 物料資料庫.圖片編碼_tb.Text & "',N'" & 物料資料庫.備註_tb.Text & "',N'" & 物料資料庫.停用料號_ch.Checked & "')"
        CmdSet_For_dr()
    End Sub
    Friend Sub SQL_物料資料庫修改()
        ConnOpen()
        SQL1 = "UPDATE 物料資料庫 SET  頁碼 = N'" & PA1 & "',品名 = N'" & PA2 & "',成本 = N'" & NU1 & "',售價 = N'" & NU2 & "',件數 = N'" & NU3 & "',尺寸 = N'" & PA3 &
                                    "',材質 = N'" & PA4 & "',圖片編碼 = N'" & PA5 & "',備註 = N'" & PA6 & "',停用 = N'" & 布林1 & "' , 最低庫存量 = N'" & NU4 & "'
                WHERE (料號 LIKE N'" & PA7 & "')"
        CmdSet_For_dr()
    End Sub
    Friend Sub SQL_物料資料庫刪除()
        ConnOpen() : SQL1 = "DELETE FROM 物料資料庫 WHERE (料號 = N'" & PA & "')" : CmdSet_For_dr()
    End Sub
    '---------------------倉儲入庫驗收-----------------------------------------------------------------------------------------------------------------
    Friend Sub SQL_倉儲入庫驗收清單()
        ConnOpen()
        SQL1 = "SELECT      倉儲明細表.資料流水號, 倉儲明細表.單據編號, 倉儲明細表.料號, 物料資料庫.頁碼,物料資料庫.品名, 物料資料庫.尺寸, 物料資料庫.材質, 倉儲明細表.入庫 AS 準備入庫數量, 倉儲明細表.備註, 
                            倉儲明細表.採購下單, 倉儲明細表.入庫日期, MJ選擇按鈕.選擇, 倉儲明細表.狀態
                FROM        倉儲明細表 LEFT OUTER JOIN MJ選擇按鈕 ON 倉儲明細表.資料流水號 = MJ選擇按鈕.按鈕 LEFT OUTER JOIN 物料資料庫 ON 倉儲明細表.料號 = 物料資料庫.料號
                WHERE      (倉儲明細表.狀態 LIKE N'採購入庫') AND (倉儲明細表.入庫日期 LIKE N'')  AND (倉儲明細表.公司編號 LIKE N'%" & 公司編號 & "%') AND (倉儲明細表.入庫 >= 0)
                ORDER BY   倉儲明細表.單據編號"
        CmdSet_For_DGV()
    End Sub
    '---------------------倉儲分區控制表-----------------------------------------------------------------------------------------------------------------
    Friend Sub SQL_倉儲分區控制表清單()
        ConnOpen() : SQL1 = "SELECT 倉級, 倉名編號, 倉名 FROM 倉儲分區控制表 ORDER BY 倉級, 倉名編號" : CmdSet_For_DGV()
    End Sub
    Friend Sub SQL_倉儲分區控制表流水號最後一筆()
        ConnOpen() : SQL1 = "SELECT TOP(1) 倉名編號 FROM 倉儲分區控制表 ORDER BY 倉名編號 DESC" : CmdSet_For_dr()
    End Sub
    Friend Sub SQL_倉儲分區控制表_倉名編號_資料重複驗證()
        ConnOpen()
        SQL1 = "SELECT 倉名編號 FROM 倉儲分區控制表 
                WHERE 倉級 LIKE N'" & 倉儲分區控制表.倉級_cb.Text & "' AND 倉名編號 LIKE N'" & 倉儲分區控制表.倉明編號_tb.Text & "' AND 倉名 LIKE N'" & 倉儲分區控制表.倉名_tb.Text & "'"
        CmdSet_For_dr()
    End Sub
    Friend Sub SQL_倉儲分區控制表新增()
        ConnOpen()
        SQL1 = "INSERT INTO 倉儲分區控制表 (倉級, 倉名編號, 倉名) 
                VALUES (N'" & 倉儲分區控制表.倉級_cb.Text & "',N'" & 倉儲分區控制表.倉明編號_tb.Text & "',N'" & 倉儲分區控制表.倉名_tb.Text & "')"
        CmdSet_For_dr()
    End Sub
    Friend Sub SQL_倉儲分區控制表修改()
        ConnOpen()
        SQL1 = "UPDATE 倉儲分區控制表 SET 倉名 = N'" & 倉儲分區控制表.倉名_tb.Text & "' 
                WHERE (倉級 LIKE N'" & 倉儲分區控制表.倉級_cb.Text & "' AND 倉名編號 LIKE N'" & 倉儲分區控制表.倉明編號_tb.Text & "')"
        CmdSet_For_dr()
    End Sub
    Friend Sub SQL_倉儲分區控制表刪除()
        ConnOpen()
        SQL1 = "DELETE FROM 倉儲分區控制表 
                WHERE 倉級 LIKE N'" & 倉儲分區控制表.倉級_cb.Text & "' AND 倉名編號 LIKE N'" & 倉儲分區控制表.倉明編號_tb.Text & "' AND 倉名 LIKE N'" & 倉儲分區控制表.倉名_tb.Text & "'"
        CmdSet_For_dr()
    End Sub
    '---------------------倉儲庫存清單-----------------------------------------------------------------------------------------------------------------
    Friend Sub SQL_倉儲庫存清單一()
        ConnOpen()
        SQL1 = "SELECT      供應商資料表.簡稱 AS 供應商, 倉儲明細表.供應商編號, 倉儲明細表.料號, 物料資料庫.品名, 物料資料庫.尺寸, 物料資料庫.材質, 
                            SUM(倉儲明細表.金額 * 倉儲明細表.匯率 * 倉儲明細表.入庫) / SUM(倉儲明細表.入庫) AS 加權成本_台幣, 
                            SUM(倉儲明細表.入庫) - SUM(倉儲明細表.出庫) AS 庫存, 
                           (SUM(倉儲明細表.入庫) - SUM(倉儲明細表.出庫)) * (SUM(倉儲明細表.金額 * 倉儲明細表.匯率 * 倉儲明細表.入庫) / SUM(倉儲明細表.入庫)) AS 庫存成本_台幣, 
                            WW.未入庫, WW.未入庫 * (SUM(倉儲明細表.金額 * 倉儲明細表.匯率 * 倉儲明細表.入庫) / SUM(倉儲明細表.入庫)) AS 在途成本_台幣, 
                            QQ.未出庫, QQ.未出庫 * (SUM(倉儲明細表.金額 * 倉儲明細表.匯率 * 倉儲明細表.入庫) / SUM(倉儲明細表.入庫))  AS 備貨成本_台幣, QQ.未出庫 AS 可領用
                 FROM       倉儲明細表 LEFT OUTER JOIN 物料資料庫 ON 倉儲明細表.料號 = 物料資料庫.料號 LEFT OUTER JOIN 供應商資料表 ON 倉儲明細表.供應商編號 = 
                            供應商資料表.編號 FULL OUTER JOIN
                                (SELECT     供應商編號, 料號, SUM(出庫) AS 未出庫 FROM       倉儲明細表 AS 倉儲明細表_2
                                 WHERE     (倉儲作業 LIKE N'') AND (狀態 LIKE N'%出庫') AND (公司編號 LIKE N'%" & 公司編號 & "%')
                                 GROUP BY   供應商編號, 料號) AS QQ ON 倉儲明細表.供應商編號 = QQ.供應商編號 AND 
                            倉儲明細表.料號 = QQ.料號 FULL OUTER JOIN
                                (SELECT     供應商編號, 料號, SUM(入庫) AS 未入庫 FROM      倉儲明細表 AS 倉儲明細表_1
                                  WHERE    (倉儲作業 LIKE N'') AND (狀態 LIKE N'%入庫') AND (公司編號 LIKE N'%" & 公司編號 & "%')
                                  GROUP BY  供應商編號, 料號) AS WW ON 倉儲明細表.供應商編號 = WW.供應商編號 AND 
                            倉儲明細表.料號 = WW.料號
                 WHERE     (倉儲明細表.倉儲作業 NOT LIKE N'') AND (倉儲明細表.公司編號 LIKE N'%" & 公司編號 & "%') AND (倉儲明細表.倉名編號 LIKE N'%" & 倉儲庫存清單.倉庫編號_tb.Text & "%')
                 GROUP BY   供應商資料表.簡稱, 倉儲明細表.供應商編號, 倉儲明細表.料號, 物料資料庫.品名, 物料資料庫.尺寸, 物料資料庫.材質, WW.未入庫, QQ.未出庫 
                 HAVING    (SUM(倉儲明細表.入庫) - SUM(倉儲明細表.出庫) > 0)
                 ORDER BY   供應商資料表.簡稱, 倉儲明細表.料號"
        CmdSet_For_DGV()
    End Sub
    Friend Sub SQL_倉儲庫存清單二()
        ConnOpen()
        SQL1 = "SELECT      倉儲明細表.資料流水號, 倉儲明細表.單據編號, 倉儲明細表.入庫, 倉儲明細表.出庫, 倉儲明細表.狀態, 倉儲明細表.採購下單, 倉儲明細表.入庫日期, 倉儲明細表.出庫日期, 
                            倉儲明細表.備註, 倉儲明細表.倉儲作業, MJ選擇按鈕.選擇, 倉儲明細表.供應商編號, 倉儲明細表.料號, 倉儲明細表.公司編號
                FROM        倉儲明細表 LEFT OUTER JOIN MJ選擇按鈕 ON 倉儲明細表.資料流水號 = MJ選擇按鈕.按鈕
                WHERE      (倉儲明細表.狀態 NOT LIKE N'組裝%') AND (倉儲明細表.入庫日期 NOT LIKE N'' OR 倉儲明細表.出庫日期 NOT LIKE N'')
                ORDER BY    倉儲明細表.出庫日期, 倉儲明細表.入庫日期"
        CmdSet_For_DGV()
    End Sub
    '---------------------倉儲控制表-----------------------------------------------------------------------------------------------------------------
    Friend Sub SQL_倉儲控制表清單一()
        ConnOpen()
        SQL1 = "SELECT  UURR.供應商, UURR.供應商編號, 物料資料庫.料號, 物料資料庫.品名, 物料資料庫.尺寸, 物料資料庫.材質, UURR.加權成本_台幣, UURR.庫存, UURR.庫存成本_台幣, UURR.未入庫, 
                        UURR.在途成本_台幣, UURR.未出庫, UURR.備貨成本_台幣, UURR.可領用, 物料資料庫.最低庫存量
                FROM    物料資料庫 FULL OUTER JOIN
                            (SELECT      供應商資料表.簡稱 AS 供應商, 倉儲明細表.供應商編號, 倉儲明細表.料號, 物料資料庫_1.品名, 物料資料庫_1.尺寸, 物料資料庫_1.材質, 
                                         SUM(倉儲明細表.金額 * 倉儲明細表.匯率 * 倉儲明細表.入庫) / SUM(倉儲明細表.入庫) AS 加權成本_台幣, SUM(倉儲明細表.入庫) - SUM(倉儲明細表.出庫) AS 庫存, 
                                         (SUM(倉儲明細表.入庫) - SUM(倉儲明細表.出庫)) * (SUM(倉儲明細表.金額 * 倉儲明細表.匯率 * 倉儲明細表.入庫) / SUM(倉儲明細表.入庫)) AS 庫存成本_台幣, WW.未入庫, 
                                          WW.未入庫 * (SUM(倉儲明細表.金額 * 倉儲明細表.匯率 * 倉儲明細表.入庫) / SUM(倉儲明細表.入庫)) AS 在途成本_台幣, QQ.未出庫, 
                                          QQ.未出庫 * (SUM(倉儲明細表.金額 * 倉儲明細表.匯率 * 倉儲明細表.入庫) / SUM(倉儲明細表.入庫)) AS 備貨成本_台幣, QQ.未出庫 AS 可領用, 物料資料庫_1.最低庫存量
                              FROM        倉儲明細表 LEFT OUTER JOIN 物料資料庫 AS 物料資料庫_1 ON 倉儲明細表.料號 = 物料資料庫_1.料號 LEFT OUTER JOIN 供應商資料表 ON 倉儲明細表.供應商編號 = 
                                          供應商資料表.編號 FULL OUTER JOIN
                                              (SELECT      供應商編號, 料號, SUM(出庫) AS 未出庫
                                               FROM        倉儲明細表 AS 倉儲明細表_2
                                               WHERE      (倉儲作業 LIKE N'') AND (狀態 LIKE N'%出庫') AND (公司編號 LIKE N'%" & 公司編號 & "%')
                                               GROUP BY    供應商編號, 料號) AS QQ ON 倉儲明細表.供應商編號 = QQ.供應商編號 AND 
                                          倉儲明細表.料號 = QQ.料號 FULL OUTER JOIN
                                              (SELECT      供應商編號, 料號, SUM(入庫) AS 未入庫
                                               FROM        倉儲明細表 AS 倉儲明細表_1
                                               WHERE      (倉儲作業 LIKE N'') AND (狀態 LIKE N'%入庫') AND (公司編號 LIKE N'%" & 公司編號 & "%')
                                               GROUP BY    供應商編號, 料號) AS WW ON 倉儲明細表.供應商編號 = WW.供應商編號 AND 
                                          倉儲明細表.料號 = WW.料號
                              WHERE      (倉儲明細表.倉儲作業 NOT LIKE N'') AND (倉儲明細表.公司編號 LIKE N'%" & 公司編號 & "%') AND (倉儲明細表.倉名編號 LIKE N'%" & 倉儲控制表.倉庫編號_tb.Text & "%')
                              GROUP BY    供應商資料表.簡稱, 倉儲明細表.供應商編號, 倉儲明細表.料號, 物料資料庫_1.品名, 物料資料庫_1.尺寸, 物料資料庫_1.材質, WW.未入庫, QQ.未出庫, 
                                          物料資料庫_1.最低庫存量) AS UURR ON 
                          物料資料庫.料號 = UURR.料號
                WHERE    (物料資料庫.停用 = 0)
                ORDER BY  UURR.供應商 DESC, 物料資料庫.料號"
        CmdSet_For_DGV()
    End Sub
    Friend Sub SQL_倉儲控制表清單二()
        ConnOpen()
        SQL1 = "SELECT  供應商資料表.簡稱 AS 供應商, 倉儲明細表.供應商編號, 倉儲明細表.料號, 物料資料庫.品名, 物料資料庫.尺寸, 物料資料庫.材質, 
                        SUM(倉儲明細表.金額 * 倉儲明細表.匯率 * 倉儲明細表.入庫) / SUM(倉儲明細表.入庫) AS 加權成本_台幣, SUM(倉儲明細表.入庫) - SUM(倉儲明細表.出庫) AS 庫存, 
                       (SUM(倉儲明細表.入庫) - SUM(倉儲明細表.出庫)) * (SUM(倉儲明細表.金額 * 倉儲明細表.匯率 * 倉儲明細表.入庫) / SUM(倉儲明細表.入庫)) AS 庫存成本_台幣, 
                        WW.未入庫, WW.未入庫 * (SUM(倉儲明細表.金額 * 倉儲明細表.匯率 * 倉儲明細表.入庫) / SUM(倉儲明細表.入庫)) AS 在途成本_台幣, QQ.未出庫, 
                        QQ.未出庫 * (SUM(倉儲明細表.金額 * 倉儲明細表.匯率 * 倉儲明細表.入庫) / SUM(倉儲明細表.入庫))  AS 備貨成本_台幣, QQ.未出庫 AS 可領用, 物料資料庫.最低庫存量
             FROM       倉儲明細表 LEFT OUTER JOIN 物料資料庫 ON 倉儲明細表.料號 = 物料資料庫.料號 LEFT OUTER JOIN 供應商資料表 ON 倉儲明細表.供應商編號 = 供應商資料表.編號 FULL OUTER JOIN
                            (SELECT     供應商編號, 料號, SUM(出庫) AS 未出庫
                             FROM       倉儲明細表 AS 倉儲明細表_2
                             WHERE     (倉儲作業 LIKE N'') AND (狀態 LIKE N'%出庫') AND (公司編號 LIKE N'%" & 公司編號 & "%')
                             GROUP BY   供應商編號, 料號) AS QQ ON 倉儲明細表.供應商編號 = QQ.供應商編號 AND 
                        倉儲明細表.料號 = QQ.料號 FULL OUTER JOIN
                            (SELECT     供應商編號, 料號, SUM(入庫) AS 未入庫
                             FROM      倉儲明細表 AS 倉儲明細表_1
                             WHERE    (倉儲作業 LIKE N'') AND (狀態 LIKE N'%入庫') AND (公司編號 LIKE N'%" & 公司編號 & "%')
                             GROUP BY  供應商編號, 料號) AS WW ON 倉儲明細表.供應商編號 = WW.供應商編號 AND 
                        倉儲明細表.料號 = WW.料號
             WHERE     (倉儲明細表.倉儲作業 NOT LIKE N'') AND (倉儲明細表.公司編號 LIKE N'%" & 公司編號 & "%') AND (倉儲明細表.倉名編號 LIKE N'%" & 倉儲控制表.倉庫編號_tb.Text & "%')
             GROUP BY   供應商資料表.簡稱, 倉儲明細表.供應商編號, 倉儲明細表.料號, 物料資料庫.品名, 物料資料庫.尺寸, 物料資料庫.材質, WW.未入庫, QQ.未出庫, 物料資料庫.最低庫存量
             HAVING    (SUM(倉儲明細表.入庫) - SUM(倉儲明細表.出庫) > 0)
             ORDER BY   供應商資料表.簡稱, 倉儲明細表.料號"
        CmdSet_For_DGV()
    End Sub
    Friend Sub SQL_倉儲控制表_明細表()
        ConnOpen()
        SQL1 = "SELECT    資料流水號, 單據編號, 入庫, 出庫, 狀態, 採購下單, 入庫日期, 出庫日期, 備註, 倉儲作業
                FROM      倉儲明細表
                WHERE    (供應商編號 LIKE N'" & 倉儲控制表.TextBox10.Text & "') AND (料號 LIKE N'" & 倉儲控制表.TextBox11.Text & "') AND (公司編號 LIKE N'%" & 公司編號 & "%')
                ORDER BY  資料流水號 DESC"
        CmdSet_For_DGV()
    End Sub
    Friend Sub SQL_倉名下拉清單含NA()
        ConnOpen() : SQL1 = "SELECT 倉名 FROM 倉儲分區控制表 ORDER BY 倉名編號" : CmdSet_For_dr()
    End Sub
    '---------------------盤盈盤損控制表-----------------------------------------------------------------------------------------------------------------
    Friend Sub SQL_盤盈盤損控制表清單()
        ConnOpen()
        SQL1 = "SELECT   UURR.供應商, UURR.供應商編號, 物料資料庫.料號, 物料資料庫.品名, 物料資料庫.尺寸, 物料資料庫.材質, 物料資料庫.成本 AS 加權成本_台幣, UURR.庫存 AS 盤盈數量, 
                         UURR.庫存 AS 盤損數量, UURR.庫存, 物料資料庫.品名 AS 狀態, 物料資料庫.頁碼
                 FROM    物料資料庫 FULL OUTER JOIN
                             (SELECT      供應商資料表.簡稱 AS 供應商, 倉儲明細表.供應商編號, 倉儲明細表.料號, 物料資料庫_1.品名, 物料資料庫_1.尺寸, 物料資料庫_1.材質, 
                                          SUM(倉儲明細表.金額 * 倉儲明細表.匯率 * 倉儲明細表.入庫) / SUM(倉儲明細表.入庫) AS 加權成本_台幣, SUM(倉儲明細表.入庫) - SUM(倉儲明細表.出庫) AS 庫存, 
                                          (SUM(倉儲明細表.入庫) - SUM(倉儲明細表.出庫)) * (SUM(倉儲明細表.金額 * 倉儲明細表.匯率 * 倉儲明細表.入庫) / SUM(倉儲明細表.入庫)) AS 庫存成本_台幣, WW.未入庫, 
                                           WW.未入庫 * (SUM(倉儲明細表.金額 * 倉儲明細表.匯率 * 倉儲明細表.入庫) / SUM(倉儲明細表.入庫)) AS 在途成本_台幣, QQ.未出庫, 
                                           QQ.未出庫 * (SUM(倉儲明細表.金額 * 倉儲明細表.匯率 * 倉儲明細表.入庫) / SUM(倉儲明細表.入庫)) AS 備貨成本_台幣, QQ.未出庫 AS 可領用, 物料資料庫_1.最低庫存量
                               FROM        倉儲明細表 LEFT OUTER JOIN 物料資料庫 AS 物料資料庫_1 ON 倉儲明細表.料號 = 物料資料庫_1.料號 LEFT OUTER JOIN
                                           供應商資料表 ON 倉儲明細表.供應商編號 = 供應商資料表.編號 FULL OUTER JOIN
                                               (SELECT      供應商編號, 料號, SUM(出庫) AS 未出庫
                                                FROM        倉儲明細表 AS 倉儲明細表_2
                                                WHERE      (倉儲作業 LIKE N'') AND (狀態 LIKE N'%出庫') AND (公司編號 LIKE N'%" & 公司編號 & "%')
                                                GROUP BY    供應商編號, 料號) AS QQ ON 倉儲明細表.供應商編號 = QQ.供應商編號 AND 
                                           倉儲明細表.料號 = QQ.料號 FULL OUTER JOIN
                                               (SELECT      供應商編號, 料號, SUM(入庫) AS 未入庫
                                                FROM        倉儲明細表 AS 倉儲明細表_1
                                                WHERE      (倉儲作業 LIKE N'') AND (狀態 LIKE N'%入庫') AND (公司編號 LIKE N'%" & 公司編號 & "%')
                                                GROUP BY    供應商編號, 料號) AS WW ON 倉儲明細表.供應商編號 = WW.供應商編號 AND 
                                           倉儲明細表.料號 = WW.料號
                               WHERE      (倉儲明細表.倉儲作業 NOT LIKE N'') AND (倉儲明細表.公司編號 LIKE N'%" & 公司編號 & "%') AND (倉儲明細表.倉名編號 LIKE N'%" & 盤盈盤損控制表.倉庫編號_tb.Text & "%')
                               GROUP BY    供應商資料表.簡稱, 倉儲明細表.供應商編號, 倉儲明細表.料號, 物料資料庫_1.品名, 物料資料庫_1.尺寸, 物料資料庫_1.材質, WW.未入庫, QQ.未出庫, 
                                           物料資料庫_1.最低庫存量) AS UURR ON 物料資料庫.料號 = UURR.料號
                 WHERE    (物料資料庫.停用 = 0)
                 ORDER BY  UURR.供應商 DESC, 物料資料庫.料號"
        CmdSet_For_DGV()
    End Sub
    '---------------------盤盈盤損確認-----------------------------------------------------------------------------------------------------------------
    Friend Sub SQL_盤盈盤損確認清單()
        ConnOpen()
        SQL1 = "SELECT      倉儲明細表.資料流水號, 倉儲明細表.單據編號, 倉儲明細表.料號, 物料資料庫.品名, 物料資料庫.尺寸, 
                            物料資料庫.材質, 倉儲明細表.出庫 AS 盤損出庫數量, 倉儲明細表.入庫 AS 盤盈入庫數量, 倉儲明細表.採購下單 AS 客戶下單, 
                            倉儲明細表.出庫日期, MJ選擇按鈕.選擇, 倉儲明細表.狀態, 倉儲分區控制表.倉名, 倉儲明細表.訂單流水號, 
                            訂單控制表.出貨備齊, 訂單明細表.資料流水號 AS 訂單明細流水
                FROM        倉儲明細表 LEFT OUTER JOIN
                            訂單明細表 ON 倉儲明細表.單據編號 = 訂單明細表.出貨單號 AND 
                            倉儲明細表.料號 = 訂單明細表.料號 AND 
                            倉儲明細表.訂單流水號 = 訂單明細表.訂單流水號 LEFT OUTER JOIN
                            訂單控制表 ON 倉儲明細表.訂單流水號 = 訂單控制表.訂單流水號 LEFT OUTER JOIN
                            倉儲分區控制表 ON 倉儲明細表.倉名編號 = 倉儲分區控制表.倉名編號 LEFT OUTER JOIN
                            MJ選擇按鈕 ON 倉儲明細表.資料流水號 = MJ選擇按鈕.按鈕 LEFT OUTER JOIN
                            物料資料庫 ON 倉儲明細表.料號 = 物料資料庫.料號
                WHERE      (倉儲明細表.狀態 LIKE N'盤%') AND (倉儲明細表.出庫日期 LIKE N'') AND (倉儲明細表.入庫日期 LIKE N'') AND 
                           (倉儲明細表.公司編號 LIKE N'%" & 公司編號 & "%')
                ORDER BY    倉儲明細表.單據編號"
        CmdSet_For_DGV()
    End Sub
    Friend Sub SQL_盤盈盤損確認_盤損出庫修改()
        ConnOpen() : SQL1 = "UPDATE 倉儲明細表 SET 出庫日期 = N'" & DTP & "', 倉儲作業 = N'" & DTP & "' WHERE (資料流水號 LIKE N'" & PA & "')  AND (狀態 LIKE N'盤損出庫')" : CmdSet_For_dr()
    End Sub
    Friend Sub SQL_盤盈盤損確認_盤盈入庫修改()
        ConnOpen() : SQL1 = "UPDATE 倉儲明細表 SET 入庫日期 = N'" & DTP & "', 倉儲作業 = N'" & DTP & "' WHERE (資料流水號 LIKE N'" & PA & "')  AND (狀態 LIKE N'盤盈入庫')" : CmdSet_For_dr()
    End Sub
End Module

