﻿Module SQL_生產系統管理
    '---------------------生產入庫-----------------------------------------------------------------------------------------------------------------
    Friend Sub SQL_生產入庫清單()
        ConnOpen()
        SQL1 = "SELECT    倉儲明細表.資料流水號, 倉儲明細表.單據編號, 倉儲明細表.料號, 物料資料庫.品名, 物料資料庫.尺寸, 物料資料庫.材質, 倉儲明細表.入庫 AS 準備入庫數量, 倉儲明細表.備註, 
                          倉儲明細表.採購下單 AS 指定生產, 倉儲明細表.入庫日期, MJ選擇按鈕.選擇, 倉儲明細表.狀態, 倉儲明細表.供應商編號, 倉儲明細表.金額, 倉儲明細表.匯率, 倉儲明細表.客戶編號, 
                          倉儲明細表.售價, 倉儲分區控制表.倉名, 倉儲分區控制表.倉名編號, 倉儲明細表.交期 AS 客戶交期
                FROM      倉儲明細表 INNER JOIN 倉儲分區控制表 ON 倉儲明細表.倉名編號 = 倉儲分區控制表.倉名編號 LEFT OUTER JOIN MJ選擇按鈕 ON 倉儲明細表.資料流水號 = MJ選擇按鈕.按鈕 LEFT OUTER JOIN
                          物料資料庫 ON 倉儲明細表.料號 = 物料資料庫.料號
                WHERE    (倉儲明細表.狀態 LIKE N'組裝入庫') AND (倉儲明細表.公司編號 LIKE N'%" & 公司編號 & "%') AND (倉儲明細表.入庫日期 LIKE N'')
                ORDER BY  倉儲明細表.單據編號"
        CmdSet_For_DGV()
    End Sub
    Friend Sub SQL_生產入庫_倉儲明細表_組裝入庫確認()
        ConnOpen() : SQL1 = "UPDATE 倉儲明細表 SET 入庫日期 = N'" & DTP & "', 倉儲作業 = N'" & DTP & "' WHERE (資料流水號 LIKE N'" & PA1 & "') AND (狀態 LIKE N'組裝入庫')" : CmdSet_For_dr()
    End Sub
    '---------------------生產控制表-----------------------------------------------------------------------------------------------------------------
    Friend Sub SQL_生產控制表清單()
        SQL1 = "SELECT      倉儲明細表.單據編號, 倉儲明細表.客戶編號, 客戶資料表.簡稱 AS 客戶, 倉儲明細表.供應商編號, 供應商資料表.簡稱 AS 廠商, 倉儲明細表.料號, 物料資料庫.品名, 物料資料庫.尺寸, 
                            物料資料庫.材質, 倉儲明細表.售價 AS 銷售單價, 倉儲明細表.金額 * 倉儲明細表.匯率 AS 單位成本, 倉儲明細表.金額 * 倉儲明細表.匯率 * 倉儲明細表.出庫 AS 物料成本, 
                            倉儲明細表.售價 * 倉儲明細表.出庫 AS 銷售金額, 倉儲明細表.出庫 AS 組裝數量, 倉儲明細表.入庫 AS 入庫數量, 倉儲明細表.採購下單 AS 指定生產日, 倉儲明細表.交期 AS 客戶交期, 
                            倉儲明細表.出庫日期 AS 開始組裝, 倉儲明細表.入庫日期 AS 組裝完工, 倉儲明細表.備註, 倉儲明細表.狀態, 倉儲分區控制表.倉名
                FROM        倉儲明細表 INNER JOIN 倉儲分區控制表 ON 倉儲明細表.倉名編號 = 倉儲分區控制表.倉名編號 LEFT OUTER JOIN 供應商資料表 ON 倉儲明細表.供應商編號 = 供應商資料表.編號 LEFT OUTER JOIN
                            物料資料庫 ON 倉儲明細表.料號 = 物料資料庫.料號 LEFT OUTER JOIN 客戶資料表 ON 倉儲明細表.客戶編號 = 客戶資料表.編號 "
        PA1 = "WHERE       (倉儲明細表.狀態 LIKE N'組裝出庫' OR 倉儲明細表.狀態 LIKE N'組裝入庫') AND (倉儲明細表.公司編號 LIKE N'%" & 公司編號 & "%') AND 
                           (倉儲明細表.採購下單 BETWEEN '" & Format(生產控制表.開始日期_dtp.Value, "yyyy/MM/dd") & "' AND '" & Format(生產控制表.結束日期_dtp.Value, "yyyy/MM/dd") & "')
                ORDER BY    倉儲明細表.單據編號 DESC, 倉儲明細表.狀態"
        PA2 = "WHERE       (倉儲明細表.狀態 LIKE N'組裝出庫' OR 倉儲明細表.狀態 LIKE N'組裝入庫') AND (倉儲明細表.出庫日期 LIKE N'') AND (倉儲明細表.入庫日期 LIKE N'') AND 
                           (倉儲明細表.公司編號 LIKE N'%" & 公司編號 & "%') AND 
                           (倉儲明細表.採購下單 BETWEEN '" & Format(生產控制表.開始日期_dtp.Value, "yyyy/MM/dd") & "' AND '" & Format(生產控制表.結束日期_dtp.Value, "yyyy/MM/dd") & "')
                ORDER BY    倉儲明細表.單據編號 DESC, 倉儲明細表.狀態"
        ConnOpen() : If PA = "1" Then : SQL1 &= PA1 : ElseIf PA = "2" Then : SQL1 &= PA2 : End If : CmdSet_For_DGV()
    End Sub
    Friend Sub SQL_生產控制表彙總()
        ConnOpen()
        SQL1 = "SELECT     客戶資料表.簡稱 AS 客戶, 倉儲明細表.採購下單 AS 指定生產日, 倉儲明細表.出庫日期 AS 開始組裝, 倉儲明細表.入庫日期 AS 組裝完工, 倉儲明細表.狀態, 倉儲明細表.單據編號
                FROM       倉儲明細表 LEFT OUTER JOIN 客戶資料表 ON 倉儲明細表.客戶編號 = 客戶資料表.編號
                WHERE     (倉儲明細表.狀態 LIKE N'組裝出庫' OR 倉儲明細表.狀態 LIKE N'組裝入庫') AND (倉儲明細表.公司編號 LIKE N'%" & 公司編號 & "%') AND 
                          (倉儲明細表.採購下單 BETWEEN '" & Format(生產控制表.開始日期_dtp.Value, "yyyy/MM/dd") & "' AND '" & Format(生產控制表.結束日期_dtp.Value, "yyyy/MM/dd") & "')
                GROUP BY   客戶資料表.簡稱, 倉儲明細表.採購下單, 倉儲明細表.出庫日期, 倉儲明細表.入庫日期, 倉儲明細表.狀態, 倉儲明細表.單據編號
                ORDER BY   客戶, 單據編號, 指定生產日 DESC, 狀態 DESC"
        CmdSet_For_DGV()
    End Sub
    '---------------------生產確認-----------------------------------------------------------------------------------------------------------------
    Friend Sub SQL_生產確認清單()
        ConnOpen()
        SQL1 = "SELECT      倉儲明細表.資料流水號, 倉儲明細表.單據編號, 倉儲明細表.料號, 物料資料庫.品名, 物料資料庫.尺寸, 物料資料庫.材質, 倉儲明細表.出庫 AS 準備出庫數量, 倉儲明細表.備註, 
                            倉儲明細表.採購下單 AS 指定生產, 倉儲明細表.出庫日期, MJ選擇按鈕.選擇, 倉儲明細表.狀態, 倉儲明細表.供應商編號, 倉儲明細表.金額, 倉儲明細表.匯率, 倉儲明細表.客戶編號, 
                            倉儲明細表.售價, LEFT(物料資料庫.頁碼, 3) AS 頁碼, 倉儲分區控制表.倉名, 倉儲明細表.倉名編號, 倉儲明細表.交期 AS 客戶交期
                FROM        倉儲明細表 INNER JOIN 倉儲分區控制表 ON 倉儲明細表.倉名編號 = 倉儲分區控制表.倉名編號 LEFT OUTER JOIN MJ選擇按鈕 ON 倉儲明細表.資料流水號 = MJ選擇按鈕.按鈕 LEFT OUTER JOIN
                            物料資料庫 ON 倉儲明細表.料號 = 物料資料庫.料號
                WHERE      (倉儲明細表.狀態 LIKE N'組裝出庫') AND (倉儲明細表.出庫日期 LIKE N'') AND (倉儲明細表.公司編號 LIKE N'%" & 公司編號 & "%')
                ORDER BY    倉儲明細表.單據編號"
        CmdSet_For_DGV()
    End Sub
    Friend Sub SQL_生產確認_倉儲明細表_組裝出庫確認()
        ConnOpen() : SQL1 = "UPDATE 倉儲明細表 SET 出庫日期 = N'" & DTP & "', 倉儲作業 = N'" & DTP & "' WHERE (資料流水號 LIKE N'" & PA1 & "') AND (狀態 LIKE N'組裝出庫')" : CmdSet_For_dr()
    End Sub
End Module

