﻿Module SQL_資料庫系統管理
    '---------------------簽名檔管理-----------------------------------------------------------------------------------------------------------------
    Friend Sub SQL_簽名檔管理清單()
        ConnOpen() : SQL1 = "SELECT 圖片流水號 AS 圖檔編碼, 簽名檔人名 FROM MJ主管簽名檔管理 ORDER BY 圖片流水號" : CmdSet_For_DGV()
    End Sub
    Friend Sub SQL_使用者權限姓名清單()
        ConnOpen() : SQL1 = "SELECT 姓名 FROM 使用者權限管理表 ORDER BY 姓名" : CmdSet_For_dr()
    End Sub
    Friend Sub SQL_主管簽名檔新增()
        ConnOpen()
        SQL1 = "INSERT INTO MJ主管簽名檔管理 (圖片流水號, 簽名檔人名, 簽名檔圖片) SELECT N'" & 簽名檔管理.圖檔編號_tb.Text & "', N'" & 簽名檔管理.簽名檔持有人_cb.Text & "', @binary_file"
        CmdSet_For_dr_pic()
    End Sub
    Friend Sub SQL_主管簽名檔刪除()
        ConnOpen() : SQL1 = "DELETE FROM MJ主管簽名檔管理 WHERE (圖片流水號 = N'" & 簽名檔管理.圖檔編號_tb.Text & "')" : CmdSet_For_dr()
    End Sub
    Friend Sub SQL_主管簽名檔流水號最後一筆()
        ConnOpen() : SQL1 = "SELECT TOP (1) 圖片流水號 FROM MJ主管簽名檔管理 ORDER BY 圖片流水號 DESC" : CmdSet_For_dr()
    End Sub
    '---------------------系統編碼規則_1-----------------------------------------------------------------------------------------------------------------
    Friend Sub SQL_佣金比例()
        ConnOpen() : SQL1 = "SELECT 比例 FROM 佣金比例 ORDER BY 比例" : CmdSet_For_DGV()
    End Sub
    Friend Sub SQL_FTP伺服器清單()
        ConnOpen() : SQL1 = "SELECT FTP地址, FTP帳號, FTP密碼, 地區 FROM FTP資料庫管理" : CmdSet_For_DGV()
    End Sub
    Friend Sub SQL_付款方式清單()
        ConnOpen() : SQL1 = "SELECT 編號, 付款方式 FROM MJ付款方式 ORDER BY 編號" : CmdSet_For_DGV()
    End Sub
    Friend Sub SQL_會計科目清單()
        ConnOpen()
        SQL1 = "SELECT 第一階, 第二階, 會計科目, 編號, 層級, 英文名稱, 統制科目, 抵銷科目, 停用, 附註, 顯示 FROM  會計科目 
                WHERE 編號 LIKE N'" & 系統編碼規則_1.會科第一層編號_cb.Text & "%' ORDER BY  編號"
        CmdSet_For_DGV()
    End Sub
    Friend Sub SQL_年份清單()
        ConnOpen() : SQL1 = "SELECT  年份 FROM 年份清單 ORDER BY 年份 DESC" : CmdSet_For_DGV()
    End Sub
    Friend Sub SQL_會計科目下拉清單一()
        ConnOpen() : SQL1 = "SELECT 第一階, LEFT(編號, 4) AS 編號 FROM 會計科目 GROUP BY 第一階, LEFT(編號, 4) ORDER BY 編號" : CmdSet_For_dr()
    End Sub
    Friend Sub SQL_會計科目下拉清單二()
        ConnOpen()
        SQL1 = "SELECT LEFT(編號, 7) AS 編號, 第二階, 層級 FROM  會計科目 
                WHERE (LEFT(編號, 4) LIKE N'" & 系統編碼規則_1.會科第一層編號_cb.Text & "') AND (層級 LIKE N'" & 系統編碼規則_1.會科第二層層級_cb.Text & "')
                GROUP BY   LEFT(編號, 7), 第二階, 層級 ORDER BY   編號"
        CmdSet_For_dr()
    End Sub
    Friend Sub SQL_會計科目流水號查詢第一段()
        ConnOpen()
        SQL1 = "SELECT TOP (1) LEFT(編號, 7) AS 編號 FROM  會計科目 WHERE (LEFT(編號, 4) LIKE N'" & 系統編碼規則_1.會科第一層編號_cb.Text & "') AND (層級 LIKE N'2') 
                GROUP BY   LEFT(編號, 7) ORDER BY   編號 DESC"
        CmdSet_For_dr()
    End Sub
    Friend Sub SQL_會計科目流水號查詢第二段()
        ConnOpen()
        SQL1 = "SELECT TOP (1) LEFT(編號, 10) AS 編號 FROM  會計科目 WHERE (LEFT(編號, 7) LIKE N'" & 系統編碼規則_1.會科第二層編號_cb.Text & "') AND (層級 LIKE N'3') 
                GROUP BY   LEFT(編號, 10) ORDER BY   編號 DESC"
        CmdSet_For_dr()
    End Sub
    Friend Sub SQL_FTP資料庫管理查詢()
        ConnOpen() : SQL1 = "SELECT 地區 FROM FTP資料庫管理 WHERE 地區 LIKE N'" & 系統編碼規則_1.地區_tb.Text & "'" : CmdSet_For_dr()
    End Sub
    Friend Sub SQL_FTP資料庫管理新增()
        SQL1 = "INSERT INTO FTP資料庫管理 (FTP地址, FTP帳號, FTP密碼, 地區) 
                VALUES (N'" & 系統編碼規則_1.FTP地址_tb.Text & "', N'" & 系統編碼規則_1.帳號_tb.Text & "', N'" & 系統編碼規則_1.密碼_tb.Text & "', N'" & 系統編碼規則_1.地區_tb.Text & "')"
    End Sub
    Friend Sub SQL_FTP資料庫管理修改()
        SQL1 = "UPDATE FTP資料庫管理 SET FTP地址 = N'" & PA & "', FTP帳號 = N'" & PA1 & "', FTP密碼 = N'" & PA2 & "' WHERE 地區 LIKE N'" & 系統編碼規則_1.地區_tb.Text & "'"
    End Sub
    Friend Sub SQL_FTP資料庫管理刪除()
        SQL1 = "DELETE FROM FTP資料庫管理 WHERE (地區 = N'" & 系統編碼規則_1.地區_tb.Text & "')"
    End Sub
    Friend Sub SQL_付款方式流水號查詢()
        ConnOpen() : SQL1 = "Select TOP (1) 編號 FROM MJ付款方式 ORDER BY 編號 DESC" : CmdSet_For_dr()
    End Sub
    Friend Sub SQL_付款方式新增()
        SQL1 = "INSERT INTO MJ付款方式 (編號, 付款方式) VALUES (N'" & PA1 & "', N'" & PA & "')"
    End Sub
    Friend Sub SQL_付款方式修改()
        SQL1 = "UPDATE MJ付款方式 SET 付款方式 = N'" & PA & "' WHERE 編號 LIKE N'" & 系統編碼規則_1.付款編號_tb.Text & "'"
    End Sub
    Friend Sub SQL_付款方式刪除()
        SQL1 = "DELETE FROM MJ付款方式 WHERE (編號 = N'" & 系統編碼規則_1.付款編號_tb.Text & "')"
    End Sub
    Friend Sub SQL_職別流水號最後一筆()
        ConnOpen() : SQL1 = "Select TOP (1) 編號 FROM MJ職別 ORDER BY 編號 DESC" : CmdSet_For_dr()
    End Sub
    Friend Sub SQL_職別新增()
        SQL1 = "INSERT INTO MJ職別 (編號, 職別) VALUES (N'" & PA1 & "', N'" & PA & "')"
    End Sub
    Friend Sub SQL_職別修改()
        SQL1 = "UPDATE MJ職別 SET 職別 = N'" & PA & "' WHERE 編號 LIKE N'" & 系統編碼規則_1.職別編號_tb.Text & "'"
    End Sub
    Friend Sub SQL_職別刪除()
        SQL1 = "DELETE FROM MJ職別 WHERE (編號 = N'" & 系統編碼規則_1.職別編號_tb.Text & "')"
    End Sub
    Friend Sub SQL_負責區域流水號最後一筆()
        ConnOpen() : SQL1 = "Select TOP (1) 編號 FROM  MJ負責區域 ORDER BY 編號 DESC" : CmdSet_For_dr()
    End Sub
    Friend Sub SQL_負責區域新增()
        SQL1 = "INSERT INTO MJ負責區域 (編號, 負責區域) VALUES (N'" & PA1 & "', N'" & PA & "')"
    End Sub
    Friend Sub SQL_負責區域修改()
        SQL1 = "UPDATE MJ負責區域 SET 負責區域 = N'" & PA & "' WHERE 編號 LIKE N'" & 系統編碼規則_1.負區編號_tb.Text & "'"
    End Sub
    Friend Sub SQL_負責區域刪除()
        SQL1 = "DELETE FROM MJ負責區域 WHERE (編號 = N'" & 系統編碼規則_1.負區編號_tb.Text & "')"
    End Sub
    Friend Sub SQL_會計科目查詢()
        ConnOpen() : SQL1 = "SELECT 編號 FROM 會計科目 WHERE 編號 LIKE N'" & 系統編碼規則_1.會科第三層編號_tb.Text & "'" : CmdSet_For_dr()
    End Sub
    Friend Sub SQL_會計科目新增一()
        SQL1 = "INSERT INTO 會計科目 (會計科目, 編號, 層級, 英文名稱, 統制科目, 抵銷科目, 停用, 附註, 第一階, 第二階, 顯示) 
                VALUES (N'" & 系統編碼規則_1.會計科目_tb.Text & "', N'" & 系統編碼規則_1.會科第三層編號_tb.Text & "', N'" & 系統編碼規則_1.會科第三層層級_cb.Text &
                    "', N'" & 系統編碼規則_1.英文名稱_tb.Text & "', N'" & 系統編碼規則_1.統治科目_cb.Checked & "', N'" & 系統編碼規則_1.抵銷科目_cb.Checked &
                    "', N'" & 系統編碼規則_1.停用_cb.Checked & "', N'" & 系統編碼規則_1.備註_tb.Text & "', N'" & 系統編碼規則_1.會計科目_tb.Text &
                    "', N'" & 系統編碼規則_1.會計科目_tb.Text & "', N'" & 系統編碼規則_1.顯示_cb.Checked & "')"
    End Sub
    Friend Sub SQL_會計科目新增二()
        SQL1 = "INSERT INTO 會計科目 (會計科目, 編號, 層級, 英文名稱, 統制科目, 抵銷科目, 停用, 附註, 第一階, 第二階, 顯示) 
                VALUES (N'" & 系統編碼規則_1.會計科目_tb.Text & "', N'" & 系統編碼規則_1.會科第三層編號_tb.Text & "', N'" & 系統編碼規則_1.會科第三層層級_cb.Text &
                    "', N'" & 系統編碼規則_1.英文名稱_tb.Text & "', N'" & 系統編碼規則_1.統治科目_cb.Checked & "', N'" & 系統編碼規則_1.抵銷科目_cb.Checked &
                    "', N'" & 系統編碼規則_1.停用_cb.Checked & "', N'" & 系統編碼規則_1.備註_tb.Text & "', N'" & 系統編碼規則_1.會科第一層_cb.Text &
                    "', N'" & 系統編碼規則_1.會計科目_tb.Text & "', N'" & 系統編碼規則_1.顯示_cb.Checked & "')"
    End Sub
    Friend Sub SQL_會計科目新增三()
        SQL1 = "INSERT INTO 會計科目 (會計科目, 編號, 層級, 英文名稱, 統制科目, 抵銷科目, 停用, 附註, 第一階, 第二階, 顯示) 
                VALUES (N'" & 系統編碼規則_1.會計科目_tb.Text & "', N'" & 系統編碼規則_1.會科第三層編號_tb.Text & "', N'" & 系統編碼規則_1.會科第三層層級_cb.Text &
                    "', N'" & 系統編碼規則_1.英文名稱_tb.Text & "', N'" & 系統編碼規則_1.統治科目_cb.Checked & "', N'" & 系統編碼規則_1.抵銷科目_cb.Checked &
                    "', N'" & 系統編碼規則_1.停用_cb.Checked & "', N'" & 系統編碼規則_1.備註_tb.Text & "', N'" & 系統編碼規則_1.會科第一層_cb.Text &
                    "', N'" & 系統編碼規則_1.會科第二層_cb.Text & "', N'" & 系統編碼規則_1.顯示_cb.Checked & "')"
    End Sub
    Friend Sub SQL_會計科目修改()
        ConnOpen()
        SQL1 = "UPDATE 會計科目 SET 會計科目 = N'" & PA1 & "', 層級 = N'" & PA2 & "', 英文名稱 = N'" & PA3 & "', 統制科目 = N'" & 布林1 & "', 抵銷科目 = N'" & 布林2 & "', 停用 = N'" & 布林3 &
                                    "', 附註 = N'" & PA4 & "', 第一階 = N'" & PA5 & "', 第二階 = N'" & PA6 & "' , 顯示 = N'" & 布林4 & "'
                    WHERE 編號 LIKE N'" & PA7 & "'"
        CmdSet_For_dr()
    End Sub
    Friend Sub SQL_會計科目刪除()
        SQL1 = "DELETE FROM 會計科目 WHERE (編號 = N'" & 系統編碼規則_1.會科第三層編號_tb.Text & "')"
    End Sub
    Friend Sub SQL_年份清單新增()
        SQL1 = "INSERT INTO 年份清單 (年份) VALUES (N'" & 系統編碼規則_1.年份_tb.Text & "')"
    End Sub
    Friend Sub SQL_年份清單修改()
        SQL1 = "UPDATE 年份清單 SET 年份 = N'" & PA & "' WHERE 年份 LIKE N'" & 系統編碼規則_1.年份_tb.Text & "'"
    End Sub
    Friend Sub SQL_年份清單刪除()
        SQL1 = "DELETE FROM 年份清單 WHERE (年份 = N'" & 系統編碼規則_1.年份_tb.Text & "')"
    End Sub
    Friend Sub SQL_公司資料清單()
        ConnOpen() : SQL1 = "SELECT 公司編號, 公司名, 統編, 電話, 地址 FROM MJ公司基本資料 ORDER BY 公司名" : CmdSet_For_DGV()
    End Sub
    Friend Sub SQL_公司基本資料流水號最後一筆()
        ConnOpen() : SQL1 = "SELECT TOP (1) 公司編號 FROM  MJ公司基本資料 ORDER BY 公司編號 DESC" : CmdSet_For_dr()
    End Sub
    Friend Sub SQL_公司基本資料新增()
        SQL1 = "INSERT INTO MJ公司基本資料 (公司編號, 公司名, 統編, 電話, 地址) 
                VALUES (N'" & 系統編碼規則_1.公司編號_tb.Text & "', N'" & 系統編碼規則_1.公司名稱_tb.Text & "', N'" & 系統編碼規則_1.統編_tb.Text &
                    "', N'" & 系統編碼規則_1.電話_tb.Text & "', N'" & 系統編碼規則_1.公司地址_tb.Text & "')"
    End Sub
    Friend Sub SQL_公司基本資料修改()
        SQL1 = "UPDATE MJ公司基本資料 SET 公司名 = N'" & 系統編碼規則_1.公司名稱_tb.Text & "', 統編 = N'" & 系統編碼規則_1.統編_tb.Text &
                                        "', 電話 = N'" & 系統編碼規則_1.電話_tb.Text & "', 地址 = N'" & 系統編碼規則_1.公司地址_tb.Text & "' 
                WHERE 公司編號 LIKE N'" & 系統編碼規則_1.公司編號_tb.Text & "'"
    End Sub
    Friend Sub SQL_公司基本資料刪除()
        SQL1 = "DELETE FROM MJ公司基本資料 WHERE (公司編號 = N'" & 系統編碼規則_1.公司編號_tb.Text & "')"
    End Sub
    Friend Sub SQL_職別清單()
        ConnOpen() : SQL1 = "SELECT 編號, 職別 FROM MJ職別 ORDER BY 編號" : CmdSet_For_DGV()
    End Sub
    Friend Sub SQL_負責區域清單()
        ConnOpen() : SQL1 = "SELECT 編號, 負責區域 FROM MJ負責區域 ORDER BY 編號" : CmdSet_For_DGV()
    End Sub
    Friend Sub SQL_佣金比例查詢()
        ConnOpen() : SQL1 = "SELECT 比例 FROM 佣金比例 WHERE 比例 LIKE N'" & 系統編碼規則_1.比例_nud.Value & "'" : CmdSet_For_dr()
    End Sub
    Friend Sub SQL_佣金比例新增()
        SQL1 = "INSERT INTO 佣金比例 (比例) VALUES (N'" & 系統編碼規則_1.比例_nud.Value & "')"
    End Sub
    Friend Sub SQL_佣金比例刪除()
        SQL1 = "DELETE FROM 佣金比例 WHERE (比例 = N'" & 系統編碼規則_1.比例_nud.Value & "')"
    End Sub
    '---------------------系統執行檔版本管理-----------------------------------------------------------------------------------------------------------------
    Friend Sub SQL_版本號管理修改()
        ConnOpen()
        SQL1 = "UPDATE 版本號管理 SET 系統認證版本號 = N'" & 系統執行檔版本管理.版本號_tb.Text & "' WHERE (系統認證版本號 = N'" & Strings.Right(系統執行檔版本管理.資料庫版本號_lb.Text, 10) & "')"
        CmdSet_For_dr()
    End Sub
    '---------------------系統使用者管理-----------------------------------------------------------------------------------------------------------------
    Friend Sub SQL_系統使用者管理清單()
        ConnOpen() : SQL1 = "SELECT " & 登入權限 & " FROM 使用者權限管理表" : CmdSet_For_DGV()
    End Sub
    Friend Sub SQL_系統使用者新增()
        ConnOpen()
        SQL1 = "INSERT INTO 使用者權限管理表 (" & 登入權限 & ") " &
               "VALUES (N'" & 系統使用者管理.姓名_tb.Text & "',N'" & 系統使用者管理.帳號_tb.Text & "',N'" & 系統使用者管理.密碼_tb.Text & "', '" & 系統使用者管理.CheckBox1.Checked &
               "', '" & 系統使用者管理.CheckBox2.Checked & "', '" & 系統使用者管理.CheckBox3.Checked & "', '" & 系統使用者管理.CheckBox4.Checked & "', '" & 系統使用者管理.CheckBox5.Checked &
               "', '" & 系統使用者管理.CheckBox6.Checked & "', '" & 系統使用者管理.CheckBox7.Checked & "', '" & 系統使用者管理.CheckBox8.Checked & "', '" & 系統使用者管理.CheckBox9.Checked &
               "', '" & 系統使用者管理.CheckBox10.Checked & "', '" & 系統使用者管理.CheckBox11.Checked & "', '" & 系統使用者管理.CheckBox12.Checked & "', '" & 系統使用者管理.CheckBox13.Checked &
               "', '" & 系統使用者管理.CheckBox14.Checked & "', '" & 系統使用者管理.CheckBox15.Checked & "', '" & 系統使用者管理.CheckBox16.Checked & "', '" & 系統使用者管理.CheckBox17.Checked &
               "', '" & 系統使用者管理.CheckBox18.Checked & "', '" & 系統使用者管理.CheckBox19.Checked & "', '" & 系統使用者管理.CheckBox20.Checked & "', '" & 系統使用者管理.CheckBox21.Checked &
               "', '" & 系統使用者管理.CheckBox22.Checked & "', '" & 系統使用者管理.CheckBox23.Checked & "', '" & 系統使用者管理.CheckBox24.Checked & "', '" & 系統使用者管理.CheckBox25.Checked &
               "', '" & 系統使用者管理.CheckBox26.Checked & "', '" & 系統使用者管理.CheckBox27.Checked & "', '" & 系統使用者管理.CheckBox28.Checked & "', '" & 系統使用者管理.CheckBox29.Checked &
               "', '" & 系統使用者管理.CheckBox30.Checked & "', '" & 系統使用者管理.CheckBox31.Checked & "', '" & 系統使用者管理.CheckBox32.Checked & "', '" & 系統使用者管理.CheckBox33.Checked &
               "', '" & 系統使用者管理.CheckBox34.Checked & "', '" & 系統使用者管理.CheckBox35.Checked & "', '" & 系統使用者管理.CheckBox36.Checked & "', '" & 系統使用者管理.CheckBox37.Checked &
               "', '" & 系統使用者管理.CheckBox38.Checked & "', '" & 系統使用者管理.CheckBox39.Checked & "', '" & 系統使用者管理.CheckBox40.Checked & "', '" & 系統使用者管理.CheckBox41.Checked &
               "', '" & 系統使用者管理.CheckBox42.Checked & "', '" & 系統使用者管理.CheckBox43.Checked & "', '" & 系統使用者管理.CheckBox44.Checked & "', '" & 系統使用者管理.CheckBox45.Checked &
               "', '" & 系統使用者管理.CheckBox46.Checked & "', '" & 系統使用者管理.CheckBox47.Checked & "', '" & 系統使用者管理.CheckBox48.Checked & "', '" & 系統使用者管理.CheckBox49.Checked &
               "', '" & 系統使用者管理.CheckBox50.Checked & "', '" & 系統使用者管理.CheckBox51.Checked & "', '" & 系統使用者管理.CheckBox52.Checked & "', '" & 系統使用者管理.CheckBox53.Checked &
               "', '" & 系統使用者管理.CheckBox54.Checked & "', '" & 系統使用者管理.CheckBox55.Checked & "', '" & 系統使用者管理.CheckBox56.Checked & "', '" & 系統使用者管理.CheckBox57.Checked &
               "', '" & 系統使用者管理.CheckBox58.Checked & "', '" & 系統使用者管理.CheckBox59.Checked & "', '" & 系統使用者管理.CheckBox60.Checked & "', '" & 系統使用者管理.CheckBox61.Checked & "')"
        CmdSet_For_dr()
    End Sub
    Friend Sub SQL_系統使用者密碼顯示()
        ConnOpen() : SQL1 = "SELECT 密碼 FROM 使用者權限管理表 WHERE 姓名 LIKE N'" & 系統使用者管理.姓名_tb.Text & "' AND 帳號 LIKE N'" & 系統使用者管理.帳號_tb.Text & "'" : CmdSet_For_dr()
    End Sub
    Friend Sub SQL_系統使用者修改()
        ConnOpen()
        SQL1 = "UPDATE 使用者權限管理表 SET 姓名 = N'" & 系統使用者管理.姓名_tb.Text & "', 密碼 = N'" & 系統使用者管理.密碼_tb.Text & "', " &
                   "CC00 = N'" & 系統使用者管理.CheckBox1.Checked & "', CC01 = N'" & 系統使用者管理.CheckBox2.Checked & "', CC02 = N'" & 系統使用者管理.CheckBox3.Checked &
                "', CC03 = N'" & 系統使用者管理.CheckBox4.Checked & "', CC04 = N'" & 系統使用者管理.CheckBox5.Checked & "', CC05 = N'" & 系統使用者管理.CheckBox6.Checked &
                "', CC06 = N'" & 系統使用者管理.CheckBox7.Checked & "', CC07 = N'" & 系統使用者管理.CheckBox8.Checked & "', CC08 = N'" & 系統使用者管理.CheckBox9.Checked &
                "', CC09 = N'" & 系統使用者管理.CheckBox10.Checked & "', CC10 = N'" & 系統使用者管理.CheckBox11.Checked & "', CC11 = N'" & 系統使用者管理.CheckBox12.Checked &
                "', CC12 = N'" & 系統使用者管理.CheckBox13.Checked & "', CC13 = N'" & 系統使用者管理.CheckBox14.Checked & "', CC14 = N'" & 系統使用者管理.CheckBox15.Checked &
                "', CC15 = N'" & 系統使用者管理.CheckBox16.Checked & "', CC16 = N'" & 系統使用者管理.CheckBox17.Checked & "', CC17 = N'" & 系統使用者管理.CheckBox18.Checked &
                "', CC18 = N'" & 系統使用者管理.CheckBox19.Checked & "', CC19 = N'" & 系統使用者管理.CheckBox20.Checked & "', CC20 = N'" & 系統使用者管理.CheckBox21.Checked &
                "', CC21 = N'" & 系統使用者管理.CheckBox22.Checked & "', CC22 = N'" & 系統使用者管理.CheckBox23.Checked & "', CC23 = N'" & 系統使用者管理.CheckBox24.Checked &
                "', CC24 = N'" & 系統使用者管理.CheckBox25.Checked & "', CC25 = N'" & 系統使用者管理.CheckBox26.Checked & "', CC26 = N'" & 系統使用者管理.CheckBox27.Checked &
                "', CC27 = N'" & 系統使用者管理.CheckBox28.Checked & "', CC28 = N'" & 系統使用者管理.CheckBox29.Checked & "', CC29 = N'" & 系統使用者管理.CheckBox30.Checked &
                "', CC30 = N'" & 系統使用者管理.CheckBox31.Checked & "', CC31 = N'" & 系統使用者管理.CheckBox32.Checked & "', CC32 = N'" & 系統使用者管理.CheckBox33.Checked &
                "', CC33 = N'" & 系統使用者管理.CheckBox34.Checked & "', CC34 = N'" & 系統使用者管理.CheckBox35.Checked & "', CC35 = N'" & 系統使用者管理.CheckBox36.Checked &
                "', CC36 = N'" & 系統使用者管理.CheckBox37.Checked & "', CC37 = N'" & 系統使用者管理.CheckBox38.Checked & "', CC38 = N'" & 系統使用者管理.CheckBox39.Checked &
                "', CC39 = N'" & 系統使用者管理.CheckBox40.Checked & "', CC40 = N'" & 系統使用者管理.CheckBox41.Checked & "', CC41 = N'" & 系統使用者管理.CheckBox42.Checked &
                "', CC42 = N'" & 系統使用者管理.CheckBox43.Checked & "', CC43 = N'" & 系統使用者管理.CheckBox44.Checked & "', CC44 = N'" & 系統使用者管理.CheckBox45.Checked &
                "', CC45 = N'" & 系統使用者管理.CheckBox46.Checked & "', CC46 = N'" & 系統使用者管理.CheckBox47.Checked & "', CC47 = N'" & 系統使用者管理.CheckBox48.Checked &
                "', CC48 = N'" & 系統使用者管理.CheckBox49.Checked & "', CC49 = N'" & 系統使用者管理.CheckBox50.Checked & "', CC50 = N'" & 系統使用者管理.CheckBox51.Checked &
                "', CC51 = N'" & 系統使用者管理.CheckBox52.Checked & "', CC52 = N'" & 系統使用者管理.CheckBox53.Checked & "', CC53 = N'" & 系統使用者管理.CheckBox54.Checked &
                "', CC54 = N'" & 系統使用者管理.CheckBox55.Checked & "', CC55 = N'" & 系統使用者管理.CheckBox56.Checked & "', CC56 = N'" & 系統使用者管理.CheckBox57.Checked &
                "', CC57 = N'" & 系統使用者管理.CheckBox58.Checked & "', CC58 = N'" & 系統使用者管理.CheckBox59.Checked & "', CC59 = N'" & 系統使用者管理.CheckBox60.Checked &
                "', CC60 = N'" & 系統使用者管理.CheckBox61.Checked & "'
                WHERE (帳號 = N'" & 系統使用者管理.帳號_tb.Text & "')"
        CmdSet_For_dr()
    End Sub
    Friend Sub SQL_系統使用者刪除()
        ConnOpen() : SQL1 = "DELETE FROM 使用者權限管理表 WHERE (帳號 = N'" & 系統使用者管理.帳號_tb.Text & "')" : CmdSet_For_dr()
    End Sub
    '---------------------列印_產品標籤介面-----------------------------------------------------------------------------------------------------------------
    Friend Sub SQL_列印_產品標籤清單()
        If PA = "維修申請單" Then
            KKKJJ = " WHERE 倉儲明細表.單據編號 LIKE N'" & 列印用SQL & "' "
        ElseIf PA = "銷售退貨單" Then
            KKKJJ = " WHERE 倉儲明細表.單據編號 LIKE N'" & 列印用SQL & "' AND 倉儲明細表.出庫 < 0 "
        ElseIf PA = "銷售出貨單" Then
            KKKJJ = " WHERE 倉儲明細表.單據編號 LIKE N'" & 列印用SQL & "' AND 倉儲明細表.出庫 >= 0 "
        ElseIf PA = "採購訂貨單" Then
            KKKJJ = " WHERE 倉儲明細表.單據編號 LIKE N'" & 列印用SQL & "' AND 倉儲明細表.入庫 >= 0 "
        ElseIf PA = "採購退貨單" Then
            KKKJJ = " WHERE 倉儲明細表.單據編號 LIKE N'" & 列印用SQL & "' AND 倉儲明細表.入庫 < 0 "
        End If
        ConnOpen()
        SQL1 = "SELECT 倉儲明細表.單據編號, 倉儲明細表.料號, 物料資料庫.頁碼, 物料資料庫.品名, 倉儲明細表.入庫, 倉儲明細表.出庫
                     FROM   倉儲明細表 INNER JOIN 物料資料庫 ON 倉儲明細表.料號 = 物料資料庫.料號
                     " & KKKJJ & "
                     GROUP BY   倉儲明細表.單據編號, 倉儲明細表.料號, 物料資料庫.頁碼, 物料資料庫.品名, 倉儲明細表.入庫, 倉儲明細表.出庫 
                     ORDER BY 倉儲明細表.料號"
        CmdSet_For_DGV()
    End Sub
    '---------------------系統通用變數管理-----------------------------------------------------------------------------------------------------------------
    Friend Sub SQL_通用預設值管理清單一()
        ConnOpen() : SQL1 = "SELECT 流水號, 使用介面, 說明, 預設值 FROM 通用預設值管理表一 ORDER BY 使用介面" : CmdSet_For_DGV()
    End Sub
    Friend Sub SQL_系統通用變數管理流水號查詢()
        ConnOpen() : SQL1 = "SELECT TOP (1) 流水號 FROM 通用預設值管理表一 ORDER BY 流水號 DESC" : CmdSet_For_dr()
    End Sub
    Friend Sub SQL_系統通用變數管理新增()
        SQL1 = "INSERT INTO 通用預設值管理表一 (流水號, 使用介面, 說明, 預設值) VALUES (N'" & PA1 & "', N'" & PA2 & "', N'" & PA3 & "', N'" & PA4 & "')"
    End Sub
    Friend Sub SQL_系統通用變數管理修改()
        SQL1 = "UPDATE 通用預設值管理表一 SET 使用介面 = N'" & PA2 & "', 說明 = N'" & PA3 & "', 預設值 = N'" & PA4 & "' WHERE 流水號 LIKE N'" & PA1 & "'"
    End Sub
    Friend Sub SQL_系統通用變數管理刪除()
        SQL1 = "DELETE FROM 通用預設值管理表一 WHERE (流水號 = N'" & PA1 & "')"
    End Sub
End Module

