﻿Option Explicit On
Imports System.Net
Imports System.IO
Public Class 車輛保養紀錄表
    ReadOnly ds As New DataSet : ReadOnly ds1 As New DataSet
    Dim EDR As Integer = 0 : Dim ESTR As String
    Private m_Leftx As Integer = 152
    Private m_Lefty As Integer = 0
    Dim m_MousePosX As Integer
    Dim m_MousePosY As Integer
    Dim m_DeltaX As Integer
    Dim m_DeltaY As Integer
    ReadOnly m_StrecthX As Double
    ReadOnly m_StrecthY As Double
    Private Sub Set_清單()
        紀錄清單_dgv.DataSource = Nothing : ds.Clear()
        紀錄清單_dgv.ColumnHeadersHeightSizeMode = DataGridViewColumnHeadersHeightSizeMode.EnableResizing
        紀錄清單_dgv.ColumnHeadersHeight = 25 : 紀錄清單_dgv.AllowUserToAddRows = False
        SQL_車輛保養紀錄表()
        da.Fill(ds) : 紀錄清單_dgv.DataSource = ds.Tables(0) : conn.Close()
        紀錄清單_dgv.Columns(0).Visible = False : 紀錄清單_dgv.Columns(1).Visible = False : 紀錄清單_dgv.Columns(2).FillWeight = 100 : 紀錄清單_dgv.Columns(3).FillWeight = 100
        紀錄清單_dgv.Columns(4).FillWeight = 100 : 紀錄清單_dgv.Columns(4).DefaultCellStyle.Format = "#,##0"
        紀錄清單_dgv.Columns(4).DefaultCellStyle.Alignment = DataGridViewContentAlignment.MiddleCenter
        紀錄清單_dgv.Columns(4).HeaderCell.Style.Alignment = DataGridViewContentAlignment.MiddleCenter
    End Sub
    Private Sub ComboBox1下拉表單資料載入()
        SQL_車牌號碼清單() : 車牌號碼_cb.Items.Clear() : While (dr.Read()) : 車牌號碼_cb.Items.Add(dr("車牌號碼")) : End While : conn.Close()
    End Sub
    Private Sub 車輛保養紀錄表_Load(sender As Object, e As EventArgs) Handles MyBase.Load
        Me.MdiParent = MAOJI_ERP_SYS : Me.WindowState = 2 : Me.AutoScroll = True
        報告圖_pb.BringToFront() : 流水號_tb.Visible = False : 檔名讀取_tb.Visible = False
    End Sub
    Private Sub 介面開啟_Shown(sender As Object, e As EventArgs) Handles MyBase.Shown
        計算分流.Enabled = True
    End Sub
    Private Sub 計算分流_Tick(sender As Object, e As EventArgs) Handles 計算分流.Tick
        ComboBox1下拉表單資料載入()
        計算分流.Enabled = False
    End Sub
    Private Sub 介面關閉_Closed(sender As Object, e As EventArgs) Handles MyBase.Closed
        MyModule1.虛擬桌面開啟()
    End Sub
    Private Sub DataGridView1_CellClick(ByVal sender As System.Object, ByVal e As System.Windows.Forms.DataGridViewCellEventArgs) Handles 紀錄清單_dgv.CellClick
        If e.RowIndex = -1 Then : Else
            保養日期_dtp.Value = 紀錄清單_dgv.Rows(e.RowIndex).Cells("保養日期").Value.ToString : 預保日期_dtp.Value = 紀錄清單_dgv.Rows(e.RowIndex).Cells("預保日期").Value.ToString
            里程數_nud.Value = 紀錄清單_dgv.Rows(e.RowIndex).Cells("里程數").Value.ToString : 流水號_tb.Text = 紀錄清單_dgv.Rows(e.RowIndex).Cells("流水號").Value.ToString
            Set_圖片顯示()
        End If
    End Sub
    Private Sub ComboBox1_SelectedIndexChanged(sender As Object, e As EventArgs) Handles 車牌號碼_cb.SelectedIndexChanged
        Set_清單()
    End Sub
    Private Sub Set_日期格式轉換()
        DTP1 = Format(保養日期_dtp.Value, "yyyy/MM/dd") : DTP2 = Format(預保日期_dtp.Value, "yyyy/MM/dd")
    End Sub
    Private Sub Set_流水號()
        SQL_車輛保養紀錄表流水號最後一筆()
        If dr.Read() Then : EDR = Double.Parse(Strings.Right(dr("流水號").ToString, 8)) : Else : EDR = 0 : End If : conn.Close() : EDR += 1
        If EDR < 10 Then : ESTR = "VM" & "0000000" & EDR : ElseIf EDR > 9 And EDR < 100 Then : ESTR = "VM" & "000000" & EDR
        ElseIf EDR > 99 And EDR < 1000 Then : ESTR = "VM" & "00000" & EDR : ElseIf EDR > 999 And EDR < 10000 Then : ESTR = "VM" & "0000" & EDR
        ElseIf EDR > 9999 And EDR < 100000 Then : ESTR = "VM" & "000" & EDR : ElseIf EDR > 99999 And EDR < 100000 Then : ESTR = "VM" & "00" & EDR
        ElseIf EDR > 999999 And EDR < 1000000 Then : ESTR = "VM" & "0" & EDR : ElseIf EDR > 9999999 Then : ESTR = "VM" & EDR : End If
        流水號_tb.Text = ESTR : Set_日期格式轉換()
    End Sub
    Private Sub Set_圖片顯示()
        報告圖_pb.Image = Nothing : SQL_車輛保養紀錄表圖片讀取()
        While dr.Read() = True
            Dim unused As Byte() = New Byte(-1) {}
            Dim bytes As Byte() = DirectCast(dr.Item("圖片"), Byte())
            Dim oStream As New MemoryStream(bytes)
            報告圖_pb.Image = Bitmap.FromStream(oStream)
        End While : conn.Close() : 報告圖_pb.SizeMode = 4
    End Sub
    Private Sub Button2_Click(sender As Object, e As EventArgs) Handles 新增資料_bt.Click
        If 車牌號碼_cb.Text = "" Then : MsgBox("請先輸入車牌，或選擇車牌") : Else
            If 檔案名稱_tb.Text = "" Then : Set_流水號() : SQL_車輛保養紀錄表新增_無圖片() : conn.Close() : 檔案名稱_tb.Text = "" : Set_圖片顯示() : 流水號_tb.Text = ""
            Else : PA49 = 檔案名稱_tb.Text : Set_流水號() : SQL_車輛保養紀錄表新增_有圖片() : conn.Close() : 檔案名稱_tb.Text = "" : Set_圖片顯示() : 流水號_tb.Text = ""
            End If : Set_清單()
        End If
    End Sub
    Private Sub 修改資料_bt_Click(sender As Object, e As EventArgs) Handles 修改資料_bt.Click
        If 車牌號碼_cb.Text = "" Then : MsgBox("請先輸入車牌，或選擇車牌") : Else
            If 檔案名稱_tb.Text = "" Then
                Set_日期格式轉換() : SQL_車輛保養紀錄表修改_無圖片() : conn.Close() : 檔案名稱_tb.Text = "" : Set_圖片顯示() : 流水號_tb.Text = ""
            Else
                PA49 = 檔案名稱_tb.Text : Set_日期格式轉換() : SQL_車輛保養紀錄表修改_有圖片() : conn.Close() : 檔案名稱_tb.Text = "" : Set_圖片顯示() : 流水號_tb.Text = ""
            End If : MsgBox("修改完成") : Set_清單()
        End If
    End Sub
    Private Sub 讀取資料夾路徑_bt_Click(sender As Object, e As EventArgs) Handles 讀取資料夾路徑_bt.Click
        開啟檔案.Filter = "圖片文件 (*.jpg; *.jpeg; *.png; *.bmp)|*.jpg;*.jpeg;*.png;*.bmp"
        開啟檔案.Title = "選擇圖片文件"
        開啟檔案.InitialDirectory = Environment.GetFolderPath(Environment.SpecialFolder.MyPictures)
        If 開啟檔案.ShowDialog() = DialogResult.OK Then
            Try
                報告圖_pb.Image = Image.FromFile(開啟檔案.FileName) : 報告圖_pb.SizeMode = 4:   檔案名稱_tb.Text = 開啟檔案.FileName
            Catch ex As Exception
                MessageBox.Show("無法加載圖片: " & ex.Message, "錯誤", MessageBoxButtons.OK, MessageBoxIcon.Error)
            End Try
        End If
    End Sub
    Private Sub Button9_Click(sender As Object, e As EventArgs) Handles 順時鐘90度_bt.Click
        報告圖_pb.Image.RotateFlip(RotateFlipType.Rotate90FlipNone) : 報告圖_pb.Refresh() : 報告圖_pb.SizeMode = 4
    End Sub
    Private Sub Button8_Click(sender As Object, e As EventArgs) Handles 逆時鐘90度_bt.Click
        報告圖_pb.Image.RotateFlip(RotateFlipType.Rotate270FlipNone) : 報告圖_pb.Refresh() : 報告圖_pb.SizeMode = 4
    End Sub
    Private Sub Button7_Click(sender As Object, e As EventArgs) Handles 水平翻轉_bt.Click
        報告圖_pb.Image.RotateFlip(RotateFlipType.Rotate180FlipX) : 報告圖_pb.Refresh() : 報告圖_pb.SizeMode = 4
    End Sub
    Private Sub Button6_Click(sender As Object, e As EventArgs) Handles 垂直翻轉_bt.Click
        報告圖_pb.Image.RotateFlip(RotateFlipType.Rotate180FlipY) : 報告圖_pb.Refresh() : 報告圖_pb.SizeMode = 4
    End Sub
    Private Sub 放大_bt_Click(sender As Object, e As EventArgs) Handles 放大_bt.Click
        Dim image = 報告圖_pb.Image : Dim g As Graphics = 報告圖_pb.CreateGraphics : g.DrawImage(image, New Rectangle(0, 0, image.Width * 2, image.Height * 2))
    End Sub
    Private Sub 復原_bt_Click(sender As Object, e As EventArgs) Handles 復原_bt.Click
        報告圖_pb.Refresh()
    End Sub

    Private Sub 讀取資料夾路徑_bt_MouseEnter(sender As Object, e As EventArgs) Handles 讀取資料夾路徑_bt.MouseEnter
        ToolTip1.SetToolTip(Me.讀取資料夾路徑_bt, "讀取資料夾路徑")
    End Sub
    Private Sub 新增資料_bt_MouseEnter(sender As Object, e As EventArgs) Handles 新增資料_bt.MouseEnter
        ToolTip1.SetToolTip(Me.新增資料_bt, "新增資料")
    End Sub
    Private Sub 修改資料_bt_MouseEnter(sender As Object, e As EventArgs) Handles 修改資料_bt.MouseEnter
        ToolTip1.SetToolTip(Me.修改資料_bt, "修改資料")
    End Sub
    Private Sub 刪除資料_bt_MouseEnter(sender As Object, e As EventArgs) Handles 刪除資料_bt.MouseEnter
        ToolTip1.SetToolTip(Me.刪除資料_bt, "刪除資料")
    End Sub
    Private Sub 順時鐘90度_bt_MouseEnter(sender As Object, e As EventArgs) Handles 順時鐘90度_bt.MouseEnter
        ToolTip1.SetToolTip(Me.順時鐘90度_bt, "順時鐘90度")
    End Sub
    Private Sub 逆時鐘90度_bt_MouseEnter(sender As Object, e As EventArgs) Handles 逆時鐘90度_bt.MouseEnter
        ToolTip1.SetToolTip(Me.逆時鐘90度_bt, "逆時鐘90度")
    End Sub
    Private Sub 水平翻轉_bt_MouseEnter(sender As Object, e As EventArgs) Handles 水平翻轉_bt.MouseEnter
        ToolTip1.SetToolTip(Me.水平翻轉_bt, "水平翻轉")
    End Sub
    Private Sub 放大_bt_MouseEnter(sender As Object, e As EventArgs) Handles 放大_bt.MouseEnter
        ToolTip1.SetToolTip(Me.放大_bt, "放大")
    End Sub
    Private Sub 垂直翻轉_bt_MouseEnter(sender As Object, e As EventArgs) Handles 垂直翻轉_bt.MouseEnter
        ToolTip1.SetToolTip(Me.垂直翻轉_bt, "垂直翻轉")
    End Sub
    Private Sub 復原_bt_MouseEnter(sender As Object, e As EventArgs) Handles 復原_bt.MouseEnter
        ToolTip1.SetToolTip(Me.復原_bt, "復原")
    End Sub

End Class