﻿Option Strict Off
Imports System.Windows.Forms.VisualStyles.VisualStyleElement

Public Class 採購退貨確認
    ReadOnly ds As New DataSet
    Private Sub Set_清單()
        退貨明細_dgv.DataSource = Nothing : ds.Clear()
        退貨明細_dgv.ColumnHeadersHeightSizeMode = DataGridViewColumnHeadersHeightSizeMode.EnableResizing
        退貨明細_dgv.ColumnHeadersHeight = 25
        退貨明細_dgv.AllowUserToAddRows = False
        SQL_採購退貨確認清單()
        da.Fill(ds) : 退貨明細_dgv.DataSource = ds.Tables(0) : conn.Close()

        退貨明細_dgv.Columns(0).Visible = False : 退貨明細_dgv.Columns(1).FillWeight = 110 : 退貨明細_dgv.Columns(2).FillWeight = 80 : 退貨明細_dgv.Columns(3).FillWeight = 200
        退貨明細_dgv.Columns(4).FillWeight = 150 : 退貨明細_dgv.Columns(5).FillWeight = 150 : 退貨明細_dgv.Columns(6).FillWeight = 60 : 退貨明細_dgv.Columns(7).FillWeight = 200
        退貨明細_dgv.Columns(8).FillWeight = 80 : 退貨明細_dgv.Columns(9).FillWeight = 80 : 退貨明細_dgv.Columns(10).FillWeight = 40 : 退貨明細_dgv.Columns(11).FillWeight = 60
        退貨明細_dgv.Columns(12).Visible = False
        退貨明細_dgv.Columns(6).DefaultCellStyle.Format = "#,##0"
        退貨明細_dgv.Columns(1).DefaultCellStyle.Alignment = DataGridViewContentAlignment.MiddleCenter : 退貨明細_dgv.Columns(1).HeaderCell.Style.Alignment = DataGridViewContentAlignment.MiddleCenter
        退貨明細_dgv.Columns(2).DefaultCellStyle.Alignment = DataGridViewContentAlignment.MiddleCenter : 退貨明細_dgv.Columns(2).HeaderCell.Style.Alignment = DataGridViewContentAlignment.MiddleCenter
        退貨明細_dgv.Columns(6).DefaultCellStyle.Alignment = DataGridViewContentAlignment.MiddleCenter : 退貨明細_dgv.Columns(6).HeaderCell.Style.Alignment = DataGridViewContentAlignment.MiddleCenter
        退貨明細_dgv.Columns(8).DefaultCellStyle.Alignment = DataGridViewContentAlignment.MiddleCenter : 退貨明細_dgv.Columns(8).HeaderCell.Style.Alignment = DataGridViewContentAlignment.MiddleCenter
        退貨明細_dgv.Columns(9).DefaultCellStyle.Alignment = DataGridViewContentAlignment.MiddleCenter : 退貨明細_dgv.Columns(9).HeaderCell.Style.Alignment = DataGridViewContentAlignment.MiddleCenter
        退貨明細_dgv.Columns(10).DefaultCellStyle.Alignment = DataGridViewContentAlignment.MiddleCenter : 退貨明細_dgv.Columns(10).HeaderCell.Style.Alignment = DataGridViewContentAlignment.MiddleCenter
        退貨明細_dgv.Columns(11).DefaultCellStyle.Alignment = DataGridViewContentAlignment.MiddleCenter : 退貨明細_dgv.Columns(11).HeaderCell.Style.Alignment = DataGridViewContentAlignment.MiddleCenter

        退貨明細_dgv.Columns(1).ReadOnly = True : 退貨明細_dgv.Columns(2).ReadOnly = True : 退貨明細_dgv.Columns(3).ReadOnly = True : 退貨明細_dgv.Columns(4).ReadOnly = True
        退貨明細_dgv.Columns(5).ReadOnly = True : 退貨明細_dgv.Columns(6).ReadOnly = True : 退貨明細_dgv.Columns(7).ReadOnly = True : 退貨明細_dgv.Columns(8).ReadOnly = True
        退貨明細_dgv.Columns(9).ReadOnly = True : 退貨明細_dgv.Columns(11).ReadOnly = True

        For i As Integer = 0 To 退貨明細_dgv.Rows.Count - 1
            退貨明細_dgv.Rows(i).Cells("選擇").Value = False
        Next
    End Sub
    Private Sub 採購退貨確認_Load(sender As Object, e As EventArgs) Handles MyBase.Load
        Me.MdiParent = MAOJI_ERP_SYS : Me.WindowState = 2 : Me.AutoScroll = True
        倉名編號_tb.Enabled = False : 倉名_tb.Enabled = False
    End Sub
    Private Sub 介面開啟_Shown(sender As Object, e As EventArgs) Handles MyBase.Shown
        計算分流.Enabled = True
    End Sub
    Private Sub 計算分流_Tick(sender As Object, e As EventArgs) Handles 計算分流.Tick
        Set_清單()
        計算分流.Enabled = False
    End Sub
    Private Sub 介面關閉_Closed(sender As Object, e As EventArgs) Handles MyBase.Closed
        MyModule1.虛擬桌面開啟()
    End Sub
    Private Sub DataGridView1_CellClick(ByVal sender As System.Object, ByVal e As DataGridViewCellEventArgs) Handles 退貨明細_dgv.CellClick
        If e.RowIndex = -1 Then : Else
            單據編號_tb.Text = 退貨明細_dgv.Rows(e.RowIndex).Cells("單據編號").Value : 倉名編號_tb.Text = 退貨明細_dgv.Rows(e.RowIndex).Cells("倉名編號").Value
        End If
    End Sub
    Private Sub DataGridView1_RowPostPaint(ByVal sender As Object, ByVal e As DataGridViewRowPostPaintEventArgs) Handles 退貨明細_dgv.RowPostPaint
        Dim linePen As New Pen(Color.Blue, 2)
        If e.RowIndex = 退貨明細_dgv.Rows.Count - 1 Then : Exit Sub
        Else
            If 退貨明細_dgv(1, e.RowIndex).Value.ToString <> 退貨明細_dgv(1, e.RowIndex + 1).Value.ToString Then
                Dim startX As Integer = IIf(退貨明細_dgv.RowHeadersVisible, 退貨明細_dgv.RowHeadersWidth, 0)
                Dim startY As Integer = e.RowBounds.Top + e.RowBounds.Height - 1
                Dim endX As Integer = startX + 退貨明細_dgv.Columns.GetColumnsWidth(DataGridViewElementStates.Visible) - 退貨明細_dgv.HorizontalScrollingOffset
                e.Graphics.DrawLine(linePen, startX, startY, endX, startY) : Exit Sub
            End If
        End If
    End Sub
    Private Sub Button1_Click(sender As Object, e As EventArgs) Handles 依單據選擇_bt.Click
        For i As Integer = 0 To 退貨明細_dgv.Rows.Count - 1
            If 單據編號_tb.Text = 退貨明細_dgv.Rows(i).Cells("單據編號").Value.ToString Then
                退貨明細_dgv.Rows(i).Cells("選擇").Value = True
            End If
        Next i
    End Sub
    Private Sub Button13_Click(sender As Object, e As EventArgs) Handles 全部選擇_bt.Click
        For i As Integer = 0 To 退貨明細_dgv.Rows.Count - 1 : 退貨明細_dgv.Rows(i).Cells("選擇").Value = True : Next i
    End Sub
    Private Sub Button12_Click(sender As Object, e As EventArgs) Handles 全部取消_bt.Click
        For i As Integer = 0 To 退貨明細_dgv.Rows.Count - 1 : 退貨明細_dgv.Rows(i).Cells("選擇").Value = False : Next i
    End Sub
    Private Sub Set_日期格式轉換()
        DTP = Format(入庫日期_dtp.Value, "yyyy/MM/dd")
    End Sub
    Private Sub Button4_Click(sender As Object, e As EventArgs) Handles 確認收料入庫_bt.Click
        If 倉名編號_tb.Text = "" Then : MsgBox("指定倉庫沒有選擇。")
        Else
            Set_日期格式轉換() : PA1 = 倉名編號_tb.Text
            For i As Integer = 0 To 退貨明細_dgv.Rows.Count - 1
                資料數 = 退貨明細_dgv.Rows.Count : MyModule1.進度條()
                If 退貨明細_dgv.Rows(i).Cells("選擇").Value = True Then
                    PA2 = 退貨明細_dgv.Rows(i).Cells("資料流水號").Value : SQL_倉儲入庫驗收確認() : conn.Close()
                End If
            Next
            Set_清單() : MsgBox("入庫完成。") : MAOJI_ERP_SYS.ToolStripProgressBar1.Value = 0 : 最終數 = 0
        End If
    End Sub
    '-----------------------------滑鼠右鍵------------------------------------------------------------------------------------------------------------------------------------------
    Private Sub 重新整理ToolStripMenuItem_Click(sender As Object, e As EventArgs)
        Set_清單() : 入庫日期_dtp.Value = Today()
    End Sub
    Private Sub TextBox1_TextChanged(sender As Object, e As EventArgs) Handles 倉名編號_tb.TextChanged
        PA = 倉名編號_tb.Text : SQL_採購退貨確認_倉名取得()
        If dr.Read() Then : 倉名_tb.Text = dr("倉名") : End If : conn.Close() : PA = ""
    End Sub

    Private Sub 列印出貨單_bt_MouseEnter(sender As Object, e As EventArgs) Handles 確認收料入庫_bt.MouseEnter
        ToolTip1.SetToolTip(Me.確認收料入庫_bt, "確認收料入庫")
    End Sub
End Class