﻿Option Strict Off
Public Class 倉儲分區控制表
    ReadOnly ds As New DataSet
    Private Sub Set_清單1()
        倉編清單_dgv.DataSource = Nothing : ds.Clear()
        倉編清單_dgv.ColumnHeadersHeightSizeMode = DataGridViewColumnHeadersHeightSizeMode.EnableResizing
        倉編清單_dgv.ColumnHeadersHeight = 25 : 倉編清單_dgv.AllowUserToAddRows = False : 倉編清單_dgv.RowTemplate.Height = 25
        SQL_倉儲分區控制表清單()
        da.Fill(ds) : 倉編清單_dgv.DataSource = ds.Tables(0) : conn.Close()
        倉編清單_dgv.Columns(0).FillWeight = 50 : 倉編清單_dgv.Columns(1).FillWeight = 50 : 倉編清單_dgv.Columns(2).FillWeight = 100
    End Sub
    Private Sub 編號推進()
        SQL_倉儲分區控制表流水號最後一筆()
        If dr.Read() Then : 倉明編號_tb.Text = dr("倉名編號")
            If Val(Strings.Right(倉明編號_tb.Text, 2)) < 10 Then
                倉明編號_tb.Text = "N0" & Val(Strings.Right(倉明編號_tb.Text, 2)) + 1
            Else
                倉明編號_tb.Text = "N" & Val(Strings.Right(倉明編號_tb.Text, 2)) + 1
            End If
        Else : 倉明編號_tb.Text = "N01" : End If : conn.Close()
    End Sub
    Private Sub 倉儲分區控制表_Load(sender As Object, e As EventArgs) Handles MyBase.Load
        Set_清單1() : 倉明編號_tb.Enabled = False
        If gUserName = "李協叡" Then : 修改_bt.Enabled = True : 刪除_bt.Enabled = True : Else : 修改_bt.Enabled = False : 刪除_bt.Enabled = False : End If
    End Sub
    Private Sub 介面開啟_Shown(sender As Object, e As EventArgs) Handles MyBase.Shown
        計算分流.Enabled = True
    End Sub
    Private Sub 計算分流_Tick(sender As Object, e As EventArgs) Handles 計算分流.Tick
        編號推進()
        計算分流.Enabled = False
    End Sub
    Private Sub DataGridView1_CellClick(ByVal sender As System.Object, ByVal e As DataGridViewCellEventArgs) Handles 倉編清單_dgv.CellClick
        If e.RowIndex = -1 Then : Else
            倉級_cb.Text = 倉編清單_dgv(0, e.RowIndex).Value.ToString : 倉明編號_tb.Text = 倉編清單_dgv(1, e.RowIndex).Value.ToString : 倉名_tb.Text = 倉編清單_dgv(2, e.RowIndex).Value.ToString
        End If
    End Sub
    Private Sub Button3_Click(sender As Object, e As EventArgs) Handles 新增_bt.Click
        If 倉級_cb.Text = "" Or 倉名_tb.Text = "" Then : MsgBox("資料不齊全。") : Else
            編號推進() : PA = 倉名_tb.Text : SQL_倉名編號取得()
            If dr.Read() Then : conn.Close() : MsgBox("資料重複。") : Else
                SQL_倉儲分區控制表_倉名編號_資料重複驗證()
                If dr.Read() Then : conn.Close() : MsgBox("資料重複。")
                Else : SQL_倉儲分區控制表新增() : conn.Close() : MsgBox("新增完成。") : 編號推進() : 倉名_tb.Text = "" : Set_清單1() : End If
            End If
        End If
    End Sub
    Private Sub Button1_Click(sender As Object, e As EventArgs) Handles 修改_bt.Click
        If 倉級_cb.Text = "" Or 倉名_tb.Text = "" Then : MsgBox("資料不齊全。") : Else : PA = 倉名_tb.Text : SQL_倉名編號取得()
            If dr.Read() Then : conn.Close() : MsgBox("資料重複。") : Else : SQL_倉儲分區控制表_倉名編號_資料重複驗證()
                If dr.Read() Then : conn.Close() : MsgBox("資料重複。")
                Else : SQL_倉儲分區控制表修改() : conn.Close() : MsgBox("修改完成。") : Set_清單1() : End If
            End If
        End If
    End Sub
    Private Sub Button2_Click(sender As Object, e As EventArgs) Handles 刪除_bt.Click
        Dim aa As MsgBoxResult = MsgBox("確定要刪除該筆資料?", MsgBoxStyle.OkCancel)
        If aa = MsgBoxResult.Ok Then : SQL_倉儲分區控制表刪除() : conn.Close() : MsgBox("刪除完成。") : 編號推進() : 倉名_tb.Text = "" : Set_清單1() : End If
    End Sub
    Private Sub 新增_bt_MouseEnter(sender As Object, e As EventArgs) Handles 新增_bt.MouseEnter
        ToolTip1.SetToolTip(Me.新增_bt, "新增")
    End Sub
    Private Sub 修改_bt_MouseEnter(sender As Object, e As EventArgs) Handles 修改_bt.MouseEnter
        ToolTip1.SetToolTip(Me.修改_bt, "修改")
    End Sub
    Private Sub 刪除_bt_MouseEnter(sender As Object, e As EventArgs) Handles 刪除_bt.MouseEnter
        ToolTip1.SetToolTip(Me.刪除_bt, "刪除")
    End Sub

End Class