﻿Option Strict Off
Imports Microsoft.Office.Interop.Excel.XlUnderlineStyle
Imports Microsoft.Office.Interop.Excel.Constants
Imports Microsoft.Office.Interop.Excel.XlBordersIndex
Imports Microsoft.Office.Interop.Excel.XlLineStyle
Imports Microsoft.Office.Interop.Excel.XlBorderWeight
Imports Microsoft.Office.Interop.Excel.XlThemeFont
Imports Microsoft.Office.Interop.Excel.XlThemeColor
Imports Microsoft.Office.Interop.Excel.XlWindowState
Imports Microsoft.Office.Interop.Excel
Public Class 應付賬款控制表
    ReadOnly ds As New DataSet : ReadOnly ds1 As New DataSet : ReadOnly ds2 As New DataSet
    Dim N1 As Integer
    Dim xlApp As Application : Dim xlBook As Workbook : Dim xlSheet As Worksheet
    Private Sub Set_賬款主單()
        應付供應商_dgv.DataSource = Nothing : ds.Clear() : 應付供應商_dgv.ColumnHeadersHeightSizeMode = DataGridViewColumnHeadersHeightSizeMode.EnableResizing : 應付供應商_dgv.ColumnHeadersHeight = 40
        應付供應商_dgv.AllowUserToAddRows = False : 應付供應商_dgv.ClipboardCopyMode = DataGridViewClipboardCopyMode.EnableWithoutHeaderText : 應付供應商_dgv.MultiSelect = True
        SQL_應付賬款主單()
        da.Fill(ds) : 應付供應商_dgv.DataSource = ds.Tables(0) : conn.Close()
        應付供應商_dgv.Columns(0).Visible = False : 應付供應商_dgv.Columns(1).FillWeight = 100
        應付供應商_dgv.Columns(0).DefaultCellStyle.Alignment = DataGridViewContentAlignment.MiddleCenter : 應付供應商_dgv.Columns(0).HeaderCell.Style.Alignment = DataGridViewContentAlignment.MiddleCenter
        應付供應商_dgv.Columns(1).DefaultCellStyle.Alignment = DataGridViewContentAlignment.MiddleCenter : 應付供應商_dgv.Columns(1).HeaderCell.Style.Alignment = DataGridViewContentAlignment.MiddleCenter
        For I As Integer = 0 To 1 : 應付供應商_dgv.Columns(I).ReadOnly = True : Next
    End Sub
    Private Sub Set_賬款清單()
        採購清單_dgv.DataSource = Nothing : ds1.Clear() : 採購清單_dgv.ColumnHeadersHeightSizeMode = DataGridViewColumnHeadersHeightSizeMode.EnableResizing : 採購清單_dgv.ColumnHeadersHeight = 40
        採購清單_dgv.AllowUserToAddRows = False : 採購清單_dgv.ClipboardCopyMode = DataGridViewClipboardCopyMode.EnableWithoutHeaderText : 採購清單_dgv.MultiSelect = True

        If 財務收支單號_tb.Text = "" Then : SQL_應付賬款清單一() : Else : SQL_應付賬款清單二() : End If

        da.Fill(ds1) : 採購清單_dgv.DataSource = ds1.Tables(0) : conn.Close()

        採購清單_dgv.Columns(0).FillWeight = 150 : 採購清單_dgv.Columns(1).Visible = False : 採購清單_dgv.Columns(2).Visible = False : 採購清單_dgv.Columns(3).Visible = False
        採購清單_dgv.Columns(4).FillWeight = 80 : 採購清單_dgv.Columns(5).FillWeight = 300 : 採購清單_dgv.Columns(6).FillWeight = 80 : 採購清單_dgv.Columns(7).FillWeight = 80
        採購清單_dgv.Columns(8).FillWeight = 80 : 採購清單_dgv.Columns(9).FillWeight = 80 : 採購清單_dgv.Columns(10).FillWeight = 100 : 採購清單_dgv.Columns(11).FillWeight = 100
        採購清單_dgv.Columns(12).FillWeight = 150 : 採購清單_dgv.Columns(13).FillWeight = 60 : 採購清單_dgv.Columns(14).FillWeight = 50 : 採購清單_dgv.Columns(15).Visible = False
        採購清單_dgv.Columns(16).FillWeight = 120 : 採購清單_dgv.Columns(17).Visible = False

        採購清單_dgv.Columns(6).DefaultCellStyle.Format = "#,##0" : 採購清單_dgv.Columns(7).DefaultCellStyle.Format = "#,##0.000"
        採購清單_dgv.Columns(8).DefaultCellStyle.Format = "#,##0" : 採購清單_dgv.Columns(9).DefaultCellStyle.Format = "#,##0"
        採購清單_dgv.Columns(0).DefaultCellStyle.Alignment = DataGridViewContentAlignment.MiddleCenter : 採購清單_dgv.Columns(0).HeaderCell.Style.Alignment = DataGridViewContentAlignment.MiddleCenter
        採購清單_dgv.Columns(2).DefaultCellStyle.Alignment = DataGridViewContentAlignment.MiddleCenter : 採購清單_dgv.Columns(2).HeaderCell.Style.Alignment = DataGridViewContentAlignment.MiddleCenter
        採購清單_dgv.Columns(4).DefaultCellStyle.Alignment = DataGridViewContentAlignment.MiddleCenter : 採購清單_dgv.Columns(4).HeaderCell.Style.Alignment = DataGridViewContentAlignment.MiddleCenter
        採購清單_dgv.Columns(6).DefaultCellStyle.Alignment = DataGridViewContentAlignment.MiddleCenter : 採購清單_dgv.Columns(6).HeaderCell.Style.Alignment = DataGridViewContentAlignment.MiddleCenter
        採購清單_dgv.Columns(7).DefaultCellStyle.Alignment = DataGridViewContentAlignment.MiddleCenter : 採購清單_dgv.Columns(7).HeaderCell.Style.Alignment = DataGridViewContentAlignment.MiddleCenter
        採購清單_dgv.Columns(8).DefaultCellStyle.Alignment = DataGridViewContentAlignment.MiddleCenter : 採購清單_dgv.Columns(8).HeaderCell.Style.Alignment = DataGridViewContentAlignment.MiddleCenter
        採購清單_dgv.Columns(9).DefaultCellStyle.Alignment = DataGridViewContentAlignment.MiddleCenter : 採購清單_dgv.Columns(9).HeaderCell.Style.Alignment = DataGridViewContentAlignment.MiddleCenter
        採購清單_dgv.Columns(10).DefaultCellStyle.Alignment = DataGridViewContentAlignment.MiddleCenter : 採購清單_dgv.Columns(10).HeaderCell.Style.Alignment = DataGridViewContentAlignment.MiddleCenter
        採購清單_dgv.Columns(11).DefaultCellStyle.Alignment = DataGridViewContentAlignment.MiddleCenter : 採購清單_dgv.Columns(11).HeaderCell.Style.Alignment = DataGridViewContentAlignment.MiddleCenter

        For I As Integer = 0 To 12 : 採購清單_dgv.Columns(I).ReadOnly = True : Next : 採購清單_dgv.Columns(14).ReadOnly = True
        For I As Integer = 0 To 採購清單_dgv.Rows.Count - 1
            If 採購清單_dgv.Rows(I).Cells("應付立帳").Value.ToString = "" Then : 採購清單_dgv.Rows(I).Cells("應付立帳").Value = False : End If
            採購清單_dgv.Rows(I).Cells("選擇").Value = False
        Next
    End Sub
    Private Sub Set_財務清單()
        對應收支單_dgv.DataSource = Nothing : ds2.Clear() : 對應收支單_dgv.ColumnHeadersHeightSizeMode = DataGridViewColumnHeadersHeightSizeMode.EnableResizing : 對應收支單_dgv.ColumnHeadersHeight = 40
        對應收支單_dgv.AllowUserToAddRows = False : 對應收支單_dgv.ClipboardCopyMode = DataGridViewClipboardCopyMode.EnableWithoutHeaderText : 對應收支單_dgv.MultiSelect = True
        對應收支單_dgv.RowTemplate.Height = 35
        SQL_應付賬款清單三()
        da.Fill(ds2) : 對應收支單_dgv.DataSource = ds2.Tables(0) : conn.Close()

        對應收支單_dgv.Columns(0).Visible = False : 對應收支單_dgv.Columns(1).Visible = False : 對應收支單_dgv.Columns(2).FillWeight = 75 : 對應收支單_dgv.Columns(3).Visible = False
        對應收支單_dgv.Columns(4).FillWeight = 150 : 對應收支單_dgv.Columns(5).FillWeight = 80 : 對應收支單_dgv.Columns(6).Visible = False : 對應收支單_dgv.Columns(7).FillWeight = 80
        對應收支單_dgv.Columns(8).Visible = False : 對應收支單_dgv.Columns(9).FillWeight = 150 : 對應收支單_dgv.Columns(10).FillWeight = 50 : 對應收支單_dgv.Columns(11).FillWeight = 50
        對應收支單_dgv.Columns(12).FillWeight = 120 : 對應收支單_dgv.Columns(13).FillWeight = 75 : 對應收支單_dgv.Columns(14).FillWeight = 95 : 對應收支單_dgv.Columns(15).FillWeight = 95
        對應收支單_dgv.Columns(16).FillWeight = 95 : 對應收支單_dgv.Columns(17).FillWeight = 95 : 對應收支單_dgv.Columns(18).FillWeight = 75 : 對應收支單_dgv.Columns(19).Visible = False
        對應收支單_dgv.Columns(20).FillWeight = 150 : 對應收支單_dgv.Columns(21).FillWeight = 100 : 對應收支單_dgv.Columns(22).FillWeight = 80 : 對應收支單_dgv.Columns(23).FillWeight = 150
        對應收支單_dgv.Columns(24).Visible = False : 對應收支單_dgv.Columns(25).Visible = False : 對應收支單_dgv.Columns(26).Visible = False

        對應收支單_dgv.Columns(6).DefaultCellStyle.Format = "#,##0" : 對應收支單_dgv.Columns(7).DefaultCellStyle.Format = "#,##0"
        對應收支單_dgv.Columns(8).DefaultCellStyle.Format = "#,##0" : 對應收支單_dgv.Columns(5).DefaultCellStyle.Format = "#,##0"
        對應收支單_dgv.Columns(2).DefaultCellStyle.Alignment = DataGridViewContentAlignment.MiddleCenter : 對應收支單_dgv.Columns(2).HeaderCell.Style.Alignment = DataGridViewContentAlignment.MiddleCenter
        對應收支單_dgv.Columns(5).DefaultCellStyle.Alignment = DataGridViewContentAlignment.MiddleCenter : 對應收支單_dgv.Columns(5).HeaderCell.Style.Alignment = DataGridViewContentAlignment.MiddleCenter
        對應收支單_dgv.Columns(6).DefaultCellStyle.Alignment = DataGridViewContentAlignment.MiddleCenter : 對應收支單_dgv.Columns(6).HeaderCell.Style.Alignment = DataGridViewContentAlignment.MiddleCenter
        對應收支單_dgv.Columns(7).DefaultCellStyle.Alignment = DataGridViewContentAlignment.MiddleCenter : 對應收支單_dgv.Columns(7).HeaderCell.Style.Alignment = DataGridViewContentAlignment.MiddleCenter
        對應收支單_dgv.Columns(8).DefaultCellStyle.Alignment = DataGridViewContentAlignment.MiddleCenter : 對應收支單_dgv.Columns(8).HeaderCell.Style.Alignment = DataGridViewContentAlignment.MiddleCenter
        對應收支單_dgv.Columns(9).DefaultCellStyle.Alignment = DataGridViewContentAlignment.MiddleCenter : 對應收支單_dgv.Columns(9).HeaderCell.Style.Alignment = DataGridViewContentAlignment.MiddleCenter
        對應收支單_dgv.Columns(10).DefaultCellStyle.Alignment = DataGridViewContentAlignment.MiddleCenter : 對應收支單_dgv.Columns(10).HeaderCell.Style.Alignment = DataGridViewContentAlignment.MiddleCenter
        對應收支單_dgv.Columns(11).DefaultCellStyle.Alignment = DataGridViewContentAlignment.MiddleCenter : 對應收支單_dgv.Columns(11).HeaderCell.Style.Alignment = DataGridViewContentAlignment.MiddleCenter
    End Sub
    Private Sub 日期格式()
        If 會計月_ch.Checked = True Then
            '-------------日期一----------------------------------------------------------------------------------------
            DTP = Strings.Left(Strings.Format(開始日期_dtp.Value, "yyyy/MM/dd"), 8) & "01" : 開始日期_dtp.Value = DTP
            開始日期_dtp.Value = 開始日期_dtp.Value.AddMonths(-1)
            DTP = Strings.Left(Strings.Format(開始日期_dtp.Value, "yyyy/MM/dd"), 8) & "26" : 開始日期_dtp.Value = DTP
            '-------------日期二----------------------------------------------------------------------------------------
            DTP = Strings.Left(Strings.Format(結束日期_dtp.Value, "yyyy/MM/dd"), 8) & "25" : 結束日期_dtp.Value = DTP
        Else
            '-------------日期一----------------------------------------------------------------------------------------
            開始日期_dtp.Value = 開始日期_dtp.Value.AddMonths(1)
            DTP = Strings.Left(Strings.Format(開始日期_dtp.Value, "yyyy/MM/dd"), 8) & "01" : 開始日期_dtp.Value = DTP
            '-------------日期二----------------------------------------------------------------------------------------
            DTP = Strings.Left(Strings.Format(結束日期_dtp.Value, "yyyy/MM/dd"), 8) & "01" : 結束日期_dtp.Value = DTP
            結束日期_dtp.Value = 結束日期_dtp.Value.AddMonths(1) : 結束日期_dtp.Value = 結束日期_dtp.Value.AddDays(-1)
        End If
    End Sub
    Private Sub 應付賬款控制表1_Load(sender As Object, e As EventArgs) Handles MyBase.Load
        Me.MdiParent = MAOJI_ERP_SYS : Me.WindowState = 2 : Me.AutoScroll = True
        中間日期_dtp.Visible = False : 供應商編號_tb.Visible = False : 實付金額計算用_tb.Visible = False
    End Sub
    Private Sub 介面開啟_Shown(sender As Object, e As EventArgs) Handles MyBase.Shown
        計算分流.Enabled = True
    End Sub
    Private Sub 計算分流_Tick(sender As Object, e As EventArgs) Handles 計算分流.Tick
        日期格式() : Set_賬款主單()
        計算分流.Enabled = False
    End Sub
    Private Sub 介面關閉_Closed(sender As Object, e As EventArgs) Handles MyBase.Closed
        MyModule1.虛擬桌面開啟()
    End Sub
    Private Sub Button1_Click(sender As Object, e As EventArgs) Handles 上個月_bt.Click
        If 會計月_ch.Checked = True Then
            中間日期_dtp.Value = 中間日期_dtp.Value.AddMonths(-1)
            開始日期_dtp.Value = 中間日期_dtp.Value
            結束日期_dtp.Value = 中間日期_dtp.Value
        Else
            中間日期_dtp.Value = 中間日期_dtp.Value.AddMonths(-1)
            開始日期_dtp.Value = 中間日期_dtp.Value.AddMonths(-1)
            結束日期_dtp.Value = 中間日期_dtp.Value
        End If
        財務收支單號_tb.Text = "" : 日期格式() : Set_賬款主單()
    End Sub
    Private Sub Button2_Click(sender As Object, e As EventArgs) Handles 下個月_bt.Click
        If 會計月_ch.Checked = True Then
            中間日期_dtp.Value = 中間日期_dtp.Value.AddMonths(1)
            開始日期_dtp.Value = 中間日期_dtp.Value
            結束日期_dtp.Value = 中間日期_dtp.Value
        Else
            中間日期_dtp.Value = 中間日期_dtp.Value.AddMonths(1)
            開始日期_dtp.Value = 中間日期_dtp.Value.AddMonths(-1)
            結束日期_dtp.Value = 中間日期_dtp.Value
        End If
        財務收支單號_tb.Text = "" : 日期格式() : Set_賬款主單()
    End Sub
    Private Sub 會計月_CheckedChanged(sender As Object, e As EventArgs) Handles 會計月_ch.Click
        會計月_ch.Checked = True : 一般月_ch.Checked = False : 財務收支單號_tb.Text = "" : 日期格式() : Set_賬款主單()
    End Sub
    Private Sub 一般月_CheckedChanged(sender As Object, e As EventArgs) Handles 一般月_ch.Click
        會計月_ch.Checked = False : 一般月_ch.Checked = True : 財務收支單號_tb.Text = "" : 日期格式() : Set_賬款主單()
    End Sub
    Private Sub 選中金額計算()
        實付金額_tb.Text = "0" : 實付金額計算用_tb.Text = "0"
        For I As Integer = 0 To 採購清單_dgv.Rows.Count - 1
            If 採購清單_dgv.Rows(I).Cells("選擇").Value = True Then
                實付金額計算用_tb.Text = Val(實付金額計算用_tb.Text) + 採購清單_dgv.Rows(I).Cells("金額").Value
                實付金額_tb.Text = Val(實付金額_tb.Text) + 採購清單_dgv.Rows(I).Cells("金額").Value
            End If
        Next
        未付金額_nud.Value = Val(實付金額計算用_tb.Text) - 實付金額_nud.Value
        實付金額_tb.Text = Strings.Format(Val(實付金額_tb.Text), "#,##0")
    End Sub
    Private Sub DataGridView1_CellClick(ByVal sender As System.Object, ByVal e As DataGridViewCellEventArgs) Handles 應付供應商_dgv.CellClick
        If e.RowIndex = -1 Then : Else
            財務收支單號_tb.Text = "" : 單據編號_tb.Text = "" : 列印多選_ch.Checked = False : 實付金額_tb.Text = "0" : 實付金額_nud.Value = 0 : 未付金額_nud.Value = 0
            供應商編號_tb.Text = 應付供應商_dgv.Rows(e.RowIndex).Cells("供應商編號").Value
            供應商名稱_tb.Text = 應付供應商_dgv.Rows(e.RowIndex).Cells("供應商").Value
            Set_賬款清單() : Set_財務清單()
            For i As Integer = 0 To 採購清單_dgv.Rows.Count - 1 : 採購清單_dgv.Rows(i).Cells("選擇").Value = True : Next i : 選中金額計算()
        End If
    End Sub
    Private Sub DataGridView2_CellClick(ByVal sender As System.Object, ByVal e As DataGridViewCellEventArgs) Handles 採購清單_dgv.CellClick
        If e.RowIndex = -1 Then : Else
            If 採購清單_dgv.Rows(e.RowIndex).Cells("申請日期").Value.ToString = "" Then : Else : 單據日期_dtp.Value = 採購清單_dgv.Rows(e.RowIndex).Cells("申請日期").Value.ToString : End If
            單據編號_tb.Text = 採購清單_dgv.Rows(e.RowIndex).Cells("單據編號").Value : 財務收支單號_tb.Text = 採購清單_dgv.Rows(e.RowIndex).Cells("財務單號").Value.ToString
            For I As Integer = 0 To 採購清單_dgv.Rows.Count - 1
                If 列印多選_ch.Checked = False Then
                    採購清單_dgv.Rows(I).Cells("選擇").Value = False
                End If
                If 單據編號_tb.Text = 採購清單_dgv.Rows(I).Cells("單據編號").Value Then
                    採購清單_dgv.Rows(I).Cells("選擇").Value = True
                End If
            Next
            選中金額計算() : Set_財務清單()
            實付金額_nud.Value = 0
            For I As Integer = 0 To 對應收支單_dgv.Rows.Count - 1
                實付金額_nud.Value = 實付金額_nud.Value + 對應收支單_dgv.Rows(I).Cells("開票").Value + 對應收支單_dgv.Rows(I).Cells("付現").Value
            Next
        End If
    End Sub
    Private Sub DataGridView2_RowPostPaint(ByVal sender As Object, ByVal e As DataGridViewRowPostPaintEventArgs) Handles 採購清單_dgv.RowPostPaint
        Dim linePen As New Pen(Color.Blue, 2)
        If e.RowIndex = 採購清單_dgv.Rows.Count - 1 Then : Exit Sub
        Else
            If 採購清單_dgv(0, e.RowIndex).Value.ToString <> 採購清單_dgv(0, e.RowIndex + 1).Value.ToString Then
                Dim startX As Integer = IIf(採購清單_dgv.RowHeadersVisible, 採購清單_dgv.RowHeadersWidth, 0)
                Dim startY As Integer = e.RowBounds.Top + e.RowBounds.Height - 1
                Dim endX As Integer = startX + 採購清單_dgv.Columns.GetColumnsWidth(DataGridViewElementStates.Visible) - 採購清單_dgv.HorizontalScrollingOffset
                e.Graphics.DrawLine(linePen, startX, startY, endX, startY) : Exit Sub
            End If
        End If
    End Sub
    Private Sub Button3_Click(sender As Object, e As EventArgs) Handles 間格時間內所有帳款_bt.Click
        財務收支單號_tb.Text = "" : 供應商編號_tb.Text = "%%" : Set_賬款清單() : Set_財務清單()
    End Sub
    Private Sub NumericUpDown1_ValueChanged(sender As Object, e As EventArgs) Handles 實付金額_nud.ValueChanged
        未付金額_nud.Value = Val(實付金額計算用_tb.Text) - 實付金額_nud.Value
    End Sub
    Private Sub Button13_Click(sender As Object, e As EventArgs) Handles 全部選擇_bt.Click
        For i As Integer = 0 To 採購清單_dgv.Rows.Count - 1 : 採購清單_dgv.Rows(i).Cells("選擇").Value = True : Next i : 選中金額計算()
    End Sub
    Private Sub Button12_Click(sender As Object, e As EventArgs) Handles 全部取消_bt.Click
        For i As Integer = 0 To 採購清單_dgv.Rows.Count - 1 : 採購清單_dgv.Rows(i).Cells("選擇").Value = False : Next i : 選中金額計算()
    End Sub
    Private Sub Button4_Click(sender As Object, e As EventArgs) Handles 開立財務單據_bt.Click
        Dim 選擇判斷 As Boolean = False
        For i As Integer = 0 To 採購清單_dgv.Rows.Count - 1
            If 採購清單_dgv.Rows(i).Cells("選擇").Value = True Then
                選擇判斷 = True : Exit For
            End If
        Next i
        If 選擇判斷 = True Then
            If 非當天日期_ch.Checked = False Then : DTP = Strings.Format(Today(), "yyyy/MM/dd") : DTP1 = Strings.Format(Today(), "yyyyMMdd")
            Else : DTP1 = Strings.Format(單據日期_dtp.Value, "yyyyMMdd") : DTP = Strings.Format(單據日期_dtp.Value, "yyyy/MM/dd") : End If
            收付應沖金額 = Val(實付金額計算用_tb.Text)
            財務單申請狀態 = "應付" : 收付對應財務單號 = 財務收支單號_tb.Text
            收付對應客戶供應商編號 = 供應商編號_tb.Text
            For I As Integer = 0 To 採購清單_dgv.Rows.Count - 1
                If 採購清單_dgv.Rows(I).Cells("選擇").Value = True Then
                    PA19 = 採購清單_dgv.Rows(I).Cells("資料流水號").Value.ToString
                    SQL_應收應付單號連接暫存檔新增() : conn.Close()
                End If
            Next
            財務單具申請.ShowDialog()
            Set_賬款清單() : Set_財務清單() : 財務單具申請.Close()
            For I As Integer = 0 To 採購清單_dgv.Rows.Count - 1
                採購清單_dgv.Rows(I).Cells("選擇").Value = True
            Next
        Else
            MsgBox("最少要選擇一張單據。")
        End If
    End Sub
    Private Sub Button6_Click(sender As Object, e As EventArgs) Handles 暫時取消立帳選擇_bt.Click
        For i As Integer = 0 To 採購清單_dgv.Rows.Count - 1
            If 單據編號_tb.Text = 採購清單_dgv.Rows(i).Cells("單據編號").Value.ToString Then
                採購清單_dgv.Rows(i).Cells("應付立帳").Value = False
            End If
        Next i
    End Sub
    Private Sub TextBox6_TextChanged(sender As Object, e As EventArgs) Handles 財務收支單號_tb.TextChanged
        列印多選_ch.Checked = True
        Set_賬款清單() : For i As Integer = 0 To 採購清單_dgv.Rows.Count - 1 : 採購清單_dgv.Rows(i).Cells("選擇").Value = True : Next i : 選中金額計算()
    End Sub
    Private Sub 列印出貨單_bt_MouseEnter(sender As Object, e As EventArgs) Handles 列印應付帳款清單_bt.MouseEnter
        ToolTip1.SetToolTip(Me.列印應付帳款清單_bt, "列印帳款清單")
    End Sub
    Private Sub Button5_Click(sender As Object, e As EventArgs) Handles 列印應付帳款清單_bt.Click
        xlApp = CType(CreateObject("Excel.Application"), Application)
        xlBook = xlApp.Workbooks.Add
        xlApp.DisplayAlerts = True
        xlApp.Visible = True
        xlApp.Application.WindowState = xlMaximized
        N1 = 0
        If 採購清單_dgv.Rows.Count = 0 Then : Else
            xlSheet = NewMethod(xlBook)
            xlSheet.Cells(1, 1) = MAOJI_ERP_SYS.公司名稱_cb.Text : xlSheet.Cells(2, 1) = 開始日期_dtp.Value & " 到 " & 結束日期_dtp.Value & " 應付帳款清單"
            xlSheet.Cells(3, 1) = "單據編號" : xlSheet.Cells(3, 2) = "供應商" : xlSheet.Cells(3, 3) = "頁碼" : xlSheet.Cells(3, 4) = "品名" : xlSheet.Cells(3, 5) = "單價" : xlSheet.Cells(3, 6) = "匯率"
            xlSheet.Cells(3, 7) = "入庫" : xlSheet.Cells(3, 8) = "金額" : xlSheet.Cells(3, 9) = "採購下單" : xlSheet.Cells(3, 10) = "入庫日期" : xlSheet.Cells(3, 11) = "是否立帳"
            xlSheet.Cells(2, 7) = "合計" : xlSheet.Cells(2, 8) = "=SUBTOTAL(9,H4:H9999)"
            For i As Integer = 0 To 採購清單_dgv.Rows.Count - 1
                If 採購清單_dgv.Rows(i).Cells("選擇").Value = True Then
                    xlSheet.Cells(N1 + 4, 1) = 採購清單_dgv.Rows(i).Cells("單據編號").Value : xlSheet.Cells(N1 + 4, 2) = 採購清單_dgv.Rows(i).Cells("供應商").Value
                    xlSheet.Cells(N1 + 4, 3) = 採購清單_dgv.Rows(i).Cells("頁碼").Value : xlSheet.Cells(N1 + 4, 4) = 採購清單_dgv.Rows(i).Cells("品名").Value
                    xlSheet.Cells(N1 + 4, 5) = 採購清單_dgv.Rows(i).Cells("單價").Value : xlSheet.Cells(N1 + 4, 6) = 採購清單_dgv.Rows(i).Cells("匯率").Value
                    xlSheet.Cells(N1 + 4, 7) = 採購清單_dgv.Rows(i).Cells("入庫").Value : xlSheet.Cells(N1 + 4, 8) = 採購清單_dgv.Rows(i).Cells("金額").Value
                    xlSheet.Cells(N1 + 4, 9) = 採購清單_dgv.Rows(i).Cells("採購下單").Value : xlSheet.Cells(N1 + 4, 10) = 採購清單_dgv.Rows(i).Cells("入庫日期").Value
                    If 採購清單_dgv.Rows(i).Cells("應付立帳").Value = True Then : PA1 = "YES" : Else : PA1 = "NO" : End If
                    xlSheet.Cells(N1 + 4, 11) = PA1
                    N1 += 1
                End If
            Next i
            N1 += 4
            AA(xlApp, xlSheet)
        End If

        xlSheet.PageSetup.PrintArea = ""
        xlApp.Cells.Select()
        xlSheet.Range("B1").Select()
        xlApp.Application.WindowState = xlMinimized
        xlSheet.Cells.Select()
        MsgBox("列印完成。")
    End Sub
    Private Shared Function NewMethod(xlBook As Workbook) As Worksheet
        Return CType(xlBook.Worksheets.Add, Worksheet)
    End Function
    Private Sub AA(ByVal myExcel As Application, ByVal xlSheet As Worksheet)
        xlSheet.Cells.Select()
        With myExcel.Selection.Font : .Name = "微軟正黑體" : .Size = 10 : .Strikethrough = False : .Superscript = False : .Subscript = False : .OutlineFont = False : .Shadow = False
            .Underline = xlUnderlineStyleNone : .ThemeColor = xlThemeColorLight1 : .TintAndShade = 0 : .ThemeFont = xlThemeFontNone : End With

        xlSheet.Columns("A:A").Select : myExcel.Selection.ColumnWidth = 18 : xlSheet.Columns("B:B").Select : myExcel.Selection.ColumnWidth = 10
        xlSheet.Columns("C:C").Select : myExcel.Selection.ColumnWidth = 9 : xlSheet.Columns("D:D").Select : myExcel.Selection.ColumnWidth = 30
        xlSheet.Columns("E:H").Select : myExcel.Selection.NumberFormatLocal = "#,##0;[紅色]-#,##0"
        xlSheet.Columns("F:F").Select : myExcel.Selection.NumberFormatLocal = "#,##0.000;[紅色]-#,##0.000"
        xlSheet.Columns("E:H").Select : myExcel.Selection.ColumnWidth = 7 : xlSheet.Columns("I:J").Select : myExcel.Selection.ColumnWidth = 10
        xlSheet.Columns("K:K").Select : myExcel.Selection.ColumnWidth = 8

        xlSheet.Rows("1:1").Select
        With myExcel.Selection.Font : .Name = "微軟正黑體" : .Size = 22 : .Strikethrough = False : .Superscript = False : .Subscript = False : .OutlineFont = False : .Shadow = False
            .Underline = xlUnderlineStyleNone : .ThemeColor = xlThemeColorLight1 : .TintAndShade = 0 : .ThemeFont = xlThemeFontNone : End With
        xlSheet.Rows("2:2").Select
        With myExcel.Selection.Font : .Name = "微軟正黑體" : .Size = 18 : .Strikethrough = False : .Superscript = False : .Subscript = False : .OutlineFont = False : .Shadow = False
            .Underline = xlUnderlineStyleNone : .ThemeColor = xlThemeColorLight1 : .TintAndShade = 0 : .ThemeFont = xlThemeFontNone : End With
        xlSheet.Rows("3:3").Select
        With myExcel.Selection : .HorizontalAlignment = xlCenter : .VerticalAlignment = xlCenter : .WrapText = False : .Orientation = 0 : .AddIndent = False : .IndentLevel = 0
            .ShrinkToFit = False : .ReadingOrder = xlContext : .MergeCells = False : End With

        xlSheet.Rows("4:4").Select : myExcel.ActiveWindow.FreezePanes = True : xlSheet.Rows("3:3").Select : myExcel.Selection.AutoFilter
        xlSheet.Rows("3:3").Select : myExcel.Selection.RowHeight = 25
        With myExcel.Selection : .HorizontalAlignment = xlCenter : .VerticalAlignment = xlTop : .WrapText = False : .Orientation = 0 : .AddIndent = False : .IndentLevel = 0
            .ShrinkToFit = False : .ReadingOrder = xlContext : .MergeCells = False : End With

        xlSheet.Range("H2:I2").Select()
        With myExcel.Selection : .HorizontalAlignment = xlCenter : .VerticalAlignment = xlCenter : .WrapText = False : .Orientation = 0 : .AddIndent = False : .IndentLevel = 0
            .ShrinkToFit = False : .ReadingOrder = xlContext : .MergeCells = False : End With : myExcel.Selection.Merge

        xlSheet.Range("G2:I2").Select()
        With myExcel.Selection.Font : .Name = "微軟正黑體" : .Size = 10 : .Strikethrough = False : .Superscript = False : .Subscript = False : .OutlineFont = False : .Shadow = False
            .Underline = xlUnderlineStyleNone : .ThemeColor = xlThemeColorLight1 : .TintAndShade = 0 : .ThemeFont = xlThemeFontNone : End With

        xlSheet.Range("A1:K1").Select()
        With myExcel.Selection : .HorizontalAlignment = xlCenter : .VerticalAlignment = xlCenter : .WrapText = False : .Orientation = 0 : .AddIndent = False : .IndentLevel = 0
            .ShrinkToFit = False : .ReadingOrder = xlContext : .MergeCells = False : End With : myExcel.Selection.Merge
        xlSheet.Range("A2:F2").Select()

        With myExcel.Selection : .HorizontalAlignment = xlRight : .VerticalAlignment = xlCenter : .WrapText = False : .Orientation = 0 : .AddIndent = False : .IndentLevel = 0
            .ShrinkToFit = False : .ReadingOrder = xlContext : .MergeCells = False : End With : myExcel.Selection.Merge

        xlSheet.Range("L10").Select() : myExcel.ActiveWindow.DisplayGridlines = False

        xlSheet.Range("G2").Select()
        With myExcel.Selection : .HorizontalAlignment = xlCenter : .VerticalAlignment = xlCenter : .WrapText = False : .Orientation = 0 : .AddIndent = False : .IndentLevel = 0
            .ShrinkToFit = False : .ReadingOrder = xlContext : .MergeCells = False : End With

        xlSheet.Range("A3:K" & N1).Select()
        myExcel.Selection.Borders(xlDiagonalDown).LineStyle = xlNone : myExcel.Selection.Borders(xlDiagonalUp).LineStyle = xlNone
        With myExcel.Selection.Borders(xlEdgeLeft) : .LineStyle = xlContinuous : .ColorIndex = 0 : .TintAndShade = 0 : .Weight = xlThin : End With
        With myExcel.Selection.Borders(xlEdgeTop) : .LineStyle = xlContinuous : .ColorIndex = 0 : .TintAndShade = 0 : .Weight = xlThin : End With
        With myExcel.Selection.Borders(xlEdgeBottom) : .LineStyle = xlContinuous : .ColorIndex = 0 : .TintAndShade = 0 : .Weight = xlThin : End With
        With myExcel.Selection.Borders(xlEdgeRight) : .LineStyle = xlContinuous : .ColorIndex = 0 : .TintAndShade = 0 : .Weight = xlThin : End With
        With myExcel.Selection.Borders(xlInsideVertical) : .LineStyle = xlContinuous : .ColorIndex = 0 : .TintAndShade = 0 : .Weight = xlThin : End With
        With myExcel.Selection.Borders(xlInsideHorizontal) : .LineStyle = xlContinuous : .ColorIndex = 0 : .TintAndShade = 0 : .Weight = xlThin : End With
    End Sub
End Class