﻿Option Strict Off
Imports Microsoft.Office.Interop.Excel.XlUnderlineStyle
Imports Microsoft.Office.Interop.Excel.Constants
Imports Microsoft.Office.Interop.Excel.XlBordersIndex
Imports Microsoft.Office.Interop.Excel.XlLineStyle
Imports Microsoft.Office.Interop.Excel.XlBorderWeight
Imports Microsoft.Office.Interop.Excel.XlThemeFont
Imports Microsoft.Office.Interop.Excel.XlThemeColor
Imports Microsoft.Office.Interop.Excel.XlWindowState
Imports Microsoft.Office.Interop.Excel
Imports System.Windows.Forms.VisualStyles.VisualStyleElement
Public Class 業務佣金計算
    ReadOnly ds As New DataSet
    Dim 新項次 As String
    Dim xlApp As Application : Dim xlBook As Workbook : Dim xlSheet As Worksheet : Dim N1 As Integer
    Private Sub Set_業務佣金清單()
        佣金明細_dgv.DataSource = Nothing : ds.Clear()
        佣金明細_dgv.ColumnHeadersHeightSizeMode = DataGridViewColumnHeadersHeightSizeMode.EnableResizing
        佣金明細_dgv.ColumnHeadersHeight = 25
        佣金明細_dgv.AllowUserToAddRows = False
        佣金明細_dgv.ClipboardCopyMode = DataGridViewClipboardCopyMode.EnableWithoutHeaderText
        佣金明細_dgv.MultiSelect = True
        SQL_業務佣金計算清單()
        da.Fill(ds) : 佣金明細_dgv.DataSource = ds.Tables(0) : conn.Close()

        佣金明細_dgv.Columns(0).FillWeight = 100 : 佣金明細_dgv.Columns(1).FillWeight = 80 : 佣金明細_dgv.Columns(2).FillWeight = 80 : 佣金明細_dgv.Columns(3).FillWeight = 250
        佣金明細_dgv.Columns(4).FillWeight = 80 : 佣金明細_dgv.Columns(5).FillWeight = 80 : 佣金明細_dgv.Columns(6).FillWeight = 80 : 佣金明細_dgv.Columns(7).FillWeight = 80
        佣金明細_dgv.Columns(8).FillWeight = 80 : 佣金明細_dgv.Columns(9).FillWeight = 60 : 佣金明細_dgv.Columns(10).FillWeight = 60 : 佣金明細_dgv.Columns(11).Visible = False

        佣金明細_dgv.Columns(4).DefaultCellStyle.Format = "#,##0" : 佣金明細_dgv.Columns(5).DefaultCellStyle.Format = "#,##0"
        佣金明細_dgv.Columns(7).DefaultCellStyle.Format = "#,##0.0" : 佣金明細_dgv.Columns(8).DefaultCellStyle.Format = "#,##0"
        佣金明細_dgv.Columns(0).DefaultCellStyle.Alignment = DataGridViewContentAlignment.MiddleCenter : 佣金明細_dgv.Columns(0).HeaderCell.Style.Alignment = DataGridViewContentAlignment.MiddleCenter
        佣金明細_dgv.Columns(1).DefaultCellStyle.Alignment = DataGridViewContentAlignment.MiddleCenter : 佣金明細_dgv.Columns(1).HeaderCell.Style.Alignment = DataGridViewContentAlignment.MiddleCenter
        佣金明細_dgv.Columns(2).DefaultCellStyle.Alignment = DataGridViewContentAlignment.MiddleCenter : 佣金明細_dgv.Columns(2).HeaderCell.Style.Alignment = DataGridViewContentAlignment.MiddleCenter
        佣金明細_dgv.Columns(4).DefaultCellStyle.Alignment = DataGridViewContentAlignment.MiddleCenter : 佣金明細_dgv.Columns(4).HeaderCell.Style.Alignment = DataGridViewContentAlignment.MiddleCenter
        佣金明細_dgv.Columns(5).DefaultCellStyle.Alignment = DataGridViewContentAlignment.MiddleCenter : 佣金明細_dgv.Columns(5).HeaderCell.Style.Alignment = DataGridViewContentAlignment.MiddleCenter
        佣金明細_dgv.Columns(6).DefaultCellStyle.Alignment = DataGridViewContentAlignment.MiddleCenter : 佣金明細_dgv.Columns(6).HeaderCell.Style.Alignment = DataGridViewContentAlignment.MiddleCenter
        佣金明細_dgv.Columns(7).DefaultCellStyle.Alignment = DataGridViewContentAlignment.MiddleCenter : 佣金明細_dgv.Columns(7).HeaderCell.Style.Alignment = DataGridViewContentAlignment.MiddleCenter
        佣金明細_dgv.Columns(8).DefaultCellStyle.Alignment = DataGridViewContentAlignment.MiddleCenter : 佣金明細_dgv.Columns(8).HeaderCell.Style.Alignment = DataGridViewContentAlignment.MiddleCenter
        佣金合計_tb.Text = "0"
        For I As Integer = 0 To 9 : 佣金明細_dgv.Columns(I).ReadOnly = True : Next
        For I As Integer = 0 To 佣金明細_dgv.Rows.Count - 1
            If 佣金明細_dgv.Rows(I).Cells("已立帳").Value.ToString = "" Then : 佣金明細_dgv.Rows(I).Cells("已立帳").Value = False : End If
            佣金明細_dgv.Rows(I).Cells("選擇").Value = False : 佣金合計_tb.Text = Val(佣金合計_tb.Text) + 佣金明細_dgv.Rows(I).Cells("佣金").Value
        Next
        佣金合計_tb.Text = Strings.Format(Val(佣金合計_tb.Text), "#,##0")
    End Sub
    Private Sub ComboBox2下拉表單資料載入()
        SQL_銷售業務人員清單()
        業務_cb.Items.Clear() : While (dr.Read()) : 業務_cb.Items.Add(dr("業務")) : End While : conn.Close()
    End Sub
    Private Sub ComboBox1下拉表單資料載入()
        SQL_會計科目_第一階_不含流動票務()
        會科第一層_cb.Items.Clear() : 會科第一層編號_cb.Items.Clear()
        While (dr.Read()) : 會科第一層_cb.Items.Add(dr("第一階")) : 會科第一層編號_cb.Items.Add(dr("編號")) : End While : conn.Close()
    End Sub
    Private Sub ComboBox3下拉表單資料載入()
        PA = 會科第一層編號_cb.Text : SQL_會計科目_第二階_不含流動票務()
        會科第二層_cb.Items.Clear() : 會科第二層編號_cb.Items.Clear()
        While (dr.Read()) : 會科第二層_cb.Items.Add(dr("第二階")) : 會科第二層編號_cb.Items.Add(dr("編號")) : End While : conn.Close() : PA = ""
    End Sub
    Private Sub ComboBox6下拉表單資料載入()
        PA = 會科第二層編號_cb.Text : SQL_會計科目_第三階_不含流動票務()
        會計科目_cb.Items.Clear() : 會計科目編號_cb.Items.Clear()
        While (dr.Read()) : 會計科目_cb.Items.Add(dr("會計科目")) : 會計科目編號_cb.Items.Add(dr("編號")) : End While : conn.Close()
        If 會計科目_cb.Items.Count <> 0 Then : 會計科目_cb.SelectedIndex = 0 : End If
    End Sub
    Private Sub 日期格式()
        If 會計月_ch.Checked = True Then
            '-------------日期一----------------------------------------------------------------------------------------
            DTP = Strings.Left(Strings.Format(開始日期_dtp.Value, "yyyy/MM/dd"), 8) & "01" : 開始日期_dtp.Value = DTP
            開始日期_dtp.Value = 開始日期_dtp.Value.AddMonths(-1)
            DTP = Strings.Left(Strings.Format(開始日期_dtp.Value, "yyyy/MM/dd"), 8) & "26" : 開始日期_dtp.Value = DTP
            '-------------日期二----------------------------------------------------------------------------------------
            DTP = Strings.Left(Strings.Format(結束日期_dtp.Value, "yyyy/MM/dd"), 8) & "25" : 結束日期_dtp.Value = DTP
        Else
            '-------------日期一----------------------------------------------------------------------------------------
            開始日期_dtp.Value = 開始日期_dtp.Value.AddMonths(1)
            DTP = Strings.Left(Strings.Format(開始日期_dtp.Value, "yyyy/MM/dd"), 8) & "01" : 開始日期_dtp.Value = DTP
            '-------------日期二----------------------------------------------------------------------------------------
            DTP = Strings.Left(Strings.Format(結束日期_dtp.Value, "yyyy/MM/dd"), 8) & "01" : 結束日期_dtp.Value = DTP
            結束日期_dtp.Value = 結束日期_dtp.Value.AddMonths(1) : 結束日期_dtp.Value = 結束日期_dtp.Value.AddDays(-1)
        End If
    End Sub
    Private Sub 業務佣金計算_Load(sender As Object, e As EventArgs) Handles MyBase.Load
        Me.MdiParent = MAOJI_ERP_SYS : Me.WindowState = 2 : Me.AutoScroll = True
        會計科目編號_cb.Visible = False : 新編號_tb.Visible = False : 中間日期_dtp.Visible = False
    End Sub
    Private Sub 介面開啟_Shown(sender As Object, e As EventArgs) Handles MyBase.Shown
        計算分流.Enabled = True
    End Sub
    Private Sub 計算分流_Tick(sender As Object, e As EventArgs) Handles 計算分流.Tick
        ComboBox1下拉表單資料載入() : ComboBox3下拉表單資料載入() : ComboBox6下拉表單資料載入() : ComboBox2下拉表單資料載入() : 業務_cb.SelectedIndex = 0 : 日期格式() : Set_業務佣金清單()
        計算分流.Enabled = False
    End Sub
    Private Sub 介面關閉_Closed(sender As Object, e As EventArgs) Handles MyBase.Closed
        MyModule1.虛擬桌面開啟()
    End Sub
    Private Sub DataGridView1_CellClick(ByVal sender As System.Object, ByVal e As DataGridViewCellEventArgs) Handles 佣金明細_dgv.CellClick
        If e.RowIndex = -1 Then : Else
            單據編號_tb.Text = 佣金明細_dgv.Rows(e.RowIndex).Cells("單據編號").Value
        End If
    End Sub
    Private Sub DataGridView1_RowPostPaint(ByVal sender As Object, ByVal e As DataGridViewRowPostPaintEventArgs) Handles 佣金明細_dgv.RowPostPaint
        Dim linePen As New Pen(Color.Blue, 2)
        If e.RowIndex = 佣金明細_dgv.Rows.Count - 1 Then : Exit Sub
        Else
            If 佣金明細_dgv(0, e.RowIndex).Value.ToString <> 佣金明細_dgv(0, e.RowIndex + 1).Value.ToString Then
                Dim startX As Integer = IIf(佣金明細_dgv.RowHeadersVisible, 佣金明細_dgv.RowHeadersWidth, 0)
                Dim startY As Integer = e.RowBounds.Top + e.RowBounds.Height - 1
                Dim endX As Integer = startX + 佣金明細_dgv.Columns.GetColumnsWidth(DataGridViewElementStates.Visible) - 佣金明細_dgv.HorizontalScrollingOffset
                e.Graphics.DrawLine(linePen, startX, startY, endX, startY) : Exit Sub
            End If
        End If
    End Sub
    Private Sub ComboBox5_SelectedIndexChanged(sender As Object, e As EventArgs) Handles 會科第一層_cb.TextChanged
        會科第一層編號_cb.SelectedIndex = 會科第一層_cb.SelectedIndex : 會科關鍵字_tb.Text = "" : ComboBox3下拉表單資料載入() : ComboBox6下拉表單資料載入()
    End Sub
    Private Sub ComboBox1_SelectedIndexChanged(sender As Object, e As EventArgs) Handles 會科第一層編號_cb.TextChanged
        會科第一層_cb.SelectedIndex = 會科第一層編號_cb.SelectedIndex : ComboBox3下拉表單資料載入() : ComboBox6下拉表單資料載入()
    End Sub
    Private Sub ComboBox3_SelectedIndexChanged(sender As Object, e As EventArgs) Handles 會科第二層_cb.TextChanged
        會科第二層編號_cb.SelectedIndex = 會科第二層_cb.SelectedIndex : ComboBox6下拉表單資料載入()
    End Sub
    Private Sub ComboBox4_SelectedIndexChanged(sender As Object, e As EventArgs) Handles 會科第二層編號_cb.TextChanged
        會科第二層_cb.SelectedIndex = 會科第二層編號_cb.SelectedIndex : ComboBox6下拉表單資料載入()
    End Sub
    Private Sub ComboBox7_SelectedIndexChanged(sender As Object, e As EventArgs) Handles 會計科目_cb.SelectedIndexChanged
        會計科目編號_cb.SelectedIndex = 會計科目_cb.SelectedIndex
    End Sub
    Private Sub ComboBox6_SelectedIndexChanged(sender As Object, e As EventArgs) Handles 會計科目編號_cb.SelectedIndexChanged
        會計科目_cb.SelectedIndex = 會計科目編號_cb.SelectedIndex
    End Sub
    Private Sub TextBox9_TextChanged(sender As Object, e As EventArgs) Handles 會科關鍵字_tb.TextChanged
        PA = 會科關鍵字_tb.Text : SQL_會計科目_關鍵字_不含流動票務()
        會計科目_cb.Items.Clear() : 會計科目編號_cb.Items.Clear() : While (dr.Read()) : 會計科目_cb.Items.Add(dr("會計科目")) : 會計科目編號_cb.Items.Add(dr("編號")) : End While : conn.Close()
        If 會計科目_cb.Items.Count <> 0 Then : 會計科目_cb.SelectedIndex = 0 : End If : PA = ""
    End Sub
    Private Sub Button1_Click(sender As Object, e As EventArgs) Handles 上個月_bt.Click
        If 會計月_ch.Checked = True Then
            中間日期_dtp.Value = 中間日期_dtp.Value.AddMonths(-1)
            開始日期_dtp.Value = 中間日期_dtp.Value
            結束日期_dtp.Value = 中間日期_dtp.Value
        Else
            中間日期_dtp.Value = 中間日期_dtp.Value.AddMonths(-1)
            開始日期_dtp.Value = 中間日期_dtp.Value.AddMonths(-1)
            結束日期_dtp.Value = 中間日期_dtp.Value
        End If
        日期格式() : Set_業務佣金清單()
    End Sub
    Private Sub Button2_Click(sender As Object, e As EventArgs) Handles 下個月_bt.Click
        If 會計月_ch.Checked = True Then
            中間日期_dtp.Value = 中間日期_dtp.Value.AddMonths(1)
            開始日期_dtp.Value = 中間日期_dtp.Value
            結束日期_dtp.Value = 中間日期_dtp.Value
        Else
            中間日期_dtp.Value = 中間日期_dtp.Value.AddMonths(1)
            開始日期_dtp.Value = 中間日期_dtp.Value.AddMonths(-1)
            結束日期_dtp.Value = 中間日期_dtp.Value
        End If
        日期格式() : Set_業務佣金清單()
    End Sub
    Private Sub 會計月_CheckedChanged(sender As Object, e As EventArgs) Handles 會計月_ch.Click
        會計月_ch.Checked = True : 一般月_ch.Checked = False : 日期格式() : Set_業務佣金清單()
    End Sub
    Private Sub 一般月_CheckedChanged(sender As Object, e As EventArgs) Handles 一般月_ch.Click
        會計月_ch.Checked = False : 一般月_ch.Checked = True : 日期格式() : Set_業務佣金清單()
    End Sub
    Private Sub ComboBox2_SelectedIndexChanged(sender As Object, e As EventArgs) Handles 業務_cb.SelectedIndexChanged
        Set_業務佣金清單()
    End Sub
    Private Sub Button3_Click(sender As Object, e As EventArgs) Handles 暫時取消立帳選擇_bt.Click
        For i As Integer = 0 To 佣金明細_dgv.Rows.Count - 1
            If 單據編號_tb.Text = 佣金明細_dgv.Rows(i).Cells("單據編號").Value.ToString Then
                佣金明細_dgv.Rows(i).Cells("選擇").Value = True
            End If
        Next i
    End Sub
    Private Sub Button13_Click(sender As Object, e As EventArgs) Handles 全部選擇_bt.Click
        For i As Integer = 0 To 佣金明細_dgv.Rows.Count - 1 : 佣金明細_dgv.Rows(i).Cells("選擇").Value = True : Next i
    End Sub
    Private Sub Button12_Click(sender As Object, e As EventArgs) Handles 全部取消_bt.Click
        For i As Integer = 0 To 佣金明細_dgv.Rows.Count - 1 : 佣金明細_dgv.Rows(i).Cells("選擇").Value = False : Next i
    End Sub
    Private Sub Button6_Click(sender As Object, e As EventArgs) Handles 暫時勾選立帳選擇_bt.Click
        For i As Integer = 0 To 佣金明細_dgv.Rows.Count - 1
            If 單據編號_tb.Text = 佣金明細_dgv.Rows(i).Cells("單據編號").Value.ToString Then
                佣金明細_dgv.Rows(i).Cells("已立帳").Value = False
            End If
        Next i
    End Sub
    Private Sub Set_日期格式轉換()
        If 非當天日期_ch.Checked = False Then : DTP = Strings.Format(Today(), "yyyy/MM/dd") : DTP1 = Strings.Format(Today(), "yyyyMMdd")
        Else : DTP1 = Strings.Format(立帳日期_dtp.Value, "yyyyMMdd") : DTP = Strings.Format(立帳日期_dtp.Value, "yyyy/MM/dd") : End If
    End Sub
    Private Sub Button4_Click(sender As Object, e As EventArgs) Handles 開立收支單_bt.Click
        Dim 確認 As Boolean = False
        If 會計科目編號_cb.Text = "" Then : MsgBox("請選擇會計科目。")
        Else
            For i As Integer = 0 To 佣金明細_dgv.Rows.Count - 1
                If 佣金明細_dgv.Rows(i).Cells("選擇").Value = True Then
                    確認 = True : Exit For
                End If
            Next
            If 確認 = False Then : MsgBox("沒有選擇任何一筆要轉收支帳的佣金明細。")
            Else
                Dim NUM1 As Integer : Set_日期格式轉換()
                For ii As Integer = 1 To 999
                    NUM1 = 0 + ii
                    If NUM1 < 10 Then : 新編號_tb.Text = "OE-" & DTP1 & "-00" & NUM1
                    ElseIf NUM1 > 9 And NUM1 < 100 Then : 新編號_tb.Text = "OE-" & DTP1 & "-0" & NUM1
                    ElseIf NUM1 > 99 Then : 新編號_tb.Text = "OE-" & DTP1 & "-" & NUM1 : End If : PA = 新編號_tb.Text
                    SQL_營運成本收支單申請_支付單號流水號()
                    If dr.Read() Then : Else : ii = 999 : End If
                Next
                SQL_營運成本控制表新增()
                For i As Integer = 0 To 佣金明細_dgv.Rows.Count - 1
                    資料數 = 佣金明細_dgv.Rows.Count : MyModule1.進度條()
                    If 佣金明細_dgv.Rows(i).Cells("已立帳").Value = False Then
                        If 佣金明細_dgv.Rows(i).Cells("選擇").Value = True Then
                            SQL_營運成本明細表項次新增查詢()
                            If dr.Read() Then : 新項次 = dr("項次") : Else : 新項次 = "00" : End If : conn.Close() : NUM1 = Double.Parse(新項次) + 1
                            If NUM1 < 10 Then : 新項次 = "0" & NUM1
                            ElseIf NUM1 > 9 And NUM1 < 100 Then : 新項次 = NUM1 : End If

                            PA1 = 新編號_tb.Text : PA2 = 新項次 : PA3 = 會計科目編號_cb.Text : PA6 = 佣金明細_dgv.Rows(i).Cells("資料流水號").Value
                            PA4 = 佣金明細_dgv.Rows(i).Cells("簡稱").Value & "-" & 佣金明細_dgv.Rows(i).Cells("品名").Value & "-" & 佣金明細_dgv.Rows(i).Cells("業務").Value & "業務佣金"
                            NU1 = 佣金明細_dgv.Rows(i).Cells("佣金").Value : PA5 = "" : NU2 = 0 : NU3 = 0 : NU4 = 0 : PA6 = "付現" : PA7 = gUserName
                            SQL_營運成本明細表新增() : SQL_業務佣金計算表_轉立收支單修改()
                        End If
                    End If
                Next i : MAOJI_ERP_SYS.ToolStripProgressBar1.Value = 0 : 最終數 = 0
                MsgBox("財務收支單(傳票)申請完成，請通知主管審核。") : Set_業務佣金清單()
            End If
        End If
    End Sub
    Private Sub 列印()
        N1 = 0
        xlSheet.Cells(1, 1) = 開始日期_dtp.Value & " 到 " & 結束日期_dtp.Value & " " & 業務_cb.Text & " 業務佣金費用"
        xlSheet.Cells(2, 1) = "單據編號" : xlSheet.Cells(2, 2) = "出貨日期" : xlSheet.Cells(2, 3) = "客戶" : xlSheet.Cells(2, 4) = "品名" : xlSheet.Cells(2, 5) = "售價"
        xlSheet.Cells(2, 6) = "數量" : xlSheet.Cells(2, 7) = "比例" : xlSheet.Cells(2, 8) = "佣金"
        For i As Integer = 0 To 佣金明細_dgv.Rows.Count - 1
            xlSheet.Cells(i + 3, 1) = 佣金明細_dgv.Rows(i).Cells("單據編號").Value : xlSheet.Cells(i + 3, 2) = 佣金明細_dgv.Rows(i).Cells("出貨日期").Value
            xlSheet.Cells(i + 3, 3) = 佣金明細_dgv.Rows(i).Cells("簡稱").Value : xlSheet.Cells(i + 3, 4) = 佣金明細_dgv.Rows(i).Cells("品名").Value
            xlSheet.Cells(i + 3, 5) = 佣金明細_dgv.Rows(i).Cells("售價").Value : xlSheet.Cells(i + 3, 6) = 佣金明細_dgv.Rows(i).Cells("數量").Value
            xlSheet.Cells(i + 3, 7) = 佣金明細_dgv.Rows(i).Cells("比例").Value : xlSheet.Cells(i + 3, 8) = 佣金明細_dgv.Rows(i).Cells("佣金").Value
            N1 = i + 3
        Next
        xlSheet.Cells(N1 + 2, 7) = "合計" : xlSheet.Cells(N1 + 2, 8) = "=SUM(H3:H" & N1 & ")"
    End Sub
    Private Sub Button5_Click(sender As Object, e As EventArgs) Handles 列印成EXCEL_bt.Click
        ComboBox2下拉表單資料載入()
        xlApp = CType(CreateObject("Excel.Application"), Application)
        xlBook = xlApp.Workbooks.Add
        xlApp.DisplayAlerts = True
        xlApp.Visible = True
        xlApp.Application.WindowState = xlMaximized

        For i As Integer = 1 To 業務_cb.Items.Count - 1
            業務_cb.SelectedIndex = i
            If 佣金明細_dgv.Rows.Count = 0 Then : Else
                xlSheet = NewMethod(xlBook) : xlApp.Sheets(1).Name = 業務_cb.Text : 列印() : AA(xlApp, xlSheet)
            End If
        Next

        xlSheet.PageSetup.PrintArea = ""
        xlApp.Cells.Select()
        xlSheet.Range("B1").Select()
        xlApp.Application.WindowState = xlMinimized
        xlSheet.Cells.Select()
        MsgBox("列印完成。")
    End Sub
    Private Shared Function NewMethod(xlBook As Workbook) As Worksheet
        Return CType(xlBook.Worksheets.Add, Worksheet)
    End Function
    Private Sub AA(ByVal myExcel As Application, ByVal xlSheet As Worksheet)
        xlSheet.Cells.Select()
        With myExcel.Selection.Font : .Name = "微軟正黑體" : .Size = 10 : .Strikethrough = False : .Superscript = False : .Subscript = False : .OutlineFont = False : .Shadow = False
            .Underline = xlUnderlineStyleNone : .ThemeColor = xlThemeColorLight1 : .TintAndShade = 0 : .ThemeFont = xlThemeFontNone : End With
        xlSheet.Rows("1:1").Select : myExcel.Selection.RowHeight = 25
        xlSheet.Columns("A:A").Select : myExcel.Selection.ColumnWidth = 17
        With myExcel.Selection : .HorizontalAlignment = xlCenter : .VerticalAlignment = xlCenter : .WrapText = False : .Orientation = 0 : .AddIndent = False : .IndentLevel = 0
            .ShrinkToFit = False : .ReadingOrder = xlContext : .MergeCells = False : End With
        xlSheet.Columns("B:B").Select : myExcel.Selection.ColumnWidth = 9
        With myExcel.Selection : .HorizontalAlignment = xlCenter : .VerticalAlignment = xlCenter : .WrapText = False : .Orientation = 0 : .AddIndent = False : .IndentLevel = 0
            .ShrinkToFit = False : .ReadingOrder = xlContext : .MergeCells = False : End With
        xlSheet.Columns("C:C").Select : myExcel.Selection.ColumnWidth = 9
        With myExcel.Selection : .HorizontalAlignment = xlCenter : .VerticalAlignment = xlCenter : .WrapText = False : .Orientation = 0 : .AddIndent = False : .IndentLevel = 0
            .ShrinkToFit = False : .ReadingOrder = xlContext : .MergeCells = False : End With
        xlSheet.Columns("D:D").Select : myExcel.Selection.ColumnWidth = 35
        xlSheet.Columns("E:F").Select : myExcel.Selection.NumberFormatLocal = "#,##0_ ;[紅色]-#,##0 "
        With myExcel.Selection : .HorizontalAlignment = xlRight : .VerticalAlignment = xlCenter : .WrapText = False : .Orientation = 0 : .AddIndent = False : .IndentLevel = 0
            .ShrinkToFit = False : .ReadingOrder = xlContext : .MergeCells = False : End With
        xlSheet.Columns("G:G").Select : myExcel.Selection.ColumnWidth = 6
        xlSheet.Columns("F:F").Select : myExcel.Selection.ColumnWidth = 6
        xlSheet.Columns("E:E").Select : myExcel.Selection.ColumnWidth = 10
        xlSheet.Columns("G:G").Select : myExcel.Selection.NumberFormatLocal = "#,##0.0_ ;[紅色]-#,##0.0 "
        xlSheet.Columns("H:H").Select : myExcel.Selection.ColumnWidth = 12 : myExcel.Selection.NumberFormatLocal = "#,##0_ ;[紅色]-#,##0 "
        xlSheet.Range("A1:H1").Select()
        With myExcel.Selection : .HorizontalAlignment = xlCenter : .VerticalAlignment = xlCenter : .WrapText = False : .Orientation = 0 : .AddIndent = False : .IndentLevel = 0
            .ShrinkToFit = False : .ReadingOrder = xlContext : .MergeCells = False : End With : myExcel.Selection.Merge

        xlSheet.Range("A1:H" & N1 & "").Select()
        myExcel.Selection.Borders(xlDiagonalDown).LineStyle = xlNone : myExcel.Selection.Borders(xlDiagonalUp).LineStyle = xlNone
        With myExcel.Selection.Borders(xlEdgeLeft) : .LineStyle = xlContinuous : .ColorIndex = 0 : .TintAndShade = 0 : .Weight = xlThin : End With
        With myExcel.Selection.Borders(xlEdgeTop) : .LineStyle = xlContinuous : .ColorIndex = 0 : .TintAndShade = 0 : .Weight = xlThin : End With
        With myExcel.Selection.Borders(xlEdgeBottom) : .LineStyle = xlContinuous : .ColorIndex = 0 : .TintAndShade = 0 : .Weight = xlThin : End With
        With myExcel.Selection.Borders(xlEdgeRight) : .LineStyle = xlContinuous : .ColorIndex = 0 : .TintAndShade = 0 : .Weight = xlThin : End With
        With myExcel.Selection.Borders(xlInsideVertical) : .LineStyle = xlContinuous : .ColorIndex = 0 : .TintAndShade = 0 : .Weight = xlThin : End With
        With myExcel.Selection.Borders(xlInsideHorizontal) : .LineStyle = xlContinuous : .ColorIndex = 0 : .TintAndShade = 0 : .Weight = xlThin : End With

        myExcel.ActiveWindow.DisplayGridlines = False
        xlSheet.Rows("3:3").Select : myExcel.ActiveWindow.FreezePanes = True
        xlSheet.Rows("2:2").Select : myExcel.Selection.RowHeight = 25
        With myExcel.Selection : .HorizontalAlignment = xlCenter : .VerticalAlignment = xlTop : .WrapText = False : .Orientation = 0 : .AddIndent = False
            .IndentLevel = 0 : .ShrinkToFit = False : .ReadingOrder = xlContext : .MergeCells = False : End With : myExcel.Selection.AutoFilter
    End Sub
    '-----------------------------滑鼠右鍵------------------------------------------------------------------------------------------------------------------------------------------
    Private Sub 重新整理ToolStripMenuItem_Click(sender As Object, e As EventArgs)
        ComboBox1下拉表單資料載入() : ComboBox3下拉表單資料載入() : ComboBox6下拉表單資料載入() : ComboBox2下拉表單資料載入() : 業務_cb.SelectedIndex = 0 : 日期格式() : Set_業務佣金清單()
    End Sub
    Private Sub 開立收支單_bt_MouseEnter(sender As Object, e As EventArgs) Handles 開立收支單_bt.MouseEnter
        ToolTip1.SetToolTip(Me.開立收支單_bt, "開立收支單")
    End Sub
    Private Sub 列印成EXCEL_bt_MouseEnter(sender As Object, e As EventArgs) Handles 列印成EXCEL_bt.MouseEnter
        ToolTip1.SetToolTip(Me.列印成EXCEL_bt, "列印成EXCEL")
    End Sub
End Class