﻿Option Strict Off
Public Class 現金收支單申請
    ReadOnly ds As New DataSet : ReadOnly ds1 As New DataSet
    Dim 新項次 As String : Dim NUM1 As Integer
    Private Sub Set_清單1()
        彙總_dgv.DataSource = Nothing : ds1.Clear()
        彙總_dgv.ColumnHeadersHeightSizeMode = DataGridViewColumnHeadersHeightSizeMode.EnableResizing
        彙總_dgv.ColumnHeadersHeight = 25
        彙總_dgv.AllowUserToAddRows = False
        SQL_營運成本收支單申請清單()
        da.Fill(ds1) : 彙總_dgv.DataSource = ds1.Tables(0) : conn.Close()

        彙總_dgv.Columns(0).FillWeight = 160 : 彙總_dgv.Columns(1).FillWeight = 100 : 彙總_dgv.Columns(2).FillWeight = 100 : 彙總_dgv.Columns(3).Visible = False
    End Sub
    Private Sub Set_費用清單()
        明細_dgv.DataSource = Nothing : ds.Clear()
        明細_dgv.ColumnHeadersHeightSizeMode = DataGridViewColumnHeadersHeightSizeMode.EnableResizing
        明細_dgv.ColumnHeadersHeight = 25
        明細_dgv.AllowUserToAddRows = False
        明細_dgv.RowTemplate.Height = 35
        SQL_營運成本收支單申請費用清單()
        da.Fill(ds) : 明細_dgv.DataSource = ds.Tables(0) : conn.Close()

        明細_dgv.Columns(0).Visible = False : 明細_dgv.Columns(1).FillWeight = 80 : 明細_dgv.Columns(2).FillWeight = 200 : 明細_dgv.Columns(3).FillWeight = 500
        明細_dgv.Columns(4).Visible = False : 明細_dgv.Columns(5).Visible = False : 明細_dgv.Columns(6).FillWeight = 140 : 明細_dgv.Columns(7).FillWeight = 140
        明細_dgv.Columns(8).FillWeight = 200 : 明細_dgv.Columns(9).Visible = False : 明細_dgv.Columns(10).FillWeight = 100

        明細_dgv.Columns(1).ReadOnly = True : 明細_dgv.Columns(2).ReadOnly = True : 明細_dgv.Columns(10).ReadOnly = True

        明細_dgv.Columns(4).DefaultCellStyle.Format = "#,##0" : 明細_dgv.Columns(5).DefaultCellStyle.Format = "#,##0" : 明細_dgv.Columns(6).DefaultCellStyle.Format = "#,##0"
        明細_dgv.Columns(7).DefaultCellStyle.Format = "#,##0"
        明細_dgv.Columns(1).DefaultCellStyle.Alignment = DataGridViewContentAlignment.MiddleCenter : 明細_dgv.Columns(1).HeaderCell.Style.Alignment = DataGridViewContentAlignment.MiddleCenter
        明細_dgv.Columns(2).DefaultCellStyle.Alignment = DataGridViewContentAlignment.MiddleCenter : 明細_dgv.Columns(2).HeaderCell.Style.Alignment = DataGridViewContentAlignment.MiddleCenter
        明細_dgv.Columns(4).DefaultCellStyle.Alignment = DataGridViewContentAlignment.MiddleRight : 明細_dgv.Columns(4).HeaderCell.Style.Alignment = DataGridViewContentAlignment.MiddleRight
        明細_dgv.Columns(5).DefaultCellStyle.Alignment = DataGridViewContentAlignment.MiddleRight : 明細_dgv.Columns(5).HeaderCell.Style.Alignment = DataGridViewContentAlignment.MiddleRight
        明細_dgv.Columns(6).DefaultCellStyle.Alignment = DataGridViewContentAlignment.MiddleRight : 明細_dgv.Columns(6).HeaderCell.Style.Alignment = DataGridViewContentAlignment.MiddleRight
        明細_dgv.Columns(7).DefaultCellStyle.Alignment = DataGridViewContentAlignment.MiddleRight : 明細_dgv.Columns(7).HeaderCell.Style.Alignment = DataGridViewContentAlignment.MiddleRight
        明細_dgv.Columns(10).DefaultCellStyle.Alignment = DataGridViewContentAlignment.MiddleCenter : 明細_dgv.Columns(10).HeaderCell.Style.Alignment = DataGridViewContentAlignment.MiddleCenter

        If 模式一_bt.Enabled = False Then
            明細_dgv.EditMode = DataGridViewEditMode.EditOnEnter
        Else
            明細_dgv.EditMode = DataGridViewEditMode.EditOnF2
        End If

        現金_tb.Text = "0" : 支出_bt.Text = "0" : 合計_tb.Text = "0" : 開票_tb.Text = "0" : 收票_tb.Text = "0"
        For i As Integer = 0 To 明細_dgv.Rows.Count - 1
            現金_tb.Text = Val(現金_tb.Text) + 明細_dgv.Rows(i).Cells("現金").Value : 支出_bt.Text = Val(支出_bt.Text) + 明細_dgv.Rows(i).Cells("支出").Value
            開票_tb.Text = Val(開票_tb.Text) + 明細_dgv.Rows(i).Cells("開票").Value : 收票_tb.Text = Val(收票_tb.Text) + 明細_dgv.Rows(i).Cells("收票").Value
            If 明細_dgv.Rows(i).Cells("支出").Value <> 0 And 明細_dgv.Rows(i).Cells("現金").Value = 0 Then
                明細_dgv.Rows(i).Cells("狀態").Value = "付現"
            ElseIf 明細_dgv.Rows(i).Cells("支出").Value = 0 And 明細_dgv.Rows(i).Cells("現金").Value <> 0 Then
                明細_dgv.Rows(i).Cells("狀態").Value = "收現"
            End If
        Next i
        合計_tb.Text = Val(現金_tb.Text) - Val(支出_bt.Text)
        If Val(合計_tb.Text) > 0 Then : 合計_tb.ForeColor = Color.Blue : Else : 合計_tb.ForeColor = Color.Red : End If
        現金_tb.Text = Format(Val(現金_tb.Text), "#,##0") : 支出_bt.Text = Format(Val(支出_bt.Text), "#,##0") : 合計_tb.Text = Format(Val(合計_tb.Text), "#,##0")
        開票_tb.Text = Format(Val(開票_tb.Text), "#,##0") : 收票_tb.Text = Format(Val(收票_tb.Text), "#,##0")
    End Sub
    Private Sub DataGridView1多行列貼上()
        Dim i, j As Integer : Dim pRow, pCol As Integer : Dim selectedCellCount As Integer : Dim startRow, startCol, endRow, endCol As Integer
        Dim pasteText, strline, strVal As String : Dim strlines, vals As String() : Dim pasteData(,) As String
        ' 当前单元格是否选择的判断
        If 明細_dgv.CurrentCell Is Nothing Then : Return : End If
        Dim insertRowIndex As Integer = 明細_dgv.CurrentCell.RowIndex
        ' 获取DataGridView选择区域，并计算要复制的行列开始、结束位置
        startRow = 9999 : startCol = 9999 : endRow = 0 : endCol = 0
        selectedCellCount = 明細_dgv.GetCellCount(DataGridViewElementStates.Selected)
        For i = 0 To selectedCellCount - 1
            startRow = Math.Min(明細_dgv.SelectedCells(i).RowIndex, startRow) : startCol = Math.Min(明細_dgv.SelectedCells(i).ColumnIndex, startCol)
            endRow = Math.Max(明細_dgv.SelectedCells(i).RowIndex, endRow) : endCol = Math.Max(明細_dgv.SelectedCells(i).ColumnIndex, endCol)
        Next
        ' 获取剪切板的内容，并按行分割
        pasteText = Clipboard.GetText()
        If String.IsNullOrEmpty(pasteText) Then : Return : End If
        pasteText = pasteText.Replace(vbCrLf, vbLf)
        Dim unused As String()
        ReDim unused(0) : strlines = pasteText.Split(vbLf) : pRow = strlines.Length : pCol = 0      '行数

        For Each strline In strlines

            Dim unused3 As String()
            ReDim unused3(0)
            vals = strline.Split(New Char() {vbTab, vbCr, vbNullChar, vbNullString}, 256, StringSplitOptions.RemoveEmptyEntries) ' 按Tab分割数据
            pCol = Math.Max(vals.Length, pCol) '列数
        Next
        ReDim pasteData(pRow, pCol) : pasteText = Clipboard.GetText() : pasteText = pasteText.Replace(vbCrLf, vbLf)
        Dim unused1 As String()
        ReDim unused1(0) : strlines = pasteText.Split(vbLf) : i = 1
        For Each strline In strlines
            j = 1
            Dim unused2 As String()
            ReDim unused2(0) : strline.TrimEnd(New Char() {vbLf}) : vals = strline.Split(New Char() {vbTab, vbCr, vbNullChar, vbNullString}, 256, StringSplitOptions.RemoveEmptyEntries)
            For Each strVal In vals : pasteData(i, j) = strVal : j += 1 : Next : i += 1
        Next
        Dim flag As Boolean = False
        For j = 1 To pCol : If pasteData(pRow, j) <> "" Then : flag = True : Exit For : End If : Next
        If flag = False Then : pRow = Math.Max(pRow - 1, 0) : End If
        For i = 1 To endRow - startRow + 1
            Dim row As DataGridViewRow = 明細_dgv.Rows(i + startRow - 1)
            If i <= pRow Then : For j = 1 To endCol - startCol + 1 : If j <= pCol Then : row.Cells(j + startCol - 1).Value = pasteData(i, j) : Else : Exit For : End If : Next
            Else : Exit For : End If
        Next
        'DataGridView1貼上資料後去除雙引號()
    End Sub

    Private Sub ComboBox1下拉表單資料載入()
        PA = 會科第二層編號_cb.Text : SQL_會計科目_第三階_不含流動票務()
        會計科目_cb.Items.Clear() : 會計科目編號_cb.Items.Clear()
        While (dr.Read()) : 會計科目_cb.Items.Add(dr("會計科目")) : 會計科目編號_cb.Items.Add(dr("編號")) : End While : conn.Close()
        If 會計科目_cb.Items.Count <> 0 Then : 會計科目_cb.SelectedIndex = 0 : End If
    End Sub
    Private Sub ComboBox2下拉表單資料載入()
        SQL_會計科目_第一階_不含流動票務()
        會科第一層_cb.Items.Clear() : 會科第一層編號_cb.Items.Clear()
        While (dr.Read()) : 會科第一層_cb.Items.Add(dr("第一階")) : 會科第一層編號_cb.Items.Add(dr("編號")) : End While : conn.Close()
    End Sub
    Private Sub ComboBox3下拉表單資料載入()
        PA = 會科第一層編號_cb.Text : SQL_會計科目_第二階_不含流動票務()
        會科第二層_cb.Items.Clear() : 會科第二層編號_cb.Items.Clear()
        While (dr.Read()) : 會科第二層_cb.Items.Add(dr("第二階")) : 會科第二層編號_cb.Items.Add(dr("編號")) : End While : conn.Close() : PA = ""
    End Sub
    Private Sub 營運成本支付申請_Load(sender As Object, e As EventArgs) Handles MyBase.Load
        Me.MdiParent = MAOJI_ERP_SYS : Me.WindowState = 2 : Me.AutoScroll = True
        未核准的現金收支單_rb.Checked = True : DateTimePicker2.Visible = False : 複製單據_bt.Enabled = False : 會計科目編號_cb.Visible = False
        開票_tb.Visible = False : 收票_tb.Visible = False : 模式一_bt.Enabled = False : 彙總_dgv.Visible = True
    End Sub
    Private Sub 介面開啟_Shown(sender As Object, e As EventArgs) Handles MyBase.Shown
        計算分流.Enabled = True
    End Sub
    Private Sub 計算分流_Tick(sender As Object, e As EventArgs) Handles 計算分流.Tick
        Set_清單1() : ComboBox2下拉表單資料載入()
        計算分流.Enabled = False
    End Sub
    Private Sub 介面關閉_Closed(sender As Object, e As EventArgs) Handles MyBase.Closed
        MyModule1.虛擬桌面開啟()
    End Sub
    Private Sub ComboBox5_SelectedIndexChanged(sender As Object, e As EventArgs) Handles 會科第一層_cb.TextChanged
        會科第一層編號_cb.SelectedIndex = 會科第一層_cb.SelectedIndex : 會科關鍵字_tb.Text = "" : ComboBox3下拉表單資料載入() : ComboBox1下拉表單資料載入()
    End Sub
    Private Sub ComboBox2_SelectedIndexChanged(sender As Object, e As EventArgs) Handles 會科第一層編號_cb.TextChanged
        會科第一層_cb.SelectedIndex = 會科第一層編號_cb.SelectedIndex : ComboBox3下拉表單資料載入() : ComboBox1下拉表單資料載入()
    End Sub
    Private Sub ComboBox3_SelectedIndexChanged(sender As Object, e As EventArgs) Handles 會科第二層_cb.TextChanged
        會科第二層編號_cb.SelectedIndex = 會科第二層_cb.SelectedIndex : ComboBox1下拉表單資料載入()
    End Sub
    Private Sub ComboBox4_SelectedIndexChanged(sender As Object, e As EventArgs) Handles 會科第二層編號_cb.TextChanged
        會科第二層_cb.SelectedIndex = 會科第二層編號_cb.SelectedIndex : ComboBox1下拉表單資料載入()
    End Sub
    Private Sub ComboBox1_SelectedIndexChanged(sender As Object, e As EventArgs) Handles 會計科目_cb.SelectedIndexChanged
        會計科目編號_cb.SelectedIndex = 會計科目_cb.SelectedIndex
    End Sub
    Private Sub ComboBox6_SelectedIndexChanged(sender As Object, e As EventArgs) Handles 會計科目編號_cb.SelectedIndexChanged
        會計科目_cb.SelectedIndex = 會計科目編號_cb.SelectedIndex
    End Sub
    Private Sub TextBox9_TextChanged(sender As Object, e As EventArgs) Handles 會科關鍵字_tb.TextChanged
        PA = 會科關鍵字_tb.Text : SQL_會計科目_關鍵字_不含流動票務()
        會計科目_cb.Items.Clear() : 會計科目編號_cb.Items.Clear()
        While (dr.Read()) : 會計科目_cb.Items.Add(dr("會計科目")) : 會計科目編號_cb.Items.Add(dr("編號")) : End While : conn.Close()
        If 會計科目_cb.Items.Count <> 0 Then : 會計科目_cb.SelectedIndex = 0 : End If : PA = ""
    End Sub
    Private Sub Timer1_Tick(sender As Object, e As EventArgs) Handles Timer1.Tick
        If 閃燈_lb.Visible = True Then : 閃燈_lb.Visible = False : Else : 閃燈_lb.Visible = True : End If
    End Sub
    Private Sub DataGridView1_CellContentCl(sender As Object, e As DataGridViewCellEventArgs) Handles 明細_dgv.CellEndEdit
        現金_tb.Text = "0" : 支出_bt.Text = "0" : 合計_tb.Text = "0" : 開票_tb.Text = "0" : 收票_tb.Text = "0"
        For i As Integer = 0 To 明細_dgv.Rows.Count - 1
            現金_tb.Text = Val(現金_tb.Text) + 明細_dgv.Rows(i).Cells("現金").Value : 支出_bt.Text = Val(支出_bt.Text) + 明細_dgv.Rows(i).Cells("支出").Value
            開票_tb.Text = Val(開票_tb.Text) + 明細_dgv.Rows(i).Cells("開票").Value : 收票_tb.Text = Val(收票_tb.Text) + 明細_dgv.Rows(i).Cells("收票").Value
            If 明細_dgv.Rows(i).Cells("支出").Value <> 0 And 明細_dgv.Rows(i).Cells("現金").Value = 0 Then
                明細_dgv.Rows(i).Cells("狀態").Value = "付現"
            ElseIf 明細_dgv.Rows(i).Cells("支出").Value = 0 And 明細_dgv.Rows(i).Cells("現金").Value <> 0 Then
                明細_dgv.Rows(i).Cells("狀態").Value = "收現"
            End If
        Next i
        合計_tb.Text = Val(現金_tb.Text) - Val(支出_bt.Text)
        If Val(合計_tb.Text) > 0 Then : 合計_tb.ForeColor = Color.Blue : Else : 合計_tb.ForeColor = Color.Red : End If
        現金_tb.Text = Format(Val(現金_tb.Text), "#,##0") : 支出_bt.Text = Format(Val(支出_bt.Text), "#,##0") : 合計_tb.Text = Format(Val(合計_tb.Text), "#,##0")
        開票_tb.Text = Format(Val(開票_tb.Text), "#,##0") : 收票_tb.Text = Format(Val(收票_tb.Text), "#,##0")
    End Sub
    Private Sub DataGridView2_CellClick(ByVal sender As System.Object, ByVal e As System.Windows.Forms.DataGridViewCellEventArgs) Handles 彙總_dgv.CellClick
        If e.RowIndex = -1 Then : Else
            收支單號_tb.Text = 彙總_dgv(0, e.RowIndex).Value.ToString : 單據日期_dtp.Value = 彙總_dgv(1, e.RowIndex).Value.ToString : Set_費用清單()
            申請人_tb.Text = 彙總_dgv(3, e.RowIndex).Value.ToString
            For i As Integer = 0 To 明細_dgv.Rows.Count - 1
                If 明細_dgv.Rows(i).Cells("支出").Value <> 0 And 明細_dgv.Rows(i).Cells("現金").Value = 0 Then
                    明細_dgv.Rows(i).Cells("狀態").Value = "付現"
                ElseIf 明細_dgv.Rows(i).Cells("支出").Value = 0 And 明細_dgv.Rows(i).Cells("現金").Value <> 0 Then
                    明細_dgv.Rows(i).Cells("狀態").Value = "收現"
                End If
            Next i
        End If
    End Sub
    Private Sub DataGridView1_CellClick(ByVal sender As System.Object, ByVal e As System.Windows.Forms.DataGridViewCellEventArgs) Handles 明細_dgv.CellClick
        If e.RowIndex = -1 Then : Else
            項次_tb.Text = 明細_dgv("項次", e.RowIndex).Value.ToString : 會科關鍵字_tb.Text = 明細_dgv("會計科目", e.RowIndex).Value.ToString
        End If
    End Sub
    Private Sub Set_切換格式()
        明細_dgv.DataSource = Nothing : ds.Clear() : 收支單號_tb.Text = "" : 申請人_tb.Text = "" : 項次_tb.Text = "" : 現金_tb.Text = "" : 支出_bt.Text = "" : 合計_tb.Text = ""
        開票_tb.Text = "" : 收票_tb.Text = "" : ComboBox1下拉表單資料載入() : Set_清單1()
    End Sub
    Private Sub RadioButton1_CheckedChanged(sender As Object, e As EventArgs) Handles 未核准的現金收支單_rb.Click
        未核准的現金收支單_rb.Checked = True : 作廢的現金收支單_rb.Checked = False : 已核准的現金收支單_rb.Checked = False
        申請完成_bt.Enabled = True : 複製單據_bt.Enabled = False
        開立現金收支單_bt.Enabled = True : 申請完成_bt.Enabled = True : 收支單中新增一筆空白資料_bt.Enabled = True
        刪除選中的一筆資料_bt.Enabled = True : 刪除選中的財務單_bt.Enabled = True : Set_切換格式()
    End Sub
    Private Sub RadioButton2_CheckedChanged(sender As Object, e As EventArgs) Handles 作廢的現金收支單_rb.Click
        未核准的現金收支單_rb.Checked = False : 作廢的現金收支單_rb.Checked = True : 已核准的現金收支單_rb.Checked = False
        申請完成_bt.Enabled = False : 複製單據_bt.Enabled = False
        開立現金收支單_bt.Enabled = False : 申請完成_bt.Enabled = False : 收支單中新增一筆空白資料_bt.Enabled = False
        刪除選中的一筆資料_bt.Enabled = False : 刪除選中的財務單_bt.Enabled = False : Set_切換格式()
    End Sub
    Private Sub RadioButton3_CheckedChanged(sender As Object, e As EventArgs) Handles 已核准的現金收支單_rb.Click
        If CC(28) = False Then
            未核准的現金收支單_rb.Checked = False : 作廢的現金收支單_rb.Checked = False : 已核准的現金收支單_rb.Checked = True
            申請完成_bt.Enabled = False : 複製單據_bt.Enabled = True
            開立現金收支單_bt.Enabled = False : 申請完成_bt.Enabled = False : 收支單中新增一筆空白資料_bt.Enabled = False
            刪除選中的一筆資料_bt.Enabled = False : 刪除選中的財務單_bt.Enabled = False : Set_切換格式()
        Else
            未核准的現金收支單_rb.Checked = False : 作廢的現金收支單_rb.Checked = False : 已核准的現金收支單_rb.Checked = True
            申請完成_bt.Enabled = True : 複製單據_bt.Enabled = True
            開立現金收支單_bt.Enabled = True : 申請完成_bt.Enabled = True : 收支單中新增一筆空白資料_bt.Enabled = True
            刪除選中的一筆資料_bt.Enabled = True : 刪除選中的財務單_bt.Enabled = True : Set_切換格式()
        End If
    End Sub
    Private Sub 存檔()
        PA4 = 收支單號_tb.Text
        For i As Integer = 0 To 明細_dgv.Rows.Count - 1
            資料數 = 明細_dgv.Rows.Count : MyModule1.進度條()
            PA1 = 明細_dgv.Rows(i).Cells("用途").Value : NU1 = 明細_dgv.Rows(i).Cells("支出").Value : PA2 = 明細_dgv.Rows(i).Cells("備註").Value
            PA3 = 明細_dgv.Rows(i).Cells("科目編號").Value : NU2 = 明細_dgv.Rows(i).Cells("現金").Value : NU3 = 明細_dgv.Rows(i).Cells("開票").Value
            NU4 = 明細_dgv.Rows(i).Cells("收票").Value : PA5 = 明細_dgv.Rows(i).Cells("項次").Value : PA6 = 明細_dgv.Rows(i).Cells("狀態").Value : PA7 = gUserName
            SQL_營運成本收支單申請修改() : conn.Close()
        Next : MAOJI_ERP_SYS.ToolStripProgressBar1.Value = 0 : 最終數 = 0
    End Sub
    Private Sub Button2_Click(sender As Object, e As EventArgs) Handles 申請完成_bt.Click
        Timer1.Enabled = False : 閃燈_lb.Visible = False
        開立現金收支單_bt.Enabled = True : 未核准的現金收支單_rb.Enabled = True : 作廢的現金收支單_rb.Enabled = True : 彙總_dgv.Enabled = True : 已核准的現金收支單_rb.Enabled = True
        存檔() : Set_清單1() : MsgBox("申請完成，請通知主管審核。")
    End Sub
    Private Sub Set_日期格式轉換()
        If 非當天日期_ch.Checked = False Then : DTP = Format(Today(), "yyyy/MM/dd") : DTP1 = Format(Today(), "yyyyMMdd")
        Else : DTP1 = Format(單據日期_dtp.Value, "yyyyMMdd") : DTP = Format(單據日期_dtp.Value, "yyyy/MM/dd") : End If
    End Sub
    Private Sub 開立零用金支付單()
        Dim NUM1 As Integer : Timer1.Enabled = True
        Set_日期格式轉換()
        For i As Integer = 1 To 999
            NUM1 = 0 + i
            If NUM1 < 10 Then : 收支單號_tb.Text = "OE-" & DTP1 & "-00" & NUM1
            ElseIf NUM1 > 9 And NUM1 < 100 Then : 收支單號_tb.Text = "OE-" & DTP1 & "-0" & NUM1
            ElseIf NUM1 > 99 Then : 收支單號_tb.Text = "OE-" & DTP1 & "-" & NUM1 : End If : PA = 收支單號_tb.Text
            SQL_營運成本收支單申請_支付單號流水號()
            If dr.Read() Then : Else : i = 999 : conn.Close() : End If : conn.Close()
        Next
        SQL_營運成本控制表新增() : 申請人_tb.Text = gUserName
    End Sub
    Private Sub Button1_Click(sender As Object, e As EventArgs) Handles 複製單據_bt.Click
        Set_日期格式轉換() : 開立零用金支付單() : 開立現金收支單_bt.Enabled = False : 未核准的現金收支單_rb.Enabled = False : 作廢的現金收支單_rb.Enabled = False
        已核准的現金收支單_rb.Enabled = False : 彙總_dgv.Enabled = False : 未核准的現金收支單_rb.Checked = True : 作廢的現金收支單_rb.Checked = False
        已核准的現金收支單_rb.Checked = False : 申請完成_bt.Enabled = True : 複製單據_bt.Enabled = False : 開立現金收支單_bt.Enabled = True
        申請完成_bt.Enabled = True : 收支單中新增一筆空白資料_bt.Enabled = True : 刪除選中的一筆資料_bt.Enabled = True : 刪除選中的財務單_bt.Enabled = True
        Set_清單1()
        For i As Integer = 0 To 明細_dgv.Rows.Count - 1
            PA1 = 收支單號_tb.Text : PA2 = 明細_dgv.Rows(i).Cells("項次").Value : PA3 = 明細_dgv.Rows(i).Cells("科目編號").Value : PA4 = 明細_dgv.Rows(i).Cells("用途").Value
            NU1 = 明細_dgv.Rows(i).Cells("支出").Value : PA5 = 明細_dgv.Rows(i).Cells("備註").Value : NU2 = 明細_dgv.Rows(i).Cells("現金").Value
            NU3 = 明細_dgv.Rows(i).Cells("開票").Value : NU4 = 明細_dgv.Rows(i).Cells("收票").Value : PA6 = 明細_dgv.Rows(i).Cells("狀態").Value : PA7 = gUserName
            SQL_營運成本明細表新增()
        Next : Set_費用清單() : MsgBox("複製單據開立完成。")
    End Sub
    Private Sub Button1_Click_1(sender As Object, e As EventArgs) Handles 會科修改_bt.Click
        存檔() : Set_清單1() : PA4 = 收支單號_tb.Text : PA5 = 項次_tb.Text : PA1 = 會計科目編號_cb.Text
        SQL_營運成本收支單申請_會科修改() : Set_費用清單() : conn.Close()
    End Sub
    Private Sub 模式一_bt_Click(sender As Object, e As EventArgs) Handles 模式一_bt.Click
        存檔() : Set_清單1() : 模式一_bt.Enabled = False : 模式二_bt.Enabled = True : Set_費用清單()
    End Sub
    Private Sub 模式二_bt_Click(sender As Object, e As EventArgs) Handles 模式二_bt.Click
        存檔() : Set_清單1() : 模式一_bt.Enabled = True : 模式二_bt.Enabled = False : Set_費用清單()
    End Sub
    Private Sub Button1_Click_2(sender As Object, e As EventArgs) Handles 修改申請日_bt.Click
        DTP1 = Strings.Format(單據日期_dtp.Value, "yyyy/MM/dd")
        PA4 = 收支單號_tb.Text : SQL_營運成本收支單申請_申請日期修改() : conn.Close() : Set_清單1() : Set_費用清單()
    End Sub
    Private Sub Button1_Click_3(sender As Object, e As EventArgs) Handles Button1.Click
        If 會計科目編號_cb.Text = "" Then
            MsgBox("沒有選擇要變更的目標會計。")
        Else
            存檔() : Set_清單1()
            If 明細_dgv.SelectedRows.Count > 0 Then
                Dim sb As New Text.StringBuilder()
                PA4 = 收支單號_tb.Text : PA1 = 會計科目編號_cb.Text
                For i As Integer = 0 To 明細_dgv.SelectedRows.Count - 1
                    PA5 = 明細_dgv.Rows(明細_dgv.SelectedRows.Item(i).Index).Cells("項次").Value
                    SQL_營運成本收支單申請_會科修改()
                Next i
                Set_費用清單() : conn.Close()
            End If
        End If
    End Sub
    '----------------------滑鼠右鍵--------------------------------------------------------------------------------------------------------------------------------------------------------------------
    Private Sub 重新讀取ToolStripMenuItem_Click(sender As Object, e As EventArgs)
        Set_清單1()
    End Sub

    Private Sub 開立現金收支單_bt_Click(sender As Object, e As EventArgs) Handles 開立現金收支單_bt.Click
        開立零用金支付單()
        開立現金收支單_bt.Enabled = False : 未核准的現金收支單_rb.Enabled = False : 作廢的現金收支單_rb.Enabled = False : 已核准的現金收支單_rb.Enabled = False : 彙總_dgv.Enabled = False
        明細_dgv.DataSource = Nothing : ds.Clear() : conn.Close() : Set_清單1()
    End Sub

    Private Sub 刪除選中的財務單_bt_Click(sender As Object, e As EventArgs) Handles 刪除選中的財務單_bt.Click
        Dim aa As MsgBoxResult = MsgBox("確定要刪除該筆資料?", MsgBoxStyle.OkCancel)
        If aa = MsgBoxResult.Ok Then
            PA1 = 收支單號_tb.Text : SQL_營運成本控制表刪除() : conn.Close() : SQL_營運成本明細表刪除() : conn.Close()
            收支單號_tb.Text = "" : 申請人_tb.Text = "" : 項次_tb.Text = "" : 明細_dgv.DataSource = Nothing : ds.Clear() : Set_清單1()
        End If
    End Sub

    Private Sub 收支單中新增一筆空白資料_bt_Click(sender As Object, e As EventArgs) Handles 收支單中新增一筆空白資料_bt.Click
        PA = InputBox("請輸入要新增的筆數，如只需要一筆就請直接按確認。(用數字輸入，謝謝)")
        If PA = "" Then : NU1 = 1 : Else : NU1 = PA : End If
        If 會計科目編號_cb.Text = "" Then : MsgBox("沒有選擇會計科目。")
        Else
            If 收支單號_tb.Text = "" Then : 開立零用金支付單() : End If
            For i As Integer = 1 To NU1
                Set_日期格式轉換() : 存檔() : PA = 收支單號_tb.Text
                SQL_營運成本明細表項次新增查詢()
                If dr.Read() Then : 新項次 = dr("項次") : Else : 新項次 = "00" : End If : conn.Close() : NUM1 = Double.Parse(新項次) + 1
                If NUM1 < 10 Then : 新項次 = "0" & NUM1 : ElseIf NUM1 > 9 And NUM1 < 100 Then : 新項次 = NUM1 : End If
                PA1 = 收支單號_tb.Text : PA2 = 新項次 : PA3 = 會計科目編號_cb.Text : PA4 = "" : NU1 = 0 : PA5 = "" : NU2 = 0 : NU3 = 0 : NU4 = 0 : PA6 = "" : PA7 = gUserName
                SQL_營運成本明細表新增()
                Set_費用清單()
            Next
        End If
    End Sub

    Private Sub 刪除選中的一筆資料_bt_Click(sender As Object, e As EventArgs) Handles 刪除選中的一筆資料_bt.Click
        If 項次_tb.Text = "" Then : MsgBox("未選擇需要刪除的資料。")
        Else
            PA1 = 收支單號_tb.Text : PA2 = 項次_tb.Text
            存檔() : SQL_營運成本明細表刪除單筆() : conn.Close() : Set_費用清單() : Dim NUM1 As Integer = 0
            For i As Integer = 0 To 明細_dgv.Rows.Count - 1
                NUM1 += 1 : If NUM1 < 10 Then : 新項次 = "0" & NUM1 : ElseIf NUM1 > 9 And NUM1 < 100 Then : 新項次 = NUM1 : End If
                PA1 = 新項次 : PA2 = 收支單號_tb.Text : PA3 = 明細_dgv.Rows(i).Cells("項次").Value
                SQL_營運成本明細表項次修改() : conn.Close()
            Next : Set_費用清單()
        End If
    End Sub

    Private Sub 貼上_bt_Click(sender As Object, e As EventArgs) Handles 貼上_bt.Click
        DataGridView1多行列貼上()
    End Sub
End Class