﻿Option Strict Off
Imports Microsoft.Office.Interop.Excel.XlUnderlineStyle
Imports Microsoft.Office.Interop.Excel.Constants
Imports Microsoft.Office.Interop.Excel.XlBordersIndex
Imports Microsoft.Office.Interop.Excel.XlLineStyle
Imports Microsoft.Office.Interop.Excel.XlBorderWeight
Imports Microsoft.Office.Interop.Excel.XlThemeFont
Imports Microsoft.Office.Interop.Excel.XlThemeColor
Imports Microsoft.Office.Interop.Excel.XlWindowState
Imports Microsoft.Office.Interop.Excel
Public Class 票務控制表
    ReadOnly ds As New DataSet
    Dim N1 As Integer : Dim N2 As Integer
    Dim xlApp As Application : Dim xlBook As Workbook : Dim xlSheet As Worksheet
    Private Sub Set_票務清單()
        票務清單_dgv.DataSource = Nothing : ds.Clear() : 票務清單_dgv.ColumnHeadersHeightSizeMode = DataGridViewColumnHeadersHeightSizeMode.EnableResizing : 票務清單_dgv.ColumnHeadersHeight = 40
        票務清單_dgv.AllowUserToAddRows = False : 票務清單_dgv.ClipboardCopyMode = DataGridViewClipboardCopyMode.EnableWithoutHeaderText : 票務清單_dgv.MultiSelect = True
        票務清單_dgv.RowTemplate.Height = 35
        SQL_票務控制表清單()
        da.Fill(ds) : 票務清單_dgv.DataSource = ds.Tables(0) : conn.Close()

        票務清單_dgv.Columns(0).Visible = False : 票務清單_dgv.Columns(1).Visible = False : 票務清單_dgv.Columns(2).FillWeight = 80 : 票務清單_dgv.Columns(3).Visible = False
        票務清單_dgv.Columns(4).FillWeight = 130 : 票務清單_dgv.Columns(5).FillWeight = 60 : 票務清單_dgv.Columns(6).FillWeight = 60 : 票務清單_dgv.Columns(7).Visible = False
        票務清單_dgv.Columns(8).Visible = False : 票務清單_dgv.Columns(9).Visible = False : 票務清單_dgv.Columns(10).FillWeight = 100 : 票務清單_dgv.Columns(11).FillWeight = 50
        票務清單_dgv.Columns(12).FillWeight = 85 : 票務清單_dgv.Columns(13).FillWeight = 85 : 票務清單_dgv.Columns(14).FillWeight = 85 : 票務清單_dgv.Columns(15).FillWeight = 85
        票務清單_dgv.Columns(16).FillWeight = 130 : 票務清單_dgv.Columns(17).Visible = False : 票務清單_dgv.Columns(18).FillWeight = 130 : 票務清單_dgv.Columns(19).FillWeight = 80
        票務清單_dgv.Columns(20).FillWeight = 80 : 票務清單_dgv.Columns(21).FillWeight = 120 : 票務清單_dgv.Columns(22).Visible = False : 票務清單_dgv.Columns(23).Visible = False
        票務清單_dgv.Columns(24).Visible = False : 票務清單_dgv.Columns(25).FillWeight = 60

        票務清單_dgv.Columns(5).DefaultCellStyle.Format = "#,##0" : 票務清單_dgv.Columns(6).DefaultCellStyle.Format = "#,##0"
        票務清單_dgv.Columns(0).DefaultCellStyle.Alignment = DataGridViewContentAlignment.MiddleCenter : 票務清單_dgv.Columns(0).HeaderCell.Style.Alignment = DataGridViewContentAlignment.MiddleCenter
        票務清單_dgv.Columns(1).DefaultCellStyle.Alignment = DataGridViewContentAlignment.MiddleCenter : 票務清單_dgv.Columns(1).HeaderCell.Style.Alignment = DataGridViewContentAlignment.MiddleCenter
        票務清單_dgv.Columns(2).DefaultCellStyle.Alignment = DataGridViewContentAlignment.MiddleCenter : 票務清單_dgv.Columns(2).HeaderCell.Style.Alignment = DataGridViewContentAlignment.MiddleCenter
        票務清單_dgv.Columns(5).DefaultCellStyle.Alignment = DataGridViewContentAlignment.MiddleCenter : 票務清單_dgv.Columns(5).HeaderCell.Style.Alignment = DataGridViewContentAlignment.MiddleCenter
        票務清單_dgv.Columns(6).DefaultCellStyle.Alignment = DataGridViewContentAlignment.MiddleCenter : 票務清單_dgv.Columns(6).HeaderCell.Style.Alignment = DataGridViewContentAlignment.MiddleCenter

        資料筆數_tb.Text = 票務清單_dgv.Rows.Count : 單據總和_tb.Text = "0" : 開票總和_tb.Text = "0" : 收票總和_tb.Text = "0"
        For i As Integer = 0 To 票務清單_dgv.Rows.Count - 1
            開票總和_tb.Text = Val(開票總和_tb.Text) + 票務清單_dgv.Rows(i).Cells("開票").Value : 收票總和_tb.Text = Val(收票總和_tb.Text) + 票務清單_dgv.Rows(i).Cells("收票").Value
            票務清單_dgv.Rows(i).Cells("選擇").Value = False
        Next i
        單據總和_tb.Text = Val(收票總和_tb.Text) - Val(開票總和_tb.Text)
        If Val(單據總和_tb.Text) > 0 Then : 單據總和_tb.ForeColor = Color.Blue : Else : 單據總和_tb.ForeColor = Color.Red : End If
        單據總和_tb.Text = Strings.Format(Val(單據總和_tb.Text), "#,##0") : 開票總和_tb.Text = Strings.Format(Val(開票總和_tb.Text), "#,##0")
        收票總和_tb.Text = Strings.Format(Val(收票總和_tb.Text), "#,##0")
    End Sub
    Private Sub ComboBox1下拉表單資料載入()
        SQL_票務控制表會科區分()
        區分_cb.Items.Clear() : While (dr.Read()) : 區分_cb.Items.Add(dr("開票會科")) : End While : conn.Close()
    End Sub
    Private Sub ComboBox2下拉表單資料載入()
        SQL_票務控制表票況區分()
        票況_cb.Items.Clear() : While (dr.Read()) : 票況_cb.Items.Add(dr("狀態")) : End While : conn.Close()
    End Sub
    Private Sub ComboBox3下拉表單資料載入()
        SQL_票務控制表兌現科目()
        兌現科目_cb.Items.Clear() : While (dr.Read()) : 兌現科目_cb.Items.Add(dr("兌現會科")) : End While : conn.Close()
    End Sub
    Private Sub ComboBox8下拉表單資料載入_收票()
        SQL_支票收支單_兌現科目_下拉清單三()
        轉換科目_cb.Items.Clear() : 轉換科目編號_cb.Items.Clear() : While (dr.Read()) : 轉換科目_cb.Items.Add(dr("會計科目")) : 轉換科目編號_cb.Items.Add(dr("編號")) : End While : conn.Close()
    End Sub
    Private Sub ComboBox8下拉表單資料載入_開票()
        SQL_支票收支單申請_兌現科目_下拉清單二()
        轉換科目_cb.Items.Clear() : 轉換科目編號_cb.Items.Clear() : While (dr.Read()) : 轉換科目_cb.Items.Add(dr("會計科目")) : 轉換科目編號_cb.Items.Add(dr("編號")) : End While : conn.Close()
    End Sub
    Private Sub 日期格式()
        If 會計月_ch.Checked = True Then
            '-------------日期一----------------------------------------------------------------------------------------
            DTP = Strings.Left(Strings.Format(開始日期_dtp.Value, "yyyy/MM/dd"), 8) & "01" : 開始日期_dtp.Value = DTP
            開始日期_dtp.Value = 開始日期_dtp.Value.AddMonths(-1)
            DTP = Strings.Left(Strings.Format(開始日期_dtp.Value, "yyyy/MM/dd"), 8) & "26" : 開始日期_dtp.Value = DTP
            '-------------日期二----------------------------------------------------------------------------------------
            DTP = Strings.Left(Strings.Format(結束日期_dtp.Value, "yyyy/MM/dd"), 8) & "25" : 結束日期_dtp.Value = DTP
        Else
            '-------------日期一----------------------------------------------------------------------------------------
            開始日期_dtp.Value = 開始日期_dtp.Value.AddMonths(1)
            DTP = Strings.Left(Strings.Format(開始日期_dtp.Value, "yyyy/MM/dd"), 8) & "01" : 開始日期_dtp.Value = DTP
            '-------------日期二----------------------------------------------------------------------------------------
            DTP = Strings.Left(Strings.Format(結束日期_dtp.Value, "yyyy/MM/dd"), 8) & "01" : 結束日期_dtp.Value = DTP
            結束日期_dtp.Value = 結束日期_dtp.Value.AddMonths(1) : 結束日期_dtp.Value = 結束日期_dtp.Value.AddDays(-1)
        End If
    End Sub
    Private Sub 票務控制表_Load(sender As Object, e As EventArgs) Handles MyBase.Load
        Me.MdiParent = MAOJI_ERP_SYS : Me.WindowState = 2 : Me.AutoScroll = True
        作帳日期_tb.Visible = False : 出納日期_tb.Visible = False
    End Sub
    Private Sub 介面開啟_Shown(sender As Object, e As EventArgs) Handles MyBase.Shown
        計算分流.Enabled = True
    End Sub
    Private Sub 計算分流_Tick(sender As Object, e As EventArgs) Handles 計算分流.Tick
        日期選項_cb.SelectedIndex = 0
        ComboBox1下拉表單資料載入() : If 區分_cb.Items.Count <> 0 Then : 區分_cb.SelectedIndex = 0 : End If
        ComboBox2下拉表單資料載入() : If 票況_cb.Items.Count <> 0 Then : 票況_cb.SelectedIndex = 0 : End If
        ComboBox3下拉表單資料載入() : 中間日期_dtp.Visible = False
        日期格式() : Set_票務清單()
        計算分流.Enabled = False
    End Sub
    Private Sub 介面關閉_Closed(sender As Object, e As EventArgs) Handles MyBase.Closed
        MyModule1.虛擬桌面開啟()
    End Sub
    Private Sub DataGridView1_CellClick(ByVal sender As System.Object, ByVal e As System.Windows.Forms.DataGridViewCellEventArgs) Handles 票務清單_dgv.CellClick
        If e.RowIndex = -1 Then : Else
            If 區分_cb.Text = "應付票據" Then : ComboBox8下拉表單資料載入_開票()
            ElseIf 區分_cb.Text = "應收票據" Then : ComboBox8下拉表單資料載入_收票()
            Else : 轉換科目_cb.Items.Clear() : 轉換科目編號_cb.Items.Clear() : End If

            If 票務清單_dgv.Rows(e.RowIndex).Cells("選擇").Value = True Then
                票務清單_dgv.Rows(e.RowIndex).Cells("選擇").Value = False
            Else
                票務清單_dgv.Rows(e.RowIndex).Cells("選擇").Value = True
            End If

            收支單號_tb.Text = 票務清單_dgv("流水號", e.RowIndex).Value.ToString : 收票金額_nud.Text = 票務清單_dgv("收票", e.RowIndex).Value.ToString
            開票金額_nud.Text = 票務清單_dgv("開票", e.RowIndex).Value.ToString : 發票人帳號_tb.Text = 票務清單_dgv("發票人帳號", e.RowIndex).Value.ToString
            用途_tb.Text = 票務清單_dgv("用途", e.RowIndex).Value.ToString : 項次_tb.Text = 票務清單_dgv("項次", e.RowIndex).Value.ToString
            會計科目_tb.Text = 票務清單_dgv("會計科目", e.RowIndex).Value.ToString : 付款銀行_cb.Text = 票務清單_dgv("付款銀行", e.RowIndex).Value.ToString
            客供編號_tb.Text = 票務清單_dgv("倉儲單號", e.RowIndex).Value.ToString : 支票號碼_tb.Text = 票務清單_dgv("支票號碼", e.RowIndex).Value.ToString
            開票人_tb.Text = 票務清單_dgv("開票人", e.RowIndex).Value.ToString : 備註_tb.Text = 票務清單_dgv("備註", e.RowIndex).Value.ToString
            轉換科目_cb.Text = 票務清單_dgv("兌現會科", e.RowIndex).Value.ToString : 狀態_tb.Text = 票務清單_dgv("狀態", e.RowIndex).Value.ToString
            作帳日期_tb.Text = 票務清單_dgv("作帳日期", e.RowIndex).Value.ToString : 出納日期_tb.Text = 票務清單_dgv("出納日期", e.RowIndex).Value.ToString
            If 票務清單_dgv("到期日", e.RowIndex).Value.ToString = "" Then : Else : 到期日_dtp.Value = 票務清單_dgv("到期日", e.RowIndex).Value.ToString : End If
            If 票務清單_dgv("預定兌現日", e.RowIndex).Value.ToString = "" Then : Else : 預訂兌現日_dtp.Value = 票務清單_dgv("預定兌現日", e.RowIndex).Value.ToString : End If
            If 票務清單_dgv("開收票日", e.RowIndex).Value.ToString = "" Then : Else : 開收票日_dtp.Value = 票務清單_dgv("開收票日", e.RowIndex).Value.ToString : End If
            If 票務清單_dgv("託收已付日", e.RowIndex).Value.ToString = "" Then : Else : 託收已付日_dtp.Value = 票務清單_dgv("託收已付日", e.RowIndex).Value.ToString : End If
            客戶供應商資料()
        End If
    End Sub
    Private Sub 客戶供應商資料()
        PA = 客供編號_tb.Text : SQL_支票收支單客戶供應商查詢()
        If (dr.Read()) Then
            If 票況_cb.Text = "開票" Then
                客供名稱_tb.Text = dr("供應商") : conn.Close()
            Else
                客供名稱_tb.Text = dr("客戶編號")
                If 客供名稱_tb.Text = "CI00000000" Then
                    conn.Close()
                    SQL_支票收支單申請_客戶資料_零售()
                    If (dr.Read()) Then
                        客供名稱_tb.Text = dr("客戶名稱") : conn.Close()
                    End If
                Else
                    客供名稱_tb.Text = dr("客戶") : conn.Close()
                End If
            End If
        Else
            客供名稱_tb.Text = "" : conn.Close()
        End If
    End Sub
    Private Sub 上個月_Click(sender As Object, e As EventArgs) Handles 上個月_bt.Click
        If 會計月_ch.Checked = True Then
            中間日期_dtp.Value = 中間日期_dtp.Value.AddMonths(-1)
            開始日期_dtp.Value = 中間日期_dtp.Value
            結束日期_dtp.Value = 中間日期_dtp.Value
        Else
            中間日期_dtp.Value = 中間日期_dtp.Value.AddMonths(-1)
            開始日期_dtp.Value = 中間日期_dtp.Value.AddMonths(-1)
            結束日期_dtp.Value = 中間日期_dtp.Value
        End If
        日期格式() : Set_票務清單()
    End Sub
    Private Sub 下個月_Click(sender As Object, e As EventArgs) Handles 下個月_bt.Click
        If 會計月_ch.Checked = True Then
            中間日期_dtp.Value = 中間日期_dtp.Value.AddMonths(1)
            開始日期_dtp.Value = 中間日期_dtp.Value
            結束日期_dtp.Value = 中間日期_dtp.Value
        Else
            中間日期_dtp.Value = 中間日期_dtp.Value.AddMonths(1)
            開始日期_dtp.Value = 中間日期_dtp.Value.AddMonths(-1)
            結束日期_dtp.Value = 中間日期_dtp.Value
        End If
        日期格式() : Set_票務清單()
    End Sub
    Private Sub 會計月_CheckedChanged(sender As Object, e As EventArgs) Handles 會計月_ch.Click
        會計月_ch.Checked = True : 一般月_ch.Checked = False : 日期格式() : Set_票務清單()
    End Sub
    Private Sub 一般月_CheckedChanged(sender As Object, e As EventArgs) Handles 一般月_ch.Click
        會計月_ch.Checked = False : 一般月_ch.Checked = True : 日期格式() : Set_票務清單()
    End Sub
    Private Sub ComboBox2_SelectedIndexChanged(sender As Object, e As EventArgs) Handles 票況_cb.SelectedIndexChanged
        If 票況_cb.Text = "開票" Then
            已付_bt.Enabled = True : 託收_bt.Enabled = False : 退票_撤票_bt.Enabled = True : ComboBox8下拉表單資料載入_開票() : Set_票務清單()
        ElseIf 票況_cb.Text = "收票" Then
            已付_bt.Enabled = False : 託收_bt.Enabled = True : 退票_撤票_bt.Enabled = True : ComboBox8下拉表單資料載入_收票() : Set_票務清單()
        ElseIf 票況_cb.Text = "託收" Or 狀態_tb.Text = "已付" Then
            已付_bt.Enabled = False : 託收_bt.Enabled = False : 退票_撤票_bt.Enabled = True : ComboBox8下拉表單資料載入_收票() : Set_票務清單()
        Else
            已付_bt.Enabled = False : 託收_bt.Enabled = False : 退票_撤票_bt.Enabled = False : 轉換科目_cb.Items.Clear() : 轉換科目編號_cb.Items.Clear() : Set_票務清單()
        End If
    End Sub
    Private Sub ComboBox15_SelectedIndexChanged(sender As Object, e As EventArgs) Handles 日期選項_cb.SelectedIndexChanged
        Set_票務清單()
    End Sub
    Private Sub Button3_Click(sender As Object, e As EventArgs) Handles 讀取_bt.Click
        Set_票務清單()
    End Sub
    Private Sub Button7_Click(sender As Object, e As EventArgs) Handles 清除_bt.Click
        ComboBox3下拉表單資料載入() : Set_票務清單()
    End Sub
    Private Sub ComboBox3_SelectedIndexChanged(sender As Object, e As EventArgs) Handles 兌現科目_cb.SelectedIndexChanged
        Set_票務清單()
    End Sub
    Private Sub ComboBox8_SelectedIndexChanged(sender As Object, e As EventArgs) Handles 轉換科目_cb.SelectedIndexChanged
        轉換科目編號_cb.SelectedIndex = 轉換科目_cb.SelectedIndex
    End Sub
    Private Sub ComboBox10_SelectedIndexChanged(sender As Object, e As EventArgs) Handles 轉換科目編號_cb.SelectedIndexChanged
        轉換科目_cb.SelectedIndex = 轉換科目編號_cb.SelectedIndex
    End Sub
    Private Sub 轉現新增()
        PA6 = 轉換科目編號_cb.Text : PA7 = 用途_tb.Text : PA8 = 備註_tb.Text : PA9 = 作帳日期_tb.Text : PA10 = 出納日期_tb.Text
        NU1 = 開票金額_nud.Value : NU2 = 收票金額_nud.Value : PA11 = 客供編號_tb.Text : PA12 = 支票號碼_tb.Text
        DTP1 = Strings.Format(到期日_dtp.Value, "yyyy/MM/dd") : DTP2 = Strings.Format(預訂兌現日_dtp.Value, "yyyy/MM/dd")
        DTP3 = Strings.Format(開收票日_dtp.Value, "yyyy/MM/dd")
        PA13 = 付款銀行_cb.Text : PA14 = 開票人_tb.Text : PA15 = 發票人帳號_tb.Text
        SQL_營運成本明細表_轉現新增() : conn.Close()
    End Sub
    Private Sub 託收_Click(sender As Object, e As EventArgs) Handles 託收_bt.Click
        If 轉換科目編號_cb.Text = "" Then : MsgBox("沒有選擇轉換科目。") : Else
            PA1 = 收支單號_tb.Text : PA2 = 項次_tb.Text
            If 狀態_tb.Text = "收票" Then
                PA3 = "託收" : PA4 = "1" : PA5 = "0" : DTP = Strings.Format(託收已付日_dtp.Value, "yyyy/MM/dd")
            Else : PA1 = "" : PA2 = "" : Exit Sub
            End If
            If 批量操作_ch.Checked = False Then
                SQL_營運成本明細表_狀態更改() : conn.Close()
                轉現新增()
            Else
                For i As Integer = 0 To 票務清單_dgv.Rows.Count - 1
                    If 票務清單_dgv.Rows(i).Cells("選擇").Value = True Then
                        PA2 = 票務清單_dgv("項次", i).Value.ToString
                        SQL_營運成本明細表_狀態更改() : conn.Close()

                        PA6 = 轉換科目編號_cb.Text : PA7 = 票務清單_dgv("用途", i).Value.ToString : PA8 = 票務清單_dgv("備註", i).Value.ToString
                        PA9 = 票務清單_dgv("作帳日期", i).Value.ToString : PA10 = 票務清單_dgv("出納日期", i).Value.ToString : NU1 = 票務清單_dgv("開票", i).Value.ToString
                        NU2 = 票務清單_dgv("收票", i).Value.ToString : PA11 = 票務清單_dgv("倉儲單號", i).Value.ToString : PA12 = 票務清單_dgv("支票號碼", i).Value.ToString
                        DTP1 = 票務清單_dgv("到期日", i).Value.ToString : DTP2 = 票務清單_dgv("預定兌現日", i).Value.ToString : DTP3 = 票務清單_dgv("開收票日", i).Value.ToString
                        PA13 = 票務清單_dgv("付款銀行", i).Value.ToString : PA14 = 票務清單_dgv("開票人", i).Value.ToString : PA15 = 票務清單_dgv("發票人帳號", i).Value.ToString
                        SQL_營運成本明細表_轉現新增() : conn.Close()
                    End If
                Next i
            End If
            Set_票務清單() : ComboBox2下拉表單資料載入() : 狀態_tb.Text = PA3
        End If
    End Sub
    Private Sub 已付_Click(sender As Object, e As EventArgs) Handles 已付_bt.Click
        If 轉換科目編號_cb.Text = "" Then : MsgBox("沒有選擇轉換科目。") : Else
            PA1 = 收支單號_tb.Text : PA2 = 項次_tb.Text
            If 狀態_tb.Text = "開票" Then
                PA3 = "已付" : PA4 = "1" : PA5 = "0" : DTP = Strings.Format(託收已付日_dtp.Value, "yyyy/MM/dd")
            Else : PA1 = "" : PA2 = "" : Exit Sub
            End If
            If 批量操作_ch.Checked = False Then
                SQL_營運成本明細表_狀態更改() : conn.Close()
                轉現新增()
            Else
                For i As Integer = 0 To 票務清單_dgv.Rows.Count - 1
                    If 票務清單_dgv.Rows(i).Cells("選擇").Value = True Then
                        PA2 = 票務清單_dgv("項次", i).Value.ToString
                        SQL_營運成本明細表_狀態更改() : conn.Close()

                        PA6 = 轉換科目編號_cb.Text : PA7 = 票務清單_dgv("用途", i).Value.ToString : PA8 = 票務清單_dgv("備註", i).Value.ToString
                        PA9 = 票務清單_dgv("作帳日期", i).Value.ToString : PA10 = 票務清單_dgv("出納日期", i).Value.ToString : NU1 = 票務清單_dgv("開票", i).Value.ToString
                        NU2 = 票務清單_dgv("收票", i).Value.ToString : PA11 = 票務清單_dgv("倉儲單號", i).Value.ToString : PA12 = 票務清單_dgv("支票號碼", i).Value.ToString
                        DTP1 = 票務清單_dgv("到期日", i).Value.ToString : DTP2 = 票務清單_dgv("預定兌現日", i).Value.ToString : DTP3 = 票務清單_dgv("開收票日", i).Value.ToString
                        PA13 = 票務清單_dgv("付款銀行", i).Value.ToString : PA14 = 票務清單_dgv("開票人", i).Value.ToString : PA15 = 票務清單_dgv("發票人帳號", i).Value.ToString
                        SQL_營運成本明細表_轉現新增() : conn.Close()
                    End If
                Next i
            End If
            Set_票務清單() : ComboBox2下拉表單資料載入() : 狀態_tb.Text = PA3
        End If
    End Sub
    Private Sub 退票_撤票_Click(sender As Object, e As EventArgs) Handles 退票_撤票_bt.Click
        If 狀態_tb.Text = "" Then
            MsgBox("做撤退票之前需要先選擇狀態。")
        Else
            If 狀態_tb.Text = "退票" Or 狀態_tb.Text = "撤票" Then : Else
                PA1 = 收支單號_tb.Text : PA2 = 項次_tb.Text
                If 狀態_tb.Text = "收票" Then : PA3 = "退票"
                ElseIf 狀態_tb.Text = "開票" Then : PA3 = "撤票"
                ElseIf 狀態_tb.Text = "託收" Then : PA3 = "收票"
                ElseIf 狀態_tb.Text = "已付" Then : PA3 = "開票"
                End If
                If 批量操作_ch.Checked = False Then
                    If 狀態_tb.Text = "託收" Or 狀態_tb.Text = "已付" Then
                        SQL_營運成本明細表_轉現刪除() : conn.Close()
                    End If
                    PA4 = "0" : PA5 = "0" : DTP = ""
                    SQL_營運成本明細表_狀態更改() : conn.Close()
                Else
                    For i As Integer = 0 To 票務清單_dgv.Rows.Count - 1
                        If 票務清單_dgv.Rows(i).Cells("選擇").Value = True Then
                            PA2 = 票務清單_dgv("項次", i).Value.ToString
                            If 狀態_tb.Text = "託收" Or 狀態_tb.Text = "已付" Then
                                SQL_營運成本明細表_轉現刪除() : conn.Close()
                            End If
                            PA4 = "0" : PA5 = "0" : DTP = ""
                            SQL_營運成本明細表_狀態更改() : conn.Close()
                        End If
                    Next i
                End If
                Set_票務清單() : ComboBox2下拉表單資料載入() : 狀態_tb.Text = PA3
            End If
        End If
    End Sub
    Private Sub 退票_撤票取消_Click(sender As Object, e As EventArgs) Handles 退票_撤票取消_bt.Click
        PA1 = 收支單號_tb.Text : PA2 = 項次_tb.Text
        If 狀態_tb.Text = "退票" Then : PA3 = "收票"
        ElseIf 狀態_tb.Text = "撤票" Then : PA3 = "開票"
        Else : PA1 = "" : PA2 = "" : Exit Sub
        End If
        If 批量操作_ch.Checked = False Then
            PA4 = "0" : PA5 = "0" : DTP = ""
            SQL_營運成本明細表_狀態更改() : conn.Close()
        Else
            For i As Integer = 0 To 票務清單_dgv.Rows.Count - 1
                If 票務清單_dgv.Rows(i).Cells("選擇").Value = True Then
                    PA2 = 票務清單_dgv("項次", i).Value.ToString
                    PA4 = "0" : PA5 = "0" : DTP = ""
                    SQL_營運成本明細表_狀態更改() : conn.Close()
                End If
            Next i
        End If
        Set_票務清單() : ComboBox2下拉表單資料載入() : 狀態_tb.Text = PA3
    End Sub
    Private Sub Button1_Click(sender As Object, e As EventArgs) Handles 不計票況_bt.Click
        已付_bt.Enabled = False : 託收_bt.Enabled = False : 退票_撤票_bt.Enabled = False : 轉換科目_cb.Items.Clear() : 轉換科目編號_cb.Items.Clear()
        SQL_票務控制表票況區分()
        票況_cb.Items.Clear() : While (dr.Read()) : 票況_cb.Items.Add(dr("狀態")) : End While : conn.Close() : Set_票務清單()
    End Sub
    Private Sub Button13_Click(sender As Object, e As EventArgs) Handles 全部選擇_bt.Click
        For i As Integer = 0 To 票務清單_dgv.Rows.Count - 1 : 票務清單_dgv.Rows(i).Cells("選擇").Value = True : Next i
    End Sub
    Private Sub Button12_Click(sender As Object, e As EventArgs) Handles 全部取消_bt.Click
        For i As Integer = 0 To 票務清單_dgv.Rows.Count - 1 : 票務清單_dgv.Rows(i).Cells("選擇").Value = False : Next i
    End Sub

    Private Sub 列印出貨單_bt_MouseEnter(sender As Object, e As EventArgs) Handles 列印成EXCEL_bt.MouseEnter
        ToolTip1.SetToolTip(Me.列印成EXCEL_bt, "列印成EXCEL")
    End Sub
    Private Sub Button1_Click_1(sender As Object, e As EventArgs) Handles 列印成EXCEL_bt.Click
        xlApp = CType(CreateObject("Excel.Application"), Application)
        xlBook = xlApp.Workbooks.Add
        xlApp.DisplayAlerts = True
        xlBook.Activate()
        xlSheet = NewMethod(xlBook)
        xlSheet.Activate()
        xlApp.Visible = True
        xlApp.Application.WindowState = xlMaximized

        Dim TXT(10) As String
        If 區分_cb.Text = "應收票據" Then
            TXT(0) = "銀行作業" : TXT(5) = "銀行名稱:" : TXT(7) = "託收日" : TXT(8) = "客戶簡稱"
        ElseIf 區分_cb.Text = "應付票據" Then
            TXT(0) = "開票科目" : TXT(5) = "會計名稱:" : TXT(7) = "已付日" : TXT(8) = "票據用途"
        End If

        If 票況_cb.Text = "" Then
            TXT(1) = "票據其況:" : TXT(2) = 區分_cb.Text
        ElseIf 票況_cb.Text <> "" Then
            TXT(1) = 票況_cb.Text & "人:" : TXT(2) = MAOJI_ERP_SYS.公司名稱_cb.Text
        End If
        TXT(3) = 日期選項_cb.Text & ":" : TXT(4) = Strings.Format(開始日期_dtp.Value, "yyyy/MM/dd") & " 到 " & Strings.Format(結束日期_dtp.Value, "yyyy/MM/dd")
        TXT(6) = 兌現科目_cb.Text
        xlSheet.Cells(1, 1) = MAOJI_ERP_SYS.公司名稱_cb.Text
        xlSheet.Cells(2, 1) = 票況_cb.Text & "票據" & TXT(0) & "明細表"
        xlSheet.Cells(3, 1) = TXT(1) : xlSheet.Cells(3, 2) = TXT(2) : xlSheet.Cells(3, 4) = TXT(3) : xlSheet.Cells(3, 5) = TXT(4)
        xlSheet.Cells(4, 1) = TXT(5) : xlSheet.Cells(4, 2) = TXT(6)
        xlSheet.Cells(6, 1) = "到期日" : xlSheet.Cells(6, 2) = TXT(7) : xlSheet.Cells(6, 3) = "付款銀行" : xlSheet.Cells(6, 4) = "發票人帳號"
        xlSheet.Cells(6, 5) = TXT(8) : xlSheet.Cells(6, 6) = "票據號碼" : xlSheet.Cells(6, 7) = "金額"

        For i As Integer = 0 To 票務清單_dgv.Rows.Count - 1
            xlSheet.Cells(i + 7, 1) = 票務清單_dgv.Rows(i).Cells("到期日").Value
            xlSheet.Cells(i + 7, 2) = 票務清單_dgv.Rows(i).Cells("託收已付日").Value
            xlSheet.Cells(i + 7, 3) = 票務清單_dgv.Rows(i).Cells("付款銀行").Value
            xlSheet.Cells(i + 7, 4) = 票務清單_dgv.Rows(i).Cells("發票人帳號").Value
            xlSheet.Cells(i + 7, 6) = 票務清單_dgv.Rows(i).Cells("支票號碼").Value
            If 區分_cb.Text = "應收票據" Then
                xlSheet.Cells(i + 7, 5) = 票務清單_dgv.Rows(i).Cells("開票人").Value
                xlSheet.Cells(i + 7, 7) = 票務清單_dgv.Rows(i).Cells("收票").Value
            ElseIf 區分_cb.Text = "應付票據" Then
                xlSheet.Cells(i + 7, 5) = 票務清單_dgv.Rows(i).Cells("用途").Value
                xlSheet.Cells(i + 7, 7) = 票務清單_dgv.Rows(i).Cells("開票").Value
            End If
            With xlApp.Selection : .Font.Bold = True : End With
            N1 = i + 7 : N2 = i + 7
        Next i
        xlSheet.Cells(N1 + 1, 2) = "合計:" : xlSheet.Cells(N1 + 1, 5) = "共 " & 資料筆數_tb.Text & "張" : xlSheet.Cells(N1 + 1, 7) = "=SUM(G7:G" & N1 & ")"
        AA(xlApp, xlSheet)

        xlSheet.PageSetup.PrintArea = ""
        xlApp.Cells.Select()
        xlSheet.Range("B1").Select()
        xlApp.Application.WindowState = xlMinimized
        xlSheet.Cells.Select()
        MsgBox("列印完成。")
    End Sub
    Private Shared Function NewMethod(xlBook As Workbook) As Worksheet
        Return CType(xlBook.Worksheets.Add, Worksheet)
    End Function
    Private Sub AA(ByVal myExcel As Application, ByVal xlSheet As Worksheet)
        xlSheet.Cells.Select()
        With myExcel.Selection.Font : .Name = "微軟正黑體" : .Size = 10 : .Strikethrough = False : .Superscript = False : .Subscript = False : .OutlineFont = False : .Shadow = False
            .Underline = xlUnderlineStyleNone : .ThemeColor = xlThemeColorLight1 : .TintAndShade = 0 : .ThemeFont = xlThemeFontNone : End With

        xlSheet.Columns("A:A").Select : myExcel.Selection.ColumnWidth = 10.5
        xlSheet.Columns("B:B").Select : myExcel.Selection.ColumnWidth = 10.5
        xlSheet.Columns("C:C").Select : myExcel.Selection.ColumnWidth = 25
        xlSheet.Columns("D:D").Select : myExcel.Selection.ColumnWidth = 15
        xlSheet.Columns("E:E").Select : myExcel.Selection.ColumnWidth = 30
        xlSheet.Columns("F:F").Select : myExcel.Selection.ColumnWidth = 15
        xlSheet.Columns("G:G").Select : myExcel.Selection.ColumnWidth = 10 : myExcel.Selection.NumberFormatLocal = "#,##0"

        xlSheet.Range("A6:F" & N1 + 1).Select()
        With myExcel.Selection : .HorizontalAlignment = xlCenter : .VerticalAlignment = xlCenter : .WrapText = False : .Orientation = 0 : .AddIndent = False : .IndentLevel = 0
            .ShrinkToFit = False : .ReadingOrder = xlContext : .MergeCells = False : End With
        xlSheet.Range("A1:G1").Select()
        With myExcel.Selection : .HorizontalAlignment = xlCenter : .VerticalAlignment = xlCenter : .WrapText = False : .Orientation = 0 : .AddIndent = False : .IndentLevel = 0
            .ShrinkToFit = False : .ReadingOrder = xlContext : .MergeCells = False : End With : myExcel.Selection.Merge
        With myExcel.Selection.Font : .Name = "微軟正黑體" : .Size = 18 : .Strikethrough = False : .Superscript = False : .Subscript = False : .OutlineFont = False : .Shadow = False
            .Underline = xlUnderlineStyleNone : .ThemeColor = xlThemeColorLight1 : .TintAndShade = 0 : .ThemeFont = xlThemeFontNone : End With

        xlSheet.Range("A2:G2").Select()
        With myExcel.Selection : .HorizontalAlignment = xlCenter : .VerticalAlignment = xlCenter : .WrapText = False : .Orientation = 0 : .AddIndent = False : .IndentLevel = 0
            .ShrinkToFit = False : .ReadingOrder = xlContext : .MergeCells = False : End With : myExcel.Selection.Merge
        With myExcel.Selection.Font : .Name = "微軟正黑體" : .Size = 14 : .Strikethrough = False : .Superscript = False : .Subscript = False : .OutlineFont = False : .Shadow = False
            .Underline = xlUnderlineStyleNone : .ThemeColor = xlThemeColorLight1 : .TintAndShade = 0 : .ThemeFont = xlThemeFontNone : End With

        xlSheet.Range("A3:A4").Select()
        With myExcel.Selection : .HorizontalAlignment = xlCenter : .VerticalAlignment = xlCenter : .WrapText = False : .Orientation = 0 : .AddIndent = False : .IndentLevel = 0
            .ShrinkToFit = False : .ReadingOrder = xlContext : .MergeCells = False : End With

        xlSheet.Range("D3").Select()
        With myExcel.Selection : .HorizontalAlignment = xlCenter : .VerticalAlignment = xlCenter : .WrapText = False : .Orientation = 0 : .AddIndent = False : .IndentLevel = 0
            .ShrinkToFit = False : .ReadingOrder = xlContext : .MergeCells = False : End With

        xlSheet.Rows("3:4").Select : myExcel.Selection.RowHeight = 20
        xlSheet.Rows("5:5").Select : myExcel.Selection.RowHeight = 5
        xlSheet.Rows("6:6").Select : myExcel.Selection.RowHeight = 25
        xlSheet.Rows("7:" & N1 + 1).Select : myExcel.Selection.RowHeight = 20

        xlSheet.Range("A5:G5").Select()
        myExcel.Selection.Borders(xlDiagonalDown).LineStyle = xlNone : myExcel.Selection.Borders(xlDiagonalUp).LineStyle = xlNone
        myExcel.Selection.Borders(xlEdgeLeft).LineStyle = xlNone : myExcel.Selection.Borders(xlEdgeTop).LineStyle = xlNone
        With myExcel.Selection.Borders(xlEdgeBottom) : .LineStyle = xlContinuous : .ColorIndex = 0 : .TintAndShade = 0 : .Weight = xlMedium : End With
        myExcel.Selection.Borders(xlEdgeRight).LineStyle = xlNone : myExcel.Selection.Borders(xlInsideVertical).LineStyle = xlNone
        myExcel.Selection.Borders(xlInsideHorizontal).LineStyle = xlNone

        xlSheet.Range("A7:G" & N1 + 1).Select()
        myExcel.Selection.Borders(xlDiagonalDown).LineStyle = xlNone : myExcel.Selection.Borders(xlDiagonalUp).LineStyle = xlNone
        myExcel.Selection.Borders(xlEdgeLeft).LineStyle = xlNone : myExcel.Selection.Borders(xlEdgeTop).LineStyle = xlNone
        myExcel.Selection.Borders(xlEdgeBottom).LineStyle = xlNone : myExcel.Selection.Borders(xlEdgeRight).LineStyle = xlNone
        myExcel.Selection.Borders(xlInsideVertical).LineStyle = xlNone
        With myExcel.Selection.Borders(xlInsideHorizontal) : .LineStyle = xlContinuous : .ColorIndex = xlAutomatic : .TintAndShade = 0 : .Weight = xlThin : End With

        xlSheet.Range("A6:G6").Select()
        With myExcel.Selection.Interior : .Pattern = xlSolid : .PatternColorIndex = xlAutomatic : .ThemeColor = xlThemeColorAccent1 : .TintAndShade = 0.799981688894314
            .PatternTintAndShade = 0 : End With

        xlSheet.Range("K12").Select() : myExcel.ActiveWindow.DisplayGridlines = False
        xlSheet.Rows("7:7").Select : myExcel.ActiveWindow.FreezePanes = True
        xlSheet.Range("A6:G6").Select() : myExcel.Selection.AutoFilter

        myExcel.Application.PrintCommunication = False
        With myExcel.ActiveSheet.PageSetup
            .PrintTitleRows = "$1:$6"
            .PrintTitleColumns = ""
        End With
        myExcel.Application.PrintCommunication = True
        myExcel.ActiveSheet.PageSetup.PrintArea = ""
        myExcel.Application.PrintCommunication = False
        With myExcel.ActiveSheet.PageSetup
            .LeftHeader = ""
            .CenterHeader = ""
            .RightHeader = ""
            .LeftFooter = ""
            .CenterFooter = ""
            .RightFooter = ""
            .LeftMargin = myExcel.Application.InchesToPoints(0.25)
            .RightMargin = myExcel.Application.InchesToPoints(0.25)
            .TopMargin = myExcel.Application.InchesToPoints(0.75)
            .BottomMargin = myExcel.Application.InchesToPoints(0.75)
            .HeaderMargin = myExcel.Application.InchesToPoints(0.3)
            .FooterMargin = myExcel.Application.InchesToPoints(0.3)
            .PrintHeadings = False
            .PrintGridlines = False
            '.PrintComments = xlPrintNoComments
            .PrintQuality = 300
            .CenterHorizontally = False
            .CenterVertically = False
            '.Orientation = xlPortrait
            .Draft = False
            '.PaperSize = xlPaperA4
            .FirstPageNumber = xlAutomatic
            '.Order = xlDownThenOver
            .BlackAndWhite = False
            .Zoom = False
            .FitToPagesWide = 1
            .FitToPagesTall = 1
            '.PrintErrors = xlPrintErrorsDisplayed
            .OddAndEvenPagesHeaderFooter = False
            .DifferentFirstPageHeaderFooter = False
            .ScaleWithDocHeaderFooter = True
            .AlignMarginsHeaderFooter = True
            .EvenPage.LeftHeader.Text = ""
            .EvenPage.CenterHeader.Text = ""
            .EvenPage.RightHeader.Text = ""
            .EvenPage.LeftFooter.Text = ""
            .EvenPage.CenterFooter.Text = ""
            .EvenPage.RightFooter.Text = ""
            .FirstPage.LeftHeader.Text = ""
            .FirstPage.CenterHeader.Text = ""
            .FirstPage.RightHeader.Text = ""
            .FirstPage.LeftFooter.Text = ""
            .FirstPage.CenterFooter.Text = ""
            .FirstPage.RightFooter.Text = ""
        End With
        myExcel.Application.PrintCommunication = True
    End Sub
End Class