﻿Option Strict Off
Public Class 系統使用者管理
    ReadOnly ds As New DataSet
    Dim HH As String
    Private Sub Set_使用者清單()
        使用者清單_dgv.DataSource = Nothing : ds.Clear()
        使用者清單_dgv.ColumnHeadersHeightSizeMode = DataGridViewColumnHeadersHeightSizeMode.EnableResizing
        使用者清單_dgv.ColumnHeadersHeight = 25
        使用者清單_dgv.AllowUserToAddRows = False
        SQL_系統使用者管理清單()
        da.Fill(ds) : 使用者清單_dgv.DataSource = ds.Tables(0) : conn.Close()
    End Sub
    Private Sub Set_grid()
        使用者清單_dgv.Columns(0).FillWeight = 90 : 使用者清單_dgv.Columns(1).FillWeight = 90 : 使用者清單_dgv.Columns(2).FillWeight = 75
        For i As Integer = 0 To 權限數量
            使用者清單_dgv.Columns(i + 3).Visible = False
        Next
        For i As Integer = 0 To 使用者清單_dgv.Rows.Count - 1 : 使用者清單_dgv.Rows(i).Cells("密碼").Value = "******" : Next
    End Sub
    Private Sub Set_格式設定()
        確認新增_bt.Enabled = False : 儲存修改_bt.Enabled = False
    End Sub
    Private Sub 系統使用者管理_Load(sender As Object, e As EventArgs) Handles MyBase.Load
        Me.MdiParent = MAOJI_ERP_SYS : Me.WindowState = 2 : Me.AutoScroll = True
        Set_使用者清單() : Set_grid() : Set_格式設定()
        CheckBox1.Enabled = True : CheckBox2.Enabled = True : 姓名_tb.Enabled = False : 帳號_tb.Enabled = False : 密碼_tb.Enabled = False
    End Sub
    Private Sub 介面關閉_Closed(sender As Object, e As EventArgs) Handles MyBase.Closed
        MyModule1.虛擬桌面開啟()
    End Sub
    Private Sub DataGridView1_CellContentClick(sender As Object, e As DataGridViewCellEventArgs) Handles 使用者清單_dgv.CellClick
        If e.RowIndex = -1 Then : Else
            姓名_tb.Text = 使用者清單_dgv.Rows(e.RowIndex).Cells("姓名").Value.ToString : 帳號_tb.Text = 使用者清單_dgv.Rows(e.RowIndex).Cells("帳號").Value
            密碼_tb.Text = 使用者清單_dgv.Rows(e.RowIndex).Cells("密碼").Value
            '---------同時控制所有具有一定命名規則的控件---------------------------------------------------------------------------------------------------------------------------------------------
            For no As Integer = 1 To 權限數量 + 1
                If no - 1 < 10 Then : HH = "0" & no - 1 : ElseIf no - 1 >= 10 Then : HH = no - 1 : End If
                Dim checkbox As CheckBox = CType(Me.Controls.Find("CheckBox" + no.ToString(), True)(0), CheckBox)
                checkbox.Checked = 使用者清單_dgv.Rows(e.RowIndex).Cells("CC" & HH).Value
            Next
        End If
    End Sub
    Private Sub Button1_Click(sender As Object, e As EventArgs) Handles 確認新增_bt.Click
        SQL_系統使用者新增()
        conn.Close() : MsgBox("新增完成") : Set_使用者清單() : Set_grid()
        確認新增_bt.Enabled = False : 新增_bt.Enabled = True : 修改_bt.Enabled = True : 姓名_tb.Enabled = False : 帳號_tb.Enabled = False : 密碼_tb.Enabled = False
    End Sub
    Private Sub Button2_Click(sender As Object, e As EventArgs) Handles 儲存修改_bt.Click
        If 姓名_tb.Text = "" Or 帳號_tb.Text = "" Or 密碼_tb.Text = "" Then : MsgBox("輸入資料有誤")
        Else
            If 密碼_tb.Text = "******" Then
                SQL_系統使用者密碼顯示()
                If dr.Read() Then : 密碼_tb.Text = dr("密碼") : End If : conn.Close()
            End If
            SQL_系統使用者修改() : conn.Close() : MsgBox("新增完成")
        End If : Set_使用者清單() : Set_grid()
        儲存修改_bt.Enabled = False : 新增_bt.Enabled = True : 修改_bt.Enabled = True : 姓名_tb.Enabled = False : 帳號_tb.Enabled = False : 密碼_tb.Enabled = False
    End Sub
    Private Sub Button3_Click(sender As Object, e As EventArgs) Handles 刪除_bt.Click
        Dim aa As MsgBoxResult = MsgBox("確定要刪除該筆資料?", MsgBoxStyle.OkCancel)
        If aa = MsgBoxResult.Ok Then
            SQL_系統使用者刪除() : MsgBox("刪除完成")
        End If : conn.Close()
        姓名_tb.Text = "" : 帳號_tb.Text = "" : 帳號_tb.Text = "" : CheckBox1.Checked = False : Set_使用者清單() : Set_grid()
    End Sub
    Private Sub Button4_Click(sender As Object, e As EventArgs) Handles 新增_bt.Click
        姓名_tb.Text = "" : 帳號_tb.Text = "" : 密碼_tb.Text = "" : 新增_bt.Enabled = False : 修改_bt.Enabled = False : 確認新增_bt.Enabled = True
        姓名_tb.Enabled = True : 帳號_tb.Enabled = True : 密碼_tb.Enabled = True
    End Sub
    Private Sub Button5_Click(sender As Object, e As EventArgs) Handles 修改_bt.Click
        新增_bt.Enabled = False : 修改_bt.Enabled = False : 儲存修改_bt.Enabled = True
        姓名_tb.Enabled = True : 帳號_tb.Enabled = True : 密碼_tb.Enabled = True
    End Sub
    Private Sub Button6_Click(sender As Object, e As EventArgs) Handles 顯示密碼_bt.Click
        SQL_系統使用者密碼顯示()
        If dr.Read() Then : 密碼_tb.Text = dr("密碼") : End If : conn.Close()
    End Sub
    '**************************************************************************************************************************************************
    Private Sub CheckBox2_CheckedChanged(sender As Object, e As EventArgs) Handles CheckBox2.Click
        If CheckBox1.Checked = False Then : CheckBox1.Checked = True : End If
    End Sub
    Private Sub CheckBox3_CheckedChanged(sender As Object, e As EventArgs) Handles CheckBox3.Click
        If CheckBox1.Checked = False Then : CheckBox1.Checked = True : End If
    End Sub
    Private Sub CheckBox4_CheckedChanged(sender As Object, e As EventArgs) Handles CheckBox4.Click
        If CheckBox1.Checked = False Then : CheckBox1.Checked = True : End If
    End Sub
    Private Sub CheckBox5_CheckedChanged(sender As Object, e As EventArgs) Handles CheckBox5.Click
        If CheckBox1.Checked = False Then : CheckBox1.Checked = True : End If
    End Sub
    Private Sub CheckBox6_CheckedChanged(sender As Object, e As EventArgs) Handles CheckBox6.Click
        If CheckBox1.Checked = False Then : CheckBox1.Checked = True : End If
    End Sub
    Private Sub CheckBox34_CheckedChanged(sender As Object, e As EventArgs) Handles CheckBox34.Click
        If CheckBox1.Checked = False Then : CheckBox1.Checked = True : End If
    End Sub
    '--------------------------------------------------------------------------------------------------------------------------------------------------


    '**************************************************************************************************************************************************
    Private Sub CheckBox8_CheckedChanged(sender As Object, e As EventArgs) Handles CheckBox8.Click
        If CheckBox7.Checked = False Then : CheckBox7.Checked = True : End If
    End Sub
    Private Sub CheckBox9_CheckedChanged(sender As Object, e As EventArgs) Handles CheckBox9.Click
        If CheckBox7.Checked = False Then : CheckBox7.Checked = True : End If
    End Sub
    '--------------------------------------------------------------------------------------------------------------------------------------------------


    '**************************************************************************************************************************************************
    Private Sub CheckBox11_CheckedChanged(sender As Object, e As EventArgs) Handles CheckBox11.Click
        If CheckBox10.Checked = False Then : CheckBox10.Checked = True : End If
    End Sub
    Private Sub CheckBox39_CheckedChanged(sender As Object, e As EventArgs) Handles CheckBox39.Click
        If CheckBox10.Checked = False Then : CheckBox10.Checked = True : End If
    End Sub
    Private Sub CheckBox40_CheckedChanged(sender As Object, e As EventArgs) Handles CheckBox40.Click
        If CheckBox10.Checked = False Then : CheckBox10.Checked = True : End If
    End Sub
    Private Sub CheckBox41_CheckedChanged(sender As Object, e As EventArgs) Handles CheckBox41.Click
        If CheckBox10.Checked = False Then : CheckBox10.Checked = True : End If
    End Sub
    Private Sub CheckBox18_CheckedChanged(sender As Object, e As EventArgs) Handles CheckBox18.Click
        If CheckBox10.Checked = False Then : CheckBox10.Checked = True : End If
    End Sub
    Private Sub CheckBox19_CheckedChanged(sender As Object, e As EventArgs) Handles CheckBox19.Click
        If CheckBox10.Checked = False Then : CheckBox10.Checked = True : End If
    End Sub
    Private Sub CheckBox20_CheckedChanged(sender As Object, e As EventArgs) Handles CheckBox20.Click
        If CheckBox10.Checked = False Then : CheckBox10.Checked = True : End If
    End Sub
    Private Sub CheckBox43_CheckedChanged(sender As Object, e As EventArgs) Handles CheckBox43.Click
        If CheckBox10.Checked = False Then : CheckBox10.Checked = True : End If
    End Sub
    '--------------------------------------------------------------------------------------------------------------------------------------------------


    '**************************************************************************************************************************************************    
    Private Sub CheckBox13_CheckedChanged(sender As Object, e As EventArgs) Handles CheckBox13.Click
        If CheckBox12.Checked = False Then : CheckBox12.Checked = True : End If
    End Sub
    Private Sub CheckBox24_CheckedChanged(sender As Object, e As EventArgs) Handles CheckBox24.Click
        If CheckBox12.Checked = False Then : CheckBox12.Checked = True : End If
    End Sub
    Private Sub CheckBox36_CheckedChanged(sender As Object, e As EventArgs) Handles CheckBox36.Click
        If CheckBox12.Checked = False Then : CheckBox12.Checked = True : End If : If CheckBox24.Checked = False Then : CheckBox24.Checked = True : End If
    End Sub
    Private Sub CheckBox25_CheckedChanged(sender As Object, e As EventArgs) Handles CheckBox25.Click
        If CheckBox12.Checked = False Then : CheckBox12.Checked = True : End If
    End Sub
    '--------------------------------------------------------------------------------------------------------------------------------------------------


    '**************************************************************************************************************************************************
    Private Sub CheckBox15_CheckedChanged(sender As Object, e As EventArgs) Handles CheckBox15.Click
        If CheckBox14.Checked = False Then : CheckBox14.Checked = True : End If
    End Sub
    Private Sub CheckBox42_CheckedChanged(sender As Object, e As EventArgs) Handles CheckBox42.Click
        If CheckBox14.Checked = False Then : CheckBox14.Checked = True : End If
    End Sub
    Private Sub CheckBox26_CheckedChanged(sender As Object, e As EventArgs) Handles CheckBox26.Click
        If CheckBox14.Checked = False Then : CheckBox14.Checked = True : End If
    End Sub
    Private Sub CheckBox35_CheckedChanged(sender As Object, e As EventArgs) Handles CheckBox35.Click
        If CheckBox14.Checked = False Then : CheckBox14.Checked = True : End If
    End Sub
    Private Sub CheckBox27_CheckedChanged(sender As Object, e As EventArgs) Handles CheckBox27.Click
        If CheckBox14.Checked = False Then : CheckBox14.Checked = True : End If
    End Sub
    Private Sub CheckBox44_CheckedChanged(sender As Object, e As EventArgs) Handles CheckBox44.Click
        If CheckBox14.Checked = False Then : CheckBox14.Checked = True : End If
    End Sub
    Private Sub CheckBox45_CheckedChanged(sender As Object, e As EventArgs) Handles CheckBox45.Click
        If CheckBox14.Checked = False Then : CheckBox14.Checked = True : End If
    End Sub
    '--------------------------------------------------------------------------------------------------------------------------------------------------


    '**************************************************************************************************************************************************
    Private Sub CheckBox21_CheckedChanged(sender As Object, e As EventArgs) Handles CheckBox21.Click
        If CheckBox16.Checked = False Then : CheckBox16.Checked = True : End If
    End Sub
    Private Sub CheckBox22_CheckedChanged(sender As Object, e As EventArgs) Handles CheckBox22.Click
        If CheckBox16.Checked = False Then : CheckBox16.Checked = True : End If
    End Sub
    Private Sub CheckBox23_CheckedChanged(sender As Object, e As EventArgs) Handles CheckBox23.Click
        If CheckBox16.Checked = False Then : CheckBox16.Checked = True : End If
    End Sub
    '--------------------------------------------------------------------------------------------------------------------------------------------------


    '**************************************************************************************************************************************************
    Private Sub CheckBox28_CheckedChanged(sender As Object, e As EventArgs) Handles CheckBox28.Click
        If CheckBox17.Checked = False Then : CheckBox17.Checked = True : End If
    End Sub
    Private Sub CheckBox29_CheckedChanged(sender As Object, e As EventArgs) Handles CheckBox29.Click
        If CheckBox17.Checked = False Then : CheckBox17.Checked = True : End If : If CheckBox28.Checked = False Then : CheckBox28.Checked = True : End If
    End Sub
    Private Sub CheckBox30_CheckedChanged(sender As Object, e As EventArgs) Handles CheckBox30.Click
        If CheckBox17.Checked = False Then : CheckBox17.Checked = True : End If
    End Sub
    Private Sub CheckBox31_CheckedChanged(sender As Object, e As EventArgs) Handles CheckBox31.Click
        If CheckBox17.Checked = False Then : CheckBox17.Checked = True : End If
    End Sub
    Private Sub CheckBox32_CheckedChanged(sender As Object, e As EventArgs) Handles CheckBox32.Click
        If CheckBox17.Checked = False Then : CheckBox17.Checked = True : End If
    End Sub
    Private Sub CheckBox33_CheckedChanged(sender As Object, e As EventArgs) Handles CheckBox33.Click
        If CheckBox17.Checked = False Then : CheckBox17.Checked = True : End If
    End Sub
    Private Sub CheckBox46_CheckedChanged(sender As Object, e As EventArgs) Handles CheckBox46.Click
        If CheckBox17.Checked = False Then : CheckBox17.Checked = True : End If
    End Sub
    '--------------------------------------------------------------------------------------------------------------------------------------------------


    '**************************************************************************************************************************************************
    Private Sub CheckBox38_CheckedChanged(sender As Object, e As EventArgs) Handles CheckBox38.Click
        If CheckBox37.Checked = False Then : CheckBox37.Checked = True : End If
    End Sub
    '--------------------------------------------------------------------------------------------------------------------------------------------------
End Class