﻿Module SQL_財務系統管理
    '---------------------營運成本收支_決算表-----------------------------------------------------------------------------------------------------------------
    Friend Sub SQL_營運成本收支_決算表年清單()
        ConnOpen()
        SQL1 = "SELECT      會計科目.層級, 會計科目.第一階, 會計科目.第二階, 會計科目.第一階 AS 主項, 會計科目.第二階 AS 子項, 會計科目.會計科目 AS 子細項, QQWW.主項金額, WWEE.子項金額, 
                            EERR.細項金額, 會計科目.抵銷科目 AS 抵銷, QQWW.主項金額 AS 主項彙總, WWEE.子項金額 AS 子項彙總, EERR.細項金額 AS 細項彙總
                FROM        會計科目 FULL OUTER JOIN
                               (SELECT 營運成本明細表_3.會計科目 AS 細項, SUM(營運成本明細表_3.支票數) + SUM(營運成本明細表_3.收款) - 
                                       SUM(營運成本明細表_3.金額) - SUM(營運成本明細表_3.零用金) AS 細項金額
                                FROM   營運成本明細表 AS 營運成本明細表_3 INNER JOIN 營運成本控制表 AS 營運成本控制表_3 ON 營運成本明細表_3.流水號 = 營運成本控制表_3.支付單號
                                WHERE (營運成本控制表_3.申請日期 LIKE N'" & 營運成本收支_決算表.ComboBox1.Text & "%') AND 
                                      (營運成本控制表_3.公司編號 LIKE N'%" & 公司編號 & "%')
                                GROUP BY    營運成本明細表_3.會計科目) AS EERR ON 會計科目.編號 = EERR.細項 
                            FULL OUTER JOIN
                               (SELECT LEFT(營運成本明細表_2.會計科目, 4) AS 主碼, SUM(營運成本明細表_2.支票數) + SUM(營運成本明細表_2.收款) - 
                                       SUM(營運成本明細表_2.金額) - SUM(營運成本明細表_2.零用金) AS 主項金額
                                FROM   營運成本明細表 AS 營運成本明細表_2 INNER JOIN 營運成本控制表 AS 營運成本控制表_2 ON 營運成本明細表_2.流水號 = 營運成本控制表_2.支付單號
                                WHERE (營運成本控制表_2.申請日期 LIKE N'" & 營運成本收支_決算表.ComboBox1.Text & "%') AND 
                                      (營運成本控制表_2.公司編號 LIKE N'%" & 公司編號 & "%')
                                GROUP BY    LEFT(營運成本明細表_2.會計科目, 4)) AS QQWW ON LEFT(會計科目.編號, 4) = QQWW.主碼 
                            FULL OUTER JOIN
                               (SELECT LEFT(營運成本明細表_1.會計科目, 7) AS 子碼, SUM(營運成本明細表_1.支票數) + SUM(營運成本明細表_1.收款) - 
                                       SUM(營運成本明細表_1.金額) + SUM(營運成本明細表_1.零用金) AS 子項金額
                                FROM   營運成本明細表 AS 營運成本明細表_1 INNER JOIN 營運成本控制表 AS 營運成本控制表_1 ON 營運成本明細表_1.流水號 = 營運成本控制表_1.支付單號
                                WHERE (營運成本控制表_1.申請日期 LIKE N'" & 營運成本收支_決算表.ComboBox1.Text & "%') AND 
                                      (營運成本控制表_1.公司編號 LIKE N'%" & 公司編號 & "%')
                                GROUP BY    LEFT(營運成本明細表_1.會計科目, 7)) AS WWEE ON LEFT(會計科目.編號, 7) = WWEE.子碼
                WHERE     (會計科目.顯示 = 1)
                ORDER BY   會計科目.編號"
        CmdSet_For_DGV()
    End Sub
    Friend Sub SQL_營運成本收支_決算表月清單()
        ConnOpen()
        SQL1 = "SELECT      會計科目.層級, 會計科目.第一階, 會計科目.第二階, 會計科目.第一階 AS 主項, 會計科目.第二階 AS 子項, 會計科目.會計科目 AS 子細項, QQWW.主項金額, WWEE.子項金額, EERR.細項金額, 
                            EERR.細項金額 AS [金額], 會計科目.抵銷科目 AS 抵銷, EERR.細項金額 AS [彙總]
                FROM        會計科目 FULL OUTER JOIN
                               (SELECT 營運成本明細表_3.會計科目 AS 細項, SUM(營運成本明細表_3.支票數) + SUM(營運成本明細表_3.收款) - 
                                       SUM(營運成本明細表_3.金額) - SUM(營運成本明細表_3.零用金) AS 細項金額
                                FROM   營運成本明細表 AS 營運成本明細表_3 INNER JOIN 營運成本控制表 AS 營運成本控制表_3 ON 營運成本明細表_3.流水號 = 營運成本控制表_3.支付單號
                                WHERE (營運成本控制表_3.申請日期 LIKE N'" & 營運成本收支_決算表.ComboBox1.Text & "/" & PA & "/%') AND 
                                      (營運成本控制表_3.公司編號 LIKE N'%" & 公司編號 & "%')
                                GROUP BY    營運成本明細表_3.會計科目) AS EERR ON 會計科目.編號 = EERR.細項 
                            FULL OUTER JOIN
                               (SELECT LEFT(營運成本明細表_2.會計科目, 4) AS 主碼, SUM(營運成本明細表_2.支票數) + SUM(營運成本明細表_2.收款) - 
                                       SUM(營運成本明細表_2.金額) - SUM(營運成本明細表_2.零用金) AS 主項金額
                                FROM   營運成本明細表 AS 營運成本明細表_2 INNER JOIN 營運成本控制表 AS 營運成本控制表_2 ON 營運成本明細表_2.流水號 = 營運成本控制表_2.支付單號
                                WHERE (營運成本控制表_2.申請日期 LIKE N'" & 營運成本收支_決算表.ComboBox1.Text & "/" & PA & "/%') AND 
                                      (營運成本控制表_2.公司編號 LIKE N'%" & 公司編號 & "%')
                                GROUP BY    LEFT(營運成本明細表_2.會計科目, 4)) AS QQWW ON LEFT(會計科目.編號, 4) = QQWW.主碼 
                            FULL OUTER JOIN
                               (SELECT LEFT(營運成本明細表_1.會計科目, 7) AS 子碼, SUM(營運成本明細表_1.支票數) + SUM(營運成本明細表_1.收款) - 
                                       SUM(營運成本明細表_1.金額) - SUM(營運成本明細表_1.零用金) AS 子項金額
                                FROM   營運成本明細表 AS 營運成本明細表_1 INNER JOIN 營運成本控制表 AS 營運成本控制表_1 ON 營運成本明細表_1.流水號 = 營運成本控制表_1.支付單號
                                WHERE (營運成本控制表_1.申請日期 LIKE N'" & 營運成本收支_決算表.ComboBox1.Text & "/" & PA & "/%') AND 
                                      (營運成本控制表_1.公司編號 LIKE N'%" & 公司編號 & "%')
                                GROUP BY    LEFT(營運成本明細表_1.會計科目, 7)) AS WWEE ON LEFT(會計科目.編號, 7) = WWEE.子碼
                WHERE     (會計科目.顯示 = 1)
                ORDER BY   會計科目.編號"
        CmdSet_For_DGV()
    End Sub
    Friend Sub SQL_財務決算表合計預設()
        ConnOpen() : SQL1 = "SELECT 項次, 名稱, 年度合計 FROM 財務決算表合計預設 ORDER BY 項次" : CmdSet_For_DGV()
    End Sub
    Friend Sub SQL_財務決算表合計預設修改()
        ConnOpen() : SQL1 = "UPDATE 財務決算表合計預設 SET  名稱 = N'" & PA1 & "', 年度合計 = N'" & 布林1 & "' WHERE (項次 LIKE N'" & PA2 & "')" : CmdSet_For_dr()
    End Sub
    Friend Sub SQL_營運成本收支_決算表_會計科目()
        ConnOpen() : SQL1 = "SELECT 會計科目 FROM 會計科目 WHERE (層級 LIKE N'1') AND (停用 IS NULL OR 停用 = 0) ORDER BY  會計科目" : CmdSet_For_dr()
    End Sub
    Friend Sub SQL_營運成本收支_決算表_彙總借貸()
        ConnOpen() : SQL1 = "SELECT 抵銷科目 FROM 會計科目 WHERE (層級 LIKE 1) AND (會計科目 LIKE N'" & PA1 & "')" : CmdSet_For_dr()
    End Sub
    '---------------------營運成本收支單_對帳表-----------------------------------------------------------------------------------------------------------------
    Friend Sub SQL_營運成本收支_決算表_清單()
        ConnOpen()
        SQL1 = "SELECT      營運成本控制表.支付單號 AS 收支單號, 營運成本控制表.申請人, 營運成本控制表.申請日期, 營運成本控制表.審核人, 
                            營運成本控制表.審核日期, 營運成本明細表.項次, 會計科目.會計科目, 營運成本明細表.用途 AS 用途與內容, 
                            營運成本明細表.零用金 AS 開票, 營運成本明細表.支票數 AS 收票, 營運成本明細表.收款 AS 現金, 
                            營運成本明細表.金額 AS 支出, 營運成本明細表.備註, 營運成本明細表.會計, 營運成本明細表.作帳日期, 
                            營運成本明細表.出納 AS 點交, 營運成本明細表.出納日期 AS 點交日期, 營運成本明細表.備用金 AS 開票已付, 
                            營運成本明細表.支票 AS 收票兌現, 營運成本明細表.現金 AS 現金點交, 營運成本明細表.公帳 AS 支出點交, 
                            營運成本明細表.到期日
                FROM        營運成本明細表 INNER JOIN
                            會計科目 ON 營運成本明細表.會計科目 = 會計科目.編號 FULL OUTER JOIN
                            營運成本控制表 ON 營運成本明細表.流水號 = 營運成本控制表.支付單號
                WHERE      (營運成本控制表.公司編號 LIKE N'%" & 公司編號 & "%') AND (營運成本明細表.狀態 NOT LIKE N'轉現') AND 
                           (營運成本控制表.審核人 NOT LIKE N'作廢%') " & KKKJJ3 & KKKJJ & KKKJJ2 & " 
                ORDER BY    收支單號 DESC, 營運成本明細表.項次"
        CmdSet_For_DGV()
    End Sub
    Friend Sub SQL_營運成本明細表_會計歸零()
        ConnOpen() : SQL1 = "UPDATE 營運成本明細表 SET 會計 = N'0' WHERE (會計 IS NULL)" : CmdSet_For_dr()
    End Sub
    Friend Sub SQL_營運成本明細表_出納歸零()
        ConnOpen() : SQL1 = "UPDATE 營運成本明細表 SET 出納 = N'0' WHERE (出納 IS NULL)" : CmdSet_For_dr()
    End Sub
    Friend Sub SQL_營運成本明細表_現金歸零()
        ConnOpen() : SQL1 = "UPDATE 營運成本明細表 SET 現金 = N'0' WHERE (現金 IS NULL)" : CmdSet_For_dr()
    End Sub
    Friend Sub SQL_營運成本明細表_備用金歸零()
        ConnOpen() : SQL1 = "UPDATE 營運成本明細表 SET 備用金 = N'0' WHERE (備用金 IS NULL)" : CmdSet_For_dr()
    End Sub
    Friend Sub SQL_營運成本明細表_公帳歸零()
        ConnOpen() : SQL1 = "UPDATE 營運成本明細表 SET 公帳 = N'0' WHERE (公帳 IS NULL)" : CmdSet_For_dr()
    End Sub
    Friend Sub SQL_營運成本明細表_支票歸零()
        ConnOpen() : SQL1 = "UPDATE 營運成本明細表 SET 支票 = N'0' WHERE (支票 IS NULL)" : CmdSet_For_dr()
    End Sub
    Friend Sub SQL_營運成本明細表_作帳日期歸零()
        ConnOpen() : SQL1 = "UPDATE 營運成本明細表 SET 作帳日期 = N'' WHERE (作帳日期 IS NULL)" : CmdSet_For_dr()
    End Sub
    Friend Sub SQL_營運成本明細表_出納日期歸零()
        ConnOpen() : SQL1 = "UPDATE 營運成本明細表 SET 出納日期 = N'' WHERE (出納日期 IS NULL)" : CmdSet_For_dr()
    End Sub
    Friend Sub SQL_營運成本明細表_對帳記錄存檔()
        ConnOpen()
        SQL1 = "UPDATE 營運成本明細表 SET 現金 = N'" & 布林1 & "', 備用金 = N'" & 布林2 & "', 公帳 = N'" & 布林3 & "', 支票 = N'" & 布林4 & "' WHERE 流水號 LIKE N'" & PA1 & "' AND 項次 LIKE N'" & PA2 & "'"
        CmdSet_For_dr()
    End Sub
    '---------------------營運成本收支單一覽表-----------------------------------------------------------------------------------------------------------------
    Friend Sub SQL_營運成本收支單一覽表清單()
        ConnOpen()
        SQL1 = "SELECT   營運成本控制表.支付單號 AS 收支單號, 營運成本控制表.申請人, 營運成本控制表.申請日期, 營運成本控制表.審核人, 營運成本控制表.審核日期, 營運成本控制表.核准圖檔, 
                         營運成本控制表.簽名編碼
                FROM     營運成本控制表 INNER JOIN 營運成本明細表 ON 營運成本控制表.支付單號 = 營運成本明細表.流水號 
                WHERE   (營運成本明細表.狀態 LIKE N'%現%' OR 營運成本明細表.狀態 IS NULL OR 營運成本明細表.狀態 LIKE N'') AND (營運成本控制表.審核人 NOT LIKE N'') AND 
                        (營運成本控制表.審核人 NOT LIKE N'作廢%') AND (營運成本控制表.公司編號 LIKE N'%" & 公司編號 & "%') AND 
                         營運成本控制表.審核日期 BETWEEN '" & Strings.Format(財務收支單一覽表.開始日期_dtp.Value, "yyyy/MM/dd") &
                                                "' AND '" & Strings.Format(財務收支單一覽表.結束日期_dtp.Value, "yyyy/MM/dd") & "'
                GROUP BY 營運成本控制表.支付單號, 營運成本控制表.申請人, 營運成本控制表.申請日期, 營運成本控制表.審核人, 營運成本控制表.審核日期, 營運成本控制表.核准圖檔, 
                         營運成本控制表.簽名編碼
                ORDER BY 營運成本控制表.審核日期 DESC"
        CmdSet_For_DGV()
    End Sub
    Friend Sub SQL_營運成本收支單一覽表彙總()
        ConnOpen()
        SQL1 = "SELECT      LEFT(營運成本控制表.審核日期, 7) AS 日期, 會計科目.第一階 AS 主項, 會計科目.第二階 AS 子項, 會計科目.會計科目 AS 子細項, SUM(營運成本明細表.零用金) AS 開票, 
                            SUM(營運成本明細表.支票數) AS 收票, SUM(營運成本明細表.收款) AS 現金, SUM(營運成本明細表.金額) AS 支出
                FROM        營運成本控制表 RIGHT OUTER JOIN 營運成本明細表 ON 營運成本控制表.支付單號 = 營運成本明細表.流水號 RIGHT OUTER JOIN 會計科目 ON 營運成本明細表.會計科目 = 會計科目.編號
                WHERE      (營運成本明細表.狀態 LIKE N'%現%' OR 營運成本明細表.狀態 IS NULL OR 營運成本明細表.狀態 LIKE N'') AND (營運成本控制表.公司編號 LIKE N'%" & 公司編號 & "%') AND 
                           (營運成本控制表.審核日期 BETWEEN '" & Strings.Format(財務收支單一覽表.開始日期_dtp.Value, "yyyy/MM/dd") & "' 
                                                        AND '" & Strings.Format(財務收支單一覽表.結束日期_dtp.Value, "yyyy/MM/dd") & "')
                GROUP BY    會計科目.第一階, 會計科目.第二階, 會計科目.會計科目, LEFT(會計科目.編號, 7), LEFT(營運成本控制表.審核日期, 7)
                ORDER BY    LEFT(營運成本控制表.審核日期, 7), LEFT(會計科目.編號, 7)"
        CmdSet_For_DGV()
    End Sub
    Friend Sub SQL_營運成本收支單一覽表費用清單()
        ConnOpen()
        SQL1 = "SELECT      營運成本明細表.流水號, 營運成本明細表.項次, 會計科目.會計科目, 營運成本明細表.用途, 
                            營運成本明細表.零用金 AS 開票, 營運成本明細表.支票數 AS 收票, 營運成本明細表.收款 AS 現金, 
                            營運成本明細表.金額 AS 支出, 營運成本明細表.備註 AS 票期
                FROM        營運成本明細表 INNER JOIN
                            會計科目 ON 營運成本明細表.會計科目 = 會計科目.編號
                WHERE      (營運成本明細表.狀態 LIKE N'%現%' OR 營運成本明細表.狀態 IS NULL OR 營運成本明細表.狀態 LIKE N'') AND (營運成本明細表.流水號 LIKE N'" & 財務收支單一覽表.收支單號_tb.Text & "')
                ORDER BY    營運成本明細表.項次"
        CmdSet_For_DGV()
    End Sub
    '---------------------現金收支單申請-----------------------------------------------------------------------------------------------------------------
    Friend Sub SQL_營運成本收支單申請清單()
        ConnOpen()
        If 現金收支單申請.未核准的現金收支單_rb.Checked = True And 現金收支單申請.作廢的現金收支單_rb.Checked = False And 現金收支單申請.已核准的現金收支單_rb.Checked = False Then
            KKKJJ = "WHERE (營運成本明細表.狀態 LIKE N'%現%' OR 營運成本明細表.狀態 IS NULL OR 營運成本明細表.狀態 LIKE N'') AND (營運成本控制表.審核人 LIKE N'') AND 
                           (營運成本控制表.公司編號 LIKE N'%" & 公司編號 & "%')"
        ElseIf 現金收支單申請.未核准的現金收支單_rb.Checked = False And 現金收支單申請.作廢的現金收支單_rb.Checked = True And 現金收支單申請.已核准的現金收支單_rb.Checked = False Then
            KKKJJ = "WHERE (營運成本明細表.狀態 LIKE N'%現%' OR 營運成本明細表.狀態 IS NULL OR 營運成本明細表.狀態 LIKE N'') AND (營運成本控制表.審核人 LIKE N'作廢%') AND 
                           (營運成本控制表.公司編號 LIKE N'%" & 公司編號 & "%')"
        ElseIf 現金收支單申請.未核准的現金收支單_rb.Checked = False And 現金收支單申請.作廢的現金收支單_rb.Checked = False And 現金收支單申請.已核准的現金收支單_rb.Checked = True Then
            KKKJJ = "WHERE (營運成本明細表.狀態 LIKE N'%現%' OR 營運成本明細表.狀態 IS NULL OR 營運成本明細表.狀態 LIKE N'') AND (營運成本控制表.審核人 NOT LIKE N'作廢%') AND 
                           (營運成本控制表.審核人 NOT LIKE N'') AND (營運成本控制表.公司編號 LIKE N'%" & 公司編號 & "%')"
        End If
        SQL1 = "SELECT    營運成本控制表.支付單號 AS 收支單號, 營運成本控制表.申請日期, 營運成本控制表.審核日期, 營運成本控制表.申請人
                FROM      營運成本控制表 INNER JOIN 營運成本明細表 ON 營運成本控制表.支付單號 = 營運成本明細表.流水號 " & KKKJJ & " 
                GROUP BY  營運成本控制表.支付單號, 營運成本控制表.申請日期, 營運成本控制表.審核日期, 營運成本控制表.申請人
                ORDER BY  營運成本控制表.申請日期 DESC"
        CmdSet_For_DGV()
    End Sub
    Friend Sub SQL_營運成本收支單申請費用清單()
        ConnOpen()
        SQL1 = "SELECT      營運成本明細表.流水號, 營運成本明細表.項次, 會計科目.會計科目, 營運成本明細表.用途, 
                            營運成本明細表.零用金 AS 開票, 營運成本明細表.支票數 AS 收票, 營運成本明細表.收款 AS 現金, 
                            營運成本明細表.金額 AS 支出, 營運成本明細表.備註, 營運成本明細表.會計科目 AS 科目編號, 
                            營運成本明細表.狀態
                FROM        營運成本明細表 INNER JOIN
                            會計科目 ON 營運成本明細表.會計科目 = 會計科目.編號
                WHERE      (狀態 LIKE N'%現%'  OR 營運成本明細表.狀態 IS NULL OR 營運成本明細表.狀態 LIKE N'') AND (營運成本明細表.流水號 LIKE N'" & 現金收支單申請.收支單號_tb.Text & "')
                ORDER BY    營運成本明細表.項次"
        CmdSet_For_DGV()
    End Sub
    Friend Sub SQL_營運成本收支單申請修改()
        ConnOpen()
        SQL1 = "UPDATE 營運成本明細表 SET  用途 = N'" & PA1 & "', 金額 = N'" & NU1 & "', 備註 = N'" & PA2 & "' , 會計科目 = N'" & PA3 &
                                       "', 收款 = N'" & NU2 & "', 零用金 = N'" & NU3 & "', 支票數 = N'" & NU4 & "', 狀態 = N'" & PA6 & "', 登錄人 = N'" & PA7 & "'
                WHERE (流水號 LIKE N'" & PA4 & "' AND 項次 LIKE N'" & PA5 & "')"
        CmdSet_For_dr()
    End Sub
    Friend Sub SQL_營運成本收支單申請_會科修改()
        ConnOpen()
        SQL1 = "UPDATE 營運成本明細表 SET  會計科目 = N'" & PA1 & "' WHERE (流水號 LIKE N'" & PA4 & "' AND 項次 LIKE N'" & PA5 & "')"
        CmdSet_For_dr()
    End Sub
    '---------------------營運成本收支單審核-----------------------------------------------------------------------------------------------------------------
    Friend Sub SQL_營運成本收支單審核清單()
        ConnOpen()
        If 財務收支單審核.未核准的營運成本收支單_rb.Checked = True And 財務收支單審核.作廢的營運成本收支單_rb.Checked = False Then
            KKKJJ = "WHERE (營運成本明細表.狀態 LIKE N'%現%') AND (營運成本控制表.審核人 LIKE N'')  AND (營運成本控制表.公司編號 LIKE N'%" & 公司編號 & "%')"
        ElseIf 財務收支單審核.未核准的營運成本收支單_rb.Checked = False And 財務收支單審核.作廢的營運成本收支單_rb.Checked = True Then
            KKKJJ = "WHERE (營運成本明細表.狀態 LIKE N'%現%') AND (營運成本控制表.審核人 LIKE N'作廢%')  AND (營運成本控制表.公司編號 LIKE N'%" & 公司編號 & "%')"
        End If
        SQL1 = "SELECT     營運成本控制表.支付單號 AS 收支單號, 營運成本控制表.申請日期, 營運成本控制表.審核日期, 營運成本控制表.申請人
                FROM       營運成本控制表 INNER JOIN 營運成本明細表 ON 營運成本控制表.支付單號 = 營運成本明細表.流水號 " & KKKJJ & " 
                GROUP BY   營運成本控制表.支付單號, 營運成本控制表.申請日期, 營運成本控制表.審核日期, 營運成本控制表.申請人
                ORDER BY   收支單號 DESC"
        CmdSet_For_DGV()
    End Sub
    Friend Sub SQL_營運成本收支單審核費用清單()
        ConnOpen()
        SQL1 = "SELECT      營運成本明細表.流水號, 營運成本明細表.項次, QQ.會計科目, 營運成本明細表.用途, 營運成本明細表.支票數 AS 收票, 營運成本明細表.零用金 AS 開票, 營運成本明細表.收款 AS 現金, 
                            營運成本明細表.金額 AS 支出, 營運成本明細表.備註, 營運成本明細表.狀態, 營運成本明細表.倉儲單號, 營運成本明細表.支票號碼, 營運成本明細表.到期日, 營運成本明細表.開票人, 
                            營運成本明細表.登錄人
                FROM        營運成本明細表 LEFT OUTER JOIN 會計科目 AS QQ ON 營運成本明細表.會計科目 = QQ.編號
                WHERE      (營運成本明細表.狀態 LIKE N'%現%') AND (營運成本明細表.流水號 LIKE N'" & 財務收支單審核.收支單號_tb.Text & "')
                ORDER BY    營運成本明細表.項次"
        CmdSet_For_DGV()
    End Sub
    Friend Sub SQL_營運成本收支單審核_圖檔編碼()
        ConnOpen() : SQL1 = "SELECT 圖片流水號 AS 圖檔編碼, 簽名檔人名 FROM MJ主管簽名檔管理 ORDER BY 圖片流水號 DESC" : CmdSet_For_DGV()
    End Sub
    Friend Sub SQL_營運成本收支單審核_簽名編碼()
        ConnOpen() : SQL1 = "SELECT 簽名編碼 FROM 營運成本控制表 WHERE 簽名編碼 LIKE N'" & 財務收支單審核.驗證碼_tb.Text & "'" : CmdSet_For_dr()
    End Sub
    Friend Sub SQL_營運成本收支單審核_控制表修改()
        ConnOpen()
        SQL1 = "UPDATE 營運成本控制表 SET 審核人 = N'" & gUserName & "', 審核日期 = N'" & DTP & "', 核准圖檔 = N'" & 財務收支單審核.圖片編碼_tb.Text &
                                    "', 簽名編碼 = N'" & 財務收支單審核.驗證碼_tb.Text & "', 出納 = N'" & gUserName & "', 出納日期 = N'" & DTP & "' 
                WHERE (支付單號 = N'" & 財務收支單審核.收支單號_tb.Text & "')"
        CmdSet_For_dr()
    End Sub
    Friend Sub SQL_營運成本收支單審核_明細表修改()
        ConnOpen() : SQL1 = "UPDATE 營運成本明細表 SET 出納 = N'1', 出納日期 = N'" & DTP & "' WHERE (流水號 LIKE N'" & 財務收支單審核.收支單號_tb.Text & "')" : CmdSet_For_dr()
    End Sub
    Friend Sub SQL_營運成本收支單審核_明細表_現金確認()
        ConnOpen() : SQL1 = "UPDATE 營運成本明細表 SET  現金 = N'1' WHERE (流水號 LIKE N'" & PA1 & "' AND 項次 LIKE N'" & PA2 & "')" : CmdSet_For_dr()
    End Sub
    Friend Sub SQL_營運成本收支單審核_明細表_公帳確認()
        ConnOpen() : SQL1 = "UPDATE 營運成本明細表 SET  公帳 = N'1' WHERE (流水號 LIKE N'" & PA1 & "' AND 項次 LIKE N'" & PA2 & "')" : CmdSet_For_dr()
    End Sub
    Friend Sub SQL_營運成本收支單審核_控制表作廢()
        ConnOpen()
        SQL1 = "UPDATE 營運成本控制表 SET 審核人 = N'作廢-" & gUserName & "', 審核日期 = N'" & DTP & "', 備註 = N'" & PA & "' WHERE (支付單號 = N'" & 財務收支單審核.收支單號_tb.Text & "')"
        CmdSet_For_dr()
    End Sub
    '---------------------營運狀態彙總_檢視表-----------------------------------------------------------------------------------------------------------------
    Friend Sub SQL_營運狀態彙總_檢視表清單_採購()
        ConnOpen()
        SQL1 = "SELECT    倉儲明細表.單據編號, 供應商資料表.簡稱 AS 廠商, SUM(倉儲明細表.金額 * 倉儲明細表.匯率 * 倉儲明細表.入庫) AS 採購成本, LEFT(倉儲明細表.入庫日期, 7) AS 入庫
                FROM      倉儲明細表 LEFT OUTER JOIN 供應商資料表 ON 倉儲明細表.供應商編號 = 供應商資料表.編號
                WHERE    (倉儲明細表.狀態 LIKE N'採購入庫') AND (倉儲明細表.公司編號 LIKE N'%" & 公司編號 & "%') AND 
                         (倉儲明細表.採購下單 LIKE N'" & 營運狀態彙總_檢視表.年份_cb.Text & "/" & 營運狀態彙總_檢視表.月份_cb.Text & "%')
                GROUP BY  供應商資料表.簡稱, LEFT(倉儲明細表.入庫日期, 7), 倉儲明細表.單據編號
                ORDER BY  廠商"
        CmdSet_For_DGV()
    End Sub
    Friend Sub SQL_營運狀態彙總_檢視表清單_訂單()
        ConnOpen()
        SQL1 = "SELECT      訂單控制表.訂單流水號, 客戶資料表.簡稱, 訂單明細表.出貨情況, SUM(訂單明細表.數量) AS 訂單總數, SUM(倉儲明細表_2.入庫) AS 訂單採購, SUM(倉儲明細表_1.出庫) AS 訂單出貨, 
                            SUM(倉儲明細表_2.入庫 * 倉儲明細表_2.金額) AS 採購成本, SUM(倉儲明細表_1.出庫 * 倉儲明細表_1.售價) AS 出貨銷售, SUM(訂單明細表.數量 * 物料資料庫.售價) AS 銷售預估
                FROM        訂單明細表 LEFT OUTER JOIN 物料資料庫 ON 訂單明細表.料號 = 物料資料庫.料號 LEFT OUTER JOIN
                                (SELECT   資料流水號, 單據編號, 供應商編號, 料號, 金額, 匯率, 入庫, 出庫, 狀態, 採購下單, 入庫日期, 
                                          出庫日期, 備註, 倉儲作業, 客戶編號, 售價, 公司編號, 倉名編號, 交期, 訂單流水號
                                 FROM     倉儲明細表
                                 WHERE   (倉儲明細表.倉儲作業 NOT LIKE N'')) AS 倉儲明細表_1 ON 
                            訂單明細表.出貨單號 = 倉儲明細表_1.單據編號 AND   訂單明細表.料號 = 倉儲明細表_1.料號 LEFT OUTER JOIN 倉儲明細表 AS 倉儲明細表_2 ON 
                            訂單明細表.料號 = 倉儲明細表_2.料號 AND 訂單明細表.採購單號 = 倉儲明細表_2.單據編號 LEFT OUTER JOIN 客戶資料表 INNER JOIN 訂單控制表 ON 
                            客戶資料表.編號 = 訂單控制表.客戶編號 ON 訂單明細表.訂單流水號 = 訂單控制表.訂單流水號
                WHERE      (訂單控制表.下單日 LIKE N'" & 營運狀態彙總_檢視表.年份_cb.Text & "/" & 營運狀態彙總_檢視表.月份_cb.Text & "%') AND (訂單控制表.公司編號 LIKE N'%" & 公司編號 & "%')
                GROUP BY    客戶資料表.簡稱, 訂單明細表.出貨情況, 訂單控制表.訂單流水號
                ORDER BY    客戶資料表.簡稱, 訂單明細表.出貨情況"
        CmdSet_For_DGV()
    End Sub
    Friend Sub SQL_營運狀態彙總_檢視表清單_生產()
        ConnOpen()
        SQL1 = "SELECT     客戶資料表.簡稱, SUM(倉儲明細表.金額 * 倉儲明細表.匯率 * 倉儲明細表.出庫) AS 損耗成本
                FROM       倉儲明細表 INNER JOIN 客戶資料表 ON 倉儲明細表.客戶編號 = 客戶資料表.編號 LEFT OUTER JOIN 物料資料庫 ON 倉儲明細表.料號 = 物料資料庫.料號
                WHERE     (物料資料庫.頁碼 LIKE N'000%') AND (倉儲明細表.狀態 LIKE N'組裝出庫') AND (倉儲明細表.公司編號 LIKE N'%" & 公司編號 & "%') AND 
                          (倉儲明細表.採購下單 LIKE N'" & 營運狀態彙總_檢視表.年份_cb.Text & "/" & 營運狀態彙總_檢視表.月份_cb.Text & "%')
                GROUP BY   客戶資料表.簡稱
                ORDER BY   客戶資料表.簡稱"
        CmdSet_For_DGV()
    End Sub
    Friend Sub SQL_營運狀態彙總_檢視表清單_銷售()
        ConnOpen()
        SQL1 = "SELECT    倉儲明細表.單據編號, 客戶資料表.簡稱 AS 客戶, SUM(倉儲明細表.售價 * 倉儲明細表.出庫) AS 銷售金額, SUM(倉儲明細表.金額 * 倉儲明細表.匯率 * 倉儲明細表.出庫) AS 銷售成本
                FROM      倉儲明細表 INNER JOIN 物料資料庫 ON 倉儲明細表.料號 = 物料資料庫.料號 LEFT OUTER JOIN 客戶資料表 ON 倉儲明細表.客戶編號 = 客戶資料表.編號
                WHERE    (倉儲明細表.狀態 LIKE N'銷售出庫') AND (倉儲明細表.公司編號 LIKE N'%" & 公司編號 & "%') AND 
                         (倉儲明細表.採購下單 LIKE N'" & 營運狀態彙總_檢視表.年份_cb.Text & "/" & 營運狀態彙總_檢視表.月份_cb.Text & "%')
                GROUP BY  客戶資料表.簡稱, 倉儲明細表.單據編號
                ORDER BY  客戶"
        CmdSet_For_DGV()
    End Sub
    Friend Sub SQL_營運狀態彙總_檢視表清單_庫存()
        ConnOpen()
        SQL1 = "SELECT      供應商資料表.簡稱 AS 供應商, 倉儲明細表.供應商編號, 倉儲明細表.料號, 物料資料庫.品名, 物料資料庫.尺寸, 物料資料庫.材質, 
                            SUM(倉儲明細表.金額 * 倉儲明細表.匯率 * 倉儲明細表.入庫) / SUM(倉儲明細表.入庫) AS 加權成本_台幣, SUM(倉儲明細表.入庫) - SUM(倉儲明細表.出庫) AS 庫存, 
                            (SUM(倉儲明細表.入庫) - SUM(倉儲明細表.出庫)) * (SUM(倉儲明細表.金額 * 倉儲明細表.匯率 * 倉儲明細表.入庫) / SUM(倉儲明細表.入庫)) AS 庫存成本_台幣, WW.未入庫, 
                            WW.未入庫 * (SUM(倉儲明細表.金額 * 倉儲明細表.匯率 * 倉儲明細表.入庫) / SUM(倉儲明細表.入庫)) AS 在途成本_台幣, QQ.未出庫, 
                            QQ.未出庫 * (SUM(倉儲明細表.金額 * 倉儲明細表.匯率 * 倉儲明細表.入庫) / SUM(倉儲明細表.入庫)) AS 備貨成本_台幣, QQ.未出庫 AS 可領用, 倉儲分區控制表.倉名, 物料資料庫.備註
                 FROM       倉儲明細表 INNER JOIN 倉儲分區控制表 ON 倉儲明細表.倉名編號 = 倉儲分區控制表.倉名編號 LEFT OUTER JOIN 物料資料庫 ON 倉儲明細表.料號 = 物料資料庫.料號 LEFT OUTER JOIN
                            供應商資料表 ON 倉儲明細表.供應商編號 = 供應商資料表.編號 FULL OUTER JOIN
                                (SELECT          供應商編號, 料號, SUM(出庫) AS 未出庫
                                  FROM           倉儲明細表 AS 倉儲明細表_2
                                  WHERE         (倉儲作業 LIKE N'') AND (狀態 LIKE N'%出庫') AND (公司編號 LIKE N'%" & 公司編號 & "%') AND 
                                                (倉儲作業 BETWEEN '2020/01/01' AND '" & 營運狀態彙總_檢視表.年份_cb.Text & "/" & 營運狀態彙總_檢視表.月份_cb.Text & "/" & PA1 & "')
                                  GROUP BY       供應商編號, 料號) AS QQ ON 倉儲明細表.供應商編號 = QQ.供應商編號 AND 
                            倉儲明細表.料號 = QQ.料號 FULL OUTER JOIN
                                (SELECT          供應商編號, 料號, SUM(入庫) AS 未入庫
                                  FROM           倉儲明細表 AS 倉儲明細表_1
                                  WHERE         (倉儲作業 LIKE N'') AND (狀態 LIKE N'%入庫') AND (公司編號 LIKE N'%" & 公司編號 & "%') AND 
                                                (倉儲作業 BETWEEN '2020/01/01' AND '" & 營運狀態彙總_檢視表.年份_cb.Text & "/" & 營運狀態彙總_檢視表.月份_cb.Text & "/" & PA1 & "')
                                  GROUP BY       供應商編號, 料號) AS WW ON 倉儲明細表.供應商編號 = WW.供應商編號 AND 
                            倉儲明細表.料號 = WW.料號
                 WHERE     (倉儲明細表.公司編號 LIKE N'%" & 公司編號 & "%') AND (倉儲明細表.倉儲作業 NOT LIKE N'') AND 
                           (倉儲明細表.倉儲作業 BETWEEN '2020/01/01' AND '" & 營運狀態彙總_檢視表.年份_cb.Text & "/" & 營運狀態彙總_檢視表.月份_cb.Text & "/" & PA1 & "')
                 GROUP BY   供應商資料表.簡稱, 倉儲明細表.供應商編號, 倉儲明細表.料號, 物料資料庫.品名, 物料資料庫.尺寸, 物料資料庫.材質, WW.未入庫, QQ.未出庫, 倉儲分區控制表.倉名, 物料資料庫.備註
                 HAVING    (SUM(倉儲明細表.入庫) - SUM(倉儲明細表.出庫) > 0)
                 ORDER BY   倉儲分區控制表.倉名, 供應商, 倉儲明細表.料號"
        CmdSet_For_DGV()
    End Sub
    Friend Sub SQL_營運狀態彙總_檢視表清單_盤點()
        ConnOpen()
        SQL1 = "SELECT    倉儲明細表.單據編號, 供應商資料表.簡稱 AS 名稱, SUM(倉儲明細表.金額 * 倉儲明細表.匯率 * 倉儲明細表.入庫) AS 盤營金額, 
                          SUM(倉儲明細表.金額 * 倉儲明細表.匯率 * 倉儲明細表.出庫) AS 盤損金額
                FROM      倉儲明細表 LEFT OUTER JOIN 供應商資料表 ON 倉儲明細表.供應商編號 = 供應商資料表.編號
                WHERE    (倉儲明細表.狀態 LIKE N'盤%') AND (倉儲明細表.公司編號 LIKE N'%" & 公司編號 & "%') AND 
                         (倉儲明細表.採購下單 LIKE N'" & 營運狀態彙總_檢視表.年份_cb.Text & "/" & 營運狀態彙總_檢視表.月份_cb.Text & "%')
                GROUP BY  供應商資料表.簡稱, 倉儲明細表.狀態, 倉儲明細表.單據編號
                ORDER BY  名稱"
        CmdSet_For_DGV()
    End Sub
    '---------------------業務佣金計算-----------------------------------------------------------------------------------------------------------------
    Friend Sub SQL_業務佣金計算清單()
        ConnOpen()
        SQL1 = "SELECT      倉儲明細表.單據編號, 倉儲明細表.出庫日期 AS 出貨日期, 客戶資料表.簡稱, 物料資料庫.品名, 倉儲明細表.售價, 倉儲明細表.出庫 AS 數量, 倉儲明細表.業務, 倉儲明細表.業務比例 AS 比例, 
                            倉儲明細表.售價 * 倉儲明細表.出庫 / 100 * 倉儲明細表.業務比例 AS 佣金, 倉儲明細表.已轉帳 AS 已立帳, 倉儲明細表.已轉帳 AS 選擇, 倉儲明細表.資料流水號
                FROM        倉儲明細表 INNER JOIN 客戶資料表 ON 倉儲明細表.客戶編號 = 客戶資料表.編號 INNER JOIN 物料資料庫 ON 倉儲明細表.料號 = 物料資料庫.料號
                WHERE      (倉儲明細表.業務 IS NOT NULL) AND (倉儲明細表.業務 LIKE N'%" & 業務佣金計算.業務_cb.Text & "%') AND (倉儲明細表.狀態 LIKE N'銷售出庫') AND 
                           (倉儲明細表.倉儲作業 BETWEEN '" & Format(業務佣金計算.開始日期_dtp.Value, "yyyy/MM/dd") & "' AND '" & Format(業務佣金計算.結束日期_dtp.Value, "yyyy/MM/dd") & "') AND 
                           (倉儲明細表.公司編號 LIKE N'%" & 公司編號 & "%') AND (倉儲明細表.業務比例 <> 0)
                ORDER BY   倉儲明細表.單據編號"
        CmdSet_For_DGV()
    End Sub
    Friend Sub SQL_銷售業務人員清單()
        ConnOpen() : SQL1 = "SELECT 業務 FROM 倉儲明細表 WHERE (業務 IS NOT NULL) GROUP BY 業務 ORDER BY 業務" : CmdSet_For_dr()
    End Sub
    Friend Sub SQL_業務佣金計算表_轉立收支單修改()
        ConnOpen() : SQL1 = "UPDATE 倉儲明細表 SET 已轉帳 = 1 WHERE 資料流水號 LIKE N'" & PA6 & "'" : CmdSet_For_dr()
    End Sub
    '---------------------司機佣金計算-----------------------------------------------------------------------------------------------------------------
    Friend Sub SQL_司機佣金計算清單()
        ConnOpen()
        SQL1 = "SELECT      倉儲明細表.單據編號, 倉儲明細表.出庫日期 AS 出貨日期, 客戶資料表.簡稱, 物料資料庫.品名, 倉儲明細表.售價, 倉儲明細表.出庫 AS 數量, 倉儲明細表.司機, 倉儲明細表.司機比例 AS 比例, 
                            倉儲明細表.售價 * 倉儲明細表.出庫 / 100 * 倉儲明細表.司機比例 AS 佣金, 倉儲明細表.已立帳, 倉儲明細表.已轉帳 AS 選擇, 倉儲明細表.資料流水號
                FROM        倉儲明細表 INNER JOIN 客戶資料表 ON 倉儲明細表.客戶編號 = 客戶資料表.編號 INNER JOIN 物料資料庫 ON 倉儲明細表.料號 = 物料資料庫.料號
                WHERE      (倉儲明細表.司機 IS NOT NULL) AND (倉儲明細表.司機 LIKE N'%" & 司機佣金計算.司機_cb.Text & "%') AND (倉儲明細表.狀態 LIKE N'銷售出庫') AND 
                           (倉儲明細表.倉儲作業 BETWEEN '" & Format(司機佣金計算.開始日期_dtp.Value, "yyyy/MM/dd") & "' AND '" & Format(司機佣金計算.結束日期_dtp.Value, "yyyy/MM/dd") & "') AND 
                           (倉儲明細表.公司編號 LIKE N'%" & 公司編號 & "%') AND (倉儲明細表.司機比例 <> 0) AND (倉儲明細表.出庫 > 0)
                ORDER BY   倉儲明細表.單據編號"
        CmdSet_For_DGV()
    End Sub
    Friend Sub SQL_銷售司機人員清單()
        ConnOpen() : SQL1 = "SELECT 司機 FROM 倉儲明細表 WHERE (司機 IS NOT NULL) GROUP BY 司機 ORDER BY 司機" : CmdSet_For_dr()
    End Sub
    Friend Sub SQL_司機佣金計算表_轉立收支單修改()
        ConnOpen() : SQL1 = "UPDATE 倉儲明細表 SET 已立帳 = 1 WHERE 資料流水號 LIKE N'" & PA6 & "'" : CmdSet_For_dr()
    End Sub
    '---------------------應付帳款控制表-----------------------------------------------------------------------------------------------------------------
    Friend Sub SQL_應付賬款主單()
        ConnOpen()
        SQL1 = "SELECT      倉儲明細表.供應商編號, 供應商資料表.簡稱 AS 供應商
                FROM        倉儲明細表 LEFT OUTER JOIN
                            供應商資料表 ON 倉儲明細表.供應商編號 = 供應商資料表.編號 LEFT OUTER JOIN
                            物料資料庫 ON 倉儲明細表.料號 = 物料資料庫.料號
                WHERE      (倉儲明細表.狀態 LIKE N'採購入庫') AND (倉儲明細表.公司編號 LIKE N'%" & 公司編號 & "%') AND 
                           (倉儲明細表.採購下單 BETWEEN '" & Format(應付賬款控制表.開始日期_dtp.Value, "yyyy/MM/dd") & "' AND '" & Format(應付賬款控制表.結束日期_dtp.Value, "yyyy/MM/dd") & "')
                GROUP BY    倉儲明細表.供應商編號, 供應商資料表.簡稱
                ORDER BY    倉儲明細表.供應商編號, 供應商資料表.簡稱"
        CmdSet_For_DGV()
    End Sub
    Friend Sub SQL_應付賬款清單一()
        ConnOpen()
        SQL1 = "SELECT      倉儲明細表.單據編號, 倉儲明細表.供應商編號, 供應商資料表.簡稱 AS 供應商, 物料資料庫.料號, 物料資料庫.頁碼, 物料資料庫.品名, 倉儲明細表.金額 AS 單價, 倉儲明細表.匯率, 
                            倉儲明細表.入庫, 倉儲明細表.金額 * 倉儲明細表.匯率 * 倉儲明細表.入庫 AS 金額, 倉儲明細表.採購下單, 倉儲明細表.入庫日期, 倉儲明細表.備註, 倉儲明細表.應收立帳 AS 選擇, 
                            倉儲明細表.應付立帳, 倉儲明細表.資料流水號, 倉儲明細表.財務單號, 營運成本控制表.申請日期
                FROM        倉儲明細表 LEFT OUTER JOIN 營運成本控制表 ON 倉儲明細表.財務單號 = 營運成本控制表.支付單號 LEFT OUTER JOIN 供應商資料表 ON 倉儲明細表.供應商編號 = 供應商資料表.編號 
                            LEFT OUTER JOIN 物料資料庫 ON 倉儲明細表.料號 = 物料資料庫.料號
                WHERE      (倉儲明細表.狀態 LIKE N'採購入庫') AND (倉儲明細表.公司編號 LIKE N'%" & 公司編號 & "%') AND (倉儲明細表.供應商編號 LIKE N'" & 應付賬款控制表.供應商編號_tb.Text & "') AND 
                           (倉儲明細表.採購下單 BETWEEN '" & Format(應付賬款控制表.開始日期_dtp.Value, "yyyy/MM/dd") & "' AND '" & Format(應付賬款控制表.結束日期_dtp.Value, "yyyy/MM/dd") & "') 
                ORDER BY    倉儲明細表.單據編號, 倉儲明細表.入庫日期"
        CmdSet_For_DGV()
    End Sub
    Friend Sub SQL_應付賬款清單二()
        ConnOpen()
        SQL1 = "SELECT      倉儲明細表.單據編號, 倉儲明細表.供應商編號, 供應商資料表.簡稱 AS 供應商, 物料資料庫.料號, 物料資料庫.頁碼, 物料資料庫.品名, 倉儲明細表.金額 AS 單價, 倉儲明細表.匯率, 
                            倉儲明細表.入庫, 倉儲明細表.金額 * 倉儲明細表.匯率 * 倉儲明細表.入庫 AS 金額, 倉儲明細表.採購下單, 倉儲明細表.入庫日期, 倉儲明細表.備註, 倉儲明細表.應收立帳 AS 選擇, 
                            倉儲明細表.應付立帳, 倉儲明細表.資料流水號, 倉儲明細表.財務單號, 營運成本控制表.申請日期
                FROM        倉儲明細表 LEFT OUTER JOIN 營運成本控制表 ON 倉儲明細表.財務單號 = 營運成本控制表.支付單號 LEFT OUTER JOIN 供應商資料表 ON 倉儲明細表.供應商編號 = 供應商資料表.編號 
                            LEFT OUTER JOIN 物料資料庫 ON 倉儲明細表.料號 = 物料資料庫.料號
                WHERE      (倉儲明細表.狀態 LIKE N'採購入庫') AND (倉儲明細表.公司編號 LIKE N'%" & 公司編號 & "%') AND (倉儲明細表.財務單號 LIKE N'" & 應付賬款控制表.財務收支單號_tb.Text & "')
                ORDER BY    倉儲明細表.單據編號, 倉儲明細表.入庫日期"
        CmdSet_For_DGV()
    End Sub
    Friend Sub SQL_應付賬款清單三()
        ConnOpen()
        SQL1 = "SELECT     營運成本明細表.流水號, 營運成本明細表.項次, QQ.會計科目 AS 開票會科, 營運成本明細表.會計科目, 營運成本明細表.用途, 營運成本明細表.零用金 AS 開票, 
                           營運成本明細表.支票數 AS 收票, 營運成本明細表.金額 AS 付現, 營運成本明細表.收款 AS 收現, 營運成本明細表.備註, 營運成本明細表.備用金 AS 開票已付, 
                           營運成本明細表.支票 AS 收票託收, 營運成本明細表.支票號碼, 營運成本明細表.狀態, 營運成本明細表.到期日, 營運成本明細表.預定兌現日, 營運成本明細表.開收票日, 
                           營運成本明細表.託收已付日, WW.會計科目 AS 兌現會科, 營運成本明細表.兌現科目, 營運成本明細表.付款銀行, 營運成本明細表.開票人, 營運成本明細表.登錄人, 
                           營運成本明細表.發票人帳號, 營運成本明細表.作帳日期, 營運成本明細表.出納日期, 營運成本明細表.倉儲單號
                FROM       營運成本明細表 LEFT OUTER JOIN 會計科目 AS QQ ON 營運成本明細表.會計科目 = QQ.編號 LEFT OUTER JOIN 會計科目 AS WW ON 營運成本明細表.兌現科目 = WW.編號
                WHERE     (營運成本明細表.公司編號 LIKE N'%" & 公司編號 & "%') AND  (營運成本明細表.流水號 LIKE N'" & 應付賬款控制表.財務收支單號_tb.Text & "') 
                ORDER BY   營運成本明細表.項次"
        CmdSet_For_DGV()
    End Sub
    '---------------------應收帳款控制表-----------------------------------------------------------------------------------------------------------------
    Friend Sub SQL_應收賬款主單()
        ConnOpen()
        SQL1 = "SELECT      倉儲明細表.客戶編號, 客戶資料表.簡稱 AS 客戶
                FROM        倉儲明細表 INNER JOIN 客戶資料表 ON 倉儲明細表.客戶編號 = 客戶資料表.編號 LEFT OUTER JOIN
                            物料資料庫 ON 倉儲明細表.料號 = 物料資料庫.料號
                WHERE      (倉儲明細表.狀態 LIKE N'銷售出庫') AND (倉儲明細表.公司編號 LIKE N'%" & 公司編號 & "%') AND 
                           (倉儲明細表.採購下單 BETWEEN '" & Format(應收帳款控制表.開始日期_dtp.Value, "yyyy/MM/dd") & "' AND '" & Format(應收帳款控制表.結束日期_dtp.Value, "yyyy/MM/dd") & "')
                GROUP BY    倉儲明細表.客戶編號, 客戶資料表.簡稱
                ORDER BY    倉儲明細表.客戶編號, 客戶資料表.簡稱"
        CmdSet_For_DGV()
    End Sub
    Friend Sub SQL_應收賬款清單一()
        ConnOpen()
        SQL1 = "SELECT      倉儲明細表.單據編號, 倉儲明細表.客戶編號, 客戶資料表.簡稱 AS 客戶, 物料資料庫.料號, 物料資料庫.頁碼, 物料資料庫.品名, 倉儲明細表.售價 AS 單價, 倉儲明細表.匯率, 
                            倉儲明細表.出庫, 倉儲明細表.售價 * 倉儲明細表.匯率 * 倉儲明細表.出庫 AS 金額, 倉儲明細表.採購下單, 倉儲明細表.出庫日期, 倉儲明細表.備註, 倉儲明細表.應付立帳 AS 選擇, 
                            倉儲明細表.應收立帳, 倉儲明細表.資料流水號, 倉儲明細表.財務單號, 營運成本控制表.申請日期
                FROM        倉儲明細表 LEFT OUTER JOIN 營運成本控制表 ON 倉儲明細表.財務單號 = 營運成本控制表.支付單號 LEFT OUTER JOIN 客戶資料表 ON 倉儲明細表.客戶編號 = 客戶資料表.編號 
                            LEFT OUTER JOIN 物料資料庫 ON 倉儲明細表.料號 = 物料資料庫.料號
                WHERE      (倉儲明細表.狀態 LIKE N'銷售出庫') AND (倉儲明細表.公司編號 LIKE N'%" & 公司編號 & "%') AND (倉儲明細表.客戶編號 LIKE N'" & 應收帳款控制表.客戶編號_tb.Text & "') AND 
                           (倉儲明細表.採購下單 BETWEEN '" & Format(應收帳款控制表.開始日期_dtp.Value, "yyyy/MM/dd") & "' AND '" & Format(應收帳款控制表.結束日期_dtp.Value, "yyyy/MM/dd") & "') 
                ORDER BY    倉儲明細表.單據編號, 倉儲明細表.入庫日期"
        CmdSet_For_DGV()
    End Sub
    Friend Sub SQL_應收賬款清單二()
        ConnOpen()
        SQL1 = "SELECT      倉儲明細表.單據編號, 倉儲明細表.客戶編號, 客戶資料表.簡稱 AS 客戶, 物料資料庫.料號, 物料資料庫.頁碼, 物料資料庫.品名, 倉儲明細表.售價 AS 單價, 倉儲明細表.匯率, 
                            倉儲明細表.出庫, 倉儲明細表.售價 * 倉儲明細表.匯率 * 倉儲明細表.出庫 AS 金額, 倉儲明細表.採購下單, 倉儲明細表.出庫日期, 倉儲明細表.備註, 倉儲明細表.應付立帳 AS 選擇, 
                            倉儲明細表.應收立帳, 倉儲明細表.資料流水號, 倉儲明細表.財務單號, 營運成本控制表.申請日期
                FROM        倉儲明細表 LEFT OUTER JOIN 營運成本控制表 ON 倉儲明細表.財務單號 = 營運成本控制表.支付單號 LEFT OUTER JOIN 客戶資料表 ON 倉儲明細表.客戶編號 = 客戶資料表.編號 
                            LEFT OUTER JOIN 物料資料庫 ON 倉儲明細表.料號 = 物料資料庫.料號
                WHERE      (倉儲明細表.狀態 LIKE N'銷售出庫') AND (倉儲明細表.公司編號 LIKE N'%" & 公司編號 & "%') AND (倉儲明細表.財務單號 LIKE N'" & 應收帳款控制表.財務收支單號_tb.Text & "')
                ORDER BY    倉儲明細表.單據編號, 倉儲明細表.入庫日期"
        CmdSet_For_DGV()
    End Sub
    Friend Sub SQL_應收賬款清單三()
        ConnOpen()
        SQL1 = "SELECT     營運成本明細表.流水號, 營運成本明細表.項次, QQ.會計科目 AS 開票會科, 營運成本明細表.會計科目, 營運成本明細表.用途, 營運成本明細表.零用金 AS 開票, 
                           營運成本明細表.支票數 AS 收票, 營運成本明細表.金額 AS 付現, 營運成本明細表.收款 AS 收現, 營運成本明細表.備註, 營運成本明細表.備用金 AS 開票已付, 
                           營運成本明細表.支票 AS 收票託收, 營運成本明細表.支票號碼, 營運成本明細表.狀態, 營運成本明細表.到期日, 營運成本明細表.預定兌現日, 營運成本明細表.開收票日, 
                           營運成本明細表.託收已付日, WW.會計科目 AS 兌現會科, 營運成本明細表.兌現科目, 營運成本明細表.付款銀行, 營運成本明細表.開票人, 營運成本明細表.登錄人, 
                           營運成本明細表.發票人帳號, 營運成本明細表.作帳日期, 營運成本明細表.出納日期, 營運成本明細表.倉儲單號
                FROM       營運成本明細表 LEFT OUTER JOIN 會計科目 AS QQ ON 營運成本明細表.會計科目 = QQ.編號 LEFT OUTER JOIN 會計科目 AS WW ON 營運成本明細表.兌現科目 = WW.編號
                WHERE     (營運成本明細表.公司編號 LIKE N'%" & 公司編號 & "%') AND  (營運成本明細表.流水號 LIKE N'" & 應收帳款控制表.財務收支單號_tb.Text & "')
                ORDER BY   營運成本明細表.項次"
        CmdSet_For_DGV()
    End Sub
    '---------------------支票收支單申請-----------------------------------------------------------------------------------------------------------------
    Friend Sub SQL_支票收支單申請清單()
        ConnOpen()
        SQL1 = "SELECT    營運成本控制表.支付單號 AS 收支單號, 營運成本控制表.申請日期, 營運成本控制表.審核日期, 營運成本控制表.申請人, 營運成本明細表.狀態
                FROM      營運成本控制表 INNER JOIN 營運成本明細表 ON 營運成本控制表.支付單號 = 營運成本明細表.流水號 
                WHERE    (營運成本明細表.狀態 NOT LIKE N'%現%' OR 營運成本明細表.狀態 IS NULL OR 營運成本明細表.狀態 LIKE N'') AND 
                         (營運成本控制表.公司編號 LIKE N'%" & 公司編號 & "%') 
                GROUP BY  營運成本控制表.支付單號, 營運成本控制表.申請日期, 營運成本控制表.審核日期, 營運成本控制表.申請人, 營運成本明細表.狀態
                ORDER BY  營運成本控制表.申請日期 DESC"
        CmdSet_For_DGV()
    End Sub
    Friend Sub SQL_支票收支單申請費用清單()
        ConnOpen()
        SQL1 = "SELECT      營運成本明細表.流水號, 營運成本明細表.項次, QQ.會計科目, 營運成本明細表.用途, 營運成本明細表.零用金 AS 開票, 
                            營運成本明細表.支票數 AS 收票, 營運成本明細表.收款 AS 現金, 營運成本明細表.金額 AS 支出, 
                            營運成本明細表.備註, 營運成本明細表.會計科目 AS 科目編號, 營運成本明細表.狀態, 營運成本明細表.倉儲單號, 
                            營運成本明細表.支票號碼, 營運成本明細表.到期日, 營運成本明細表.預定兌現日, 營運成本明細表.開收票日, 
                            營運成本明細表.託收已付日, 營運成本明細表.兌現科目, 營運成本明細表.付款銀行, 營運成本明細表.開票人, 
                            營運成本明細表.登錄人, 營運成本明細表.發票人帳號, WW.會計科目 AS 兌現會科
                FROM        營運成本明細表 LEFT OUTER JOIN
                            會計科目 AS QQ ON 營運成本明細表.會計科目 = QQ.編號 LEFT OUTER JOIN
                            會計科目 AS WW ON 營運成本明細表.兌現科目 = WW.編號
                WHERE      (營運成本明細表.狀態 NOT LIKE N'%現%' OR 營運成本明細表.狀態 IS NULL OR 營運成本明細表.狀態 LIKE N'') AND 
                           (營運成本明細表.流水號 LIKE N'" & 支票收支單申請.收支單號_tb.Text & "')
                ORDER BY    營運成本明細表.項次"
        CmdSet_For_DGV()
    End Sub
    Friend Sub SQL_支票收支單申請複製單據新增()
        ConnOpen()
        SQL1 = "INSERT INTO 營運成本明細表 (流水號, 項次, 會計科目, 用途, 金額, 備註, 收款, 零用金, 支票數, 會計, 出納, 現金, 備用金, 公帳, 支票, 作帳日期, 出納日期, 公司編號, 狀態, 登錄人, 
                                                發票人帳號, 兌現科目, 付款銀行, 倉儲單號, 支票號碼, 開票人, 到期日, 預定兌現日, 開收票日) 
                VALUES (N'" & PA1 & "', N'" & PA2 & "', N'" & PA3 & "', N'" & PA4 & "', N'" & NU1 & "', N'" & PA5 & "', N'" & NU2 & "', N'" & NU3 & "', N'" & NU4 &
                    "', N'1', N'0', N'0', N'0', N'0', N'0', N'" & DTP & "', N'', N'" & 公司編號 & "', N'" & PA6 & "', N'" & PA7 & "', N'" & PA8 & "', N'" & PA9 &
                    "', N'" & PA10 & "', N'" & PA11 & "', N'" & PA12 & "', N'" & PA13 & "', N'" & PA14 & "', N'" & PA15 & "', N'" & PA16 & "')"
        CmdSet_For_dr()
    End Sub
    Friend Sub SQL_支票收支單申請_營運成本控制表新增()
        ConnOpen()
        SQL1 = "INSERT INTO 營運成本控制表 (支付單號, 申請人, 申請日期, 審核人, 審核日期, 會計, 作帳日期, 出納, 出納日期, 備註, 公司編號) 
                VALUES (N'" & PA & "', N'" & gUserName & "', N'" & DTP & "', N'" & gUserName & "', N'" & DTP & "', N'" & gUserName & "', N'" & DTP &
                    "', N'" & gUserName & "', N'" & DTP & "', N'票據作業', N'" & 公司編號 & "')"
        CmdSet_For_dr()
    End Sub
    '---------------------票務控制表-----------------------------------------------------------------------------------------------------------------
    Friend Sub SQL_票務控制表清單()
        ConnOpen()
        SQL1 = "SELECT      營運成本明細表.流水號, 營運成本明細表.項次, QQ.會計科目 AS 開票會科, 營運成本明細表.會計科目, 
                            營運成本明細表.用途, 營運成本明細表.零用金 AS 開票, 營運成本明細表.支票數 AS 收票, 營運成本明細表.備註, 
                            營運成本明細表.備用金 AS 開票已付, 營運成本明細表.支票 AS 收票託收, 營運成本明細表.支票號碼, 
                            營運成本明細表.狀態, 營運成本明細表.到期日, 營運成本明細表.預定兌現日, 營運成本明細表.開收票日, 
                            營運成本明細表.託收已付日, WW.會計科目 AS 兌現會科, 營運成本明細表.兌現科目, 營運成本明細表.付款銀行, 
                            營運成本明細表.開票人, 營運成本明細表.登錄人, 營運成本明細表.發票人帳號, 營運成本明細表.作帳日期, 
                            營運成本明細表.出納日期, 營運成本明細表.倉儲單號, MJ選擇按鈕.選擇
                FROM        營運成本明細表 LEFT OUTER JOIN
                            MJ選擇按鈕 ON 營運成本明細表.流水號 = MJ選擇按鈕.按鈕 LEFT OUTER JOIN
                            會計科目 AS QQ ON 營運成本明細表.會計科目 = QQ.編號 LEFT OUTER JOIN
                            會計科目 AS WW ON 營運成本明細表.兌現科目 = WW.編號
                WHERE     (營運成本明細表.狀態 LIKE N'%" & 票務控制表.票況_cb.Text & "%') AND (營運成本明細表.公司編號 LIKE N'%" & 公司編號 & "%') AND 
                          (QQ.會計科目 LIKE N'" & 票務控制表.區分_cb.Text & "') AND (WW.會計科目 LIKE N'%" & 票務控制表.兌現科目_cb.Text & "%') AND
                          (營運成本明細表." & 票務控制表.日期選項_cb.Text & " BETWEEN '" & Format(票務控制表.開始日期_dtp.Value, "yyyy/MM/dd") &
                                                                              "' AND '" & Format(票務控制表.結束日期_dtp.Value, "yyyy/MM/dd") & "')
                ORDER BY   營運成本明細表." & 票務控制表.日期選項_cb.Text & ""
        CmdSet_For_DGV()
    End Sub
    Friend Sub SQL_票務控制表會科區分()
        ConnOpen()
        SQL1 = "SELECT     QQ.會計科目 AS 開票會科
                FROM       營運成本明細表 LEFT OUTER JOIN 會計科目 AS QQ ON 營運成本明細表.會計科目 = QQ.編號 LEFT OUTER JOIN 會計科目 AS WW ON 營運成本明細表.兌現科目 = WW.編號
                WHERE     (營運成本明細表.狀態 NOT LIKE N'%現%') AND (營運成本明細表.公司編號 LIKE N'%" & 公司編號 & "%')
                GROUP BY   QQ.會計科目 ORDER BY QQ.會計科目 DESC"
        CmdSet_For_dr()
    End Sub
    Friend Sub SQL_票務控制表票況區分()
        ConnOpen()
        SQL1 = "SELECT     營運成本明細表.狀態
                FROM       營運成本明細表 LEFT OUTER JOIN 會計科目 AS QQ ON 營運成本明細表.會計科目 = QQ.編號 LEFT OUTER JOIN 會計科目 AS WW ON 營運成本明細表.兌現科目 = WW.編號
                WHERE     (營運成本明細表.狀態 NOT LIKE N'%現%') AND (營運成本明細表.公司編號 LIKE N'%" & 公司編號 & "%')
                GROUP BY   營運成本明細表.狀態 ORDER BY 營運成本明細表.狀態"
        CmdSet_For_dr()
    End Sub
    Friend Sub SQL_票務控制表兌現科目()
        ConnOpen()
        SQL1 = "SELECT     WW.會計科目 AS 兌現會科
                FROM       營運成本明細表 LEFT OUTER JOIN 會計科目 AS QQ ON 營運成本明細表.會計科目 = QQ.編號 LEFT OUTER JOIN 會計科目 AS WW ON 營運成本明細表.兌現科目 = WW.編號
                WHERE     (營運成本明細表.狀態 NOT LIKE N'%現%') AND (營運成本明細表.公司編號 LIKE N'%" & 公司編號 & "%')
                GROUP BY   WW.會計科目 ORDER BY WW.會計科目"
        CmdSet_For_dr()
    End Sub
    Friend Sub SQL_支票收支單_兌現科目_下拉清單三()
        ConnOpen() : SQL1 = "SELECT 會計科目, 編號 FROM 會計科目 WHERE (編號 LIKE N'D%' OR 編號 LIKE N'G%') AND (統制科目 = 0) AND (停用 = 0) ORDER BY 編號" : CmdSet_For_dr()
    End Sub
    Friend Sub SQL_營運成本明細表_狀態更改()
        ConnOpen()
        SQL1 = "UPDATE 營運成本明細表 SET 狀態 = N'" & PA3 & "', 支票 = N'" & PA4 & "', 備用金 = N'" & PA5 & "', 託收已付日 = N'" & DTP & "' 
                WHERE (流水號 LIKE N'" & PA1 & "') AND (項次 LIKE N'" & PA2 & "')"
        CmdSet_For_dr()
    End Sub
    Friend Sub SQL_營運成本明細表_轉現新增()
        ConnOpen()
        SQL1 = "INSERT INTO 營運成本明細表 (流水號, 項次, 會計科目, 用途, 金額, 備註, 收款, 會計, 出納, 現金, 備用金, 公帳, 支票, 作帳日期, 出納日期, 零用金, 支票數, 公司編號, 
                                            倉儲單號, 支票號碼, 狀態, 到期日, 預定兌現日, 開收票日, 託收已付日, 兌現科目, 付款銀行, 開票人, 登錄人, 發票人帳號) 
                VALUES (N'" & PA1 & "', N'" & PA2 & "', N'" & PA6 & "', N'" & PA7 & "', N'0', N'" & PA8 & "', N'0', N'1', N'0', N'0', N'0', N'0', N'1', N'" & PA9 & "', N'" & PA10 & "', N'" & NU1 &
                    "', N'" & NU2 & "', N'" & 公司編號 & "', N'" & PA11 & "', N'" & PA12 & "', N'轉現', N'" & DTP1 & "', N'" & DTP2 & "', N'" & DTP3 & "', N'" & DTP & "', N'', N'" & PA13 &
                    "', N'" & PA14 & "', N'" & gUserName & "', N'" & PA15 & "')"
        CmdSet_For_dr()
    End Sub
    Friend Sub SQL_營運成本明細表_轉現刪除()
        ConnOpen() : SQL1 = "DELETE FROM 營運成本明細表 WHERE (流水號 LIKE N'" & PA1 & "') AND (項次 LIKE N'" & PA2 & "') AND (狀態 LIKE N'轉現')" : CmdSet_For_dr()
    End Sub
    '---------------------財務單具申請-----------------------------------------------------------------------------------------------------------------
    Friend Sub SQL_會計科目_第一階_應付_不含流動票務() '-----------------------應付_不含流動票務---------------------------------------------------
        ConnOpen()
        SQL1 = "SELECT 第一階, LEFT(編號, 4) AS 編號 FROM 會計科目  
                WHERE (編號 NOT LIKE N'D%') AND (編號 NOT LIKE N'G%') AND (停用 = 0) AND (第一階 NOT LIKE N'流動%') GROUP BY 第一階, LEFT(編號, 4) ORDER BY 編號"
        CmdSet_For_dr()
    End Sub
    Friend Sub SQL_會計科目_第二階_應付_不含流動票務()
        ConnOpen()
        SQL1 = "SELECT LEFT(編號, 7) AS 編號, 第二階, 層級 FROM  會計科目 
                WHERE (編號 NOT LIKE N'D%') AND (編號 NOT LIKE N'G%') AND (LEFT(編號, 4) LIKE N'" & PA & "') AND (層級 NOT LIKE N'3') AND (停用 = 0) AND (第一階 NOT LIKE N'流動%')
                GROUP BY   LEFT(編號, 7), 第二階, 層級 ORDER BY   編號"
        CmdSet_For_dr()
    End Sub
    Friend Sub SQL_會計科目_第三階_應付_不含流動票務()
        ConnOpen()
        SQL1 = "SELECT 會計科目, 編號 FROM 會計科目 
                WHERE (編號 NOT LIKE N'D%') AND (編號 NOT LIKE N'G%') AND (LEFT(編號, 7) LIKE N'" & PA & "') AND (停用 = 0) AND (統制科目 = 0) AND (第一階 NOT LIKE N'流動%') ORDER BY 編號"
        CmdSet_For_dr()
    End Sub
    Friend Sub SQL_會計科目_關鍵字_應付_不含流動票務()
        ConnOpen()
        SQL1 = "SELECT 會計科目, 編號 FROM 會計科目 
                WHERE (編號 NOT LIKE N'D%') AND (編號 NOT LIKE N'G%') AND (會計科目 LIKE N'%" & PA & "%') AND (停用 = 0) AND (統制科目 = 0) AND (第一階 NOT LIKE N'流動%') ORDER BY 編號"
        CmdSet_For_dr()
    End Sub
    Friend Sub SQL_會計科目_第一階_應付_只含流動票務() '-----------------------應付_只含流動票務---------------------------------------------------
        ConnOpen()
        SQL1 = "SELECT 第一階, LEFT(編號, 4) AS 編號 FROM 會計科目  
                WHERE (編號 NOT LIKE N'A%') AND (停用 = 0) AND (第一階 LIKE N'流動%') GROUP BY 第一階, LEFT(編號, 4) ORDER BY 編號"
        CmdSet_For_dr()
    End Sub
    Friend Sub SQL_會計科目_第二階_應付_只含流動票務()
        ConnOpen()
        SQL1 = "SELECT LEFT(編號, 7) AS 編號, 第二階, 層級 FROM  會計科目 
                WHERE (編號 NOT LIKE N'A%') AND (LEFT(編號, 4) LIKE N'" & PA & "') AND (層級 NOT LIKE N'3') AND (停用 = 0) AND (第一階 LIKE N'流動%')
                GROUP BY   LEFT(編號, 7), 第二階, 層級 ORDER BY   編號"
        CmdSet_For_dr()
    End Sub
    Friend Sub SQL_會計科目_第三階_應付_只含流動票務()
        ConnOpen()
        SQL1 = "SELECT 會計科目, 編號 FROM 會計科目 
                WHERE (編號 NOT LIKE N'A%') AND (LEFT(編號, 7) LIKE N'" & PA & "') AND (停用 = 0) AND (統制科目 = 0) AND (第一階 LIKE N'流動%') ORDER BY 編號"
        CmdSet_For_dr()
    End Sub
    Friend Sub SQL_會計科目_關鍵字_應付_只含流動票務()
        ConnOpen()
        SQL1 = "SELECT 會計科目, 編號 FROM 會計科目 
                WHERE (編號 NOT LIKE N'A%') AND (會計科目 LIKE N'%" & PA & "%') AND (停用 = 0) AND (統制科目 = 0) AND (第一階 LIKE N'流動%') ORDER BY 編號"
        CmdSet_For_dr()
    End Sub
    Friend Sub SQL_會計科目_第一階_應收_不含流動票務() '-----------------------應收_不含流動票務---------------------------------------------------
        ConnOpen()
        SQL1 = "SELECT 第一階, LEFT(編號, 4) AS 編號 FROM 會計科目  
                WHERE (編號 LIKE N'D%' OR 編號 LIKE N'G%') AND (停用 = 0) AND (第一階 NOT LIKE N'流動%') GROUP BY 第一階, LEFT(編號, 4) ORDER BY 編號"
        CmdSet_For_dr()
    End Sub
    Friend Sub SQL_會計科目_第二階_應收_不含流動票務()
        ConnOpen()
        SQL1 = "SELECT LEFT(編號, 7) AS 編號, 第二階, 層級 FROM  會計科目 
                WHERE (編號 LIKE N'D%' OR 編號 LIKE N'G%') AND (LEFT(編號, 4) LIKE N'" & PA & "') AND (層級 NOT LIKE N'3') AND (停用 = 0) AND (第一階 NOT LIKE N'流動%')
                GROUP BY   LEFT(編號, 7), 第二階, 層級 ORDER BY   編號"
        CmdSet_For_dr()
    End Sub
    Friend Sub SQL_會計科目_第三階_應收_不含流動票務()
        ConnOpen()
        SQL1 = "SELECT 會計科目, 編號 FROM 會計科目 
                WHERE (編號 LIKE N'D%' OR 編號 LIKE N'G%') AND (LEFT(編號, 7) LIKE N'" & PA & "') AND (停用 = 0) AND (統制科目 = 0) AND (第一階 NOT LIKE N'流動%') ORDER BY 編號"
        CmdSet_For_dr()
    End Sub
    Friend Sub SQL_會計科目_關鍵字_應收_不含流動票務()
        ConnOpen()
        SQL1 = "SELECT 會計科目, 編號 FROM 會計科目 
                WHERE (編號 LIKE N'D%' OR 編號 LIKE N'G%') AND (會計科目 LIKE N'%" & PA & "%') AND (停用 = 0) AND (統制科目 = 0) AND (第一階 NOT LIKE N'流動%') ORDER BY 編號"
        CmdSet_For_dr()
    End Sub
    Friend Sub SQL_會計科目_第一階_應收_只含流動票務() '-----------------------應收_只含流動票務---------------------------------------------------
        ConnOpen()
        SQL1 = "SELECT 第一階, LEFT(編號, 4) AS 編號 FROM 會計科目  
                WHERE (編號 LIKE N'A%') AND (停用 = 0) AND (第一階 LIKE N'流動%') GROUP BY 第一階, LEFT(編號, 4) ORDER BY 編號"
        CmdSet_For_dr()
    End Sub
    Friend Sub SQL_會計科目_第二階_應收_只含流動票務()
        ConnOpen()
        SQL1 = "SELECT LEFT(編號, 7) AS 編號, 第二階, 層級 FROM  會計科目 
                WHERE (編號 LIKE N'A%') AND (LEFT(編號, 4) LIKE N'" & PA & "') AND (層級 NOT LIKE N'3') AND (停用 = 0) AND (第一階 LIKE N'流動%')
                GROUP BY   LEFT(編號, 7), 第二階, 層級 ORDER BY   編號"
        CmdSet_For_dr()
    End Sub
    Friend Sub SQL_會計科目_第三階_應收_只含流動票務()
        ConnOpen()
        SQL1 = "SELECT 會計科目, 編號 FROM 會計科目 
                WHERE (編號 LIKE N'A%') AND (LEFT(編號, 7) LIKE N'" & PA & "') AND (停用 = 0) AND (統制科目 = 0) AND (第一階 LIKE N'流動%') ORDER BY 編號"
        CmdSet_For_dr()
    End Sub
    Friend Sub SQL_會計科目_關鍵字_應收_只含流動票務()
        ConnOpen()
        SQL1 = "SELECT 會計科目, 編號 FROM 會計科目 
                WHERE (編號 LIKE N'A%') AND (會計科目 LIKE N'%" & PA & "%') AND (停用 = 0) AND (統制科目 = 0) AND (第一階 LIKE N'流動%') ORDER BY 編號"
        CmdSet_For_dr()
    End Sub
    Friend Sub SQL_應收應付單號連接暫存檔讀取()
        ConnOpen() : SQL1 = "SELECT 流水單號 FROM 應收應付單號連接暫存檔" : CmdSet_For_DGV()
    End Sub
    Friend Sub SQL_財務單具申請費用清單()
        ConnOpen()
        SQL1 = "SELECT      營運成本明細表.流水號, 營運成本明細表.項次, QQ.會計科目, 營運成本明細表.用途, 營運成本明細表.零用金 AS 開票, 營運成本明細表.支票數 AS 收票, 營運成本明細表.金額 AS 支出, 
                            營運成本明細表.收款 AS 現金, 營運成本明細表.備註, 營運成本明細表.會計科目 AS 科目編號, 營運成本明細表.狀態, 營運成本明細表.倉儲單號, 營運成本明細表.支票號碼, 
                            營運成本明細表.到期日, 營運成本明細表.預定兌現日, 營運成本明細表.開收票日, 營運成本明細表.託收已付日, 
                            營運成本明細表.兌現科目, 營運成本明細表.付款銀行, 營運成本明細表.開票人, 營運成本明細表.登錄人, 營運成本明細表.發票人帳號
                FROM        營運成本明細表 INNER JOIN 會計科目 AS QQ ON 營運成本明細表.會計科目 = QQ.編號
                WHERE      (營運成本明細表.流水號 LIKE N'" & 財務單具申請.收支單號_tb.Text & "')
                ORDER BY    營運成本明細表.項次"
        CmdSet_For_DGV()
    End Sub
    Friend Sub SQL_倉儲明細表財務單號連接修改()
        ConnOpen() : SQL1 = "UPDATE 倉儲明細表 SET  財務單號 = N'" & PA & "' WHERE (資料流水號 LIKE N'" & PA19 & "')" : CmdSet_For_dr()
    End Sub
    Friend Sub SQL_應付賬款_倉儲明細應付立帳修改()
        ConnOpen() : SQL1 = "UPDATE 倉儲明細表 SET 應付立帳 = N'" & PA7 & "' WHERE 資料流水號 LIKE N'" & PA6 & "'" : CmdSet_For_dr()
    End Sub
    Friend Sub SQL_應收賬款_倉儲明細應付立帳修改()
        ConnOpen() : SQL1 = "UPDATE 倉儲明細表 SET 應收立帳 = N'" & PA7 & "' WHERE 資料流水號 LIKE N'" & PA6 & "'" : CmdSet_For_dr()
    End Sub
    Friend Sub SQL_支票收支單申請_兌現科目_下拉清單三()
        ConnOpen() : SQL1 = "SELECT 會計科目, 編號 FROM 會計科目 WHERE (編號 LIKE N'D%') AND (統制科目 = 0) AND (停用 = 0) ORDER BY 編號" : CmdSet_For_dr()
    End Sub
End Module

