﻿Option Strict Off
Imports System.Runtime.InteropServices.ComTypes

Public Class 員工資料表
    ReadOnly ds As New DataSet
    Dim EDR As Integer = 0 : Dim ESTR As String
    Private Sub Set_員工清單()
        員工資料表_dgv.DataSource = Nothing : ds.Clear()
        員工資料表_dgv.ColumnHeadersHeightSizeMode = DataGridViewColumnHeadersHeightSizeMode.EnableResizing
        員工資料表_dgv.ColumnHeadersHeight = 25
        員工資料表_dgv.AllowUserToAddRows = False
        員工資料表_dgv.ClipboardCopyMode = DataGridViewClipboardCopyMode.EnableWithoutHeaderText
        員工資料表_dgv.MultiSelect = True
        SQL_員工資料清單()
        da.Fill(ds) : 員工資料表_dgv.DataSource = ds.Tables(0) : conn.Close()
        員工資料表_dgv.Columns(0).Visible = False : 員工資料表_dgv.Columns(1).FillWeight = 7 : 員工資料表_dgv.Columns(2).FillWeight = 6 : 員工資料表_dgv.Columns(3).FillWeight = 10
        員工資料表_dgv.Columns(4).FillWeight = 10 : 員工資料表_dgv.Columns(5).FillWeight = 27 : 員工資料表_dgv.Columns(6).FillWeight = 10 : 員工資料表_dgv.Columns(7).FillWeight = 8
        員工資料表_dgv.Columns(8).FillWeight = 10 : 員工資料表_dgv.Columns(9).FillWeight = 10 : 員工資料表_dgv.Columns(10).FillWeight = 10 : 員工資料表_dgv.Columns(11).FillWeight = 10
        員工資料表_dgv.Columns(12).FillWeight = 8 : 員工資料表_dgv.Columns(13).FillWeight = 10 : 員工資料表_dgv.Columns(14).FillWeight = 9 : 員工資料表_dgv.Columns(15).Visible = False
        員工資料表_dgv.Columns(15).FillWeight = 10 : 員工資料表_dgv.Columns(16).Visible = False : 員工資料表_dgv.Columns(16).FillWeight = 10

        員工資料表_dgv.EditMode = DataGridViewEditMode.EditOnEnter
        員工資料表_dgv.Columns(12).DefaultCellStyle.Format = "#,##0"
        員工資料表_dgv.Columns(12).DefaultCellStyle.Alignment = DataGridViewContentAlignment.MiddleRight : 員工資料表_dgv.Columns(12).HeaderCell.Style.Alignment = DataGridViewContentAlignment.MiddleRight

        If 模式一_bt.Enabled = False Then
            員工資料表_dgv.Columns(15).Visible = False : 員工資料表_dgv.Columns(16).Visible = False
            員工資料表_dgv.Columns(1).ReadOnly = True : 員工資料表_dgv.Columns(2).ReadOnly = True : 員工資料表_dgv.Columns(3).ReadOnly = True : 員工資料表_dgv.Columns(4).ReadOnly = True
            員工資料表_dgv.Columns(5).ReadOnly = True : 員工資料表_dgv.Columns(6).ReadOnly = True : 員工資料表_dgv.Columns(7).ReadOnly = True : 員工資料表_dgv.Columns(8).ReadOnly = True
            員工資料表_dgv.Columns(9).ReadOnly = True : 員工資料表_dgv.Columns(10).ReadOnly = True : 員工資料表_dgv.Columns(11).ReadOnly = True : 員工資料表_dgv.Columns(12).ReadOnly = True
            員工資料表_dgv.Columns(13).ReadOnly = True : 員工資料表_dgv.Columns(14).ReadOnly = True
        Else
            員工資料表_dgv.Columns(15).Visible = True : 員工資料表_dgv.Columns(16).Visible = True
            員工資料表_dgv.Columns(1).ReadOnly = False : 員工資料表_dgv.Columns(2).ReadOnly = False : 員工資料表_dgv.Columns(3).ReadOnly = False : 員工資料表_dgv.Columns(4).ReadOnly = False
            員工資料表_dgv.Columns(5).ReadOnly = False : 員工資料表_dgv.Columns(6).ReadOnly = False : 員工資料表_dgv.Columns(7).ReadOnly = False : 員工資料表_dgv.Columns(8).ReadOnly = False
            員工資料表_dgv.Columns(9).ReadOnly = False : 員工資料表_dgv.Columns(10).ReadOnly = False : 員工資料表_dgv.Columns(11).ReadOnly = False : 員工資料表_dgv.Columns(12).ReadOnly = False
            員工資料表_dgv.Columns(13).ReadOnly = False : 員工資料表_dgv.Columns(14).ReadOnly = False
        End If
    End Sub
    Private Sub ComboBox2下拉表單資料載入()
        SQL_職別下拉清單()
        職別_cb.Items.Clear() : While (dr.Read()) : 職別_cb.Items.Add(dr("職別")) : End While : conn.Close()
    End Sub
    Private Sub ComboBox3下拉表單資料載入()
        SQL_負責區域下拉清單()
        負責區域_cb.Items.Clear() : While (dr.Read()) : 負責區域_cb.Items.Add(dr("負責區域")) : End While : conn.Close()
    End Sub
    Private Sub DataGridView1多行列貼上()
        Dim i, j As Integer : Dim pRow, pCol As Integer : Dim selectedCellCount As Integer : Dim startRow, startCol, endRow, endCol As Integer
        Dim pasteText, strline, strVal As String : Dim strlines, vals As String() : Dim pasteData(,) As String
        ' 当前单元格是否选择的判断
        If 員工資料表_dgv.CurrentCell Is Nothing Then : Return : End If
        Dim insertRowIndex As Integer = 員工資料表_dgv.CurrentCell.RowIndex
        ' 获取DataGridView选择区域，并计算要复制的行列开始、结束位置
        startRow = 9999 : startCol = 9999 : endRow = 0 : endCol = 0
        selectedCellCount = 員工資料表_dgv.GetCellCount(DataGridViewElementStates.Selected)
        For i = 0 To selectedCellCount - 1
            startRow = Math.Min(員工資料表_dgv.SelectedCells(i).RowIndex, startRow) : startCol = Math.Min(員工資料表_dgv.SelectedCells(i).ColumnIndex, startCol)
            endRow = Math.Max(員工資料表_dgv.SelectedCells(i).RowIndex, endRow) : endCol = Math.Max(員工資料表_dgv.SelectedCells(i).ColumnIndex, endCol)
        Next
        ' 获取剪切板的内容，并按行分割
        pasteText = Clipboard.GetText()
        If String.IsNullOrEmpty(pasteText) Then : Return : End If
        pasteText = pasteText.Replace(vbCrLf, vbLf)
        Dim unused As String()
        ReDim unused(0) : strlines = pasteText.Split(vbLf) : pRow = strlines.Length : pCol = 0      '行数

        For Each strline In strlines

            Dim unused3 As String()
            ReDim unused3(0)
            vals = strline.Split(New Char() {vbTab, vbCr, vbNullChar, vbNullString}, 256, StringSplitOptions.RemoveEmptyEntries) ' 按Tab分割数据
            pCol = Math.Max(vals.Length, pCol) '列数
        Next
        ReDim pasteData(pRow, pCol) : pasteText = Clipboard.GetText() : pasteText = pasteText.Replace(vbCrLf, vbLf)
        Dim unused1 As String()
        ReDim unused1(0) : strlines = pasteText.Split(vbLf) : i = 1
        For Each strline In strlines
            j = 1
            Dim unused2 As String()
            ReDim unused2(0) : strline.TrimEnd(New Char() {vbLf}) : vals = strline.Split(New Char() {vbTab, vbCr, vbNullChar, vbNullString}, 256, StringSplitOptions.RemoveEmptyEntries)
            For Each strVal In vals : pasteData(i, j) = strVal : j += 1 : Next : i += 1
        Next
        Dim flag As Boolean = False
        For j = 1 To pCol : If pasteData(pRow, j) <> "" Then : flag = True : Exit For : End If : Next
        If flag = False Then : pRow = Math.Max(pRow - 1, 0) : End If
        For i = 1 To endRow - startRow + 1
            Dim row As DataGridViewRow = 員工資料表_dgv.Rows(i + startRow - 1)
            If i <= pRow Then : For j = 1 To endCol - startCol + 1 : If j <= pCol Then : row.Cells(j + startCol - 1).Value = pasteData(i, j) : Else : Exit For : End If : Next
            Else : Exit For : End If
        Next
        'DataGridView1貼上資料後去除雙引號()
    End Sub
    Private Sub 員工資料表_Load(sender As Object, e As EventArgs) Handles MyBase.Load
        Me.MdiParent = MAOJI_ERP_SYS : Me.WindowState = 2 : Me.AutoScroll = True
        編號_tb.Enabled = False : 職別編號_tb.Visible = False : 負責區域編號_tb.Visible = False : 模式一_bt.Enabled = False : 模式二_bt.Enabled = True
        If gUserName = "李協叡" Then : 資料刪除_bt.Enabled = True : Else : 資料刪除_bt.Enabled = False : End If
    End Sub
    Private Sub 介面開啟_Shown(sender As Object, e As EventArgs) Handles MyBase.Shown
        計算分流.Enabled = True
    End Sub
    Private Sub 計算分流_Tick(sender As Object, e As EventArgs) Handles 計算分流.Tick
        ComboBox2下拉表單資料載入() : ComboBox3下拉表單資料載入() : Set_員工清單()
        計算分流.Enabled = False
    End Sub
    Private Sub 介面關閉_Closed(sender As Object, e As EventArgs) Handles MyBase.Closed
        MyModule1.虛擬桌面開啟()
    End Sub
    Private Sub DataGridView1_CellClick(ByVal sender As System.Object, ByVal e As System.Windows.Forms.DataGridViewCellEventArgs) Handles 員工資料表_dgv.CellClick
        If e.RowIndex = -1 Then : Else
            編號_tb.Text = 員工資料表_dgv.Rows(e.RowIndex).Cells("編號").Value.ToString : 名稱_tb.Text = 員工資料表_dgv.Rows(e.RowIndex).Cells("名稱").Value
            性別_cb.Text = 員工資料表_dgv.Rows(e.RowIndex).Cells("性別").Value.ToString : 身分證_tb.Text = 員工資料表_dgv.Rows(e.RowIndex).Cells("身分證").Value.ToString
            地址_tb.Text = 員工資料表_dgv.Rows(e.RowIndex).Cells("居住址").Value.ToString : 手機_tb.Text = 員工資料表_dgv.Rows(e.RowIndex).Cells("手機").Value.ToString
            配偶_tb.Text = 員工資料表_dgv.Rows(e.RowIndex).Cells("配偶").Value.ToString : 配偶手機_tb.Text = 員工資料表_dgv.Rows(e.RowIndex).Cells("配偶手機").Value.ToString
            住家電話_tb.Text = 員工資料表_dgv.Rows(e.RowIndex).Cells("住家連絡電話").Value.ToString : 職別_cb.Text = 員工資料表_dgv.Rows(e.RowIndex).Cells("職稱").Value.ToString
            薪資_tb.Text = 員工資料表_dgv.Rows(e.RowIndex).Cells("薪水").Value.ToString : LINEID_tb.Text = 員工資料表_dgv.Rows(e.RowIndex).Cells("LineID").Value.ToString
            負責區域_cb.Text = 員工資料表_dgv.Rows(e.RowIndex).Cells("責任區").Value.ToString
            If 員工資料表_dgv.Rows(e.RowIndex).Cells("出生日期").Value = "" Then : Else : 出生日期_dtp.Value = 員工資料表_dgv.Rows(e.RowIndex).Cells("出生日期").Value.ToString : End If
            If 員工資料表_dgv.Rows(e.RowIndex).Cells("到職日期").Value = "" Then : Else : 到職日期_dtp.Value = 員工資料表_dgv.Rows(e.RowIndex).Cells("到職日期").Value.ToString : End If
            薪資_tb.Text = Strings.Format(Val(薪資_tb.Text), "#,##0")
        End If
    End Sub
    Private Sub DataGridView1_KeyDown(ByVal sender As Object, ByVal e As KeyEventArgs) Handles 員工資料表_dgv.KeyDown
        If (e.Modifiers = Keys.Control) And (e.KeyCode = Keys.V) Then
            DataGridView1多行列貼上()
        End If
    End Sub
    Private Sub 模式一_bt_Click(sender As Object, e As EventArgs) Handles 模式一_bt.Click
        模式一_bt.Enabled = False : 模式二_bt.Enabled = True
        員工資料表_dgv.Columns(15).Visible = False : 員工資料表_dgv.Columns(16).Visible = False
        員工資料表_dgv.Columns(1).ReadOnly = True : 員工資料表_dgv.Columns(2).ReadOnly = True : 員工資料表_dgv.Columns(3).ReadOnly = True : 員工資料表_dgv.Columns(4).ReadOnly = True
        員工資料表_dgv.Columns(5).ReadOnly = True : 員工資料表_dgv.Columns(6).ReadOnly = True : 員工資料表_dgv.Columns(7).ReadOnly = True : 員工資料表_dgv.Columns(8).ReadOnly = True
        員工資料表_dgv.Columns(9).ReadOnly = True : 員工資料表_dgv.Columns(10).ReadOnly = True : 員工資料表_dgv.Columns(11).ReadOnly = True : 員工資料表_dgv.Columns(12).ReadOnly = True
        員工資料表_dgv.Columns(13).ReadOnly = True : 員工資料表_dgv.Columns(14).ReadOnly = True
    End Sub
    Private Sub 模式二_bt_Click(sender As Object, e As EventArgs) Handles 模式二_bt.Click
        模式一_bt.Enabled = True : 模式二_bt.Enabled = False
        員工資料表_dgv.Columns(15).Visible = True : 員工資料表_dgv.Columns(16).Visible = True
        員工資料表_dgv.Columns(1).ReadOnly = False : 員工資料表_dgv.Columns(2).ReadOnly = False : 員工資料表_dgv.Columns(3).ReadOnly = False : 員工資料表_dgv.Columns(4).ReadOnly = False
        員工資料表_dgv.Columns(5).ReadOnly = False : 員工資料表_dgv.Columns(6).ReadOnly = False : 員工資料表_dgv.Columns(7).ReadOnly = False : 員工資料表_dgv.Columns(8).ReadOnly = False
        員工資料表_dgv.Columns(9).ReadOnly = False : 員工資料表_dgv.Columns(10).ReadOnly = False : 員工資料表_dgv.Columns(11).ReadOnly = False : 員工資料表_dgv.Columns(12).ReadOnly = False
        員工資料表_dgv.Columns(13).ReadOnly = False : 員工資料表_dgv.Columns(14).ReadOnly = False
    End Sub
    Private Sub CheckBox1_CheckedChanged(sender As Object, e As EventArgs) Handles 可全選_ch.Click
        If 可全選_ch.Checked = False Then : 可全選_ch.Checked = False : 員工資料表_dgv.EditMode = DataGridViewEditMode.EditOnEnter
        Else : 可全選_ch.Checked = True : 員工資料表_dgv.EditMode = DataGridViewEditMode.EditOnKeystrokeOrF2 : End If
    End Sub
    Private Sub 負責區域_cb_SelectedIndexChanged(sender As Object, e As EventArgs) Handles 負責區域_cb.SelectedIndexChanged
        PA = 負責區域_cb.Text : SQL_負責區域查詢() : If dr.Read() Then : 負責區域編號_tb.Text = dr("編號") : End If : conn.Close() : PA = ""
    End Sub
    Private Sub 職別_cb_SelectedIndexChanged(sender As Object, e As EventArgs) Handles 職別_cb.SelectedIndexChanged
        PA = 職別_cb.Text : SQL_職別查詢() : If dr.Read() Then : 職別編號_tb.Text = dr("編號") : End If : conn.Close() : PA = ""
    End Sub
    Private Sub 關鍵字查詢_bt_Click(sender As Object, e As EventArgs) Handles 關鍵字查詢_bt.Click
        PA = InputBox("請輸入要查詢的關鍵字") : Set_員工清單() : PA = ""
    End Sub
    Private Sub Set_日期格式轉換()
        DTP1 = Format(出生日期_dtp.Value, "yyyy/MM/dd") : DTP2 = Format(到職日期_dtp.Value, "yyyy/MM/dd")
    End Sub
    Private Sub 新增1()
        '----------------------自动生成流水号-------------------------------------------------------------------------
        SQL_員工資料表流水號最後一筆()
        If dr.Read() Then : EDR = Double.Parse(Strings.Right(dr("編號").ToString, 8)) : Else : EDR = 0 : End If : conn.Close() : EDR += 1
        If EDR < 10 Then : ESTR = "SI" & "0000000" & EDR
        ElseIf EDR > 9 And EDR < 100 Then : ESTR = "SI" & "000000" & EDR
        ElseIf EDR > 99 And EDR < 1000 Then : ESTR = "SI" & "00000" & EDR
        ElseIf EDR > 999 And EDR < 10000 Then : ESTR = "SI" & "0000" & EDR
        ElseIf EDR > 9999 And EDR < 100000 Then : ESTR = "SI" & "000" & EDR
        ElseIf EDR > 99999 And EDR < 100000 Then : ESTR = "SI" & "00" & EDR
        ElseIf EDR > 999999 And EDR < 1000000 Then : ESTR = "SI" & "0" & EDR
        ElseIf EDR > 9999999 Then : ESTR = "SI" & EDR : End If : 編號_tb.Text = ESTR
    End Sub
    Private Sub 新增2()
        SQL_員工資料表新增() : conn.Close()
    End Sub
    Private Sub 存檔1()
        For i As Integer = 0 To 員工資料表_dgv.Rows.Count - 1
            資料數 = 員工資料表_dgv.Rows.Count : MyModule1.進度條()
            PA1 = 員工資料表_dgv.Rows(i).Cells("名稱").Value : PA2 = 員工資料表_dgv.Rows(i).Cells("性別").Value : PA3 = 員工資料表_dgv.Rows(i).Cells("身分證").Value
            PA4 = 員工資料表_dgv.Rows(i).Cells("出生日期").Value : PA5 = 員工資料表_dgv.Rows(i).Cells("居住址").Value : PA6 = 員工資料表_dgv.Rows(i).Cells("手機").Value
            PA7 = 員工資料表_dgv.Rows(i).Cells("配偶").Value : PA8 = 員工資料表_dgv.Rows(i).Cells("配偶手機").Value : PA9 = 員工資料表_dgv.Rows(i).Cells("住家連絡電話").Value
            PA10 = 員工資料表_dgv.Rows(i).Cells("職別").Value : PA11 = 員工資料表_dgv.Rows(i).Cells("到職日期").Value : NU1 = 員工資料表_dgv.Rows(i).Cells("薪水").Value
            PA12 = 員工資料表_dgv.Rows(i).Cells("LineID").Value : PA13 = 員工資料表_dgv.Rows(i).Cells("負責區域").Value : PA14 = 員工資料表_dgv.Rows(i).Cells("編號").Value
            SQL_員工資料表修改()
        Next
        MAOJI_ERP_SYS.ToolStripProgressBar1.Value = 0 : 最終數 = 0
    End Sub
    Private Sub 存檔2()
        If 編號_tb.Text = "" Then : Else
            Set_日期格式轉換()
            PA1 = 名稱_tb.Text : PA2 = 性別_cb.Text : PA3 = 身分證_tb.Text : PA4 = DTP1 : PA5 = 地址_tb.Text : PA6 = 手機_tb.Text : PA7 = 配偶_tb.Text : PA8 = 配偶手機_tb.Text
            PA9 = 住家電話_tb.Text : PA10 = 職別編號_tb.Text : PA11 = DTP2 : NU1 = Val(薪資_tb.Text) : PA12 = LINEID_tb.Text : PA13 = 負責區域編號_tb.Text : PA14 = 編號_tb.Text
            SQL_員工資料表修改()
        End If
    End Sub
    Private Sub 新增一筆空白資料_bt_Click(sender As Object, e As EventArgs) Handles 新增一筆空白資料_bt.Click
        存檔1() : 新增1()
        性別_cb.Text = "NA" : ComboBox2下拉表單資料載入() : ComboBox3下拉表單資料載入()
        名稱_tb.Text = "" : 身分證_tb.Text = "" : 地址_tb.Text = "" : 手機_tb.Text = "" : 配偶_tb.Text = "" : 配偶手機_tb.Text = ""
        住家電話_tb.Text = "" : 薪資_tb.Text = "" : LINEID_tb.Text = "" : 職別編號_tb.Text = "" : 負責區域編號_tb.Text = ""
        新增2() : Set_員工清單()
    End Sub
    Private Sub 單一資料存檔_bt_Click(sender As Object, e As EventArgs) Handles 單一資料存檔_bt.Click
        If 編號_tb.Text = "" Then : 新增1() : 新增2() : End If
        存檔2() : Set_員工清單() : MsgBox("資料存檔完畢 。")
    End Sub
    Private Sub 整體清單存檔_bt_Click(sender As Object, e As EventArgs) Handles 整體清單存檔_bt.Click
        If 模式二_bt.Enabled = True Then : MsgBox("整體存檔功能使用前請切換至模式二，並注意清單最後兩排資料的編碼原則，如不熟悉此操作規則請使用模式一作業。")
        Else : 存檔1() : MsgBox("資料存檔完畢 。") : End If
    End Sub

    Private Sub 貼上_bt_Click(sender As Object, e As EventArgs) Handles 貼上_bt.Click
        DataGridView1多行列貼上()
    End Sub

    Private Sub 重新整理_bt_Click(sender As Object, e As EventArgs) Handles 重新整理_bt.Click
        Set_員工清單()
    End Sub

    Private Sub 資料刪除_bt_Click(sender As Object, e As EventArgs) Handles 資料刪除_bt.Click

    End Sub


    Private Sub 重新整理_bt_MouseEnter(sender As Object, e As EventArgs) Handles 重新整理_bt.MouseEnter
        ToolTip1.SetToolTip(Me.重新整理_bt, "重新整理")
    End Sub
    Private Sub 開新出貨單_bt_MouseEnter(sender As Object, e As EventArgs) Handles 新增一筆空白資料_bt.MouseEnter
        ToolTip1.SetToolTip(Me.新增一筆空白資料_bt, "新增一筆空白資料")
    End Sub
    Private Sub 新增物料到出貨單_bt_MouseEnter(sender As Object, e As EventArgs) Handles 關鍵字查詢_bt.MouseEnter
        ToolTip1.SetToolTip(Me.關鍵字查詢_bt, "關鍵字查詢")
    End Sub
    Private Sub 修改存檔_bt_MouseEnter(sender As Object, e As EventArgs) Handles 貼上_bt.MouseEnter
        ToolTip1.SetToolTip(Me.貼上_bt, "貼上")
    End Sub
    Private Sub 刪除採購單中選中的物料_bt_MouseEnter(sender As Object, e As EventArgs) Handles 資料刪除_bt.MouseEnter
        ToolTip1.SetToolTip(Me.資料刪除_bt, "資料刪除")
    End Sub
    Private Sub 列印產品標籤_bt_MouseEnter(sender As Object, e As EventArgs) Handles 單一資料存檔_bt.MouseEnter
        ToolTip1.SetToolTip(Me.單一資料存檔_bt, "資料存檔(單一筆資料)")
    End Sub
    Private Sub 列印出貨單_bt_MouseEnter(sender As Object, e As EventArgs) Handles 整體清單存檔_bt.MouseEnter
        ToolTip1.SetToolTip(Me.整體清單存檔_bt, "資料存檔整體清單適用excel表格資料貼上")
    End Sub
End Class