﻿Option Strict Off
Imports Microsoft.Office.Interop.Excel.XlUnderlineStyle
Imports Microsoft.Office.Interop.Excel.Constants
Imports Microsoft.Office.Interop.Excel.XlBordersIndex
Imports Microsoft.Office.Interop.Excel.XlLineStyle
Imports Microsoft.Office.Interop.Excel.XlBorderWeight
Imports Microsoft.Office.Interop.Excel.XlThemeFont
Imports Microsoft.Office.Interop.Excel.XlThemeColor
Imports Microsoft.Office.Interop.Excel.XlWindowState
Imports Microsoft.Office.Interop.Excel
Imports System.Windows.Forms.VisualStyles.VisualStyleElement
Public Class 銷售退貨清單
    ReadOnly ds1 As New DataSet : ReadOnly ds2 As New DataSet
    Dim N1 As Integer = 0
    Dim xlApp As Application : Dim xlBook As Workbook : Dim xlSheet As Worksheet
    Private Sub Set_銷售清單()
        彙總_dgv.DataSource = Nothing : ds1.Clear() : 彙總_dgv.ColumnHeadersHeightSizeMode = DataGridViewColumnHeadersHeightSizeMode.EnableResizing : 彙總_dgv.ColumnHeadersHeight = 25
        彙總_dgv.AllowUserToAddRows = False : 彙總_dgv.ClipboardCopyMode = DataGridViewClipboardCopyMode.EnableWithoutHeaderText : 彙總_dgv.MultiSelect = True
        SQL_銷售退貨清單_彙總()
        da.Fill(ds1) : 彙總_dgv.DataSource = ds1.Tables(0) : conn.Close()
        彙總_dgv.Columns(0).FillWeight = 150 : 彙總_dgv.Columns(1).FillWeight = 90 : 彙總_dgv.Columns(2).Visible = False : 彙總_dgv.Columns(3).FillWeight = 100
        彙總_dgv.Columns(4).Visible = False : 彙總_dgv.Columns(5).FillWeight = 90 : 彙總_dgv.Columns(6).Visible = False : 彙總_dgv.Columns(7).Visible = False
        彙總_dgv.Columns(8).Visible = False : 彙總_dgv.Columns(9).Visible = False

        For i As Integer = 0 To 彙總_dgv.Rows.Count - 1
            If 彙總_dgv.Rows(i).Cells("業務比例").Value.ToString = "" Then : 彙總_dgv.Rows(i).Cells("業務比例").Value = 0 : End If
            If 彙總_dgv.Rows(i).Cells("司機比例").Value.ToString = "" Then : 彙總_dgv.Rows(i).Cells("司機比例").Value = 0 : End If
        Next
    End Sub
    Private Sub Set_單據明細()
        明細_dgv.DataSource = Nothing : ds2.Clear() : 明細_dgv.ColumnHeadersHeightSizeMode = DataGridViewColumnHeadersHeightSizeMode.EnableResizing : 明細_dgv.ColumnHeadersHeight = 25
        明細_dgv.AllowUserToAddRows = False : 明細_dgv.ClipboardCopyMode = DataGridViewClipboardCopyMode.EnableWithoutHeaderText : 明細_dgv.MultiSelect = True
        SQL_銷售退貨清單_清單()
        da.Fill(ds2) : 明細_dgv.DataSource = ds2.Tables(0) : conn.Close()

        明細_dgv.Columns(6).DefaultCellStyle.Format = "#,##0" : 明細_dgv.Columns(7).DefaultCellStyle.Format = "#,##0"
        明細_dgv.Columns(8).DefaultCellStyle.Format = "#,##0.0000" : 明細_dgv.Columns(9).DefaultCellStyle.Format = "#,##0" : 明細_dgv.Columns(10).DefaultCellStyle.Format = "#,##0"
        明細_dgv.Columns(1).DefaultCellStyle.Alignment = DataGridViewContentAlignment.MiddleCenter : 明細_dgv.Columns(1).HeaderCell.Style.Alignment = DataGridViewContentAlignment.MiddleCenter
        明細_dgv.Columns(2).DefaultCellStyle.Alignment = DataGridViewContentAlignment.MiddleCenter : 明細_dgv.Columns(2).HeaderCell.Style.Alignment = DataGridViewContentAlignment.MiddleCenter
        明細_dgv.Columns(6).DefaultCellStyle.Alignment = DataGridViewContentAlignment.MiddleCenter : 明細_dgv.Columns(6).HeaderCell.Style.Alignment = DataGridViewContentAlignment.MiddleCenter
        明細_dgv.Columns(7).DefaultCellStyle.Alignment = DataGridViewContentAlignment.MiddleCenter : 明細_dgv.Columns(7).HeaderCell.Style.Alignment = DataGridViewContentAlignment.MiddleCenter
        明細_dgv.Columns(8).DefaultCellStyle.Alignment = DataGridViewContentAlignment.MiddleCenter : 明細_dgv.Columns(8).HeaderCell.Style.Alignment = DataGridViewContentAlignment.MiddleCenter
        明細_dgv.Columns(9).DefaultCellStyle.Alignment = DataGridViewContentAlignment.MiddleCenter : 明細_dgv.Columns(9).HeaderCell.Style.Alignment = DataGridViewContentAlignment.MiddleCenter
        明細_dgv.Columns(10).DefaultCellStyle.Alignment = DataGridViewContentAlignment.MiddleCenter : 明細_dgv.Columns(10).HeaderCell.Style.Alignment = DataGridViewContentAlignment.MiddleCenter
        明細_dgv.Columns(12).DefaultCellStyle.Alignment = DataGridViewContentAlignment.MiddleCenter : 明細_dgv.Columns(12).HeaderCell.Style.Alignment = DataGridViewContentAlignment.MiddleCenter
        明細_dgv.Columns(13).DefaultCellStyle.Alignment = DataGridViewContentAlignment.MiddleCenter : 明細_dgv.Columns(13).HeaderCell.Style.Alignment = DataGridViewContentAlignment.MiddleCenter

        明細_dgv.Columns(0).Visible = False : 明細_dgv.Columns(1).FillWeight = 30 : 明細_dgv.Columns(2).FillWeight = 80 : 明細_dgv.Columns(3).FillWeight = 150
        明細_dgv.Columns(4).FillWeight = 80 : 明細_dgv.Columns(5).FillWeight = 80 : 明細_dgv.Columns(6).FillWeight = 50 : 明細_dgv.Columns(7).FillWeight = 50
        明細_dgv.Columns(8).Visible = False : 明細_dgv.Columns(9).Visible = False : 明細_dgv.Columns(10).Visible = False : 明細_dgv.Columns(11).FillWeight = 100
        明細_dgv.Columns(12).FillWeight = 80 : 明細_dgv.Columns(13).FillWeight = 50 : 明細_dgv.Columns(14).Visible = False : 明細_dgv.Columns(15).Visible = False

        明細_dgv.EditMode = DataGridViewEditMode.EditOnEnter
        明細_dgv.Columns(1).ReadOnly = True : 明細_dgv.Columns(2).ReadOnly = True : 明細_dgv.Columns(3).ReadOnly = True : 明細_dgv.Columns(4).ReadOnly = True
        明細_dgv.Columns(5).ReadOnly = True : 明細_dgv.Columns(6).ReadOnly = True : 明細_dgv.Columns(8).ReadOnly = True : 明細_dgv.Columns(9).ReadOnly = True
        明細_dgv.Columns(10).ReadOnly = True : 明細_dgv.Columns(12).ReadOnly = True

        For i As Integer = 0 To 明細_dgv.Rows.Count - 1
            明細_dgv(1, i).Value = i + 1
        Next
    End Sub
    Private Sub ComboBox2下拉表單資料載入()
        SQL_客戶資料表_下拉清單讀取()
        客戶_cb.Items.Clear() : 客戶編號_cb.Items.Clear() : While (dr.Read()) : 客戶_cb.Items.Add(dr("簡稱")) : 客戶編號_cb.Items.Add(dr("編號")) : End While : conn.Close()
    End Sub
    Private Sub ComboBox6下拉表單資料載入()
        SQL_員工名稱下拉清單()
        業務_cb.Items.Clear() : 司機_cb.Items.Clear() : While (dr.Read()) : 業務_cb.Items.Add(dr("名稱")) : 司機_cb.Items.Add(dr("名稱")) : End While : conn.Close()
    End Sub
    Private Sub ComboBox7下拉表單資料載入()
        SQL_傭金比例下拉清單()
        業務比例_cb.Items.Clear() : 司機比例_cb.Items.Clear()
        While (dr.Read()) : 業務比例_cb.Items.Add(Strings.Format(dr("比例"), "#,##0.0")) : 司機比例_cb.Items.Add(Strings.Format(dr("比例"), "#,##0.0")) : End While : conn.Close()
    End Sub
    Private Sub 銷售退貨清單_Load(sender As Object, e As EventArgs) Handles MyBase.Load
        Me.MdiParent = MAOJI_ERP_SYS : Me.WindowState = 2 : Me.AutoScroll = True
        單據編號_tb.Enabled = False : 客戶公司_tb.Enabled = False : 統編_tb.Enabled = False : 電話_tb.Enabled = False : 付款方式_tb.Enabled = False : 手機_tb.Enabled = False
        店面地址_tb.Enabled = False : 郵號_tb.Enabled = False : 送貨地址_tb.Enabled = False : 選擇_tb.Enabled = False : 傳真_tb.Enabled = False
        客戶_cb.Enabled = False : 業務比例_cb.Enabled = False : 業務_cb.Enabled = False : 司機_cb.Enabled = False : 司機比例_cb.Enabled = False
        銷售下單_dtp.Enabled = False : 客戶交期_dtp.Enabled = False
        狀態_tb.Visible = False : 客戶編號_cb.Visible = False
    End Sub
    Private Sub 介面開啟_Shown(sender As Object, e As EventArgs) Handles MyBase.Shown
        計算分流.Enabled = True
    End Sub
    Private Sub 計算分流_Tick(sender As Object, e As EventArgs) Handles 計算分流.Tick
        ComboBox2下拉表單資料載入() : ComboBox6下拉表單資料載入() : ComboBox7下拉表單資料載入() : Set_銷售清單()
        計算分流.Enabled = False
    End Sub
    Private Sub 介面關閉_Closed(sender As Object, e As EventArgs) Handles MyBase.Closed
        MyModule1.虛擬桌面開啟()
    End Sub
    Private Sub DataGridView2_CellClick(ByVal sender As System.Object, ByVal e As System.Windows.Forms.DataGridViewCellEventArgs) Handles 彙總_dgv.CellClick
        If e.RowIndex = -1 Then : Else
            ComboBox6下拉表單資料載入() : ComboBox7下拉表單資料載入()
            單據編號_tb.Text = 彙總_dgv.Rows(e.RowIndex).Cells("單據編號").Value.ToString : 客戶編號_cb.Text = 彙總_dgv.Rows(e.RowIndex).Cells("客戶編號").Value.ToString
            狀態_tb.Text = 彙總_dgv.Rows(e.RowIndex).Cells("狀態").Value.ToString : 銷售下單_dtp.Value = 彙總_dgv.Rows(e.RowIndex).Cells("銷售下單").Value.ToString
            客戶交期_dtp.Value = 彙總_dgv.Rows(e.RowIndex).Cells("客戶交期").Value.ToString : 業務_cb.Text = 彙總_dgv.Rows(e.RowIndex).Cells("業務").Value.ToString
            業務比例_cb.Text = Strings.Format(彙總_dgv.Rows(e.RowIndex).Cells("業務比例").Value, "#,##0.0") : 司機_cb.Text = 彙總_dgv.Rows(e.RowIndex).Cells("司機").Value.ToString
            司機比例_cb.Text = Strings.Format(彙總_dgv.Rows(e.RowIndex).Cells("司機比例").Value, "#,##0.0") : 列印用SQL = 單據編號_tb.Text
            Set_單據明細() : 客戶資料()
        End If
    End Sub
    Private Sub DataGridView3_CellClick(ByVal sender As System.Object, ByVal e As System.Windows.Forms.DataGridViewCellEventArgs) Handles 明細_dgv.CellClick
        If e.RowIndex = -1 Then : Else
            選擇_tb.Text = 明細_dgv.Rows(e.RowIndex).Cells("資料流水號").Value.ToString
        End If
    End Sub
    Private Sub DataGridView3_CellEnter(sender As Object, e As DataGridViewCellEventArgs) Handles 明細_dgv.CellEnter
        For i As Integer = 0 To 明細_dgv.Rows.Count - 1
            明細_dgv.Rows(i).Cells("台幣單價").Value = 明細_dgv.Rows(i).Cells("單價").Value * 明細_dgv.Rows(i).Cells("匯率").Value
            明細_dgv.Rows(i).Cells("出貨成本_台幣").Value = 明細_dgv.Rows(i).Cells("單價").Value * 明細_dgv.Rows(i).Cells("匯率").Value * 明細_dgv.Rows(i).Cells("數量").Value
            明細_dgv(1, i).Value = i + 1
        Next i
    End Sub
    Private Sub 客戶資料()
        conn.Close()
        If 客戶編號_cb.Text = "CI00000000" Then
            SQL_銷售退貨清單_客戶資料_零售一()
            If (dr.Read()) Then
                付款方式_tb.Text = dr("付款方式")
            End If : conn.Close()
            SQL_銷售退貨清單_客戶資料_零售二()
            If (dr.Read()) Then
                客戶公司_tb.Text = dr("客戶名稱") : 手機_tb.Text = dr("手機") : 電話_tb.Text = dr("電話") : 傳真_tb.Text = dr("傳真") : 郵號_tb.Text = dr("郵遞區號")
                店面地址_tb.Text = dr("店面地址") : 送貨地址_tb.Text = dr("送貨地址") : 統編_tb.Text = dr("統一編號")
            End If : conn.Close()
        Else
            SQL_銷售退貨清單_客戶資料_銷售二()
            If (dr.Read()) Then
                客戶公司_tb.Text = dr("店名") : 手機_tb.Text = dr("手機") : 電話_tb.Text = dr("電話") : 傳真_tb.Text = dr("傳真") : 郵號_tb.Text = dr("店面地址郵遞區號")
                店面地址_tb.Text = dr("店面地址") : 送貨地址_tb.Text = dr("送貨地址") : 統編_tb.Text = dr("統編") : 付款方式_tb.Text = dr("付款方式")
            End If : conn.Close()
        End If
    End Sub
    Private Sub ComboBox2_SelectedIndexChanged(sender As Object, e As EventArgs) Handles 客戶_cb.SelectedIndexChanged
        客戶編號_cb.SelectedIndex = 客戶_cb.SelectedIndex : 客戶資料()
    End Sub
    Private Sub ComboBox3_SelectedIndexChanged(sender As Object, e As EventArgs) Handles 客戶編號_cb.SelectedIndexChanged
        客戶_cb.SelectedIndex = 客戶編號_cb.SelectedIndex : 客戶資料()
    End Sub
    Private Sub Button3_Click(sender As Object, e As EventArgs) Handles 列印退貨單_bt.Click
        If 單據編號_tb.Text = "" Then : MsgBox("請選擇維修單。") : Else
            xlApp = CType(CreateObject("Excel.Application"), Application)
            xlBook = xlApp.Workbooks.Add
            xlApp.DisplayAlerts = True
            xlBook.Activate()
            xlSheet = NewMethod(xlBook)
            xlSheet.Activate()
            xlApp.Visible = True
            xlApp.Application.WindowState = xlMaximized

            xlSheet.Cells(1, 1) = MAOJI_ERP_SYS.公司名稱_cb.Text : xlSheet.Cells(2, 1) = 公司地址 : xlSheet.Cells(3, 1) = "銷售退貨單"
            xlSheet.Cells(4, 1) = "客戶" : xlSheet.Cells(5, 1) = "統編" : xlSheet.Cells(6, 1) = "地址"
            xlSheet.Cells(4, 2) = 客戶公司_tb.Text : xlSheet.Cells(5, 2) = 統編_tb.Text : xlSheet.Cells(6, 2) = 送貨地址_tb.Text
            xlSheet.Cells(4, 5) = "單據編號" : xlSheet.Cells(5, 5) = "聯絡手機" : xlSheet.Cells(6, 5) = "聯繫電話"
            xlSheet.Cells(4, 6) = 單據編號_tb.Text : xlSheet.Cells(5, 6) = 手機_tb.Text : xlSheet.Cells(6, 6) = 電話_tb.Text
            xlSheet.Cells(8, 1) = "NO" : xlSheet.Cells(8, 2) = "品名" : xlSheet.Cells(8, 3) = "尺寸" : xlSheet.Cells(8, 4) = "材質" : xlSheet.Cells(8, 5) = "數量" : xlSheet.Cells(8, 6) = "備註"
            N1 = 0
            For I As Integer = 0 To 明細_dgv.Rows.Count - 1
                xlSheet.Cells(I + 9, 1) = 明細_dgv.Rows(I).Cells("項次").Value
                xlSheet.Cells(I + 9, 2) = 明細_dgv.Rows(I).Cells("品名").Value
                xlSheet.Cells(I + 9, 3) = 明細_dgv.Rows(I).Cells("尺寸").Value
                xlSheet.Cells(I + 9, 4) = 明細_dgv.Rows(I).Cells("材質").Value
                xlSheet.Cells(I + 9, 5) = 明細_dgv.Rows(I).Cells("數量").Value
                xlSheet.Cells(I + 9, 6) = 明細_dgv.Rows(I).Cells("備註").Value
                N1 = I + 9
            Next
            xlSheet.Cells(N1 + 1, 1) = "(以下空白)"
            xlSheet.Cells(N1 + 3, 1) = "客戶回簽 :" : xlSheet.Cells(N1 + 3, 5) = "收貨人員 :"
            AA(xlApp, xlSheet)

            xlSheet.PageSetup.PrintArea = ""
            xlApp.Cells.Select()
            xlSheet.Range("B1").Select()
            xlApp.Application.WindowState = xlMinimized
            xlSheet.Cells.Select()
            MsgBox("列印完成。")
        End If
    End Sub
    Private Shared Function NewMethod(xlBook As Workbook) As Worksheet
        Return CType(xlBook.Worksheets.Add, Worksheet)
    End Function
    Private Sub AA(ByVal myExcel As Application, ByVal xlSheet As Worksheet)
        xlSheet.Cells.Select()
        With myExcel.Selection.Font : .Name = "微軟正黑體" : .Size = 10 : .Strikethrough = False : .Superscript = False : .Subscript = False : .OutlineFont = False : .Shadow = False
            .Underline = xlUnderlineStyleNone : .ThemeColor = xlThemeColorLight1 : .TintAndShade = 0 : .ThemeFont = xlThemeFontNone : End With

        xlSheet.Rows("1:1").Select : myExcel.Selection.RowHeight = 35
        xlSheet.Rows("2:2").Select : myExcel.Selection.RowHeight = 25
        xlSheet.Rows("3:3").Select : myExcel.Selection.RowHeight = 20

        xlSheet.Rows("1:1").Select
        With myExcel.Selection.Font : .Name = "微軟正黑體" : .Size = 24 : .Strikethrough = False : .Superscript = False : .Subscript = False : .OutlineFont = False : .Shadow = False
            .Underline = xlUnderlineStyleNone : .ThemeColor = xlThemeColorLight1 : .TintAndShade = 0 : .ThemeFont = xlThemeFontNone : End With
        xlSheet.Rows("2:2").Select
        With myExcel.Selection.Font : .Name = "微軟正黑體" : .Size = 16 : .Strikethrough = False : .Superscript = False : .Subscript = False : .OutlineFont = False : .Shadow = False
            .Underline = xlUnderlineStyleNone : .ThemeColor = xlThemeColorLight1 : .TintAndShade = 0 : .ThemeFont = xlThemeFontNone : End With
        xlSheet.Rows("3:3").Select
        With myExcel.Selection.Font : .Name = "微軟正黑體" : .Size = 14 : .Strikethrough = False : .Superscript = False : .Subscript = False : .OutlineFont = False : .Shadow = False
            .Underline = xlUnderlineStyleNone : .ThemeColor = xlThemeColorLight1 : .TintAndShade = 0 : .ThemeFont = xlThemeFontNone : End With

        xlSheet.Columns("A:A").Select : myExcel.Selection.ColumnWidth = 7
        xlSheet.Columns("B:B").Select : myExcel.Selection.ColumnWidth = 35
        xlSheet.Columns("C:C").Select : myExcel.Selection.ColumnWidth = 15
        xlSheet.Columns("D:D").Select : myExcel.Selection.ColumnWidth = 15
        xlSheet.Columns("E:E").Select : myExcel.Selection.ColumnWidth = 9
        xlSheet.Columns("F:F").Select : myExcel.Selection.ColumnWidth = 25
        xlSheet.Range("B4:B6").Select()

        With myExcel.Selection : .HorizontalAlignment = xlLeft : .VerticalAlignment = xlCenter : .WrapText = False : .Orientation = 0 : .AddIndent = False : .IndentLevel = 0
            .ShrinkToFit = False : .ReadingOrder = xlContext : .MergeCells = False : End With

        xlSheet.Range("F4:F6").Select()
        With myExcel.Selection : .HorizontalAlignment = xlLeft : .VerticalAlignment = xlCenter : .WrapText = False : .Orientation = 0 : .AddIndent = False : .IndentLevel = 0
            .ShrinkToFit = False : .ReadingOrder = xlContext : .MergeCells = False : End With

        xlSheet.Rows("7:7").Select : myExcel.Selection.RowHeight = 5
        xlSheet.Rows("8:8").Select : myExcel.Selection.RowHeight = 30
        xlSheet.Rows("9:" & N1 + 1).Select : myExcel.Selection.RowHeight = 16
        xlSheet.Rows(N1 + 2 & ":" & N1 + 2).Select : myExcel.Selection.RowHeight = 5
        xlSheet.Rows(N1 + 3 & ":" & N1 + 3).Select : myExcel.Selection.RowHeight = 40

        xlSheet.Range("A1:F1").Select()
        With myExcel.Selection : .HorizontalAlignment = xlCenter : .VerticalAlignment = xlCenter : .WrapText = False : .Orientation = 0 : .AddIndent = False : .IndentLevel = 0
            .ShrinkToFit = False : .ReadingOrder = xlContext : .MergeCells = False : End With : myExcel.Selection.Merge
        xlSheet.Range("A2:F2").Select()
        With myExcel.Selection : .HorizontalAlignment = xlCenter : .VerticalAlignment = xlCenter : .WrapText = False : .Orientation = 0 : .AddIndent = False : .IndentLevel = 0
            .ShrinkToFit = False : .ReadingOrder = xlContext : .MergeCells = False : End With : myExcel.Selection.Merge
        xlSheet.Range("A3:F3").Select()
        With myExcel.Selection : .HorizontalAlignment = xlCenter : .VerticalAlignment = xlCenter : .WrapText = False : .Orientation = 0 : .AddIndent = False : .IndentLevel = 0
            .ShrinkToFit = False : .ReadingOrder = xlContext : .MergeCells = False : End With : myExcel.Selection.Merge

        xlSheet.Range("A2:F2").Select()
        myExcel.Selection.Borders(xlDiagonalDown).LineStyle = xlNone : myExcel.Selection.Borders(xlDiagonalUp).LineStyle = xlNone
        myExcel.Selection.Borders(xlEdgeLeft).LineStyle = xlNone : myExcel.Selection.Borders(xlEdgeTop).LineStyle = xlNone
        With myExcel.Selection.Borders(xlEdgeBottom) : .LineStyle = xlContinuous : .ColorIndex = 0 : .TintAndShade = 0 : .Weight = xlThin : End With
        myExcel.Selection.Borders(xlEdgeRight).LineStyle = xlNone : myExcel.Selection.Borders(xlInsideVertical).LineStyle = xlNone : myExcel.Selection.Borders(xlInsideHorizontal).LineStyle = xlNone

        xlSheet.Range("A5:F6").Select()
        myExcel.Selection.Borders(xlDiagonalDown).LineStyle = xlNone : myExcel.Selection.Borders(xlDiagonalUp).LineStyle = xlNone
        myExcel.Selection.Borders(xlEdgeLeft).LineStyle = xlNone : myExcel.Selection.Borders(xlEdgeTop).LineStyle = xlNone
        With myExcel.Selection.Borders(xlEdgeBottom) : .LineStyle = xlContinuous : .ColorIndex = 0 : .TintAndShade = 0 : .Weight = xlMedium : End With
        myExcel.Selection.Borders(xlEdgeRight).LineStyle = xlNone : myExcel.Selection.Borders(xlInsideVertical).LineStyle = xlNone : myExcel.Selection.Borders(xlInsideHorizontal).LineStyle = xlNone

        xlSheet.Range("A8:F8").Select()
        myExcel.Selection.Borders(xlDiagonalDown).LineStyle = xlNone : myExcel.Selection.Borders(xlDiagonalUp).LineStyle = xlNone : myExcel.Selection.Borders(xlEdgeLeft).LineStyle = xlNone
        With myExcel.Selection.Borders(xlEdgeTop) : .LineStyle = xlContinuous : .ColorIndex = 0 : .TintAndShade = 0 : .Weight = xlThin : End With
        With myExcel.Selection.Borders(xlEdgeBottom) : .LineStyle = xlContinuous : .ColorIndex = 0 : .TintAndShade = 0 : .Weight = xlThin : End With
        myExcel.Selection.Borders(xlEdgeRight).LineStyle = xlNone : myExcel.Selection.Borders(xlInsideVertical).LineStyle = xlNone : myExcel.Selection.Borders(xlInsideHorizontal).LineStyle = xlNone

        xlSheet.Range("A" & N1 + 1 & ":F" & N1 + 1).Select()
        myExcel.Selection.Borders(xlDiagonalDown).LineStyle = xlNone : myExcel.Selection.Borders(xlDiagonalUp).LineStyle = xlNone
        myExcel.Selection.Borders(xlEdgeLeft).LineStyle = xlNone : myExcel.Selection.Borders(xlEdgeTop).LineStyle = xlNone
        With myExcel.Selection.Borders(xlEdgeBottom) : .LineStyle = xlContinuous : .ColorIndex = 0 : .TintAndShade = 0 : .Weight = xlThin
        End With
        myExcel.Selection.Borders(xlEdgeRight).LineStyle = xlNone : myExcel.Selection.Borders(xlInsideVertical).LineStyle = xlNone : myExcel.Selection.Borders(xlInsideHorizontal).LineStyle = xlNone

        myExcel.ActiveWindow.DisplayGridlines = False

        xlSheet.Range("B9:D" & N1).Select()
        With myExcel.Selection : .HorizontalAlignment = xlLeft : .VerticalAlignment = xlCenter : .WrapText = False : .Orientation = 0 : .AddIndent = False : .IndentLevel = 0
            .ShrinkToFit = False : .ReadingOrder = xlContext : .MergeCells = False : End With

        xlSheet.Range("E9:E" & N1).Select()
        With myExcel.Selection : .HorizontalAlignment = xlCenter : .VerticalAlignment = xlCenter : .WrapText = False : .Orientation = 0 : .AddIndent = False : .IndentLevel = 0
            .ShrinkToFit = False : .ReadingOrder = xlContext : .MergeCells = False : End With
    End Sub
    Private Sub Button1_Click(sender As Object, e As EventArgs) Handles 列印產品標籤_bt.Click
        If 單據編號_tb.Text = "" Then : MsgBox("沒有選擇要列印的單號 。") : Else : 列印用SQL = 單據編號_tb.Text : PA = "銷售退貨單" : 列印_產品標籤介面.ShowDialog() : End If
    End Sub

    Private Sub ContextMenuStrip1_Opening(sender As Object, e As System.ComponentModel.CancelEventArgs)

    End Sub

    Private Sub 刪除採購單中選中的物料_bt_MouseEnter(sender As Object, e As EventArgs) Handles 單號查詢_bt.MouseEnter
        ToolTip1.SetToolTip(Me.單號查詢_bt, "單號查詢")
    End Sub
    Private Sub 列印產品標籤_bt_MouseEnter(sender As Object, e As EventArgs) Handles 列印產品標籤_bt.MouseEnter
        ToolTip1.SetToolTip(Me.列印產品標籤_bt, "列印產品標籤")
    End Sub
    Private Sub 列印出貨單_bt_MouseEnter(sender As Object, e As EventArgs) Handles 列印退貨單_bt.MouseEnter
        ToolTip1.SetToolTip(Me.列印退貨單_bt, "列印退貨單")
    End Sub
End Class