﻿Option Strict Off
Public Class 零售客戶記錄表
    ReadOnly ds As New DataSet
    Private Sub Set_清單()
        零售清單_tb.DataSource = Nothing : ds.Clear()
        零售清單_tb.ColumnHeadersHeightSizeMode = DataGridViewColumnHeadersHeightSizeMode.EnableResizing
        零售清單_tb.ColumnHeadersHeight = 40
        零售清單_tb.AllowUserToAddRows = False
        零售清單_tb.ClipboardCopyMode = DataGridViewClipboardCopyMode.EnableWithoutHeaderText
        零售清單_tb.MultiSelect = True
        SQL_零售客戶記錄表清單()
        da.Fill(ds) : 零售清單_tb.DataSource = ds.Tables(0) : conn.Close()

        零售清單_tb.Columns(0).FillWeight = 60 : 零售清單_tb.Columns(1).FillWeight = 60 : 零售清單_tb.Columns(2).FillWeight = 60 : 零售清單_tb.Columns(3).FillWeight = 30
        零售清單_tb.Columns(4).FillWeight = 190 : 零售清單_tb.Columns(5).FillWeight = 190 : 零售清單_tb.Columns(6).FillWeight = 70 : 零售清單_tb.Columns(7).FillWeight = 70
        零售清單_tb.Columns(8).FillWeight = 70 : 零售清單_tb.Columns(9).FillWeight = 90

        零售清單_tb.Columns(0).DefaultCellStyle.Alignment = DataGridViewContentAlignment.MiddleCenter : 零售清單_tb.Columns(0).HeaderCell.Style.Alignment = DataGridViewContentAlignment.MiddleCenter
        零售清單_tb.Columns(1).DefaultCellStyle.Alignment = DataGridViewContentAlignment.MiddleCenter : 零售清單_tb.Columns(1).HeaderCell.Style.Alignment = DataGridViewContentAlignment.MiddleCenter
        零售清單_tb.Columns(2).DefaultCellStyle.Alignment = DataGridViewContentAlignment.MiddleCenter : 零售清單_tb.Columns(2).HeaderCell.Style.Alignment = DataGridViewContentAlignment.MiddleCenter
        零售清單_tb.Columns(3).DefaultCellStyle.Alignment = DataGridViewContentAlignment.MiddleCenter : 零售清單_tb.Columns(3).HeaderCell.Style.Alignment = DataGridViewContentAlignment.MiddleCenter
        零售清單_tb.Columns(6).DefaultCellStyle.Alignment = DataGridViewContentAlignment.MiddleCenter : 零售清單_tb.Columns(6).HeaderCell.Style.Alignment = DataGridViewContentAlignment.MiddleCenter
        零售清單_tb.Columns(7).DefaultCellStyle.Alignment = DataGridViewContentAlignment.MiddleCenter : 零售清單_tb.Columns(7).HeaderCell.Style.Alignment = DataGridViewContentAlignment.MiddleCenter
        零售清單_tb.Columns(8).DefaultCellStyle.Alignment = DataGridViewContentAlignment.MiddleCenter : 零售清單_tb.Columns(8).HeaderCell.Style.Alignment = DataGridViewContentAlignment.MiddleCenter
        零售清單_tb.Columns(9).DefaultCellStyle.Alignment = DataGridViewContentAlignment.MiddleCenter : 零售清單_tb.Columns(9).HeaderCell.Style.Alignment = DataGridViewContentAlignment.MiddleCenter

        零售清單_tb.Columns(0).ReadOnly = True : 零售清單_tb.Columns(1).ReadOnly = True : 零售清單_tb.Columns(2).ReadOnly = True : 零售清單_tb.Columns(3).ReadOnly = True
        零售清單_tb.Columns(4).ReadOnly = True : 零售清單_tb.Columns(5).ReadOnly = True : 零售清單_tb.Columns(6).ReadOnly = True : 零售清單_tb.Columns(7).ReadOnly = True
        零售清單_tb.Columns(8).ReadOnly = True : 零售清單_tb.Columns(9).ReadOnly = True
    End Sub
    Private Sub 零售客戶記錄表_Load(sender As Object, e As EventArgs) Handles MyBase.Load
        Me.MdiParent = MAOJI_ERP_SYS : Me.WindowState = 2 : Me.AutoScroll = True
        資料流水號_tb.Enabled = False
    End Sub
    Private Sub 介面開啟_Shown(sender As Object, e As EventArgs) Handles MyBase.Shown
        計算分流.Enabled = True
    End Sub
    Private Sub 計算分流_Tick(sender As Object, e As EventArgs) Handles 計算分流.Tick
        Set_清單()
        計算分流.Enabled = False
    End Sub
    Private Sub 介面關閉_Closed(sender As Object, e As EventArgs) Handles MyBase.Closed
        MyModule1.虛擬桌面開啟()
    End Sub
    Private Sub DataGridView3_CellClick(ByVal sender As System.Object, ByVal e As System.Windows.Forms.DataGridViewCellEventArgs) Handles 零售清單_tb.CellClick
        If e.RowIndex = -1 Then : Else
            資料流水號_tb.Text = 零售清單_tb.Rows(e.RowIndex).Cells("零售流水號").Value.ToString : 客戶_tb.Text = 零售清單_tb.Rows(e.RowIndex).Cells("客戶名稱").Value.ToString
            電話_tb.Text = 零售清單_tb.Rows(e.RowIndex).Cells("電話").Value.ToString : 手機_tb.Text = 零售清單_tb.Rows(e.RowIndex).Cells("手機").Value.ToString
            傳真_tb.Text = 零售清單_tb.Rows(e.RowIndex).Cells("傳真").Value.ToString : 統編_tb.Text = 零售清單_tb.Rows(e.RowIndex).Cells("統一編號").Value.ToString
            郵號_tb.Text = 零售清單_tb.Rows(e.RowIndex).Cells("郵遞區號").Value.ToString : 店面地址_tb.Text = 零售清單_tb.Rows(e.RowIndex).Cells("店面地址").Value.ToString
            送貨地址_tb.Text = 零售清單_tb.Rows(e.RowIndex).Cells("送貨地址").Value.ToString
        End If
    End Sub
    Private Sub Button1_Click(sender As Object, e As EventArgs) Handles 修改存檔_bt.Click
        SQL_零售客戶記錄表修改() : conn.Close() : Set_清單() : MsgBox("資料存檔完畢 。")
    End Sub
    '-----------------------------滑鼠右鍵------------------------------------------------------------------------------------------------------------------------------------------
    Private Sub 重新整理ToolStripMenuItem_Click(sender As Object, e As EventArgs) Handles 重新整理ToolStripMenuItem.Click
        Set_清單()
    End Sub
End Class