﻿Option Strict Off
Imports System.Windows.Forms.VisualStyles.VisualStyleElement

Public Class 採購退貨申請
    ReadOnly ds As New DataSet : ReadOnly ds1 As New DataSet : ReadOnly ds2 As New DataSet
    Dim EDR As Integer = 0 : Dim ESTR As String
    Private Sub Set_採購清單()
        彙總_dgv.DataSource = Nothing : ds1.Clear()
        彙總_dgv.ColumnHeadersHeightSizeMode = DataGridViewColumnHeadersHeightSizeMode.EnableResizing
        彙總_dgv.ColumnHeadersHeight = 25
        彙總_dgv.AllowUserToAddRows = False
        彙總_dgv.ClipboardCopyMode = DataGridViewClipboardCopyMode.EnableWithoutHeaderText
        彙總_dgv.MultiSelect = True
        SQL_採購退貨申請_單號彙總()
        da.Fill(ds1) : 彙總_dgv.DataSource = ds1.Tables(0) : conn.Close()
        彙總_dgv.Columns(0).FillWeight = 135 : 彙總_dgv.Columns(1).FillWeight = 90 : 彙總_dgv.Columns(2).Visible = False : 彙總_dgv.Columns(3).FillWeight = 100
        彙總_dgv.Columns(4).FillWeight = 90
    End Sub
    Private Sub Set_單據明細()
        明細_dgv.DataSource = Nothing : ds2.Clear()
        明細_dgv.ColumnHeadersHeightSizeMode = DataGridViewColumnHeadersHeightSizeMode.EnableResizing
        明細_dgv.ColumnHeadersHeight = 25
        明細_dgv.AllowUserToAddRows = False
        明細_dgv.ClipboardCopyMode = DataGridViewClipboardCopyMode.EnableWithoutHeaderText
        明細_dgv.MultiSelect = True
        SQL_採購退貨申請明細()
        da.Fill(ds2) : 明細_dgv.DataSource = ds2.Tables(0) : conn.Close()

        總金額_tb.Text = "0"
        For i As Integer = 0 To 明細_dgv.Rows.Count - 1
            明細_dgv(1, i).Value = i + 1 : 總金額_tb.Text = Val(總金額_tb.Text) + 明細_dgv.Rows(i).Cells("進貨成本_台幣").Value
            明細_dgv.Rows(i).Cells("選擇").Value = False
        Next
        總金額_tb.Text = Strings.Format(Val(總金額_tb.Text), "#,#00")

        明細_dgv.Columns(6).DefaultCellStyle.Format = "#,##0" : 明細_dgv.Columns(7).DefaultCellStyle.Format = "#,##0.00"
        明細_dgv.Columns(8).DefaultCellStyle.Format = "#,##0.0000" : 明細_dgv.Columns(9).DefaultCellStyle.Format = "#,##0" : 明細_dgv.Columns(10).DefaultCellStyle.Format = "#,##0"
        明細_dgv.Columns(1).DefaultCellStyle.Alignment = DataGridViewContentAlignment.MiddleCenter : 明細_dgv.Columns(1).HeaderCell.Style.Alignment = DataGridViewContentAlignment.MiddleCenter
        明細_dgv.Columns(2).DefaultCellStyle.Alignment = DataGridViewContentAlignment.MiddleCenter : 明細_dgv.Columns(2).HeaderCell.Style.Alignment = DataGridViewContentAlignment.MiddleCenter
        明細_dgv.Columns(6).DefaultCellStyle.Alignment = DataGridViewContentAlignment.MiddleCenter : 明細_dgv.Columns(6).HeaderCell.Style.Alignment = DataGridViewContentAlignment.MiddleCenter
        明細_dgv.Columns(7).DefaultCellStyle.Alignment = DataGridViewContentAlignment.MiddleCenter : 明細_dgv.Columns(7).HeaderCell.Style.Alignment = DataGridViewContentAlignment.MiddleCenter
        明細_dgv.Columns(8).DefaultCellStyle.Alignment = DataGridViewContentAlignment.MiddleCenter : 明細_dgv.Columns(8).HeaderCell.Style.Alignment = DataGridViewContentAlignment.MiddleCenter
        明細_dgv.Columns(9).DefaultCellStyle.Alignment = DataGridViewContentAlignment.MiddleCenter : 明細_dgv.Columns(9).HeaderCell.Style.Alignment = DataGridViewContentAlignment.MiddleCenter
        明細_dgv.Columns(10).DefaultCellStyle.Alignment = DataGridViewContentAlignment.MiddleCenter : 明細_dgv.Columns(10).HeaderCell.Style.Alignment = DataGridViewContentAlignment.MiddleCenter
        明細_dgv.Columns(12).DefaultCellStyle.Alignment = DataGridViewContentAlignment.MiddleCenter : 明細_dgv.Columns(12).HeaderCell.Style.Alignment = DataGridViewContentAlignment.MiddleCenter

        明細_dgv.Columns(0).Visible = False : 明細_dgv.Columns(1).FillWeight = 50 : 明細_dgv.Columns(2).FillWeight = 80 : 明細_dgv.Columns(3).FillWeight = 200
        明細_dgv.Columns(4).Visible = False : 明細_dgv.Columns(5).Visible = False : 明細_dgv.Columns(6).FillWeight = 50 : 明細_dgv.Columns(7).FillWeight = 50
        明細_dgv.Columns(8).FillWeight = 50 : 明細_dgv.Columns(9).FillWeight = 50 : 明細_dgv.Columns(10).FillWeight = 65 : 明細_dgv.Columns(11).FillWeight = 100
        明細_dgv.Columns(12).FillWeight = 80 : 明細_dgv.Columns(13).Visible = False : 明細_dgv.Columns(14).Visible = False : 明細_dgv.Columns(15).Visible = False
        明細_dgv.Columns(16).Visible = False : 明細_dgv.Columns(17).FillWeight = 50

        明細_dgv.EditMode = DataGridViewEditMode.EditOnEnter
        明細_dgv.Columns(1).ReadOnly = True : 明細_dgv.Columns(2).ReadOnly = True : 明細_dgv.Columns(3).ReadOnly = True : 明細_dgv.Columns(4).ReadOnly = True
        明細_dgv.Columns(5).ReadOnly = True : 明細_dgv.Columns(8).ReadOnly = True : 明細_dgv.Columns(9).ReadOnly = True : 明細_dgv.Columns(10).ReadOnly = True
        明細_dgv.Columns(12).ReadOnly = True
    End Sub
    Private Sub Set_清單()
        庫存_dgv.DataSource = Nothing : ds.Clear()
        庫存_dgv.ColumnHeadersHeightSizeMode = DataGridViewColumnHeadersHeightSizeMode.EnableResizing
        庫存_dgv.ColumnHeadersHeight = 40
        庫存_dgv.AllowUserToAddRows = False
        庫存_dgv.ClipboardCopyMode = DataGridViewClipboardCopyMode.EnableWithoutHeaderText
        庫存_dgv.MultiSelect = True
        SQL_採購退貨申請清單()
        da.Fill(ds) : 庫存_dgv.DataSource = ds.Tables(0) : conn.Close()

        庫存_dgv.Columns(0).FillWeight = 130 : 庫存_dgv.Columns(1).Visible = False : 庫存_dgv.Columns(2).Visible = False : 庫存_dgv.Columns(3).FillWeight = 350
        庫存_dgv.Columns(4).Visible = False : 庫存_dgv.Columns(5).Visible = False : 庫存_dgv.Columns(6).Visible = False : 庫存_dgv.Columns(7).FillWeight = 85
        庫存_dgv.Columns(8).Visible = False : 庫存_dgv.Columns(9).Visible = False : 庫存_dgv.Columns(10).Visible = False : 庫存_dgv.Columns(11).Visible = False
        庫存_dgv.Columns(12).Visible = False : 庫存_dgv.Columns(13).FillWeight = 90 : 庫存_dgv.Columns(14).Visible = False

        庫存_dgv.Columns(6).DefaultCellStyle.Format = "#,##0" : 庫存_dgv.Columns(7).DefaultCellStyle.Format = "#,##0" : 庫存_dgv.Columns(8).DefaultCellStyle.Format = "#,##0"
        庫存_dgv.Columns(9).DefaultCellStyle.Format = "#,##0" : 庫存_dgv.Columns(10).DefaultCellStyle.Format = "#,##0" : 庫存_dgv.Columns(11).DefaultCellStyle.Format = "#,##0"
        庫存_dgv.Columns(12).DefaultCellStyle.Format = "#,##0" : 庫存_dgv.Columns(13).DefaultCellStyle.Format = "#,##0"
        庫存_dgv.Columns(0).DefaultCellStyle.Alignment = DataGridViewContentAlignment.MiddleCenter : 庫存_dgv.Columns(0).HeaderCell.Style.Alignment = DataGridViewContentAlignment.MiddleCenter
        庫存_dgv.Columns(6).DefaultCellStyle.Alignment = DataGridViewContentAlignment.MiddleCenter : 庫存_dgv.Columns(6).HeaderCell.Style.Alignment = DataGridViewContentAlignment.MiddleCenter
        庫存_dgv.Columns(7).DefaultCellStyle.Alignment = DataGridViewContentAlignment.MiddleCenter : 庫存_dgv.Columns(7).HeaderCell.Style.Alignment = DataGridViewContentAlignment.MiddleCenter
        庫存_dgv.Columns(8).DefaultCellStyle.Alignment = DataGridViewContentAlignment.MiddleCenter : 庫存_dgv.Columns(8).HeaderCell.Style.Alignment = DataGridViewContentAlignment.MiddleCenter
        庫存_dgv.Columns(9).DefaultCellStyle.Alignment = DataGridViewContentAlignment.MiddleCenter : 庫存_dgv.Columns(9).HeaderCell.Style.Alignment = DataGridViewContentAlignment.MiddleCenter
        庫存_dgv.Columns(10).DefaultCellStyle.Alignment = DataGridViewContentAlignment.MiddleCenter : 庫存_dgv.Columns(10).HeaderCell.Style.Alignment = DataGridViewContentAlignment.MiddleCenter
        庫存_dgv.Columns(11).DefaultCellStyle.Alignment = DataGridViewContentAlignment.MiddleCenter : 庫存_dgv.Columns(11).HeaderCell.Style.Alignment = DataGridViewContentAlignment.MiddleCenter
        庫存_dgv.Columns(12).DefaultCellStyle.Alignment = DataGridViewContentAlignment.MiddleCenter : 庫存_dgv.Columns(12).HeaderCell.Style.Alignment = DataGridViewContentAlignment.MiddleCenter
        庫存_dgv.Columns(13).DefaultCellStyle.Alignment = DataGridViewContentAlignment.MiddleCenter : 庫存_dgv.Columns(13).HeaderCell.Style.Alignment = DataGridViewContentAlignment.MiddleCenter

        庫存_dgv.Columns(0).ReadOnly = True : 庫存_dgv.Columns(3).ReadOnly = True : 庫存_dgv.Columns(4).ReadOnly = True : 庫存_dgv.Columns(5).ReadOnly = True
        庫存_dgv.Columns(6).ReadOnly = True : 庫存_dgv.Columns(7).ReadOnly = True : 庫存_dgv.Columns(8).ReadOnly = True : 庫存_dgv.Columns(9).ReadOnly = True
        庫存_dgv.Columns(10).ReadOnly = True : 庫存_dgv.Columns(11).ReadOnly = True : 庫存_dgv.Columns(12).ReadOnly = True : 庫存_dgv.Columns(13).ReadOnly = True

        庫存_dgv.Columns(7).DefaultCellStyle.BackColor = Color.MistyRose : 庫存_dgv.Columns(8).DefaultCellStyle.BackColor = Color.MistyRose
        庫存_dgv.Columns(9).DefaultCellStyle.BackColor = Color.LightYellow : 庫存_dgv.Columns(10).DefaultCellStyle.BackColor = Color.LightYellow
        庫存_dgv.Columns(11).DefaultCellStyle.BackColor = Color.LightGreen : 庫存_dgv.Columns(12).DefaultCellStyle.BackColor = Color.LightGreen
        For i As Integer = 0 To 庫存_dgv.Rows.Count - 1
            If 庫存_dgv.Rows(i).Cells("未入庫").Value.ToString = "" Then : 庫存_dgv.Rows(i).Cells("未入庫").Value = 0 : End If
            If 庫存_dgv.Rows(i).Cells("在途成本_台幣").Value.ToString = "" Then : 庫存_dgv.Rows(i).Cells("在途成本_台幣").Value = 0 : End If
            If 庫存_dgv.Rows(i).Cells("未出庫").Value.ToString = "" Then : 庫存_dgv.Rows(i).Cells("未出庫").Value = 0 : End If
            If 庫存_dgv.Rows(i).Cells("備貨成本_台幣").Value.ToString = "" Then : 庫存_dgv.Rows(i).Cells("備貨成本_台幣").Value = 0 : End If
            庫存_dgv.Rows(i).Cells("可領用").Value = 庫存_dgv.Rows(i).Cells("庫存").Value + 庫存_dgv.Rows(i).Cells("未入庫").Value - 庫存_dgv.Rows(i).Cells("未出庫").Value
        Next
        總金額_tb.Text = "" : 料號_tb.Text = "" : 可出庫_tb.Text = "0" : 申請數_nud.Value = 0
    End Sub
    Private Sub ComboBox1下拉表單資料載入()
        SQL_物料頁碼清單()
        頁碼_cb.Items.Clear() : While (dr.Read()) : 頁碼_cb.Items.Add(dr("頁碼")) : End While : conn.Close()
    End Sub
    Private Sub ComboBox2下拉表單資料載入()
        SQL_供應商資料表下拉清單()
        供應商_cb.Items.Clear() : 供應商編號_cb.Items.Clear() : While (dr.Read()) : 供應商_cb.Items.Add(dr("簡稱")) : 供應商編號_cb.Items.Add(dr("編號")) : End While : conn.Close()
    End Sub
    Private Sub ComboBox5下拉表單資料載入()
        SQL_倉名下拉清單()
        指定倉處_cb.Items.Clear() : While (dr.Read()) : 指定倉處_cb.Items.Add(dr("倉名")) : End While : conn.Close()
    End Sub
    Private Sub ComboBox5_SelectedIndexChanged(sender As Object, e As EventArgs) Handles 指定倉處_cb.SelectedIndexChanged
        PA = 指定倉處_cb.Text : SQL_倉名編號取得()
        If dr.Read() Then : 倉庫編號_tb.Text = dr("倉名編號") : End If : conn.Close() : Set_清單()
    End Sub
    Private Sub 採購退貨申請_Load(sender As Object, e As EventArgs) Handles MyBase.Load
        Me.MdiParent = MAOJI_ERP_SYS : Me.WindowState = 2 : Me.AutoScroll = True
        供應商_cb.Enabled = False : 供應商編號_cb.Enabled = False : 可出庫_tb.Enabled = False : 供應商_tb.Enabled = False : 公司電話2_tb.Enabled = False
        付款方式_tb.Enabled = False : 供應商編號_tb.Enabled = False : 公司電話1_tb.Enabled = False : 料號_tb.Enabled = False : 傳真1_tb.Enabled = False
        單據編號_tb.Enabled = False : 地址1_tb.Enabled = False : 郵號1_tb.Enabled = False : 地址2_tb.Enabled = False : 郵號2_tb.Enabled = False
        選擇_tb.Enabled = False : 總金額_tb.Enabled = False : 歷史售價_tb.Enabled = False : 倉庫編號_tb.Enabled = False : 統編_tb.Enabled = False
        採購下單_dtp.Enabled = False : 供應商交期_dtp.Enabled = False
        加權成本_台幣_tb.Visible = False
    End Sub
    Private Sub 介面開啟_Shown(sender As Object, e As EventArgs) Handles MyBase.Shown
        計算分流.Enabled = True
    End Sub
    Private Sub 計算分流_Tick(sender As Object, e As EventArgs) Handles 計算分流.Tick
        Set_採購清單() : ComboBox2下拉表單資料載入() : ComboBox5下拉表單資料載入() : ComboBox1下拉表單資料載入() : 指定倉處_cb.SelectedIndex = 0
        計算分流.Enabled = False
    End Sub
    Private Sub 介面關閉_Closed(sender As Object, e As EventArgs) Handles MyBase.Closed
        MyModule1.虛擬桌面開啟()
    End Sub
    Private Sub DataGridView1_CellClick(ByVal sender As System.Object, ByVal e As System.Windows.Forms.DataGridViewCellEventArgs) Handles 庫存_dgv.CellClick
        If e.RowIndex = -1 Then : Else
            供應商編號_tb.Text = 庫存_dgv.Rows(e.RowIndex).Cells("供應商編號").Value.ToString : 料號_tb.Text = 庫存_dgv.Rows(e.RowIndex).Cells("料號").Value.ToString
            加權成本_台幣_tb.Text = 庫存_dgv.Rows(e.RowIndex).Cells("加權成本_台幣").Value.ToString : 歷史售價_tb.Text = 庫存_dgv.Rows(e.RowIndex).Cells("售價").Value.ToString
            可出庫_tb.Text = Format(庫存_dgv.Rows(e.RowIndex).Cells("庫存").Value - 庫存_dgv.Rows(e.RowIndex).Cells("未出庫").Value, "#,##0")
            歷史售價_tb.Text = Format(Val(歷史售價_tb.Text), "#,##0")
        End If
    End Sub
    Private Sub DataGridView1_RowPostPaint(ByVal sender As Object, ByVal e As DataGridViewRowPostPaintEventArgs) Handles 庫存_dgv.RowPostPaint
        Dim linePen As New Pen(Color.Blue, 2)
        If e.RowIndex = 庫存_dgv.Rows.Count - 1 Then : Exit Sub
        Else
            If 非當天日期_ch.Checked = True Then
                If 庫存_dgv(0, e.RowIndex).Value.ToString <> 庫存_dgv(0, e.RowIndex + 1).Value.ToString Then
                    Dim startX As Integer = IIf(庫存_dgv.RowHeadersVisible, 庫存_dgv.RowHeadersWidth, 0)
                    Dim startY As Integer = e.RowBounds.Top + e.RowBounds.Height - 1
                    Dim endX As Integer = startX + 庫存_dgv.Columns.GetColumnsWidth(DataGridViewElementStates.Visible) - 庫存_dgv.HorizontalScrollingOffset
                    e.Graphics.DrawLine(linePen, startX, startY, endX, startY) : Exit Sub
                End If
            Else
                If 庫存_dgv(2, e.RowIndex).Value.ToString <> 庫存_dgv(2, e.RowIndex + 1).Value.ToString Then
                    Dim startX As Integer = IIf(庫存_dgv.RowHeadersVisible, 庫存_dgv.RowHeadersWidth, 0)
                    Dim startY As Integer = e.RowBounds.Top + e.RowBounds.Height - 1
                    Dim endX As Integer = startX + 庫存_dgv.Columns.GetColumnsWidth(DataGridViewElementStates.Visible) - 庫存_dgv.HorizontalScrollingOffset
                    e.Graphics.DrawLine(linePen, startX, startY, endX, startY) : Exit Sub
                End If
            End If
        End If
        For i As Integer = 0 To 庫存_dgv.Rows.Count - 1
            If 庫存_dgv.Rows(i).Cells("可領用").Value = 0 Then : 庫存_dgv.Rows(i).DefaultCellStyle.BackColor = Color.LightPink : End If
        Next
    End Sub
    Private Sub DataGridView2_CellClick(ByVal sender As System.Object, ByVal e As System.Windows.Forms.DataGridViewCellEventArgs) Handles 彙總_dgv.CellClick
        If e.RowIndex = -1 Then : Else
            單據編號_tb.Text = 彙總_dgv.Rows(e.RowIndex).Cells("單據編號").Value.ToString : 供應商編號_cb.Text = 彙總_dgv.Rows(e.RowIndex).Cells("供應商編號").Value.ToString
            採購下單_dtp.Value = 彙總_dgv.Rows(e.RowIndex).Cells("採購下單").Value.ToString : 供應商交期_dtp.Value = 彙總_dgv.Rows(e.RowIndex).Cells("交期").Value.ToString
            Set_單據明細()
        End If
    End Sub
    Private Sub DataGridView3_CellClick(ByVal sender As System.Object, ByVal e As System.Windows.Forms.DataGridViewCellEventArgs) Handles 明細_dgv.CellClick
        If e.RowIndex = -1 Then : Else
            選擇_tb.Text = 明細_dgv.Rows(e.RowIndex).Cells("資料流水號").Value.ToString : 物料關鍵字_tb.Text = 明細_dgv.Rows(e.RowIndex).Cells("品名").Value.ToString
            For i As Integer = 0 To 明細_dgv.Rows.Count - 1 : 明細_dgv.Rows(i).Cells("選擇").Value = False : Next
            明細_dgv.Rows(e.RowIndex).Cells("選擇").Value = True
        End If
    End Sub
    Private Sub DataGridView3_CellEnter(sender As Object, e As DataGridViewCellEventArgs) Handles 明細_dgv.CellEnter
        總金額_tb.Text = "0"
        For i As Integer = 0 To 明細_dgv.Rows.Count - 1
            明細_dgv.Rows(i).Cells("台幣單價").Value = 明細_dgv.Rows(i).Cells("單價").Value * 明細_dgv.Rows(i).Cells("匯率").Value
            明細_dgv.Rows(i).Cells("進貨成本_台幣").Value = 明細_dgv.Rows(i).Cells("單價").Value * 明細_dgv.Rows(i).Cells("匯率").Value * 明細_dgv.Rows(i).Cells("數量").Value
            明細_dgv(1, i).Value = i + 1
            總金額_tb.Text = Val(總金額_tb.Text) + 明細_dgv.Rows(i).Cells("進貨成本_台幣").Value
        Next i
        總金額_tb.Text = Strings.Format(Val(總金額_tb.Text), "#,#00")
    End Sub
    Private Sub 供應商資料()
        SQL_採購退貨申請_供應商資料表讀取()
        If (dr.Read()) Then
            供應商_tb.Text = dr("名稱") : 公司電話1_tb.Text = dr("公司電話1") : 公司電話2_tb.Text = dr("公司電話2") : 傳真1_tb.Text = dr("傳真1") : 郵號1_tb.Text = dr("郵遞區號1")
            地址1_tb.Text = dr("地址1") : 郵號2_tb.Text = dr("郵遞區號2") : 地址2_tb.Text = dr("地址2") : 統編_tb.Text = dr("統一編號") : 付款方式_tb.Text = dr("付款方式")
        End If : conn.Close()
    End Sub
    Private Sub ComboBox2_SelectedIndexChanged(sender As Object, e As EventArgs) Handles 供應商_cb.SelectedIndexChanged
        供應商編號_cb.SelectedIndex = 供應商_cb.SelectedIndex : 供應商資料()
    End Sub
    Private Sub ComboBox3_SelectedIndexChanged(sender As Object, e As EventArgs) Handles 供應商編號_cb.SelectedIndexChanged
        供應商_cb.SelectedIndex = 供應商編號_cb.SelectedIndex : 供應商資料()
    End Sub
    Private Sub ComboBox1_SelectedIndexChanged(sender As Object, e As EventArgs) Handles 頁碼_cb.SelectedIndexChanged
        Set_清單()
    End Sub
    Private Sub TextBox18_TextChanged(sender As Object, e As EventArgs) Handles 物料關鍵字_tb.TextChanged
        Set_清單()
    End Sub
    Private Sub Set_日期格式轉換()
        DTP = Strings.Format(採購下單_dtp.Value, "yyyy/MM/dd") : DTP1 = Strings.Format(採購下單_dtp.Value, "yyyyMMdd") : DTP2 = Strings.Format(供應商交期_dtp.Value, "yyyy/MM/dd")
    End Sub
    Private Sub Set_自動生成流水號()
        SQL_倉儲明細表流水號最後一筆()
        If dr.Read() Then : EDR = Double.Parse(Strings.Right(dr("資料流水號").ToString, 8)) : Else : EDR = 0 : End If : conn.Close() : EDR += 1
        If EDR < 10 Then : ESTR = "WD" & "0000000" & EDR
        ElseIf EDR > 9 And EDR < 100 Then : ESTR = "WD" & "000000" & EDR
        ElseIf EDR > 99 And EDR < 1000 Then : ESTR = "WD" & "00000" & EDR
        ElseIf EDR > 999 And EDR < 10000 Then : ESTR = "WD" & "0000" & EDR
        ElseIf EDR > 9999 And EDR < 100000 Then : ESTR = "WD" & "000" & EDR
        ElseIf EDR > 99999 And EDR < 100000 Then : ESTR = "WD" & "00" & EDR
        ElseIf EDR > 999999 And EDR < 1000000 Then : ESTR = "WD" & "0" & EDR
        ElseIf EDR > 9999999 Then : ESTR = "WD" & EDR
        End If
    End Sub
    Private Sub 存檔1()
        Dim SSDD As Integer = 0
        For i As Integer = 0 To 明細_dgv.Rows.Count - 1
            資料數 = 明細_dgv.Rows.Count : MyModule1.進度條()
            PA1 = 明細_dgv.Rows(i).Cells("資料流水號").Value : SQL_倉儲明細表_入庫日期讀取()
            If dr.Read() Then
                If dr("入庫日期").ToString = "" Then
                    NU1 = 明細_dgv.Rows(i).Cells("單價").Value : NU2 = 明細_dgv.Rows(i).Cells("數量").Value
                    PA1 = 明細_dgv.Rows(i).Cells("備註").Value : PA2 = DTP2 : PA3 = 明細_dgv.Rows(i).Cells("資料流水號").Value
                    SQL_採購單申請_倉儲明細表修改_入庫(Strings.Format(採購下單_dtp.Value, "yyyy/MM/dd")) : conn.Close()
                Else
                    conn.Close() : SSDD += 1
                End If
            End If
        Next : MAOJI_ERP_SYS.ToolStripProgressBar1.Value = 0 : 最終數 = 0 : If SSDD = 0 Then : Else : End If
    End Sub
    Private Sub Set_新增明細()
        PA1 = 料號_tb.Text : SQL_物料資料庫成本查詢()
        If dr.Read() Then
            If dr("成本") = 0 Then : NU1 = 加權成本_台幣_tb.Text : PA1 = 料號_tb.Text : SQL_物料資料庫成本修改() : conn.Close() : Else : conn.Close() : End If
        End If
        PA1 = ESTR : PA2 = 單據編號_tb.Text : PA3 = 供應商編號_cb.Text : PA4 = 料號_tb.Text : NU1 = 加權成本_台幣_tb.Text : NU2 = 1
        NU3 = 申請數_nud.Value : NU4 = 0 : PA5 = "採購入庫" : PA6 = DTP : PA7 = "" : NU5 = 0 : PA8 = 倉庫編號_tb.Text : PA9 = DTP2
        SQL_倉儲明細表新增() : conn.Close()
        MsgBox("資料新增完畢 。") : Set_單據明細()
    End Sub
    Private Sub Button1_Click(sender As Object, e As EventArgs) Handles 新增物料到退貨單.Click
        If 料號_tb.Text = "" Then : MsgBox("料號沒有選擇") : Else
            If 供應商編號_cb.Text = "" Then : MsgBox("供應商沒有選擇") : Else
                If 加權成本_台幣_tb.Text = 0 Then : MsgBox("採購金額沒有填寫") : Else
                    If 申請數_nud.Value = 0 Then : MsgBox("數量不可為零") : Else
                        If Val(可出庫_tb.Text) < 申請數_nud.Value * -1 Then : MsgBox("退貨數無法大於庫存數") : Else
                            If 單據編號_tb.Text = "" Then
                                '----------------------自动生成單據編號-------------------------------------------------------------------------
                                If 非當天日期_ch.Checked = True Then : Else : 採購下單_dtp.Value = Today() : End If
                                Dim NUM1 As Integer : Set_日期格式轉換()
                                For i As Integer = 1 To 999
                                    NUM1 = 0 + i
                                    If NUM1 < 10 Then : 單據編號_tb.Text = "WD-" & DTP1 & "-00" & NUM1
                                    ElseIf NUM1 > 9 And NUM1 < 100 Then : 單據編號_tb.Text = "WD-" & DTP1 & "-0" & NUM1
                                    ElseIf NUM1 > 99 Then : 單據編號_tb.Text = "WD-" & DTP1 & "-" & NUM1 : End If : PA1 = 單據編號_tb.Text
                                    SQL_倉儲明細表生成單據編號()
                                    If dr.Read() Then : Else : i = 999 : conn.Close() : End If : conn.Close()
                                Next
                                Set_自動生成流水號() : 選擇_tb.Text = ESTR : conn.Close() : 存檔1() : Set_新增明細() : Set_採購清單()
                            Else
                                Set_日期格式轉換() : Set_自動生成流水號() : 選擇_tb.Text = ESTR : conn.Close() : 存檔1() : Set_新增明細()
                            End If
                        End If
                    End If
                End If
            End If
        End If
    End Sub
    Private Sub Button3_Click(sender As Object, e As EventArgs) Handles 修改存檔_bt.Click
        Set_日期格式轉換() : 存檔1() : Set_單據明細() : Set_採購清單() : MsgBox("資料修改，存檔完畢 。")
    End Sub
    '-----------------------------滑鼠右鍵------------------------------------------------------------------------------------------------------------------------------------------
    Private Sub 重新整理ToolStripMenuItem_Click(sender As Object, e As EventArgs)
        Set_採購清單() : ComboBox2下拉表單資料載入() : ComboBox5下拉表單資料載入() : ComboBox1下拉表單資料載入() : 指定倉處_cb.SelectedIndex = 0
    End Sub
    Private Sub 刪除出貨單中選中的物料_bt_Click(sender As Object, e As EventArgs) Handles 刪除出貨單中選中的物料_bt.Click
        PA1 = 選擇_tb.Text : SQL_倉儲明細表_入庫日期讀取()
        If dr.Read() Then
            If dr("入庫日期").ToString = "" Then : conn.Close()
                If 選擇_tb.Text = "" Then : MsgBox("沒有選擇要刪除了料號 。")
                Else
                    Dim aa1 As MsgBoxResult = MsgBox("確定要刪除該筆資料?", MsgBoxStyle.OkCancel)
                    If aa1 = MsgBoxResult.Ok Then
                        PA1 = 選擇_tb.Text : SQL_倉儲明細表刪除() : conn.Close() : 選擇_tb.Text = "" : Set_單據明細()
                    End If
                End If
            Else
                conn.Close() : MsgBox("已入庫的資料不可刪除 。")
            End If
        Else
            conn.Close() : MsgBox("資料錯誤，請聯繫系統開發人員 。")
        End If
    End Sub
    Private Sub 列印產品標籤_bt_MouseEnter(sender As Object, e As EventArgs) Handles 修改存檔_bt.MouseEnter
        ToolTip1.SetToolTip(Me.修改存檔_bt, "修改存檔")
    End Sub
    Private Sub 列印出貨單_bt_MouseEnter(sender As Object, e As EventArgs) Handles 刪除出貨單中選中的物料_bt.MouseEnter
        ToolTip1.SetToolTip(Me.刪除出貨單中選中的物料_bt, "刪除出貨單中選中的物料")
    End Sub
End Class