﻿Option Strict Off
Imports Microsoft.Office.Interop.Excel.XlUnderlineStyle
Imports Microsoft.Office.Interop.Excel.Constants
Imports Microsoft.Office.Interop.Excel.XlBordersIndex
Imports Microsoft.Office.Interop.Excel.XlLineStyle
Imports Microsoft.Office.Interop.Excel.XlBorderWeight
Imports Microsoft.Office.Interop.Excel.XlThemeFont
Imports Microsoft.Office.Interop.Excel.XlThemeColor
Imports Microsoft.Office.Interop.Excel.XlWindowState
Imports Microsoft.Office.Interop.Excel
Public Class 採購退賀清單
    ReadOnly ds1 As New DataSet : ReadOnly ds2 As New DataSet
    Dim xlApp As Application : Dim xlBook As Workbook : Dim xlSheet As Worksheet
    Dim N1 As Integer
    Private Sub Set_採購清單()
        彙總_dgv.DataSource = Nothing : ds1.Clear()
        彙總_dgv.ColumnHeadersHeightSizeMode = DataGridViewColumnHeadersHeightSizeMode.EnableResizing
        彙總_dgv.ColumnHeadersHeight = 25
        彙總_dgv.AllowUserToAddRows = False
        彙總_dgv.ClipboardCopyMode = DataGridViewClipboardCopyMode.EnableWithoutHeaderText
        彙總_dgv.MultiSelect = True
        SQL_採購退貨清單_單號彙總()
        da.Fill(ds1) : 彙總_dgv.DataSource = ds1.Tables(0) : conn.Close()
        彙總_dgv.Columns(0).FillWeight = 135 : 彙總_dgv.Columns(1).FillWeight = 90 : 彙總_dgv.Columns(2).Visible = False : 彙總_dgv.Columns(3).FillWeight = 100
        彙總_dgv.Columns(4).FillWeight = 90
    End Sub
    Private Sub Set_單據明細()
        明細_dgv.DataSource = Nothing : ds2.Clear()
        明細_dgv.ColumnHeadersHeightSizeMode = DataGridViewColumnHeadersHeightSizeMode.EnableResizing
        明細_dgv.ColumnHeadersHeight = 25
        明細_dgv.AllowUserToAddRows = False
        明細_dgv.ClipboardCopyMode = DataGridViewClipboardCopyMode.EnableWithoutHeaderText
        明細_dgv.MultiSelect = True
        SQL_採購退貨清單明細()
        da.Fill(ds2) : 明細_dgv.DataSource = ds2.Tables(0) : conn.Close()

        總金額_tb.Text = "0"
        For i As Integer = 0 To 明細_dgv.Rows.Count - 1
            明細_dgv(1, i).Value = i + 1 : 總金額_tb.Text = Val(總金額_tb.Text) + 明細_dgv.Rows(i).Cells("進貨成本_台幣").Value
            明細_dgv.Rows(i).Cells("選擇").Value = False
        Next
        總金額_tb.Text = Strings.Format(Val(總金額_tb.Text), "#,#00")

        明細_dgv.Columns(6).DefaultCellStyle.Format = "#,##0" : 明細_dgv.Columns(7).DefaultCellStyle.Format = "#,##0.00"
        明細_dgv.Columns(8).DefaultCellStyle.Format = "#,##0.0000" : 明細_dgv.Columns(9).DefaultCellStyle.Format = "#,##0" : 明細_dgv.Columns(10).DefaultCellStyle.Format = "#,##0"
        明細_dgv.Columns(1).DefaultCellStyle.Alignment = DataGridViewContentAlignment.MiddleCenter : 明細_dgv.Columns(1).HeaderCell.Style.Alignment = DataGridViewContentAlignment.MiddleCenter
        明細_dgv.Columns(2).DefaultCellStyle.Alignment = DataGridViewContentAlignment.MiddleCenter : 明細_dgv.Columns(2).HeaderCell.Style.Alignment = DataGridViewContentAlignment.MiddleCenter
        明細_dgv.Columns(6).DefaultCellStyle.Alignment = DataGridViewContentAlignment.MiddleCenter : 明細_dgv.Columns(6).HeaderCell.Style.Alignment = DataGridViewContentAlignment.MiddleCenter
        明細_dgv.Columns(7).DefaultCellStyle.Alignment = DataGridViewContentAlignment.MiddleCenter : 明細_dgv.Columns(7).HeaderCell.Style.Alignment = DataGridViewContentAlignment.MiddleCenter
        明細_dgv.Columns(8).DefaultCellStyle.Alignment = DataGridViewContentAlignment.MiddleCenter : 明細_dgv.Columns(8).HeaderCell.Style.Alignment = DataGridViewContentAlignment.MiddleCenter
        明細_dgv.Columns(9).DefaultCellStyle.Alignment = DataGridViewContentAlignment.MiddleCenter : 明細_dgv.Columns(9).HeaderCell.Style.Alignment = DataGridViewContentAlignment.MiddleCenter
        明細_dgv.Columns(10).DefaultCellStyle.Alignment = DataGridViewContentAlignment.MiddleCenter : 明細_dgv.Columns(10).HeaderCell.Style.Alignment = DataGridViewContentAlignment.MiddleCenter
        明細_dgv.Columns(12).DefaultCellStyle.Alignment = DataGridViewContentAlignment.MiddleCenter : 明細_dgv.Columns(12).HeaderCell.Style.Alignment = DataGridViewContentAlignment.MiddleCenter

        明細_dgv.Columns(0).Visible = False : 明細_dgv.Columns(1).FillWeight = 50 : 明細_dgv.Columns(2).FillWeight = 80 : 明細_dgv.Columns(3).FillWeight = 200
        明細_dgv.Columns(4).Visible = False : 明細_dgv.Columns(5).Visible = False : 明細_dgv.Columns(6).FillWeight = 50 : 明細_dgv.Columns(7).FillWeight = 50
        明細_dgv.Columns(8).FillWeight = 50 : 明細_dgv.Columns(9).FillWeight = 50 : 明細_dgv.Columns(10).FillWeight = 65 : 明細_dgv.Columns(11).FillWeight = 100
        明細_dgv.Columns(12).FillWeight = 80 : 明細_dgv.Columns(13).Visible = False : 明細_dgv.Columns(14).Visible = False : 明細_dgv.Columns(15).Visible = False
        明細_dgv.Columns(16).Visible = False : 明細_dgv.Columns(17).FillWeight = 50

        明細_dgv.EditMode = DataGridViewEditMode.EditOnEnter
        明細_dgv.Columns(1).ReadOnly = True : 明細_dgv.Columns(2).ReadOnly = True : 明細_dgv.Columns(3).ReadOnly = True : 明細_dgv.Columns(4).ReadOnly = True
        明細_dgv.Columns(5).ReadOnly = True : 明細_dgv.Columns(8).ReadOnly = True : 明細_dgv.Columns(9).ReadOnly = True : 明細_dgv.Columns(10).ReadOnly = True
        明細_dgv.Columns(12).ReadOnly = True
    End Sub
    Private Sub ComboBox2下拉表單資料載入()
        SQL_供應商資料表下拉清單()
        供應商_cb.Items.Clear() : 供應商編號_cb.Items.Clear() : While (dr.Read()) : 供應商_cb.Items.Add(dr("簡稱")) : 供應商編號_cb.Items.Add(dr("編號")) : End While : conn.Close()
    End Sub
    Private Sub 採購退貨清單_Load(sender As Object, e As EventArgs) Handles MyBase.Load
        Me.MdiParent = MAOJI_ERP_SYS : Me.WindowState = 2 : Me.AutoScroll = True
        供應商_cb.Enabled = False : 供應商編號_cb.Enabled = False : 供應商_tb.Enabled = False : 公司電話2_tb.Enabled = False : 付款方式_tb.Enabled = False : 統編_tb.Enabled = False
        公司電話1_tb.Enabled = False : 傳真1_tb.Enabled = False : 單據編號_tb.Enabled = False : 地址1_tb.Enabled = False : 郵號1_tb.Enabled = False : 地址2_tb.Enabled = False
        郵號2_tb.Enabled = False : 選擇_tb.Enabled = False : 總金額_tb.Enabled = False : 採購下單_dtp.Enabled = False : 供應商交期_dtp.Enabled = False
    End Sub
    Private Sub 介面開啟_Shown(sender As Object, e As EventArgs) Handles MyBase.Shown
        計算分流.Enabled = True
    End Sub
    Private Sub 計算分流_Tick(sender As Object, e As EventArgs) Handles 計算分流.Tick
        Set_採購清單() : ComboBox2下拉表單資料載入()
        計算分流.Enabled = False
    End Sub
    Private Sub 介面關閉_Closed(sender As Object, e As EventArgs) Handles MyBase.Closed
        MyModule1.虛擬桌面開啟()
    End Sub
    Private Sub DataGridView2_CellClick(ByVal sender As System.Object, ByVal e As System.Windows.Forms.DataGridViewCellEventArgs) Handles 彙總_dgv.CellClick
        If e.RowIndex = -1 Then : Else
            單據編號_tb.Text = 彙總_dgv.Rows(e.RowIndex).Cells("單據編號").Value.ToString : 供應商編號_cb.Text = 彙總_dgv.Rows(e.RowIndex).Cells("供應商編號").Value.ToString
            採購下單_dtp.Value = 彙總_dgv.Rows(e.RowIndex).Cells("採購下單").Value.ToString : 供應商交期_dtp.Value = 彙總_dgv.Rows(e.RowIndex).Cells("交期").Value.ToString
            Set_單據明細()
        End If
    End Sub
    Private Sub DataGridView3_CellClick(ByVal sender As System.Object, ByVal e As System.Windows.Forms.DataGridViewCellEventArgs) Handles 明細_dgv.CellClick
        If e.RowIndex = -1 Then : Else
            選擇_tb.Text = 明細_dgv.Rows(e.RowIndex).Cells("資料流水號").Value.ToString
            For i As Integer = 0 To 明細_dgv.Rows.Count - 1 : 明細_dgv.Rows(i).Cells("選擇").Value = False : Next
            明細_dgv.Rows(e.RowIndex).Cells("選擇").Value = True
        End If
    End Sub
    Private Sub DataGridView3_CellEnter(sender As Object, e As DataGridViewCellEventArgs) Handles 明細_dgv.CellEnter
        總金額_tb.Text = "0"
        For i As Integer = 0 To 明細_dgv.Rows.Count - 1
            明細_dgv.Rows(i).Cells("台幣單價").Value = 明細_dgv.Rows(i).Cells("單價").Value * 明細_dgv.Rows(i).Cells("匯率").Value
            明細_dgv.Rows(i).Cells("進貨成本_台幣").Value = 明細_dgv.Rows(i).Cells("單價").Value * 明細_dgv.Rows(i).Cells("匯率").Value * 明細_dgv.Rows(i).Cells("數量").Value
            明細_dgv(1, i).Value = i + 1
            總金額_tb.Text = Val(總金額_tb.Text) + 明細_dgv.Rows(i).Cells("進貨成本_台幣").Value
        Next i
        總金額_tb.Text = Strings.Format(Val(總金額_tb.Text), "#,#00")
    End Sub
    Private Sub 供應商資料()
        SQL_採購退貨清單_供應商資料表讀取()
        If (dr.Read()) Then
            供應商_tb.Text = dr("名稱") : 公司電話1_tb.Text = dr("公司電話1") : 公司電話2_tb.Text = dr("公司電話2") : 傳真1_tb.Text = dr("傳真1") : 郵號1_tb.Text = dr("郵遞區號1")
            地址1_tb.Text = dr("地址1") : 郵號2_tb.Text = dr("郵遞區號2") : 地址2_tb.Text = dr("地址2") : 統編_tb.Text = dr("統一編號") : 付款方式_tb.Text = dr("付款方式")
        End If : conn.Close()
    End Sub
    Private Sub ComboBox2_SelectedIndexChanged(sender As Object, e As EventArgs) Handles 供應商_cb.SelectedIndexChanged
        供應商編號_cb.SelectedIndex = 供應商_cb.SelectedIndex : 供應商資料()
    End Sub
    Private Sub ComboBox3_SelectedIndexChanged(sender As Object, e As EventArgs) Handles 供應商編號_cb.SelectedIndexChanged
        供應商_cb.SelectedIndex = 供應商編號_cb.SelectedIndex : 供應商資料()
    End Sub
    Private Sub Button3_Click(sender As Object, e As EventArgs) Handles 列印退貨單_bt.Click
        xlApp = CType(CreateObject("Excel.Application"), Application)
        xlBook = xlApp.Workbooks.Add
        xlApp.DisplayAlerts = True
        xlBook.Activate()
        xlSheet = NewMethod(xlBook)
        xlSheet.Activate()
        xlApp.Visible = True
        xlApp.Application.WindowState = xlMaximized

        xlSheet.Cells(1, 1) = MAOJI_ERP_SYS.公司名稱_cb.Text : xlSheet.Cells(2, 1) = 公司地址 : xlSheet.Cells(3, 1) = "採購訂單-退貨單" : xlSheet.Cells(4, 1) = "採購編號 : "
        xlSheet.Cells(4, 3) = 單據編號_tb.Text
        xlSheet.Cells(5, 1) = "採購日期:" : xlSheet.Cells(5, 3) = 採購下單_dtp.Value : xlSheet.Cells(5, 6) = "付款方式:" : xlSheet.Cells(5, 7) = 付款方式_tb.Text : xlSheet.Cells(5, 9) = "需求交期:"
        xlSheet.Cells(5, 10) = 供應商交期_dtp.Value : xlSheet.Cells(4, 9) = "統一編號:" : xlSheet.Cells(4, 10) = 公司統編 : xlSheet.Cells(7, 1) = "TO:" : xlSheet.Cells(8, 1) = "郵號1:"
        xlSheet.Cells(9, 1) = "郵號1:" : xlSheet.Cells(7, 2) = 供應商_tb.Text : xlSheet.Cells(8, 2) = 郵號1_tb.Text : xlSheet.Cells(9, 2) = 郵號2_tb.Text : xlSheet.Cells(8, 3) = "地址1:"
        xlSheet.Cells(9, 3) = "地址2:" : xlSheet.Cells(8, 4) = 地址1_tb.Text : xlSheet.Cells(9, 4) = 地址2_tb.Text : xlSheet.Cells(7, 9) = "公司電話1:" : xlSheet.Cells(8, 9) = "公司電話2:"
        xlSheet.Cells(9, 9) = "傳真:" : xlSheet.Cells(7, 10) = 公司電話1_tb.Text : xlSheet.Cells(8, 10) = 公司電話2_tb.Text : xlSheet.Cells(9, 10) = 傳真1_tb.Text : xlSheet.Cells(11, 1) = "項次"
        xlSheet.Cells(11, 2) = "料號" : xlSheet.Cells(11, 4) = "品名" : xlSheet.Cells(11, 6) = "數量" : xlSheet.Cells(11, 7) = "單價" : xlSheet.Cells(11, 8) = "匯率" : xlSheet.Cells(11, 9) = "採購金額"
        xlSheet.Cells(11, 10) = "備註"
        For i As Integer = 0 To 明細_dgv.Rows.Count - 1
            xlSheet.Cells(i + 12, 1) = 明細_dgv.Rows(i).Cells("項次").Value
            xlSheet.Cells(i + 12, 2) = 明細_dgv.Rows(i).Cells("料號").Value
            xlSheet.Cells(i + 12, 4) = 明細_dgv.Rows(i).Cells("品名").Value
            xlSheet.Cells(i + 12, 6) = 明細_dgv.Rows(i).Cells("數量").Value
            xlSheet.Cells(i + 12, 7) = 明細_dgv.Rows(i).Cells("單價").Value
            xlSheet.Cells(i + 12, 8) = 明細_dgv.Rows(i).Cells("匯率").Value
            xlSheet.Cells(i + 12, 9) = "=F" & i + 12 & "*G" & i + 12 & "*H" & i + 12
            xlSheet.Cells(i + 12, 10) = 明細_dgv.Rows(i).Cells("備註").Value
            N1 = i + 12
        Next
        xlSheet.Cells(N1 + 1, 5) = "TOTAL : " : xlSheet.Cells(N1 + 1, 6) = "=SUM(F12:F" & N1 & ")" : xlSheet.Cells(N1 + 1, 9) = "=SUM(I12:I" & N1 & ")" : xlSheet.Cells(N1 + 2, 1) = "核准 : "
        xlSheet.Cells(N1 + 2, 9) = "製表人 : " : xlSheet.Cells(N1 + 2, 10) = gUserName
        AA(xlApp, xlSheet)

        xlSheet.PageSetup.PrintArea = ""
        xlApp.Cells.Select()
        xlSheet.Range("B1").Select()
        xlApp.Application.WindowState = xlMinimized
        xlSheet.Cells.Select()
        MsgBox("列印完成。")
    End Sub
    Private Shared Function NewMethod(xlBook As Workbook) As Worksheet
        Return CType(xlBook.Worksheets.Add, Worksheet)
    End Function
    Private Sub AA(ByVal myExcel As Application, ByVal xlSheet As Worksheet)
        xlSheet.Cells.Select()
        With myExcel.Selection.Font : .Name = "微軟正黑體" : .Size = 10 : .Strikethrough = False : .Superscript = False : .Subscript = False : .OutlineFont = False : .Shadow = False
            .Underline = xlUnderlineStyleNone : .ThemeColor = xlThemeColorLight1 : .TintAndShade = 0 : .ThemeFont = xlThemeFontNone : End With
        xlSheet.Columns("A:C").Select : myExcel.Selection.ColumnWidth = 6
        xlSheet.Columns("D:D").Select : myExcel.Selection.ColumnWidth = 10
        xlSheet.Columns("E:E").Select : myExcel.Selection.ColumnWidth = 20
        xlSheet.Columns("F:G").Select : myExcel.Selection.ColumnWidth = 10
        xlSheet.Columns("H:H").Select : myExcel.Selection.ColumnWidth = 8
        xlSheet.Columns("I:I").Select : myExcel.Selection.ColumnWidth = 12
        xlSheet.Columns("J:J").Select : myExcel.Selection.ColumnWidth = 30
        xlSheet.Rows("1:1").Select
        With myExcel.Selection.Font : .Name = "微軟正黑體" : .Size = 28 : .Strikethrough = False : .Superscript = False : .Subscript = False : .OutlineFont = False : .Shadow = False
            .Underline = xlUnderlineStyleNone : .ThemeColor = xlThemeColorLight1 : .TintAndShade = 0 : .ThemeFont = xlThemeFontNone : End With
        xlSheet.Rows("2:2").Select
        With myExcel.Selection.Font : .Name = "微軟正黑體" : .Size = 16 : .Strikethrough = False : .Superscript = False : .Subscript = False : .OutlineFont = False : .Shadow = False
            .Underline = xlUnderlineStyleNone : .ThemeColor = xlThemeColorLight1 : .TintAndShade = 0 : .ThemeFont = xlThemeFontNone : End With
        xlSheet.Rows("3:3").Select
        With myExcel.Selection.Font : .Name = "微軟正黑體" : .Size = 12 : .Strikethrough = False : .Superscript = False : .Subscript = False : .OutlineFont = False : .Shadow = False
            .Underline = xlUnderlineStyleNone : .ThemeColor = xlThemeColorLight1 : .TintAndShade = 0 : .ThemeFont = xlThemeFontNone : End With

        xlSheet.Range("A1:J1").Select()
        With myExcel.Selection : .HorizontalAlignment = xlCenter : .VerticalAlignment = xlCenter : .WrapText = False : .Orientation = 0 : .AddIndent = False : .IndentLevel = 0
            .ShrinkToFit = False : .ReadingOrder = xlContext : .MergeCells = False : End With : myExcel.Selection.Merge
        xlSheet.Range("A2:J2").Select()
        With myExcel.Selection : .HorizontalAlignment = xlCenter : .VerticalAlignment = xlCenter : .WrapText = False : .Orientation = 0 : .AddIndent = False : .IndentLevel = 0
            .ShrinkToFit = False : .ReadingOrder = xlContext : .MergeCells = False : End With : myExcel.Selection.Merge
        xlSheet.Range("A3:J3").Select()
        With myExcel.Selection : .HorizontalAlignment = xlCenter : .VerticalAlignment = xlCenter : .WrapText = False : .Orientation = 0 : .AddIndent = False : .IndentLevel = 0
            .ShrinkToFit = False : .ReadingOrder = xlContext : .MergeCells = False : End With : myExcel.Selection.Merge

        myExcel.Selection.Borders(xlDiagonalDown).LineStyle = xlNone : myExcel.Selection.Borders(xlDiagonalUp).LineStyle = xlNone
        myExcel.Selection.Borders(xlEdgeLeft).LineStyle = xlNone : myExcel.Selection.Borders(xlEdgeTop).LineStyle = xlNone
        With myExcel.Selection.Borders(xlEdgeBottom) : .LineStyle = xlContinuous : .ColorIndex = 0 : .TintAndShade = 0 : .Weight = xlThin : End With
        myExcel.Selection.Borders(xlEdgeRight).LineStyle = xlNone : myExcel.Selection.Borders(xlInsideVertical).LineStyle = xlNone : myExcel.Selection.Borders(xlInsideHorizontal).LineStyle = xlNone

        xlSheet.Range("A4:B4").Select()
        With myExcel.Selection : .HorizontalAlignment = xlCenter : .VerticalAlignment = xlCenter : .WrapText = False : .Orientation = 0 : .AddIndent = False : .IndentLevel = 0
            .ShrinkToFit = False : .ReadingOrder = xlContext : .MergeCells = False : End With : myExcel.Selection.Merge
        With myExcel.Selection : .HorizontalAlignment = xlLeft : .VerticalAlignment = xlCenter : .WrapText = False : .Orientation = 0 : .AddIndent = False : .IndentLevel = 0
            .ShrinkToFit = False : .ReadingOrder = xlContext : .MergeCells = True : End With

        xlSheet.Range("A5:B5").Select()
        With myExcel.Selection : .HorizontalAlignment = xlCenter : .VerticalAlignment = xlCenter : .WrapText = False : .Orientation = 0 : .AddIndent = False : .IndentLevel = 0
            .ShrinkToFit = False : .ReadingOrder = xlContext : .MergeCells = False : End With : myExcel.Selection.Merge
        With myExcel.Selection : .HorizontalAlignment = xlLeft : .VerticalAlignment = xlCenter : .WrapText = False : .Orientation = 0 : .AddIndent = False : .IndentLevel = 0
            .ShrinkToFit = False : .ReadingOrder = xlContext : .MergeCells = True : End With

        xlSheet.Range("C4:D4").Select()
        With myExcel.Selection : .HorizontalAlignment = xlCenter : .VerticalAlignment = xlCenter : .WrapText = False : .Orientation = 0 : .AddIndent = False : .IndentLevel = 0
            .ShrinkToFit = False : .ReadingOrder = xlContext : .MergeCells = False : End With : myExcel.Selection.Merge
        With myExcel.Selection : .HorizontalAlignment = xlLeft : .VerticalAlignment = xlCenter : .WrapText = False : .Orientation = 0 : .AddIndent = False : .IndentLevel = 0
            .ShrinkToFit = False : .ReadingOrder = xlContext : .MergeCells = True : End With

        xlSheet.Range("C5:D5").Select()
        With myExcel.Selection : .HorizontalAlignment = xlCenter : .VerticalAlignment = xlCenter : .WrapText = False : .Orientation = 0 : .AddIndent = False : .IndentLevel = 0
            .ShrinkToFit = False : .ReadingOrder = xlContext : .MergeCells = False : End With : myExcel.Selection.Merge
        With myExcel.Selection : .HorizontalAlignment = xlLeft : .VerticalAlignment = xlCenter : .WrapText = False : .Orientation = 0 : .AddIndent = False : .IndentLevel = 0
            .ShrinkToFit = False : .ReadingOrder = xlContext : .MergeCells = True : End With

        xlSheet.Range("J4").Select()
        With myExcel.Selection : .HorizontalAlignment = xlLeft : .VerticalAlignment = xlCenter : .WrapText = False : .Orientation = 0 : .AddIndent = False : .IndentLevel = 0
            .ShrinkToFit = False : .ReadingOrder = xlContext : .MergeCells = False : End With

        xlSheet.Range("J5").Select()
        With myExcel.Selection : .HorizontalAlignment = xlLeft : .VerticalAlignment = xlCenter : .WrapText = False : .Orientation = 0 : .AddIndent = False : .IndentLevel = 0
            .ShrinkToFit = False : .ReadingOrder = xlContext : .MergeCells = False : End With

        xlSheet.Range("A7:A9").Select()
        With myExcel.Selection : .HorizontalAlignment = xlRight : .VerticalAlignment = xlCenter : .WrapText = False : .Orientation = 0 : .AddIndent = False : .IndentLevel = 0
            .ShrinkToFit = False : .ReadingOrder = xlContext : .MergeCells = False : End With

        xlSheet.Range("I4:I9").Select()
        With myExcel.Selection : .HorizontalAlignment = xlRight : .VerticalAlignment = xlCenter : .WrapText = False : .Orientation = 0 : .AddIndent = False : .IndentLevel = 0
            .ShrinkToFit = False : .ReadingOrder = xlContext : .MergeCells = False : End With

        xlSheet.Range("B8").Select()
        With myExcel.Selection : .HorizontalAlignment = xlCenter : .VerticalAlignment = xlCenter : .WrapText = False : .Orientation = 0 : .AddIndent = False : .IndentLevel = 0
            .ShrinkToFit = False : .ReadingOrder = xlContext : .MergeCells = False : End With

        xlSheet.Range("C8:C9").Select()
        With myExcel.Selection : .HorizontalAlignment = xlRight : .VerticalAlignment = xlCenter : .WrapText = False : .Orientation = 0 : .AddIndent = False : .IndentLevel = 0
            .ShrinkToFit = False : .ReadingOrder = xlContext : .MergeCells = False : End With

        xlSheet.Rows("4:9").Select : myExcel.Selection.RowHeight = 18
        xlSheet.Rows("6:6").Select : myExcel.Selection.RowHeight = 5
        xlSheet.Rows("10:10").Select : myExcel.Selection.RowHeight = 5
        xlSheet.Rows("11:11").Select : myExcel.Selection.RowHeight = 25
        xlSheet.Rows("12:" & N1 + 1).Select : myExcel.Selection.RowHeight = 18
        xlSheet.Rows(N1 + 2 & ":" & N1 + 2).Select : myExcel.Selection.RowHeight = 30

        xlSheet.Range("A4:B5").Select()
        With myExcel.Selection.Interior : .Pattern = xlSolid : .PatternColorIndex = xlAutomatic : .ThemeColor = xlThemeColorAccent1 : .TintAndShade = 0.799981688894314 : .PatternTintAndShade = 0 : End With

        xlSheet.Range("F5").Select()
        With myExcel.Selection : .HorizontalAlignment = xlRight : .VerticalAlignment = xlCenter : .WrapText = False : .Orientation = 0 : .AddIndent = False : .IndentLevel = 0
            .ShrinkToFit = False : .ReadingOrder = xlContext : .MergeCells = True : End With
        With myExcel.Selection.Interior : .Pattern = xlSolid : .PatternColorIndex = xlAutomatic : .ThemeColor = xlThemeColorAccent1 : .TintAndShade = 0.799981688894314 : .PatternTintAndShade = 0 : End With

        xlSheet.Range("I4:I5").Select()
        With myExcel.Selection.Interior : .Pattern = xlSolid : .PatternColorIndex = xlAutomatic : .ThemeColor = xlThemeColorAccent1 : .TintAndShade = 0.799981688894314 : .PatternTintAndShade = 0 : End With

        xlSheet.Range("A5:J5").Select()
        myExcel.Selection.Borders(xlDiagonalDown).LineStyle = xlNone : myExcel.Selection.Borders(xlDiagonalUp).LineStyle = xlNone
        myExcel.Selection.Borders(xlEdgeLeft).LineStyle = xlNone : myExcel.Selection.Borders(xlEdgeTop).LineStyle = xlNone
        With myExcel.Selection.Borders(xlEdgeBottom) : .LineStyle = xlContinuous : .ColorIndex = 0 : .TintAndShade = 0 : .Weight = xlMedium : End With
        myExcel.Selection.Borders(xlEdgeRight).LineStyle = xlNone : myExcel.Selection.Borders(xlInsideVertical).LineStyle = xlNone : myExcel.Selection.Borders(xlInsideHorizontal).LineStyle = xlNone

        xlSheet.Range("A7:A9").Select()
        With myExcel.Selection.Interior : .Pattern = xlSolid : .PatternColorIndex = xlAutomatic : .ThemeColor = xlThemeColorAccent1 : .TintAndShade = 0.799981688894314 : .PatternTintAndShade = 0 : End With

        xlSheet.Range("C8:C9").Select()
        With myExcel.Selection.Interior : .Pattern = xlSolid : .PatternColorIndex = xlAutomatic : .ThemeColor = xlThemeColorAccent1 : .TintAndShade = 0.799981688894314 : .PatternTintAndShade = 0 : End With

        xlSheet.Range("I7:I9").Select()
        With myExcel.Selection.Interior : .Pattern = xlSolid : .PatternColorIndex = xlAutomatic : .ThemeColor = xlThemeColorAccent1 : .TintAndShade = 0.799981688894314 : .PatternTintAndShade = 0 : End With

        xlSheet.Range("A9:J9").Select()
        myExcel.Selection.Borders(xlDiagonalDown).LineStyle = xlNone : myExcel.Selection.Borders(xlDiagonalUp).LineStyle = xlNone
        myExcel.Selection.Borders(xlEdgeLeft).LineStyle = xlNone : myExcel.Selection.Borders(xlEdgeTop).LineStyle = xlNone
        With myExcel.Selection.Borders(xlEdgeBottom) : .LineStyle = xlContinuous : .ColorIndex = 0 : .TintAndShade = 0 : .Weight = xlMedium : End With
        myExcel.Selection.Borders(xlEdgeRight).LineStyle = xlNone : myExcel.Selection.Borders(xlInsideVertical).LineStyle = xlNone : myExcel.Selection.Borders(xlInsideHorizontal).LineStyle = xlNone

        xlSheet.Range("A11:J" & N1).Select()
        myExcel.Selection.Borders(xlDiagonalDown).LineStyle = xlNone : myExcel.Selection.Borders(xlDiagonalUp).LineStyle = xlNone
        With myExcel.Selection.Borders(xlEdgeLeft) : .LineStyle = xlContinuous : .ColorIndex = 0 : .TintAndShade = 0 : .Weight = xlThin : End With
        With myExcel.Selection.Borders(xlEdgeTop) : .LineStyle = xlContinuous : .ColorIndex = 0 : .TintAndShade = 0 : .Weight = xlThin : End With
        With myExcel.Selection.Borders(xlEdgeBottom) : .LineStyle = xlContinuous : .ColorIndex = 0 : .TintAndShade = 0 : .Weight = xlThin : End With
        With myExcel.Selection.Borders(xlEdgeRight) : .LineStyle = xlContinuous : .ColorIndex = 0 : .TintAndShade = 0 : .Weight = xlThin : End With
        With myExcel.Selection.Borders(xlInsideVertical) : .LineStyle = xlContinuous : .ColorIndex = 0 : .TintAndShade = 0 : .Weight = xlThin : End With
        With myExcel.Selection.Borders(xlInsideHorizontal) : .LineStyle = xlContinuous : .ColorIndex = 0 : .TintAndShade = 0 : .Weight = xlThin : End With

        xlSheet.Range("A" & N1 + 1 & ":J" & N1 + 1).Select()
        myExcel.Selection.Borders(xlDiagonalDown).LineStyle = xlNone : myExcel.Selection.Borders(xlDiagonalUp).LineStyle = xlNone
        With myExcel.Selection.Borders(xlEdgeLeft) : .LineStyle = xlContinuous : .ColorIndex = 0 : .TintAndShade = 0 : .Weight = xlThin : End With
        With myExcel.Selection.Borders(xlEdgeTop) : .LineStyle = xlContinuous : .ColorIndex = 0 : .TintAndShade = 0 : .Weight = xlThin : End With
        With myExcel.Selection.Borders(xlEdgeBottom) : .LineStyle = xlContinuous : .ColorIndex = 0 : .TintAndShade = 0 : .Weight = xlThin : End With
        With myExcel.Selection.Borders(xlEdgeRight) : .LineStyle = xlContinuous : .ColorIndex = 0 : .TintAndShade = 0 : .Weight = xlThin : End With
        myExcel.Selection.Borders(xlInsideVertical).LineStyle = xlNone : myExcel.Selection.Borders(xlInsideHorizontal).LineStyle = xlNone

        xlSheet.Range("A11:A" & N1).Select()
        With myExcel.Selection : .HorizontalAlignment = xlRight : .VerticalAlignment = xlCenter : .WrapText = False : .Orientation = 0 : .AddIndent = False : .IndentLevel = 0
            .ShrinkToFit = False : .ReadingOrder = xlContext : .MergeCells = False : End With

        For i As Integer = 11 To N1
            xlSheet.Range("B" & i & ":C" & i).Select()
            With myExcel.Selection : .HorizontalAlignment = xlCenter : .VerticalAlignment = xlCenter : .WrapText = False : .Orientation = 0 : .AddIndent = False
                .IndentLevel = 0 : .ShrinkToFit = False : .ReadingOrder = xlContext : .MergeCells = False : End With : myExcel.Selection.Merge

            xlSheet.Range("D" & i & ":E" & i).Select()
            With myExcel.Selection : .HorizontalAlignment = xlLeft : .VerticalAlignment = xlCenter : .WrapText = False : .Orientation = 0 : .AddIndent = False
                .IndentLevel = 0 : .ShrinkToFit = False : .ReadingOrder = xlContext : .MergeCells = False : End With : myExcel.Selection.Merge
        Next

        xlSheet.Range("F11:F" & N1 + 1).Select() : myExcel.Selection.Style = "Comma" : myExcel.Selection.NumberFormatLocal = "_-* #,##0_-;-* #,##0_-;_-* ""-""??_-;_-@_-"

        xlSheet.Range("F11").Select()
        With myExcel.Selection : .HorizontalAlignment = xlRight : .VerticalAlignment = xlCenter : .WrapText = False : .Orientation = 0 : .AddIndent = False : .IndentLevel = 0
            .ShrinkToFit = False : .ReadingOrder = xlContext : .MergeCells = False : End With

        xlSheet.Range("G11:G" & N1).Select() : myExcel.Selection.Style = "Comma" : myExcel.Selection.NumberFormatLocal = "_-* #,##0.0_-;-* #,##0.0_-;_-* ""-""??_-;_-@_-"

        xlSheet.Range("G11").Select()
        With myExcel.Selection : .HorizontalAlignment = xlRight : .VerticalAlignment = xlCenter : .WrapText = False : .Orientation = 0 : .AddIndent = False : .IndentLevel = 0
            .ShrinkToFit = False : .ReadingOrder = xlContext : .MergeCells = False : End With

        xlSheet.Range("H11:H" & N1).Select() : myExcel.Selection.Style = "Comma" : myExcel.Selection.NumberFormatLocal = "_-* #,##0.000_-;-* #,##0.000_-;_-* ""-""??_-;_-@_-"

        xlSheet.Range("H11").Select()
        With myExcel.Selection : .HorizontalAlignment = xlRight : .VerticalAlignment = xlCenter : .WrapText = False : .Orientation = 0 : .AddIndent = False : .IndentLevel = 0
            .ShrinkToFit = False : .ReadingOrder = xlContext : .MergeCells = False : End With

        xlSheet.Range("I11:I" & N1 + 1).Select() : myExcel.Selection.Style = "Comma" : myExcel.Selection.NumberFormatLocal = "_-* #,##0_-;-* #,##0_-;_-* ""-""??_-;_-@_-"

        xlSheet.Range("I11").Select()
        With myExcel.Selection : .HorizontalAlignment = xlRight : .VerticalAlignment = xlCenter : .WrapText = False : .Orientation = 0 : .AddIndent = False : .IndentLevel = 0
            .ShrinkToFit = False : .ReadingOrder = xlContext : .MergeCells = False : End With

        xlSheet.Range("E" & N1 + 1).Select()
        With myExcel.Selection : .HorizontalAlignment = xlRight : .VerticalAlignment = xlCenter : .WrapText = False : .Orientation = 0 : .AddIndent = False : .IndentLevel = 0
            .ShrinkToFit = False : .ReadingOrder = xlContext : .MergeCells = False : End With

        xlSheet.Range("A" & N1 + 2).Select()
        With myExcel.Selection : .HorizontalAlignment = xlRight : .VerticalAlignment = xlCenter : .WrapText = False : .Orientation = 0 : .AddIndent = False : .IndentLevel = 0
            .ShrinkToFit = False : .ReadingOrder = xlContext : .MergeCells = False : End With

        xlSheet.Range("I" & N1 + 2).Select()
        With myExcel.Selection : .HorizontalAlignment = xlRight : .VerticalAlignment = xlCenter : .WrapText = False : .Orientation = 0 : .AddIndent = False : .IndentLevel = 0
            .ShrinkToFit = False : .ReadingOrder = xlContext : .MergeCells = False : End With

        myExcel.ActiveWindow.DisplayGridlines = False
    End Sub
    Private Sub Button1_Click(sender As Object, e As EventArgs) Handles 列印產品標籤_bt.Click
        If 單據編號_tb.Text = "" Then : MsgBox("沒有選擇要列印的單號 。") : Else : 列印用SQL = 單據編號_tb.Text : PA = "採購退貨單" : 列印_產品標籤介面.ShowDialog() : End If
    End Sub

    Private Sub 重新整理ToolStripMenuItem_Click(sender As Object, e As EventArgs)
        Set_採購清單() : ComboBox2下拉表單資料載入()
    End Sub
    Private Sub 刪除採購單中選中的物料_bt_MouseEnter(sender As Object, e As EventArgs) Handles 單號查詢_bt.MouseEnter
        ToolTip1.SetToolTip(Me.單號查詢_bt, "單號查詢")
    End Sub
    Private Sub 列印產品標籤_bt_MouseEnter(sender As Object, e As EventArgs) Handles 列印產品標籤_bt.MouseEnter
        ToolTip1.SetToolTip(Me.列印產品標籤_bt, "列印產品標籤")
    End Sub
    Private Sub 列印出貨單_bt_MouseEnter(sender As Object, e As EventArgs) Handles 列印退貨單_bt.MouseEnter
        ToolTip1.SetToolTip(Me.列印退貨單_bt, "列印退貨單")
    End Sub
End Class