﻿Option Strict Off
Imports System.IO
Imports System.Net
Imports Microsoft.Office.Interop.Excel.XlUnderlineStyle
Imports Microsoft.Office.Interop.Excel.Constants
Imports Microsoft.Office.Interop.Excel.XlBordersIndex
Imports Microsoft.Office.Interop.Excel.XlLineStyle
Imports Microsoft.Office.Interop.Excel.XlBorderWeight
Imports Microsoft.Office.Interop.Excel.XlThemeFont
Imports Microsoft.Office.Interop.Excel.XlThemeColor
Imports Microsoft.Office.Interop.Excel.XlWindowState
Public Class 物料資料庫
    ReadOnly ds As New DataSet : ReadOnly ds1 As New DataSet : ReadOnly ds2 As New DataSet : ReadOnly ds3 As New DataSet : ReadOnly ds4 As New DataSet : ReadOnly ds5 As New DataSet
    Dim EDR, N As Integer : Dim ESTR, file_name As String
    Dim xlApp As Microsoft.Office.Interop.Excel.Application
    Dim xlBook As Microsoft.Office.Interop.Excel.Workbook
    Dim xlSheet As Microsoft.Office.Interop.Excel.Worksheet
    Private Sub Set_DGV1開始()
        物料清單_dgv.DataSource = Nothing : ds.Clear()
        物料清單_dgv.ColumnHeadersHeightSizeMode = DataGridViewColumnHeadersHeightSizeMode.EnableResizing
        物料清單_dgv.ColumnHeadersHeight = 40 : 物料清單_dgv.AllowUserToAddRows = False
        物料清單_dgv.ClipboardCopyMode = DataGridViewClipboardCopyMode.EnableWithoutHeaderText : 物料清單_dgv.MultiSelect = True

        物料清單1_dgv.DataSource = Nothing : ds3.Clear()
        物料清單1_dgv.ColumnHeadersHeightSizeMode = DataGridViewColumnHeadersHeightSizeMode.EnableResizing
        物料清單1_dgv.ColumnHeadersHeight = 40 : 物料清單1_dgv.AllowUserToAddRows = False
        物料清單1_dgv.ClipboardCopyMode = DataGridViewClipboardCopyMode.EnableWithoutHeaderText : 物料清單1_dgv.MultiSelect = True
    End Sub
    Private Sub Set_物料清單()
        If 全部_ch.Checked = True And 啟用_ch.Checked = False And 停用_ch.Checked = False Then : SQL2 = ""
        ElseIf 全部_ch.Checked = False And 啟用_ch.Checked = True And 停用_ch.Checked = False Then : SQL2 = " AND 停用 <> '1'"
        ElseIf 全部_ch.Checked = False And 啟用_ch.Checked = False And 停用_ch.Checked = True Then : SQL2 = " AND 停用 = N'1'" : End If
        NU1 = True : NU2 = False : Set_DGV1開始() : SQL__物料資料庫清單() : Set_DGV1結束() : SQL2 = ""
    End Sub
    Private Sub Set_DGV1結束()
        da.Fill(ds) : 物料清單_dgv.DataSource = ds.Tables(0) : conn.Close()
        da.Fill(ds3) : 物料清單1_dgv.DataSource = ds3.Tables(0) : conn.Close()

        物料清單_dgv.Columns(0).FillWeight = 8 : 物料清單_dgv.Columns(1).FillWeight = 6 : 物料清單_dgv.Columns(2).FillWeight = 20 : 物料清單_dgv.Columns(3).FillWeight = 5
        物料清單_dgv.Columns(4).FillWeight = 5 : 物料清單_dgv.Columns(5).FillWeight = 5 : 物料清單_dgv.Columns(6).FillWeight = 10 : 物料清單_dgv.Columns(7).FillWeight = 10
        物料清單_dgv.Columns(8).Visible = False : 物料清單_dgv.Columns(9).FillWeight = 10 : 物料清單_dgv.Columns(10).FillWeight = 5 : 物料清單_dgv.Columns(11).FillWeight = 3
        物料清單_dgv.Columns(12).FillWeight = 3
        物料清單_dgv.EditMode = DataGridViewEditMode.EditOnEnter
        物料清單_dgv.Columns(3).DefaultCellStyle.Format = "#,##0" : 物料清單_dgv.Columns(4).DefaultCellStyle.Format = "#,##0" : 物料清單_dgv.Columns(5).DefaultCellStyle.Format = "#,##0"
        物料清單_dgv.Columns(10).DefaultCellStyle.Format = "#,##0"
        物料清單_dgv.Columns(3).DefaultCellStyle.Alignment = DataGridViewContentAlignment.MiddleCenter : 物料清單_dgv.Columns(5).DefaultCellStyle.Alignment = DataGridViewContentAlignment.MiddleCenter
        物料清單_dgv.Columns(3).HeaderCell.Style.Alignment = DataGridViewContentAlignment.MiddleCenter : 物料清單_dgv.Columns(5).HeaderCell.Style.Alignment = DataGridViewContentAlignment.MiddleCenter
        物料清單_dgv.Columns(4).HeaderCell.Style.Alignment = DataGridViewContentAlignment.MiddleCenter : 物料清單_dgv.Columns(4).DefaultCellStyle.Alignment = DataGridViewContentAlignment.MiddleCenter
        物料清單_dgv.Columns(10).HeaderCell.Style.Alignment = DataGridViewContentAlignment.MiddleCenter : 物料清單_dgv.Columns(10).DefaultCellStyle.Alignment = DataGridViewContentAlignment.MiddleCenter
        物料清單_dgv.Columns(1).ReadOnly = True : 物料清單_dgv.Columns(2).ReadOnly = True : 物料清單_dgv.Columns(3).ReadOnly = True : 物料清單_dgv.Columns(4).ReadOnly = True
        物料清單_dgv.Columns(5).ReadOnly = True : 物料清單_dgv.Columns(6).ReadOnly = True : 物料清單_dgv.Columns(7).ReadOnly = True : 物料清單_dgv.Columns(8).ReadOnly = True
        物料清單_dgv.Columns(9).ReadOnly = True : 物料清單_dgv.Columns(11).ReadOnly = True : 物料清單_dgv.Columns(0).ReadOnly = True : 物料清單_dgv.Columns(12).ReadOnly = True
        For i As Integer = 0 To 物料清單_dgv.Rows.Count - 1
            If 物料清單_dgv.Rows(i).Cells("最低庫存量").Value.ToString = "" Then : 物料清單_dgv.Rows(i).Cells("最低庫存量").Value = 0 : End If
            If 物料清單1_dgv.Rows(i).Cells("最低庫存量").Value.ToString = "" Then : 物料清單1_dgv.Rows(i).Cells("最低庫存量").Value = 0 : End If
            物料清單_dgv("選擇", i).Value = False
        Next
    End Sub
    Private Sub Set_未配置圖片的物料清單()
        無圖料號_dgv.DataSource = Nothing : ds1.Clear()
        無圖料號_dgv.ColumnHeadersHeightSizeMode = DataGridViewColumnHeadersHeightSizeMode.EnableResizing
        無圖料號_dgv.ColumnHeadersHeight = 25 : 無圖料號_dgv.AllowUserToAddRows = False
        無圖料號_dgv.ClipboardCopyMode = DataGridViewClipboardCopyMode.EnableWithoutHeaderText : 無圖料號_dgv.MultiSelect = True
        SQL_未配置圖片的物料清單()
        da.Fill(ds1) : 無圖料號_dgv.DataSource = ds1.Tables(0) : conn.Close()
        無圖料號_dgv.Columns(0).FillWeight = 10 : 無圖料號_dgv.Columns(0).ReadOnly = True
    End Sub
    Private Sub Set_廠商有賣的物料清單()
        廠商有賣_dgv.DataSource = Nothing : ds4.Clear()
        廠商有賣_dgv.ColumnHeadersHeightSizeMode = DataGridViewColumnHeadersHeightSizeMode.EnableResizing
        廠商有賣_dgv.ColumnHeadersHeight = 40 : 廠商有賣_dgv.AllowUserToAddRows = False
        廠商有賣_dgv.ClipboardCopyMode = DataGridViewClipboardCopyMode.EnableWithoutHeaderText : 廠商有賣_dgv.MultiSelect = True

        廠商有賣1_dgv.DataSource = Nothing : ds5.Clear()
        廠商有賣1_dgv.ColumnHeadersHeightSizeMode = DataGridViewColumnHeadersHeightSizeMode.EnableResizing
        廠商有賣1_dgv.ColumnHeadersHeight = 40 : 廠商有賣1_dgv.AllowUserToAddRows = False
        廠商有賣1_dgv.ClipboardCopyMode = DataGridViewClipboardCopyMode.EnableWithoutHeaderText : 廠商有賣_dgv.MultiSelect = True
        SQL_廠商的物料清單(供應商編號_cb.Text)
        da.Fill(ds4) : 廠商有賣_dgv.DataSource = ds4.Tables(0)
        da.Fill(ds5) : 廠商有賣1_dgv.DataSource = ds5.Tables(0)

        廠商有賣_dgv.EditMode = DataGridViewEditMode.EditOnEnter
        廠商有賣_dgv.Columns(0).FillWeight = 50 : 廠商有賣_dgv.Columns(2).FillWeight = 30 : 廠商有賣_dgv.Columns(3).FillWeight = 30 : 廠商有賣_dgv.Columns(4).FillWeight = 15
        廠商有賣_dgv.Columns(5).Visible = False
        廠商有賣_dgv.Columns(2).DefaultCellStyle.Format = "#,##0" : 廠商有賣_dgv.Columns(3).DefaultCellStyle.Format = "#,##0"
        廠商有賣_dgv.Columns(2).DefaultCellStyle.Alignment = DataGridViewContentAlignment.MiddleCenter
        廠商有賣_dgv.Columns(3).DefaultCellStyle.Alignment = DataGridViewContentAlignment.MiddleCenter
        廠商有賣_dgv.Columns(0).ReadOnly = True : 廠商有賣_dgv.Columns(1).ReadOnly = True : 廠商有賣_dgv.Columns(4).ReadOnly = True
        For i As Integer = 0 To 廠商有賣_dgv.Rows.Count - 1
            If IsDBNull(廠商有賣_dgv(2, i).Value) = True Then : 廠商有賣_dgv(2, i).Value = 0 : End If
            If IsDBNull(廠商有賣_dgv(3, i).Value) = True Then : 廠商有賣_dgv(3, i).Value = 0 : End If
            If IsDBNull(廠商有賣1_dgv(2, i).Value) = True Then : 廠商有賣1_dgv(2, i).Value = 0 : End If
            If IsDBNull(廠商有賣1_dgv(3, i).Value) = True Then : 廠商有賣1_dgv(3, i).Value = 0 : End If
            If IsDBNull(廠商有賣_dgv(4, i).Value) = True Then : 廠商有賣_dgv(4, i).Value = False : End If
        Next
    End Sub
    Private Sub 供應商資料()
        SQL_採購單申請_供應商資料表讀取() : If (dr.Read()) Then : 供應商_tb.Text = dr("名稱") : End If : conn.Close() : Set_廠商有賣的物料清單()
    End Sub
    Private Sub ComboBox1下拉表單資料載入()
        SQL_物料頁碼清單() : 頁碼_cb.Items.Clear() : 頁碼_cb.Items.Add("") : While (dr.Read()) : 頁碼_cb.Items.Add(dr("頁碼")) : End While : conn.Close()
    End Sub
    Private Sub ComboBox2下拉表單資料載入()
        SQL_供應商資料表下拉清單()
        供應商_cb.Items.Clear() : 供應商編號_cb.Items.Clear() : While (dr.Read()) : 供應商_cb.Items.Add(dr("簡稱")) : 供應商編號_cb.Items.Add(dr("編號")) : End While : conn.Close()
    End Sub
    Private Sub 供應商_cb_SelectedIndexChanged(sender As Object, e As EventArgs) Handles 供應商_cb.SelectedIndexChanged
        供應商編號_cb.SelectedIndex = 供應商_cb.SelectedIndex : 供應商資料()
    End Sub
    Private Sub 供應商編號_cb_SelectedIndexChanged(sender As Object, e As EventArgs) Handles 供應商編號_cb.SelectedIndexChanged
        供應商_cb.SelectedIndex = 供應商編號_cb.SelectedIndex : 供應商資料()
    End Sub
    Private Sub 圖片導入()
        物料圖_pb.Image = Nothing : PA = 圖片編碼_tb.Text : SQL_物料圖庫_圖片顯示()
        While dr.Read() = True
            Dim unused As Byte() = New Byte(-1) {}
            Dim bytes As Byte() = DirectCast(dr.Item("圖片"), Byte())
            Dim oStream As New MemoryStream(bytes)
            物料圖_pb.Image = Bitmap.FromStream(oStream)
        End While
        conn.Close() : 物料圖_pb.SizeMode = 4 : PA = ""
    End Sub
    Private Sub 關鍵字查詢_bt_MouseEnter(sender As Object, e As EventArgs) Handles 關鍵字查詢_bt.MouseEnter
        ToolTip1.SetToolTip(Me.關鍵字查詢_bt, "關鍵字查詢")
    End Sub
    Private Sub 新增物料資料_bt_MouseEnter(sender As Object, e As EventArgs) Handles 新增物料資料_bt.MouseEnter
        ToolTip1.SetToolTip(Me.新增物料資料_bt, "新增物料資料")
    End Sub
    Private Sub 單筆存檔_bt_MouseEnter(sender As Object, e As EventArgs) Handles 單筆存檔_bt.MouseEnter
        ToolTip1.SetToolTip(Me.單筆存檔_bt, "單筆存檔")
    End Sub
    Private Sub 批量存檔_bt_MouseEnter(sender As Object, e As EventArgs) Handles 批量存檔_bt.MouseEnter
        ToolTip1.SetToolTip(Me.批量存檔_bt, "批量存檔")
    End Sub
    Private Sub 導入EXCEL_bt_MouseEnter(sender As Object, e As EventArgs) Handles 導入EXCEL_bt.MouseEnter
        ToolTip1.SetToolTip(Me.導入EXCEL_bt, "導入EXCEL")
    End Sub
    Private Sub 導出EXCEL_bt_MouseEnter(sender As Object, e As EventArgs) Handles 導出EXCEL_bt.MouseEnter
        ToolTip1.SetToolTip(Me.導出EXCEL_bt, "導出EXCEL")
    End Sub
    Private Sub 刪除物料_bt_MouseEnter(sender As Object, e As EventArgs) Handles 刪除物料_bt.MouseEnter
        ToolTip1.SetToolTip(Me.刪除物料_bt, "刪除物料")
    End Sub
    Private Sub 廠商關鍵字_bt_MouseEnter(sender As Object, e As EventArgs) Handles 廠商關鍵字_bt.MouseEnter
        ToolTip1.SetToolTip(Me.廠商關鍵字_bt, "供應商關鍵字")
    End Sub
    Private Sub 資料加入_bt_MouseEnter(sender As Object, e As EventArgs) Handles 資料加入_bt.MouseEnter
        ToolTip1.SetToolTip(Me.資料加入_bt, "資料庫選擇的物料加入到指定供應商的表單中")
    End Sub
    Private Sub 資料退回_bt_MouseEnter(sender As Object, e As EventArgs) Handles 資料退回_bt.MouseEnter
        ToolTip1.SetToolTip(Me.資料退回_bt, "在供應商有販售的物料清單中把選宗的資料去除")
    End Sub
    Private Sub 存檔_bt_MouseEnter(sender As Object, e As EventArgs) Handles 存檔_bt.MouseEnter
        ToolTip1.SetToolTip(Me.存檔_bt, "存檔")
    End Sub
    Private Sub 物料資料庫_Load(sender As Object, e As EventArgs) Handles MyBase.Load
        MAOJI_ERP_SYS.WindowState = 2 : Me.MdiParent = MAOJI_ERP_SYS : Me.WindowState = 2 : Me.AutoScroll = True
        料號_tb.Enabled = False : 批量存檔_bt.Enabled = False : Panel1.SendToBack()
        圖片編碼_tb.Visible = False : 檔名讀取_tb.Visible = False : 下載檔名_tb.Visible = False
        If gUserName = "李協叡" Then : 資料刪除ToolStripMenuItem.Enabled = True : Else : 資料刪除ToolStripMenuItem.Enabled = False : End If
    End Sub
    Private Sub 介面開啟_Shown(sender As Object, e As EventArgs) Handles MyBase.Shown
        計算分流.Enabled = True
    End Sub
    Private Sub 計算分流_Tick(sender As Object, e As EventArgs) Handles 計算分流.Tick
        ComboBox1下拉表單資料載入() : Set_物料清單() : Set_未配置圖片的物料清單() : ComboBox2下拉表單資料載入() : Set_廠商有賣的物料清單()
        計算分流.Enabled = False
    End Sub
    Private Sub 介面關閉_Closed(sender As Object, e As EventArgs) Handles MyBase.Closed
        MyModule1.虛擬桌面開啟()
    End Sub
    Private Sub 物料清單_dgv_CellClick(ByVal sender As System.Object, ByVal e As System.Windows.Forms.DataGridViewCellEventArgs) Handles 物料清單_dgv.CellClick
        If e.RowIndex = -1 Then : Else
            料號_tb.Text = 物料清單_dgv.Rows(e.RowIndex).Cells("料號").Value.ToString : 頁碼_tb.Text = 物料清單_dgv.Rows(e.RowIndex).Cells("頁碼").Value.ToString
            品名_tb.Text = 物料清單_dgv.Rows(e.RowIndex).Cells("品名").Value.ToString : 成本_nud.Value = 物料清單_dgv.Rows(e.RowIndex).Cells("成本").Value.ToString
            售價_nud.Value = 物料清單_dgv.Rows(e.RowIndex).Cells("售價").Value.ToString : 件數_nud.Value = 物料清單_dgv.Rows(e.RowIndex).Cells("件數").Value.ToString
            尺寸_tb.Text = 物料清單_dgv.Rows(e.RowIndex).Cells("尺寸").Value.ToString : 材質_tb.Text = 物料清單_dgv.Rows(e.RowIndex).Cells("材質").Value.ToString
            圖片編碼_tb.Text = 物料清單_dgv.Rows(e.RowIndex).Cells("圖片編碼").Value.ToString : 備註_tb.Text = 物料清單_dgv.Rows(e.RowIndex).Cells("備註").Value.ToString
            停用料號_ch.Checked = 物料清單_dgv.Rows(e.RowIndex).Cells("停用").Value : 最低庫存量_nud.Value = 物料清單_dgv.Rows(e.RowIndex).Cells("最低庫存量").Value
            圖片導入()
            For i As Integer = 0 To 無圖料號_dgv.Rows.Count - 1
                If 物料清單_dgv.Rows(e.RowIndex).Cells("料號").Value.ToString = 無圖料號_dgv.Rows(i).Cells("料號").Value.ToString Then
                    圖片用料號_tb.Text = 物料清單_dgv.Rows(e.RowIndex).Cells("料號").Value.ToString : Exit For
                Else : 圖片用料號_tb.Text = "" : End If
            Next
        End If
    End Sub
    Private Sub 物料清單_dgv_MouseUp(ByVal sender As Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles 物料清單_dgv.MouseUp
        Dim 位置Y As Integer = 物料清單_dgv.SelectedCells(0).ColumnIndex : Dim 位置 As Integer = 物料清單_dgv.SelectedCells(0).RowIndex
        If 位置Y = 0 Or 位置Y = 12 Then
            If 物料清單_dgv.Rows(位置).Cells("選擇").Value = False Then : 物料清單_dgv.Rows(位置).Cells("選擇").Value = True
            Else : 物料清單_dgv.Rows(位置).Cells("選擇").Value = False : End If
        End If
    End Sub
    Private Sub 物料清單_dgv_RowPostPaint(ByVal sender As Object, ByVal e As DataGridViewRowPostPaintEventArgs) Handles 物料清單_dgv.RowPostPaint
        Dim linePen As New Pen(Color.Blue, 2)
        If e.RowIndex = 物料清單_dgv.Rows.Count - 1 Then : Exit Sub : Else
            If Strings.Left(物料清單_dgv("頁碼", e.RowIndex).Value.ToString, 4) <> Strings.Left(物料清單_dgv("頁碼", e.RowIndex + 1).Value.ToString, 4) Then
                Dim startX As Integer = IIf(物料清單_dgv.RowHeadersVisible, 物料清單_dgv.RowHeadersWidth, 0) : Dim startY As Integer = e.RowBounds.Top + e.RowBounds.Height - 1
                Dim endX As Integer = startX + 物料清單_dgv.Columns.GetColumnsWidth(DataGridViewElementStates.Visible) - 物料清單_dgv.HorizontalScrollingOffset
                e.Graphics.DrawLine(linePen, startX, startY, endX, startY) : Exit Sub
            End If
        End If
        For i As Integer = 0 To 物料清單_dgv.Rows.Count - 1
            If 物料清單_dgv("選擇", i).Value = True Then
                物料清單_dgv.Rows(i).DefaultCellStyle.BackColor = Color.LightGreen
            Else : 物料清單_dgv.Rows(i).DefaultCellStyle.BackColor = Color.White : End If
        Next
    End Sub
    Private Sub 廠商有賣_dgv_MouseUp(ByVal sender As Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles 廠商有賣_dgv.MouseUp
        Dim 位置Y As Integer = 廠商有賣_dgv.SelectedCells(0).ColumnIndex : Dim 位置 As Integer = 廠商有賣_dgv.SelectedCells(0).RowIndex
        If 位置Y = 0 Or 位置Y = 1 Or 位置Y = 4 Then
            If 廠商有賣_dgv.Rows(位置).Cells("選擇").Value = False Then : 廠商有賣_dgv.Rows(位置).Cells("選擇").Value = True
            Else : 廠商有賣_dgv.Rows(位置).Cells("選擇").Value = False : End If
        End If
    End Sub
    Private Sub 廠商有賣_dgv_RowPostPaint(ByVal sender As Object, ByVal e As DataGridViewRowPostPaintEventArgs) Handles 廠商有賣_dgv.RowPostPaint
        For i As Integer = 0 To 廠商有賣_dgv.Rows.Count - 1
            If 廠商有賣_dgv("選擇", i).Value = True Then
                廠商有賣_dgv.Rows(i).DefaultCellStyle.BackColor = Color.LightGreen
            Else : 廠商有賣_dgv.Rows(i).DefaultCellStyle.BackColor = Color.White : End If
        Next
    End Sub
    Private Sub 無圖料號_dgv_CellClick(ByVal sender As System.Object, ByVal e As System.Windows.Forms.DataGridViewCellEventArgs) Handles 無圖料號_dgv.CellClick
        If e.RowIndex = -1 Then : Else
            圖片用料號_tb.Text = 無圖料號_dgv.Rows(e.RowIndex).Cells("料號").Value.ToString
        End If
    End Sub
    Private Sub ComboBox1_SelectedIndexChanged(sender As Object, e As EventArgs) Handles 頁碼_cb.SelectedIndexChanged
        PA = 頁碼_cb.Text : NU1 = False : NU2 = True : Set_DGV1開始() : SQL__物料資料庫清單() : Set_DGV1結束() : PA = ""
    End Sub
    Private Sub 全部_ch_CheckedChanged(sender As Object, e As EventArgs) Handles 全部_ch.Click
        全部_ch.Checked = True : 啟用_ch.Checked = False : 停用_ch.Checked = False : Set_物料清單()
    End Sub
    Private Sub 啟用_ch_CheckedChanged(sender As Object, e As EventArgs) Handles 啟用_ch.Click
        全部_ch.Checked = False : 啟用_ch.Checked = True : 停用_ch.Checked = False : Set_物料清單()
    End Sub
    Private Sub 停用_ch_CheckedChanged(sender As Object, e As EventArgs) Handles 停用_ch.Click
        全部_ch.Checked = False : 啟用_ch.Checked = False : 停用_ch.Checked = True : Set_物料清單()
    End Sub
    Private Sub 資料加入_bt_Click(sender As Object, e As EventArgs) Handles 資料加入_bt.Click
        If 供應商編號_cb.Text = "" Then : MsgBox("請先選擇供應商!!") : Else
            For I As Integer = 0 To 物料清單_dgv.Rows.Count - 1
                If 物料清單_dgv("選擇", I).Value = True Then
                    SQL_物料是否有加指定過供應商判斷(供應商編號_cb.Text, 物料清單_dgv("料號", I).Value.ToString)
                    If dr.Read Then : Else
                        SQL_物料指定廠商新增(供應商編號_cb.Text, 物料清單_dgv("料號", I).Value.ToString, 物料清單_dgv("成本", I).Value.ToString, 物料清單_dgv("售價", I).Value.ToString)

                    End If
                End If
            Next : Set_廠商有賣的物料清單()
        End If
    End Sub
    Private Sub 資料退回_bt_Click(sender As Object, e As EventArgs) Handles 資料退回_bt.Click
        If 供應商編號_cb.Text = "" Then : MsgBox("請先選擇供應商!!") : Else
            For I As Integer = 0 To 廠商有賣_dgv.Rows.Count - 1
                If 廠商有賣_dgv("選擇", I).Value = True Then
                    SQL_物料指定廠商刪除(供應商編號_cb.Text, 廠商有賣_dgv("料號", I).Value.ToString)
                End If
            Next : Set_廠商有賣的物料清單()
        End If
    End Sub
    Private Sub 存檔_bt_Click(sender As Object, e As EventArgs) Handles 存檔_bt.Click
        If 供應商編號_cb.Text = "" Then : MsgBox("請先選擇供應商!!") : Else
            For I As Integer = 0 To 廠商有賣_dgv.Rows.Count - 1
                If 廠商有賣_dgv("成本", I).Value.ToString <> 廠商有賣1_dgv("成本", I).Value.ToString Or 廠商有賣_dgv("售價", I).Value.ToString <> 廠商有賣1_dgv("售價", I).Value.ToString Then
                    SQL_物料指定廠商修改(供應商編號_cb.Text, 廠商有賣_dgv("料號", I).Value.ToString, 廠商有賣_dgv("成本", I).Value.ToString, 廠商有賣_dgv("售價", I).Value.ToString)
                End If
            Next : MsgBox("存檔完成!!")
        End If
    End Sub
    Private Sub 關鍵字查詢_bt_Click(sender As Object, e As EventArgs) Handles 關鍵字查詢_bt.Click
        PA = InputBox("請輸入要查詢的關鍵字") : Set_物料清單()
    End Sub
    Private Sub 廠商關鍵字_bt_Click(sender As Object, e As EventArgs) Handles 廠商關鍵字_bt.Click
        PA = InputBox("請輸入廠商的關鍵字來做查詢") : SQL_供應商資料表關鍵字查詢()
        供應商_cb.Items.Clear() : 供應商編號_cb.Items.Clear()
        While (dr.Read()) : 供應商_cb.Items.Add(dr("簡稱")) : 供應商編號_cb.Items.Add(dr("編號")) : End While : conn.Close() : PA = ""
        If 供應商_cb.Items.Count > 2999 Then : MsgBox("清單數量超過3000個，清通知系統管理員修改程式!!") : Else
            For I As Integer = 0 To 3000 : PPBB(I) = "" : Next
            For I As Integer = 0 To 供應商_cb.Items.Count - 1 : PPBB(I) = 供應商_cb.Items(I).ToString : NN1 = I : Next
            下拉清單_1.ShowDialog() : 供應商_cb.Text = PPAA
        End If
        PA = ""
    End Sub
    Private Sub Button6_Click(sender As Object, e As EventArgs) Handles 新增物料資料_bt.Click
        物料清單_dgv.Enabled = False
        頁碼_tb.Text = "0" : 品名_tb.Text = "" : 尺寸_tb.Text = "" : 材質_tb.Text = "" : 圖片編碼_tb.Text = "" : 備註_tb.Text = ""
        成本_nud.Value = 0 : 售價_nud.Value = 0 : 件數_nud.Value = 0 : 停用料號_ch.Checked = False : ComboBox1下拉表單資料載入()
        '----------------------自动生成流水号-------------------------------------------------------------------------
        SQL_物料圖庫流水號最後一筆()
        If dr.Read() Then : EDR = Double.Parse(Strings.Right(dr("料號").ToString, 8)) : Else : EDR = 0 : End If : conn.Close() : EDR += 1
        If EDR < 10 Then : ESTR = "PR" & "0000000" & EDR
        ElseIf EDR > 9 And EDR < 100 Then : ESTR = "PR" & "000000" & EDR
        ElseIf EDR > 99 And EDR < 1000 Then : ESTR = "PR" & "00000" & EDR
        ElseIf EDR > 999 And EDR < 10000 Then : ESTR = "PR" & "0000" & EDR
        ElseIf EDR > 9999 And EDR < 100000 Then : ESTR = "PR" & "000" & EDR
        ElseIf EDR > 99999 And EDR < 100000 Then : ESTR = "PR" & "00" & EDR
        ElseIf EDR > 999999 And EDR < 1000000 Then : ESTR = "PR" & "0" & EDR
        ElseIf EDR > 9999999 Then : ESTR = "PR" & EDR : End If : 料號_tb.Text = ESTR
        MsgBox("請注意頁碼格式前三碼為數字後續再用符號-隔開，在頁碼前三碼大於999之後請通知系統開發商更新程4碼。")
    End Sub
    Private Sub 單筆存檔_bt_Click(sender As Object, e As EventArgs) Handles 單筆存檔_bt.Click
        If 物料清單_dgv.Enabled = False Then
            If 頁碼_tb.Text = "0" Then : MsgBox("沒有輸入頁碼，請注意頁碼格式前三碼為數字後續再用符號-隔開，在頁碼前三碼大於999之後請通知系統開發商更新程4碼。")
            Else
                SQL_物料資料庫新增() : conn.Close()
                MsgBox("資料新增完畢 。") : Set_物料清單() : Set_未配置圖片的物料清單() : PA = "" : 物料清單_dgv.Enabled = True
            End If
        Else
            PA1 = 頁碼_tb.Text : PA2 = 品名_tb.Text : NU1 = 成本_nud.Value : NU2 = 售價_nud.Value : NU3 = 件數_nud.Value : PA3 = 尺寸_tb.Text : PA4 = 材質_tb.Text
            PA5 = 圖片編碼_tb.Text : PA6 = 備註_tb.Text : 布林1 = 停用料號_ch.Checked : PA7 = 料號_tb.Text : NU4 = 最低庫存量_nud.Value
            SQL_物料資料庫修改() : conn.Close()
            MsgBox("資料存檔完畢 。") : Set_物料清單() : PA = "" : 物料清單_dgv.Enabled = True
        End If
    End Sub
    Private Sub 刪除物料_bt_Click(sender As Object, e As EventArgs) Handles 刪除物料_bt.Click
        Dim aa As MsgBoxResult
        aa = MsgBox("確定要刪除該筆資料?", MsgBoxStyle.OkCancel)
        If aa = MsgBoxResult.Ok Then
            PA = 料號_tb.Text
            SQL_物料圖庫_圖片刪除() : conn.Close() : SQL_物料資料庫刪除() : conn.Close()
            MsgBox("刪除完成") : Set_物料清單() : Set_未配置圖片的物料清單() : PA = ""
        End If
    End Sub
    Private Sub Button14_Click(sender As Object, e As EventArgs) Handles 讀取資料夾路徑_bt.Click
    End Sub
    Private Sub Button7_Click(sender As Object, e As EventArgs) Handles 下載圖檔_bt.Click
        If 圖片編碼_tb.Text = "" Then : MsgBox("所選擇的資料沒有圖片檔案，無法下載。")
        Else
            With SaveFileDialog1 : .Filter = "所有文件(*.jpg)|*.jpg" : End With
            SaveFileDialog1.FileName = 圖片編碼_tb.Text & "-" & Strings.Format(Today(), "yyyyMMdd") & ".jpg"

            SaveFileDialog1.ShowDialog() : 下載檔名_tb.Text = SaveFileDialog1.FileName
            ds2.Clear() : SQL_物料圖庫_圖片下載() : da.Fill(ds2) : conn.Close()
            If ds2.Tables(0).Rows.Count > 0 Then
                Dim imgData() As Byte
                imgData = ds2.Tables(0).Rows(0).Item("圖片")
                Dim fs As FileStream
                fs = File.Create(下載檔名_tb.Text, imgData.Length - 1)
                fs.Write(imgData, 0, imgData.Length - 1)
                fs.Close()
            End If : MsgBox("下載完成")
        End If
    End Sub
    Private Sub Button2_Click(sender As Object, e As EventArgs) Handles 刪除圖檔_bt.Click
        Dim aa As MsgBoxResult = MsgBox("確定要刪除該筆資料?", MsgBoxStyle.OkCancel)
        If aa = MsgBoxResult.Ok Then
            PA = 圖片編碼_tb.Text
            SQL_物料圖庫_圖片刪除() : conn.Close()
            SQL_物料圖庫_圖片刪除後圖片編號取消() : conn.Close()
            MsgBox("刪除完成") : Set_物料清單() : Set_未配置圖片的物料清單() : PA = ""
        End If
    End Sub
    Private Sub Button5_Click(sender As Object, e As EventArgs) Handles 圖檔入系統_bt.Click
        If FTP關閉 = False Then
            If 圖片用料號_tb.Text = "" Then : MsgBox("請先選擇未指定圖片的物料料號")
            Else
                SQL_物料圖庫_圖片新增時圖片編號註冊() : conn.Close() : SQL_物料圖庫_圖片新增() : conn.Close()
                '----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
                物料圖_pb.Image = Nothing : PA = 圖片用料號_tb.Text : SQL_物料圖庫_圖片顯示()
                While dr.Read() = True
                    Dim unused As Byte() = New Byte(-1) {}
                    Dim bytes As Byte() = DirectCast(dr.Item("圖片"), Byte())
                    Dim oStream As New MemoryStream(bytes)
                    物料圖_pb.Image = Bitmap.FromStream(oStream)
                End While
                conn.Close()
                物料圖_pb.SizeMode = 4
                '----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
                檔案名稱_tb.Text = "" : 圖片用料號_tb.Text = "" : PA = "" : Set_物料清單() : Set_未配置圖片的物料清單()
            End If
        Else
            MsgBox("在外網時FTP伺服器無法使用!!!")
        End If
    End Sub
    Private Sub Button1_Click(sender As Object, e As EventArgs) Handles 修改圖片_bt.Click
        If FTP關閉 = False Then
            If 圖片編碼_tb.Text = "" Then : MsgBox("請先選擇要修改圖片的物料料號")
            Else
                SQL_物料圖庫_圖片修改()
                '----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
                檔案名稱_tb.Text = "" : MsgBox("修改完成") : Set_物料清單() : 圖片導入()
            End If
        Else
            MsgBox("在外網時FTP伺服器無法使用!!!")
        End If
    End Sub
    Private Sub 格式1()
        批量修改_ch.Checked = False : 批量存檔_bt.Enabled = False
        物料清單_dgv.Columns(3).ReadOnly = True : 物料清單_dgv.Columns(4).ReadOnly = True : 物料清單_dgv.Columns(5).ReadOnly = True : 物料清單_dgv.Columns(6).ReadOnly = True
        物料清單_dgv.Columns(7).ReadOnly = True : 物料清單_dgv.Columns(9).ReadOnly = True : 物料清單_dgv.Columns(10).ReadOnly = True
    End Sub
    Private Sub CheckBox2_CheckedChanged(sender As Object, e As EventArgs) Handles 批量修改_ch.Click
        If 批量修改_ch.Checked = False Then
            格式1()
        Else
            批量修改_ch.Checked = True : 批量存檔_bt.Enabled = True
            物料清單_dgv.Columns(3).ReadOnly = False : 物料清單_dgv.Columns(4).ReadOnly = False : 物料清單_dgv.Columns(5).ReadOnly = False : 物料清單_dgv.Columns(6).ReadOnly = False
            物料清單_dgv.Columns(7).ReadOnly = False : 物料清單_dgv.Columns(9).ReadOnly = False : 物料清單_dgv.Columns(10).ReadOnly = False
            MsgBox("請注意成本，售價，件數，三格欄位內的資料必須是阿拉伯數字，不然存檔時會出錯喔。")
        End If
    End Sub
    Private Sub 存檔1()
        For i As Integer = 0 To 物料清單_dgv.Rows.Count - 1
            If 物料清單_dgv.Rows(i).Cells("頁碼").Value.ToString <> 物料清單1_dgv.Rows(i).Cells("頁碼").Value.ToString Or
               物料清單_dgv.Rows(i).Cells("品名").Value.ToString <> 物料清單1_dgv.Rows(i).Cells("品名").Value.ToString Or
          CDbl(物料清單_dgv.Rows(i).Cells("成本").Value.ToString) <> CDbl(物料清單1_dgv.Rows(i).Cells("成本").Value.ToString) Or
          CDbl(物料清單_dgv.Rows(i).Cells("售價").Value.ToString) <> CDbl(物料清單1_dgv.Rows(i).Cells("售價").Value.ToString) Or
               物料清單_dgv.Rows(i).Cells("件數").Value.ToString <> 物料清單1_dgv.Rows(i).Cells("件數").Value.ToString Or
               物料清單_dgv.Rows(i).Cells("尺寸").Value.ToString <> 物料清單1_dgv.Rows(i).Cells("尺寸").Value.ToString Or
               物料清單_dgv.Rows(i).Cells("材質").Value.ToString <> 物料清單1_dgv.Rows(i).Cells("材質").Value.ToString Or
               物料清單_dgv.Rows(i).Cells("圖片編碼").Value.ToString <> 物料清單1_dgv.Rows(i).Cells("圖片編碼").Value.ToString Or
               物料清單_dgv.Rows(i).Cells("備註").Value.ToString <> 物料清單1_dgv.Rows(i).Cells("備註").Value.ToString Or
               物料清單_dgv.Rows(i).Cells("停用").Value.ToString <> 物料清單1_dgv.Rows(i).Cells("停用").Value.ToString Or
               物料清單_dgv.Rows(i).Cells("料號").Value.ToString <> 物料清單1_dgv.Rows(i).Cells("料號").Value.ToString Or
               物料清單_dgv.Rows(i).Cells("最低庫存量").Value.ToString <> 物料清單1_dgv.Rows(i).Cells("最低庫存量").Value.ToString Then
                資料數 = 物料清單_dgv.Rows.Count : MyModule1.進度條()
                PA1 = 物料清單_dgv.Rows(i).Cells("頁碼").Value.ToString : PA2 = 物料清單_dgv.Rows(i).Cells("品名").Value.ToString
                NU1 = 物料清單_dgv.Rows(i).Cells("成本").Value : NU2 = 物料清單_dgv.Rows(i).Cells("售價").Value : NU3 = 物料清單_dgv.Rows(i).Cells("件數").Value
                PA3 = 物料清單_dgv.Rows(i).Cells("尺寸").Value.ToString : PA4 = 物料清單_dgv.Rows(i).Cells("材質").Value.ToString
                PA5 = 物料清單_dgv.Rows(i).Cells("圖片編碼").Value.ToString : PA6 = 物料清單_dgv.Rows(i).Cells("備註").Value.ToString
                布林1 = 物料清單_dgv.Rows(i).Cells("停用").Value : PA7 = 物料清單_dgv.Rows(i).Cells("料號").Value.ToString : NU4 = 物料清單_dgv.Rows(i).Cells("最低庫存量").Value
                SQL_物料資料庫修改() : conn.Close()
            End If
        Next : MAOJI_ERP_SYS.ToolStripProgressBar1.Value = 0 : 最終數 = 0
    End Sub
    Private Sub Button8_Click(sender As Object, e As EventArgs) Handles 批量存檔_bt.Click
        存檔1() : MsgBox("修改完成") : 格式1()
    End Sub

    Private Sub 導出EXCEL_bt_Click_1(sender As Object, e As EventArgs) Handles 導出EXCEL_bt.Click
        xlApp = CType(CreateObject("Excel.Application"), Microsoft.Office.Interop.Excel.Application)
        xlBook = xlApp.Workbooks.Add : xlApp.DisplayAlerts = True : xlBook.Activate() : xlSheet = NewMethod(xlBook)
        xlSheet.Activate() : xlApp.Visible = True : xlApp.Application.WindowState = xlMaximized

        xlSheet.Cells(1, 1) = "系統物料資料庫總表"
        xlSheet.Cells(2, 1) = "請注意，料號欄位為系統主要參考項目，請勿修改，如有新增品項的需求，清直接新增在EXCEL資料表最下方，從新導入時系統會自動新增品項到資料庫中。"
        xlSheet.Cells(3, 1) = "料號" : xlSheet.Cells(3, 2) = "頁碼" : xlSheet.Cells(3, 3) = "品名" : xlSheet.Cells(3, 4) = "成本" : xlSheet.Cells(3, 5) = "售價"
        xlSheet.Cells(3, 6) = "件數" : xlSheet.Cells(3, 7) = "尺寸" : xlSheet.Cells(3, 8) = "材質" : xlSheet.Cells(3, 9) = "備註" : xlSheet.Cells(3, 10) = "最低庫存量"
        xlSheet.Cells(3, 11) = "停用"
        For i As Integer = 0 To 物料清單_dgv.Rows.Count - 1
            xlSheet.Cells(i + 4, 1) = 物料清單_dgv.Rows(i).Cells("料號").Value : xlSheet.Cells(i + 4, 2) = 物料清單_dgv.Rows(i).Cells("頁碼").Value
            xlSheet.Cells(i + 4, 3) = 物料清單_dgv.Rows(i).Cells("品名").Value : xlSheet.Cells(i + 4, 4) = 物料清單_dgv.Rows(i).Cells("成本").Value
            xlSheet.Cells(i + 4, 5) = 物料清單_dgv.Rows(i).Cells("售價").Value : xlSheet.Cells(i + 4, 6) = 物料清單_dgv.Rows(i).Cells("件數").Value
            xlSheet.Cells(i + 4, 7) = 物料清單_dgv.Rows(i).Cells("尺寸").Value : xlSheet.Cells(i + 4, 8) = 物料清單_dgv.Rows(i).Cells("材質").Value
            xlSheet.Cells(i + 4, 9) = 物料清單_dgv.Rows(i).Cells("備註").Value : xlSheet.Cells(i + 4, 10) = 物料清單_dgv.Rows(i).Cells("最低庫存量").Value
            xlSheet.Cells(i + 4, 11) = 物料清單_dgv.Rows(i).Cells("停用").Value
            With xlApp.Selection : .Font.Bold = True : End With : N = i + 4
        Next i : BB(xlApp, xlSheet)
        xlSheet.PageSetup.PrintArea = "" : xlApp.Cells.Select() : xlSheet.Range("B1").Select() : xlApp.Application.WindowState = xlMinimized : MsgBox("列印完成")
    End Sub
    Private Shared Function NewMethod(xlBook As Microsoft.Office.Interop.Excel.Workbook) As Microsoft.Office.Interop.Excel.Worksheet
        Return CType(xlBook.Worksheets.Add, Microsoft.Office.Interop.Excel.Worksheet)
    End Function
    Private Sub BB(ByVal myExcel As Microsoft.Office.Interop.Excel.Application, ByVal xlSheet As Microsoft.Office.Interop.Excel.Worksheet)
        xlSheet.Cells.Select()
        With myExcel.Selection.Font : .Name = "微軟正黑體" : .Size = 12 : .Strikethrough = False : .Superscript = False : .Subscript = False : .OutlineFont = False : .Shadow = False
            .Underline = xlUnderlineStyleNone : .ThemeColor = xlThemeColorLight1 : .TintAndShade = 0 : .ThemeFont = xlThemeFontNone : End With

        xlSheet.Columns("A:A").Select : myExcel.Selection.ColumnWidth = 12 : xlSheet.Columns("B:B").Select : myExcel.Selection.ColumnWidth = 10
        xlSheet.Columns("C:C").Select : myExcel.Selection.ColumnWidth = 35 : xlSheet.Columns("G:G").Select : myExcel.Selection.ColumnWidth = 30
        xlSheet.Columns("H:H").Select : myExcel.Selection.ColumnWidth = 30 : xlSheet.Columns("I:I").Select : myExcel.Selection.ColumnWidth = 30

        xlSheet.Range("A1:K1").Select()
        With myExcel.Selection : .HorizontalAlignment = xlCenter : .VerticalAlignment = xlCenter : .WrapText = False : .Orientation = 0 : .AddIndent = False : .IndentLevel = 0
            .ShrinkToFit = False : .ReadingOrder = xlContext : .MergeCells = False : End With : myExcel.Selection.Merge

        xlSheet.Range("A2:K2").Select()
        With myExcel.Selection : .HorizontalAlignment = xlCenter : .VerticalAlignment = xlCenter : .WrapText = False : .Orientation = 0 : .AddIndent = False : .IndentLevel = 0
            .ShrinkToFit = False : .ReadingOrder = xlContext : .MergeCells = False : End With : myExcel.Selection.Merge

        xlSheet.Range("A2:K2").Select() : With myExcel.Selection.Font : .Color = -16776961 : .TintAndShade = 0 : End With

        xlSheet.Range("A1:K1").Select()
        With myExcel.Selection.Font : .Name = "微軟正黑體" : .Size = 18 : .Strikethrough = False : .Superscript = False : .Subscript = False : .OutlineFont = False : .Shadow = False
            .Underline = xlUnderlineStyleNone : .ThemeColor = xlThemeColorLight1 : .TintAndShade = 0 : .ThemeFont = xlThemeFontNone : End With

        xlSheet.Range("A1:K3").Select()
        myExcel.Selection.Borders(xlDiagonalDown).LineStyle = xlNone : myExcel.Selection.Borders(xlDiagonalUp).LineStyle = xlNone
        With myExcel.Selection.Borders(xlEdgeLeft) : .LineStyle = xlContinuous : .ColorIndex = 0 : .TintAndShade = 0 : .Weight = xlThin : End With
        With myExcel.Selection.Borders(xlEdgeTop) : .LineStyle = xlContinuous : .ColorIndex = 0 : .TintAndShade = 0 : .Weight = xlThin : End With
        With myExcel.Selection.Borders(xlEdgeBottom) : .LineStyle = xlContinuous : .ColorIndex = 0 : .TintAndShade = 0 : .Weight = xlThin : End With
        With myExcel.Selection.Borders(xlEdgeRight) : .LineStyle = xlContinuous : .ColorIndex = 0 : .TintAndShade = 0 : .Weight = xlThin : End With
        With myExcel.Selection.Borders(xlInsideVertical) : .LineStyle = xlContinuous : .ColorIndex = 0 : .TintAndShade = 0 : .Weight = xlThin : End With
        With myExcel.Selection.Borders(xlInsideHorizontal) : .LineStyle = xlContinuous : .ColorIndex = 0 : .TintAndShade = 0 : .Weight = xlThin : End With

        xlSheet.Range("A4:K" & N).Select()
        myExcel.Selection.Borders(xlDiagonalDown).LineStyle = xlNone : myExcel.Selection.Borders(xlDiagonalUp).LineStyle = xlNone
        With myExcel.Selection.Borders(xlEdgeLeft) : .LineStyle = xlContinuous : .ColorIndex = 0 : .TintAndShade = 0 : .Weight = xlThin : End With
        With myExcel.Selection.Borders(xlEdgeTop) : .LineStyle = xlContinuous : .ColorIndex = 0 : .TintAndShade = 0 : .Weight = xlThin : End With
        With myExcel.Selection.Borders(xlEdgeBottom) : .LineStyle = xlContinuous : .ColorIndex = 0 : .TintAndShade = 0 : .Weight = xlThin : End With
        With myExcel.Selection.Borders(xlEdgeRight) : .LineStyle = xlContinuous : .ColorIndex = 0 : .TintAndShade = 0 : .Weight = xlThin : End With
        With myExcel.Selection.Borders(xlInsideVertical) : .LineStyle = xlContinuous : .ColorIndex = 0 : .TintAndShade = 0 : .Weight = xlThin : End With
        With myExcel.Selection.Borders(xlInsideHorizontal) : .LineStyle = xlContinuous : .ColorIndex = 0 : .TintAndShade = 0 : .Weight = xlThin : End With

        xlSheet.Rows("3:3").Select : myExcel.Selection.RowHeight = 35
        With myExcel.Selection : .HorizontalAlignment = xlGeneral : .VerticalAlignment = xlCenter : .WrapText = True : .Orientation = 0 : .AddIndent = False : .IndentLevel = 0
            .ShrinkToFit = False : .ReadingOrder = xlContext : .MergeCells = False : End With
        With myExcel.Selection : .HorizontalAlignment = xlGeneral : .VerticalAlignment = xlTop : .WrapText = True : .Orientation = 0 : .AddIndent = False : .IndentLevel = 0
            .ShrinkToFit = False : .ReadingOrder = xlContext : .MergeCells = False : End With

        xlSheet.Rows("4:4").Select : myExcel.ActiveWindow.FreezePanes = False : xlSheet.Rows("4:4").Select : myExcel.ActiveWindow.FreezePanes = True
        xlSheet.Rows("3:3").Select : myExcel.Selection.AutoFilter : myExcel.ActiveWindow.DisplayGridlines = False

        xlSheet.Rows("2:2").Select : myExcel.Selection.RowHeight = 30
        xlSheet.Range("A2:K2").Select()
        With myExcel.Selection : .HorizontalAlignment = xlCenter : .VerticalAlignment = xlCenter : .WrapText = True : .Orientation = 0 : .AddIndent = False : .IndentLevel = 0
            .ShrinkToFit = False : .ReadingOrder = xlContext : .MergeCells = True : End With
        xlSheet.Columns("A:K").Select : xlSheet.Range("A3").Activate() : xlSheet.Columns("A:K").EntireColumn.AutoFit
    End Sub
    Private Sub 導入EXCEL_bt_Click(sender As Object, e As EventArgs) Handles 導入EXCEL_bt.Click
        If OpenFileDialog1.ShowDialog = Windows.Forms.DialogResult.OK Then
            file_name = OpenFileDialog1.FileName : xlApp = CreateObject("Excel.Application")
            xlApp.DisplayAlerts = False : xlApp.Visible = True : xlApp.Workbooks.Open(file_name) : xlSheet = xlApp.Worksheets(1)
            xlSheet.Activate() : xlApp.Visible = False : Dim 次數 As Integer = 0
            For YY As Integer = 1 To 5000 : 資料數 = 5000 : MyModule1.進度條()
                If IsNothing(xlSheet.Cells(YY + 3, 3).value) Then : Exit For : End If
                If IsNothing(xlSheet.Cells(YY + 3, 1).value) Then
                    '----------------------自动生成流水号-------------------------------------------------------------------------
                    SQL_物料圖庫流水號最後一筆()
                    If dr.Read() Then : EDR = Double.Parse(Strings.Right(dr("料號").ToString, 8)) : Else : EDR = 0 : End If : conn.Close() : EDR += 1
                    If EDR < 10 Then : ESTR = "PR" & "0000000" & EDR
                    ElseIf EDR > 9 And EDR < 100 Then : ESTR = "PR" & "000000" & EDR
                    ElseIf EDR > 99 And EDR < 1000 Then : ESTR = "PR" & "00000" & EDR
                    ElseIf EDR > 999 And EDR < 10000 Then : ESTR = "PR" & "0000" & EDR
                    ElseIf EDR > 9999 And EDR < 100000 Then : ESTR = "PR" & "000" & EDR
                    ElseIf EDR > 99999 And EDR < 100000 Then : ESTR = "PR" & "00" & EDR
                    ElseIf EDR > 999999 And EDR < 1000000 Then : ESTR = "PR" & "0" & EDR
                    ElseIf EDR > 9999999 Then : ESTR = "PR" & EDR : End If
                    ConnOpen()
                    SQL1 = "INSERT INTO 物料資料庫 (料號, 頁碼, 品名, 成本, 售價, 件數, 尺寸, 材質, 圖片編碼, 備註, 停用, 最低庫存量) 
                            VALUES (N'" & ESTR & "', N'" & xlSheet.Cells(YY + 3, 2).value & "', N'" & xlSheet.Cells(YY + 3, 3).value & "',
                                    N'" & xlSheet.Cells(YY + 3, 4).value & "', N'" & xlSheet.Cells(YY + 3, 5).value & "', N'" & xlSheet.Cells(YY + 3, 6).value & "', 
                                    N'" & xlSheet.Cells(YY + 3, 7).value & "', N'" & xlSheet.Cells(YY + 3, 8).value & "', '', N'" & xlSheet.Cells(YY + 3, 9).value & "', 
                                    '0', N'" & xlSheet.Cells(YY + 3, 10).value & "')"
                    CmdSet_For_dr() : conn.Close()
                    次數 += 1
                Else
                    PA = xlSheet.Cells(YY + 3, 1).value : SQL_物料料號確認()
                    If dr.Read() Then
                        ConnOpen()
                        SQL1 = "UPDATE 物料資料庫 SET 頁碼 = N'" & xlSheet.Cells(YY + 3, 2).value & "', 品名  = N'" & xlSheet.Cells(YY + 3, 3).value & "', 
                                                  成本 = N'" & xlSheet.Cells(YY + 3, 4).value & "', 售價 = N'" & xlSheet.Cells(YY + 3, 5).value & "', 
                                                  件數 = N'" & xlSheet.Cells(YY + 3, 6).value & "', 尺寸 = N'" & xlSheet.Cells(YY + 3, 7).value & "', 
                                                  材質 = N'" & xlSheet.Cells(YY + 3, 8).value & "', 備註 = N'" & xlSheet.Cells(YY + 3, 9).value & "', 
                                                  最低庫存量 = N'" & xlSheet.Cells(YY + 3, 10).value & "', 停用 = N'" & xlSheet.Cells(YY + 3, 11).value & "'
                            WHERE 料號 LIKE N'" & xlSheet.Cells(YY + 3, 1).value & "'"
                        CmdSet_For_dr() : conn.Close()
                    Else
                        '----------------------自动生成流水号-------------------------------------------------------------------------
                        SQL_物料圖庫流水號最後一筆()
                        If dr.Read() Then : EDR = Double.Parse(Strings.Right(dr("料號").ToString, 8)) : Else : EDR = 0 : End If : conn.Close() : EDR += 1
                        If EDR < 10 Then : ESTR = "PR" & "0000000" & EDR
                        ElseIf EDR > 9 And EDR < 100 Then : ESTR = "PR" & "000000" & EDR
                        ElseIf EDR > 99 And EDR < 1000 Then : ESTR = "PR" & "00000" & EDR
                        ElseIf EDR > 999 And EDR < 10000 Then : ESTR = "PR" & "0000" & EDR
                        ElseIf EDR > 9999 And EDR < 100000 Then : ESTR = "PR" & "000" & EDR
                        ElseIf EDR > 99999 And EDR < 100000 Then : ESTR = "PR" & "00" & EDR
                        ElseIf EDR > 999999 And EDR < 1000000 Then : ESTR = "PR" & "0" & EDR
                        ElseIf EDR > 9999999 Then : ESTR = "PR" & EDR : End If
                        ConnOpen()
                        SQL1 = "INSERT INTO 物料資料庫 (料號, 頁碼, 品名, 成本, 售價, 件數, 尺寸, 材質, 圖片編碼, 備註, 停用, 最低庫存量) 
                            VALUES (N'" & ESTR & "', N'" & xlSheet.Cells(YY + 3, 2).value & "', N'" & xlSheet.Cells(YY + 3, 3).value & "',
                                    N'" & xlSheet.Cells(YY + 3, 4).value & "', N'" & xlSheet.Cells(YY + 3, 5).value & "', N'" & xlSheet.Cells(YY + 3, 6).value & "', 
                                    N'" & xlSheet.Cells(YY + 3, 7).value & "', N'" & xlSheet.Cells(YY + 3, 8).value & "', '', N'" & xlSheet.Cells(YY + 3, 9).value & "', 
                                    '0', N'" & xlSheet.Cells(YY + 3, 10).value & "')"
                        CmdSet_For_dr() : conn.Close()
                    End If

                    次數 += 1
                End If
            Next : MAOJI_ERP_SYS.ToolStripProgressBar1.Value = 0 : 最終數 = 0 : MsgBox("已修改  " & 次數 & "  次!") : xlApp.Quit() : xlApp = Nothing
        ElseIf OpenFileDialog1.ShowDialog = Windows.Forms.DialogResult.No Then : End If : Set_物料清單()
    End Sub
End Class