﻿Option Strict Off
Imports Microsoft.Office.Interop.Excel.XlUnderlineStyle
Imports Microsoft.Office.Interop.Excel.Constants
Imports Microsoft.Office.Interop.Excel.XlBordersIndex
Imports Microsoft.Office.Interop.Excel.XlLineStyle
Imports Microsoft.Office.Interop.Excel.XlBorderWeight
Imports Microsoft.Office.Interop.Excel.XlThemeFont
Imports Microsoft.Office.Interop.Excel.XlThemeColor
Imports Microsoft.Office.Interop.Excel.XlWindowState
Imports Microsoft.Office.Interop.Excel
Imports System.Windows.Forms.VisualStyles.VisualStyleElement
Public Class 財務收支單_對帳表
    ReadOnly ds As New DataSet
    Dim N1 As Integer : Dim N2 As Integer
    Dim xlApp As Application : Dim xlBook As Workbook : Dim xlSheet As Worksheet
    Private Sub Set_清單1()
        明細_dgv.DataSource = Nothing : ds.Clear()
        明細_dgv.ColumnHeadersHeightSizeMode = DataGridViewColumnHeadersHeightSizeMode.EnableResizing
        明細_dgv.ColumnHeadersHeight = 40
        明細_dgv.AllowUserToAddRows = False
        SQL_營運成本收支_決算表_清單() : 列印用SQL = SQL1
        da.Fill(ds) : 明細_dgv.DataSource = ds.Tables(0) : conn.Close() : Set_grid()
    End Sub
    Private Sub Set_grid()
        明細_dgv.Columns(0).FillWeight = 120 : 明細_dgv.Columns(1).FillWeight = 60 : 明細_dgv.Columns(2).FillWeight = 80 : 明細_dgv.Columns(3).FillWeight = 60
        明細_dgv.Columns(4).FillWeight = 80 : 明細_dgv.Columns(5).FillWeight = 50 : 明細_dgv.Columns(6).FillWeight = 130 : 明細_dgv.Columns(7).FillWeight = 305
        明細_dgv.Columns(8).FillWeight = 80 : 明細_dgv.Columns(9).FillWeight = 80 : 明細_dgv.Columns(10).FillWeight = 80 : 明細_dgv.Columns(11).FillWeight = 80
        明細_dgv.Columns(12).FillWeight = 80 : 明細_dgv.Columns(13).FillWeight = 50 : 明細_dgv.Columns(14).FillWeight = 85 : 明細_dgv.Columns(15).FillWeight = 50
        明細_dgv.Columns(16).FillWeight = 85 : 明細_dgv.Columns(17).FillWeight = 80 : 明細_dgv.Columns(18).FillWeight = 80 : 明細_dgv.Columns(19).FillWeight = 80
        明細_dgv.Columns(20).FillWeight = 80 : 明細_dgv.Columns(21).Visible = False

        If 隱藏2_ch.Checked = False Then
            明細_dgv.Columns(1).Visible = True : 明細_dgv.Columns(2).Visible = True : 明細_dgv.Columns(3).Visible = True : 明細_dgv.Columns(4).Visible = True
        Else
            明細_dgv.Columns(1).Visible = False : 明細_dgv.Columns(2).Visible = False : 明細_dgv.Columns(3).Visible = False : 明細_dgv.Columns(4).Visible = False
        End If

        If 隱藏1_ch.Checked = False Then
            明細_dgv.Columns(13).Visible = True : 明細_dgv.Columns(14).Visible = True : 明細_dgv.Columns(15).Visible = True : 明細_dgv.Columns(16).Visible = True
        Else
            明細_dgv.Columns(13).Visible = False : 明細_dgv.Columns(14).Visible = False : 明細_dgv.Columns(15).Visible = False : 明細_dgv.Columns(16).Visible = False
        End If

        明細_dgv.Columns(8).DefaultCellStyle.Format = "#,##0" : 明細_dgv.Columns(9).DefaultCellStyle.Format = "#,##0" : 明細_dgv.Columns(10).DefaultCellStyle.Format = "#,##0"
        明細_dgv.Columns(11).DefaultCellStyle.Format = "#,##0"
        明細_dgv.Columns(8).DefaultCellStyle.Alignment = DataGridViewContentAlignment.MiddleRight : 明細_dgv.Columns(8).HeaderCell.Style.Alignment = DataGridViewContentAlignment.MiddleRight
        明細_dgv.Columns(9).DefaultCellStyle.Alignment = DataGridViewContentAlignment.MiddleRight : 明細_dgv.Columns(9).HeaderCell.Style.Alignment = DataGridViewContentAlignment.MiddleRight
        明細_dgv.Columns(10).DefaultCellStyle.Alignment = DataGridViewContentAlignment.MiddleRight : 明細_dgv.Columns(10).HeaderCell.Style.Alignment = DataGridViewContentAlignment.MiddleRight
        明細_dgv.Columns(11).DefaultCellStyle.Alignment = DataGridViewContentAlignment.MiddleRight : 明細_dgv.Columns(11).HeaderCell.Style.Alignment = DataGridViewContentAlignment.MiddleRight

        支出_tb.Text = "0" : 現金_tb.Text = "0" : 已發生損益_tb.Text = "0" : 未給付支票_tb.Text = "0" : 已託收支票_tb.Text = "0" : 未託收支票_tb.Text = "0" : 已給付支票_tb.Text = "0"
        For i As Integer = 0 To 明細_dgv.Rows.Count - 1
            現金_tb.Text = Val(現金_tb.Text) + 明細_dgv.Rows(i).Cells("現金").Value : 支出_tb.Text = Val(支出_tb.Text) + 明細_dgv.Rows(i).Cells("支出").Value

            If 明細_dgv("收票", i).Value <> 0 And 明細_dgv("收票兌現", i).Value = True Then
                已託收支票_tb.Text = Val(已託收支票_tb.Text) + 明細_dgv.Rows(i).Cells("收票").Value
            ElseIf 明細_dgv("收票", i).Value <> 0 And 明細_dgv("收票兌現", i).Value = False Then
                未託收支票_tb.Text = Val(未託收支票_tb.Text) + 明細_dgv.Rows(i).Cells("收票").Value
            End If

            If 明細_dgv("開票", i).Value <> 0 And 明細_dgv("開票已付", i).Value = True Then
                已給付支票_tb.Text = Val(已給付支票_tb.Text) + 明細_dgv.Rows(i).Cells("開票").Value
            ElseIf 明細_dgv("開票", i).Value <> 0 And 明細_dgv("開票已付", i).Value = False Then
                未給付支票_tb.Text = Val(未給付支票_tb.Text) + 明細_dgv.Rows(i).Cells("開票").Value
            End If
        Next i
        已發生損益_tb.Text = Val(已託收支票_tb.Text) + Val(現金_tb.Text) - Val(支出_tb.Text) - Val(已給付支票_tb.Text)
        If Val(已發生損益_tb.Text) > 0 Then : 已發生損益_tb.ForeColor = Color.Blue : Else : 已發生損益_tb.ForeColor = Color.Red : End If
        支出_tb.Text = Strings.Format(Val(支出_tb.Text), "#,##0") : 已發生損益_tb.Text = Strings.Format(Val(已發生損益_tb.Text), "#,##0")
        現金_tb.Text = Strings.Format(Val(現金_tb.Text), "#,##0") : 未給付支票_tb.Text = Strings.Format(Val(未給付支票_tb.Text), "#,##0")
        已託收支票_tb.Text = Strings.Format(Val(已託收支票_tb.Text), "#,##0") : 未託收支票_tb.Text = Strings.Format(Val(未託收支票_tb.Text), "#,##0")
    End Sub
    Private Sub 日期格式()
        If 會計月_ch.Checked = True Then
            '-------------日期一----------------------------------------------------------------------------------------
            DTP = Strings.Left(Strings.Format(開始日期_dtp.Value, "yyyy/MM/dd"), 8) & "01" : 開始日期_dtp.Value = DTP
            開始日期_dtp.Value = 開始日期_dtp.Value.AddMonths(-1)
            DTP = Strings.Left(Strings.Format(開始日期_dtp.Value, "yyyy/MM/dd"), 8) & "26" : 開始日期_dtp.Value = DTP
            '-------------日期二----------------------------------------------------------------------------------------
            DTP = Strings.Left(Strings.Format(結束日期_dtp.Value, "yyyy/MM/dd"), 8) & "25" : 結束日期_dtp.Value = DTP
        Else
            '-------------日期一----------------------------------------------------------------------------------------
            開始日期_dtp.Value = 開始日期_dtp.Value.AddMonths(1)
            DTP = Strings.Left(Strings.Format(開始日期_dtp.Value, "yyyy/MM/dd"), 8) & "01" : 開始日期_dtp.Value = DTP
            '-------------日期二----------------------------------------------------------------------------------------
            DTP = Strings.Left(Strings.Format(結束日期_dtp.Value, "yyyy/MM/dd"), 8) & "01" : 結束日期_dtp.Value = DTP
            結束日期_dtp.Value = 結束日期_dtp.Value.AddMonths(1) : 結束日期_dtp.Value = 結束日期_dtp.Value.AddDays(-1)
        End If
    End Sub
    Private Sub 營運成本收支單_對帳表_Load(sender As Object, e As EventArgs) Handles MyBase.Load
        MAOJI_ERP_SYS.WindowState = 2 : Me.MdiParent = MAOJI_ERP_SYS : Me.WindowState = 2 : Me.AutoScroll = True
        現金_2_tb.Text = "0" : 支出_2_tb.Text = "0" : 已發生損益_2_tb.Text = "0" : 未給付支票_2_tb.Text = "0" : 已託收支票_2_tb.Text = "0" : 未託收支票_2_tb.Text = "0"
        KKKJJ = "" : KKKJJ2 = "" : KKKJJ3 = ""
    End Sub
    Private Sub 介面開啟_Shown(sender As Object, e As EventArgs) Handles MyBase.Shown
        計算分流.Enabled = True
    End Sub
    Private Sub 計算分流_Tick(sender As Object, e As EventArgs) Handles 計算分流.Tick
        SQL_營運成本明細表_會計歸零() : SQL_營運成本明細表_出納歸零() : SQL_營運成本明細表_現金歸零() : SQL_營運成本明細表_備用金歸零()
        SQL_營運成本明細表_公帳歸零() : SQL_營運成本明細表_支票歸零() : SQL_營運成本明細表_作帳日期歸零() : SQL_營運成本明細表_出納日期歸零() : conn.Close()
        閃燈_lb.Visible = False : 中間日期_dtp.Visible = False
        日期格式() : KKKJJ3 = "AND (營運成本控制表.申請日期 BETWEEN '" & Strings.Format(開始日期_dtp.Value, "yyyy/MM/dd") & "' AND '" & Strings.Format(結束日期_dtp.Value, "yyyy/MM/dd") & "') "
        Set_清單1()
        計算分流.Enabled = False
    End Sub
    Private Sub Timer1_Tick(sender As Object, e As EventArgs) Handles Timer1.Tick
        If 閃燈_lb.Visible = True Then : 閃燈_lb.Visible = False : Else : 閃燈_lb.Visible = True : End If
    End Sub
    Private Sub 營運成本收支單_對帳表_Closed(sender As Object, e As EventArgs) Handles MyBase.Closed
        MAOJI_ERP_SYS.WindowState = 0 : MyModule1.虛擬桌面開啟()
    End Sub
    Private Sub 總金額計算()
        Dim FFGG As Integer = 0 : Dim GGHH As Integer = 0 : Dim HHJJ As Integer = 0 : Dim JJKK As Integer = 0 : Dim KKLL As Integer = 0 : Dim ZZXX As Integer = 0
        現金_2_tb.Text = "0" : 支出_2_tb.Text = "0" : 已發生損益_2_tb.Text = "0" : 未給付支票_2_tb.Text = "0" : 已託收支票_2_tb.Text = "0" : 未託收支票_2_tb.Text = "0" : 已給付支票_2_tb.Text = "0"
        For i As Integer = 0 To 明細_dgv.Rows.Count - 1
            If 明細_dgv.Rows(i).Cells("收支單號").Value = 收支單號_tb.Text Then
                FFGG = Val(FFGG) + 明細_dgv.Rows(i).Cells("現金").Value : GGHH = Val(GGHH) + 明細_dgv.Rows(i).Cells("支出").Value

                If 明細_dgv("收票", i).Value <> 0 And 明細_dgv("收票兌現", i).Value = True Then : JJKK = Val(JJKK) + 明細_dgv.Rows(i).Cells("收票").Value
                ElseIf 明細_dgv("收票", i).Value <> 0 And 明細_dgv("收票兌現", i).Value = False Then : KKLL = Val(KKLL) + 明細_dgv.Rows(i).Cells("收票").Value : End If

                If 明細_dgv("開票", i).Value <> 0 And 明細_dgv("開票已付", i).Value = False Then : HHJJ = Val(HHJJ) + 明細_dgv.Rows(i).Cells("開票").Value
                ElseIf 明細_dgv("開票", i).Value <> 0 And 明細_dgv("開票已付", i).Value = True Then : ZZXX = Val(ZZXX) + 明細_dgv.Rows(i).Cells("開票").Value : End If
            End If
        Next i
        現金_2_tb.Text = FFGG : 支出_2_tb.Text = GGHH : 未給付支票_2_tb.Text = HHJJ : 已給付支票_2_tb.Text = ZZXX : 已託收支票_2_tb.Text = JJKK
        未託收支票_2_tb.Text = KKLL : 已發生損益_2_tb.Text = JJKK + FFGG - GGHH - ZZXX
        If Val(已發生損益_2_tb.Text) > 0 Then : 已發生損益_2_tb.ForeColor = Color.Blue : Else : 已發生損益_2_tb.ForeColor = Color.Red : End If
        現金_2_tb.Text = Strings.Format(Val(現金_2_tb.Text), "#,##0") : 支出_2_tb.Text = Strings.Format(Val(支出_2_tb.Text), "#,##0")
        已發生損益_2_tb.Text = Strings.Format(Val(已發生損益_2_tb.Text), "#,##0") : 未給付支票_2_tb.Text = Strings.Format(Val(未給付支票_2_tb.Text), "#,##0")
        已託收支票_2_tb.Text = Strings.Format(Val(已託收支票_2_tb.Text), "#,##0") : 未託收支票_2_tb.Text = Strings.Format(Val(未託收支票_2_tb.Text), "#,##0")
    End Sub
    Private Sub DataGridView1_CellClick(ByVal sender As System.Object, ByVal e As DataGridViewCellEventArgs) Handles 明細_dgv.CellClick
        If e.RowIndex = -1 Then : Else
            收支單號_tb.Text = 明細_dgv.Rows(e.RowIndex).Cells("收支單號").Value : Timer1.Enabled = True : 總金額計算()
        End If
    End Sub
    Private Sub DataGridView1_RowPostPaint(ByVal sender As Object, ByVal e As DataGridViewRowPostPaintEventArgs) Handles 明細_dgv.RowPostPaint
        Dim linePen As New Pen(Color.Blue, 2)
        If e.RowIndex = 明細_dgv.Rows.Count - 1 Then : Exit Sub
        Else
            If 明細_dgv(0, e.RowIndex).Value.ToString <> 明細_dgv(0, e.RowIndex + 1).Value.ToString Then
                Dim startX As Integer = IIf(明細_dgv.RowHeadersVisible, 明細_dgv.RowHeadersWidth, 0)
                Dim startY As Integer = e.RowBounds.Top + e.RowBounds.Height - 1
                Dim endX As Integer = startX + 明細_dgv.Columns.GetColumnsWidth(DataGridViewElementStates.Visible) - 明細_dgv.HorizontalScrollingOffset
                e.Graphics.DrawLine(linePen, startX, startY, endX, startY) : Exit Sub
            End If
        End If
        For i As Integer = 0 To 明細_dgv.Rows.Count - 1
            If 明細_dgv("收票", i).Value <> 0 And 明細_dgv("收票兌現", i).Value = True Then : 明細_dgv.Rows(i).DefaultCellStyle.BackColor = Color.LightPink
            ElseIf 明細_dgv("收票", i).Value <> 0 And 明細_dgv("收票兌現", i).Value = False Then : 明細_dgv.Rows(i).DefaultCellStyle.BackColor = Color.LightGoldenrodYellow : End If
            If 明細_dgv("開票", i).Value <> 0 And 明細_dgv("開票已付", i).Value = True Then : 明細_dgv.Rows(i).DefaultCellStyle.BackColor = Color.LightPink
            ElseIf 明細_dgv("開票", i).Value <> 0 And 明細_dgv("開票已付", i).Value = False Then : 明細_dgv.Rows(i).DefaultCellStyle.BackColor = Color.LightGoldenrodYellow : End If
        Next
    End Sub
    Private Sub CheckBox1_CheckedChanged(sender As Object, e As EventArgs) Handles 只顯示支票資料_ch.Click
        KKKJJ = "" : KKKJJ2 = "" : KKKJJ3 = ""
        If 只顯示支票資料_ch.Checked = False Then : KKKJJ = "" : Set_清單1()
        Else : KKKJJ = " AND (營運成本明細表.支票數 <> 0) " : Set_清單1() : End If
    End Sub
    Private Sub CheckBox4_CheckedChanged(sender As Object, e As EventArgs) Handles 隱藏2_ch.Click
        Set_grid()
    End Sub
    Private Sub CheckBox5_CheckedChanged(sender As Object, e As EventArgs) Handles 隱藏1_ch.Click
        Set_grid()
    End Sub
    Private Sub Button1_Click(sender As Object, e As EventArgs) Handles 上個月_bt.Click
        If 會計月_ch.Checked = True Then
            中間日期_dtp.Value = 中間日期_dtp.Value.AddMonths(-1)
            開始日期_dtp.Value = 中間日期_dtp.Value
            結束日期_dtp.Value = 中間日期_dtp.Value
        Else
            中間日期_dtp.Value = 中間日期_dtp.Value.AddMonths(-1)
            開始日期_dtp.Value = 中間日期_dtp.Value.AddMonths(-1)
            結束日期_dtp.Value = 中間日期_dtp.Value
        End If : 日期格式() : KKKJJ = "" : KKKJJ2 = "" : KKKJJ3 = ""
        KKKJJ3 = "AND (營運成本控制表.申請日期 BETWEEN '" & Strings.Format(開始日期_dtp.Value, "yyyy/MM/dd") & "' AND '" & Strings.Format(結束日期_dtp.Value, "yyyy/MM/dd") & "') " : Set_清單1()
    End Sub
    Private Sub Button2_Click(sender As Object, e As EventArgs) Handles 下個月_bt.Click
        If 會計月_ch.Checked = True Then
            中間日期_dtp.Value = 中間日期_dtp.Value.AddMonths(1)
            開始日期_dtp.Value = 中間日期_dtp.Value
            結束日期_dtp.Value = 中間日期_dtp.Value
        Else
            中間日期_dtp.Value = 中間日期_dtp.Value.AddMonths(1)
            開始日期_dtp.Value = 中間日期_dtp.Value.AddMonths(-1)
            結束日期_dtp.Value = 中間日期_dtp.Value
        End If : 日期格式() : KKKJJ = "" : KKKJJ2 = "" : KKKJJ3 = ""
        KKKJJ3 = "AND (營運成本控制表.申請日期 BETWEEN '" & Strings.Format(開始日期_dtp.Value, "yyyy/MM/dd") & "' AND '" & Strings.Format(結束日期_dtp.Value, "yyyy/MM/dd") & "') " : Set_清單1()
    End Sub
    Private Sub 會計月_CheckedChanged(sender As Object, e As EventArgs) Handles 會計月_ch.Click
        會計月_ch.Checked = True : 一般月_ch.Checked = False : 日期格式() : KKKJJ = "" : KKKJJ2 = "" : KKKJJ3 = ""
        KKKJJ3 = "AND (營運成本控制表.申請日期 BETWEEN '" & Strings.Format(開始日期_dtp.Value, "yyyy/MM/dd") & "' AND '" & Strings.Format(結束日期_dtp.Value, "yyyy/MM/dd") & "') " : Set_清單1()
    End Sub
    Private Sub 一般月_CheckedChanged(sender As Object, e As EventArgs) Handles 一般月_ch.Click
        會計月_ch.Checked = False : 一般月_ch.Checked = True : 日期格式() : KKKJJ = "" : KKKJJ2 = "" : KKKJJ3 = ""
        KKKJJ3 = "AND (營運成本控制表.申請日期 BETWEEN '" & Strings.Format(開始日期_dtp.Value, "yyyy/MM/dd") & "' AND '" & Strings.Format(結束日期_dtp.Value, "yyyy/MM/dd") & "') " : Set_清單1()
    End Sub
    Private Sub Button3_Click(sender As Object, e As EventArgs)
        KKKJJ = "" : KKKJJ2 = "" : KKKJJ3 = ""
        KKKJJ3 = "AND (營運成本控制表.申請日期 BETWEEN '" & Strings.Format(開始日期_dtp.Value, "yyyy/MM/dd") & "' AND '" & Strings.Format(結束日期_dtp.Value, "yyyy/MM/dd") & "') " : Set_清單1()
    End Sub
    Private Sub 開始日期_dtp_ValueChanged(sender As Object, e As EventArgs) Handles 開始日期_dtp.ValueChanged
        KKKJJ = "" : KKKJJ2 = "" : KKKJJ3 = ""
        KKKJJ3 = "AND (營運成本控制表.申請日期 BETWEEN '" & Strings.Format(開始日期_dtp.Value, "yyyy/MM/dd") & "' AND '" & Strings.Format(結束日期_dtp.Value, "yyyy/MM/dd") & "') " : Set_清單1()
    End Sub
    Private Sub 結束日期_dtp_ValueChanged(sender As Object, e As EventArgs) Handles 結束日期_dtp.ValueChanged
        KKKJJ = "" : KKKJJ2 = "" : KKKJJ3 = ""
        KKKJJ3 = "AND (營運成本控制表.申請日期 BETWEEN '" & Strings.Format(開始日期_dtp.Value, "yyyy/MM/dd") & "' AND '" & Strings.Format(結束日期_dtp.Value, "yyyy/MM/dd") & "') " : Set_清單1()
    End Sub
    Private Sub 今天_bt_Click(sender As Object, e As EventArgs) Handles 今天_bt.Click
        開始日期_dtp.Value = Today() : 結束日期_dtp.Value = Today()
    End Sub
    Private Sub Button1_Click_1(sender As Object, e As EventArgs) Handles 列印成EXCEL_bt.Click
        xlApp = CType(CreateObject("Excel.Application"), Application)
        xlBook = xlApp.Workbooks.Add
        xlApp.DisplayAlerts = True
        xlBook.Activate()
        xlSheet = NewMethod(xlBook)
        xlSheet.Activate()
        xlApp.Visible = True
        xlApp.Application.WindowState = xlMaximized

        xlSheet.Cells(1, 1) = "年度" : xlSheet.Cells(1, 2) = Year(Today) - 1911

        xlSheet.Cells(1, 3) = MAOJI_ERP_SYS.公司名稱_cb.Text & "-營運費用收支明細表"
        xlSheet.Cells(2, 1) = "收款日期" : xlSheet.Cells(2, 2) = "會計科目" : xlSheet.Cells(2, 3) = "客戶或用途"
        xlSheet.Cells(2, 4) = "開票" : xlSheet.Cells(2, 5) = "收票" : xlSheet.Cells(2, 6) = "現金" : xlSheet.Cells(2, 7) = "支出" : xlSheet.Cells(2, 8) = "現金餘額" : xlSheet.Cells(2, 9) = "票期"

        For i As Integer = 0 To 明細_dgv.Rows.Count - 1
            xlSheet.Cells(i + 3, 1) = 明細_dgv.Rows(i).Cells("申請日期").Value : xlSheet.Cells(i + 3, 2) = 明細_dgv.Rows(i).Cells("會計科目").Value
            xlSheet.Cells(i + 3, 3) = 明細_dgv.Rows(i).Cells("用途與內容").Value : xlSheet.Cells(i + 3, 4) = 明細_dgv.Rows(i).Cells("開票").Value
            xlSheet.Cells(i + 3, 5) = 明細_dgv.Rows(i).Cells("收票").Value : xlSheet.Cells(i + 3, 6) = 明細_dgv.Rows(i).Cells("現金").Value
            xlSheet.Cells(i + 3, 7) = 明細_dgv.Rows(i).Cells("支出").Value : xlSheet.Cells(i + 3, 9) = 明細_dgv.Rows(i).Cells("到期日").Value
            If i = 0 Then
                xlSheet.Cells(i + 3, 8) = "=D3+F3-G3"
            Else
                xlSheet.Cells(i + 3, 8) = "=H" & i + 2 & "+D" & i + 3 & "+F" & i + 3 & "-G" & i + 3 & ""
            End If
            With xlApp.Selection
                .Font.Bold = True
            End With
            N1 = i + 3 : N2 = i + 3
        Next i
        xlSheet.Cells(N1 + 1, 3) = "以下空白" : xlSheet.Cells(N1 + 3, 1) = "簽核(點交)" : xlSheet.Cells(N1 + 3, 7) = "製表 : " & gUserName & " - " & Today()
        xlSheet.Cells(N1 + 2, 4) = "=SUM(D3:D" & N1 + 1 & ")" : xlSheet.Cells(N1 + 2, 5) = "=SUM(E3:E" & N1 + 1 & ")" : xlSheet.Cells(N1 + 2, 6) = "=SUM(F3:F" & N1 + 1 & ")"
        xlSheet.Cells(N1 + 2, 7) = "=SUM(G3:G" & N1 + 1 & ")" : xlSheet.Cells(N1 + 2, 8) = "=H" & N1 : xlSheet.Cells(N1 + 2, 1) = "合計"

        AA(xlApp, xlSheet)

        xlSheet.PageSetup.PrintArea = ""
        xlApp.Cells.Select()
        xlSheet.Range("B1").Select()
        xlApp.Application.WindowState = xlMinimized
        xlSheet.Cells.Select()
        MsgBox("列印完成。")
    End Sub
    Private Shared Function NewMethod(xlBook As Workbook) As Worksheet
        Return CType(xlBook.Worksheets.Add, Worksheet)
    End Function
    Private Sub AA(ByVal myExcel As Application, ByVal xlSheet As Worksheet)
        xlSheet.Cells.Select()
        With myExcel.Selection.Font : .Name = "微軟正黑體" : .Size = 10 : .Strikethrough = False : .Superscript = False : .Subscript = False : .OutlineFont = False : .Shadow = False
            .Underline = xlUnderlineStyleNone : .ThemeColor = xlThemeColorLight1 : .TintAndShade = 0 : .ThemeFont = xlThemeFontNone
        End With

        xlSheet.Columns("A:A").Select : myExcel.Selection.NumberFormatLocal = "m/d;@"
        With myExcel.Selection : .HorizontalAlignment = xlCenter : .VerticalAlignment = xlCenter : .WrapText = False : .Orientation = 0 : .AddIndent = False : .IndentLevel = 0
            .ShrinkToFit = False : .ReadingOrder = xlContext : .MergeCells = False
        End With

        xlSheet.Range("B1").Select()
        With myExcel.Selection : .HorizontalAlignment = xlLeft : .VerticalAlignment = xlCenter : .WrapText = False : .Orientation = 0 : .AddIndent = False : .IndentLevel = 0
            .ShrinkToFit = False : .ReadingOrder = xlContext : .MergeCells = False
        End With

        xlSheet.Columns("B:B").Select : myExcel.Selection.ColumnWidth = 25
        xlSheet.Columns("C:C").Select : myExcel.Selection.ColumnWidth = 30
        xlSheet.Columns("D:H").Select : myExcel.Selection.ColumnWidth = 10 : myExcel.Selection.NumberFormatLocal = "_-* #,##0_-;-* #,##0_-;_-* ""-""_-;_-@_-"
        xlSheet.Columns("I:I").Select : myExcel.Selection.ColumnWidth = 10 : myExcel.Selection.NumberFormatLocal = "[$-zh-TW]e/m/d;@"
        xlSheet.Rows("2:2").Select : myExcel.Selection.RowHeight = 25

        xlSheet.Range("A2:I2").Select()
        With myExcel.Selection : .HorizontalAlignment = xlGeneral : .VerticalAlignment = xlCenter : .WrapText = False : .Orientation = 0 : .AddIndent = False : .IndentLevel = 0
            .ShrinkToFit = False : .ReadingOrder = xlContext : .MergeCells = False
        End With
        With myExcel.Selection : .HorizontalAlignment = xlCenter : .VerticalAlignment = xlCenter : .WrapText = False : .Orientation = 0 : .AddIndent = False : .IndentLevel = 0
            .ShrinkToFit = False : .ReadingOrder = xlContext : .MergeCells = False
        End With

        xlSheet.Range("A2:I" & N1 + 2).Select() : myExcel.Selection.Borders(xlDiagonalDown).LineStyle = xlNone : myExcel.Selection.Borders(xlDiagonalUp).LineStyle = xlNone
        With myExcel.Selection.Borders(xlEdgeLeft) : .LineStyle = xlContinuous : .ColorIndex = 0 : .TintAndShade = 0 : .Weight = xlThin : End With
        With myExcel.Selection.Borders(xlEdgeTop) : .LineStyle = xlContinuous : .ColorIndex = 0 : .TintAndShade = 0 : .Weight = xlThin : End With
        With myExcel.Selection.Borders(xlEdgeBottom) : .LineStyle = xlContinuous : .ColorIndex = 0 : .TintAndShade = 0 : .Weight = xlThin : End With
        With myExcel.Selection.Borders(xlEdgeRight) : .LineStyle = xlContinuous : .ColorIndex = 0 : .TintAndShade = 0 : .Weight = xlThin : End With
        With myExcel.Selection.Borders(xlInsideVertical) : .LineStyle = xlContinuous : .ColorIndex = 0 : .TintAndShade = 0 : .Weight = xlThin : End With
        With myExcel.Selection.Borders(xlInsideHorizontal) : .LineStyle = xlContinuous : .ColorIndex = 0 : .TintAndShade = 0 : .Weight = xlThin : End With
        myExcel.ActiveWindow.DisplayGridlines = False

        xlSheet.Rows("3:" & N1 + 2).Select : myExcel.Selection.RowHeight = 20
        xlSheet.Rows(N1 + 3 & ":" & N1 + 3).Select : myExcel.Selection.RowHeight = 40

        xlSheet.Columns("I:I").Select
        With myExcel.Selection : .HorizontalAlignment = xlCenter : .VerticalAlignment = xlCenter : .WrapText = False : .Orientation = 0 : .AddIndent = False : .IndentLevel = 0
            .ShrinkToFit = False : .ReadingOrder = xlContext : .MergeCells = False
        End With

        xlSheet.Range("A" & N1 + 2 & ":C" & N1 + 2).Select() : myExcel.Selection.Merge
        With myExcel.Selection : .HorizontalAlignment = xlRight : .VerticalAlignment = xlCenter : .WrapText = False : .Orientation = 0 : .AddIndent = False : .IndentLevel = 0
            .ShrinkToFit = False : .ReadingOrder = xlContext : .MergeCells = True
        End With

        xlSheet.Rows("1:1").Select : myExcel.Selection.RowHeight = 25
        With myExcel.Selection.Font : .Name = "微軟正黑體" : .Size = 14 : .Strikethrough = False : .Superscript = False : .Subscript = False : .OutlineFont = False : .Shadow = False
            .Underline = xlUnderlineStyleNone : .ThemeColor = xlThemeColorLight1 : .TintAndShade = 0 : .ThemeFont = xlThemeFontNone
        End With
    End Sub
    '-----------------------------滑鼠右鍵--------------------------------------------------------------------------------------------------------------------------------------
    Private Sub 對帳記錄存檔ToolStripMenuItem_Click(sender As Object, e As EventArgs)
        Timer1.Enabled = False : 閃燈_lb.Visible = False
        For i As Integer = 0 To 明細_dgv.Rows.Count - 1
            資料數 = 明細_dgv.Rows.Count : MyModule1.進度條()
            布林1 = 明細_dgv.Rows(i).Cells("現金點交").Value : 布林2 = 明細_dgv.Rows(i).Cells("開票已付").Value : 布林3 = 明細_dgv.Rows(i).Cells("支出點交").Value
            布林4 = 明細_dgv.Rows(i).Cells("收票兌現").Value : PA1 = 明細_dgv.Rows(i).Cells("收支單號").Value : PA2 = 明細_dgv.Rows(i).Cells("項次").Value
            SQL_營運成本明細表_對帳記錄存檔() : conn.Close()
        Next : MsgBox("存檔完成。") : Set_清單1() : MAOJI_ERP_SYS.ToolStripProgressBar1.Value = 0 : 最終數 = 0
    End Sub
    Private Sub 關鍵字查詢ToolStripMenuItem_Click(sender As Object, e As EventArgs)
        PA = InputBox("請輸入要查詢的關鍵字。") : KKKJJ = "" : KKKJJ2 = "" : KKKJJ3 = ""
        KKKJJ2 = " AND (營運成本控制表.支付單號 LIKE N'%" & PA & "%' OR 營運成本控制表.申請人 LIKE N'%" & PA & "%' OR 營運成本控制表.審核人 LIKE N'%" & PA &
                 "%' OR 營運成本明細表.用途 LIKE N'%" & PA & "%' OR 營運成本控制表.備註 LIKE N'%" & PA & "%' OR 營運成本明細表.備註 LIKE N'%" & PA & "%')" : Set_清單1()
        KKKJJ2 = "" : PA = ""
    End Sub
    Private Sub BBBToolStripMenuItem_Click(sender As Object, e As EventArgs)
        列印成EXCEL_bt.PerformClick()
    End Sub
    Private Sub 關鍵字搜尋_bt_MouseEnter(sender As Object, e As EventArgs) Handles 關鍵字搜尋_bt.MouseEnter
        ToolTip1.SetToolTip(Me.關鍵字搜尋_bt, "關鍵字搜尋")
    End Sub
    Private Sub 對帳記錄存檔_bt_MouseEnter(sender As Object, e As EventArgs) Handles 對帳記錄存檔_bt.MouseEnter
        ToolTip1.SetToolTip(Me.對帳記錄存檔_bt, "對帳記錄存檔")
    End Sub
    Private Sub 列印成EXCEL_bt_MouseEnter(sender As Object, e As EventArgs) Handles 列印成EXCEL_bt.MouseEnter
        ToolTip1.SetToolTip(Me.列印成EXCEL_bt, "列印成EXCEL")
    End Sub

End Class