﻿Option Strict Off
Imports System.IO
Public Class 財務收支單審核
    ReadOnly ds As New DataSet : ReadOnly ds1 As New DataSet : ReadOnly ds2 As New DataSet
    Private ReadOnly QQW(11) As String
    Private II As Integer
    Private Sub Set_清單1()
        彙總_dgv.DataSource = Nothing : ds1.Clear()
        彙總_dgv.ColumnHeadersHeightSizeMode = DataGridViewColumnHeadersHeightSizeMode.EnableResizing
        彙總_dgv.ColumnHeadersHeight = 25
        彙總_dgv.AllowUserToAddRows = False
        SQL_營運成本收支單審核清單()
        da.Fill(ds1) : 彙總_dgv.DataSource = ds1.Tables(0) : conn.Close()

        彙總_dgv.Columns(0).FillWeight = 160 : 彙總_dgv.Columns(1).FillWeight = 100 : 彙總_dgv.Columns(2).FillWeight = 100 : 彙總_dgv.Columns(3).Visible = False
    End Sub
    Private Sub Set_費用清單()
        明細_dgv.DataSource = Nothing : ds.Clear()
        明細_dgv.ColumnHeadersHeightSizeMode = DataGridViewColumnHeadersHeightSizeMode.EnableResizing
        明細_dgv.ColumnHeadersHeight = 40
        明細_dgv.AllowUserToAddRows = False
        明細_dgv.RowTemplate.Height = 35
        SQL_營運成本收支單審核費用清單()
        da.Fill(ds) : 明細_dgv.DataSource = ds.Tables(0) : conn.Close()

        明細_dgv.Columns(0).Visible = False : 明細_dgv.Columns(1).FillWeight = 80 : 明細_dgv.Columns(2).FillWeight = 200 : 明細_dgv.Columns(3).FillWeight = 500
        明細_dgv.Columns(4).FillWeight = 110 : 明細_dgv.Columns(5).FillWeight = 110 : 明細_dgv.Columns(6).FillWeight = 110 : 明細_dgv.Columns(7).FillWeight = 110
        明細_dgv.Columns(8).FillWeight = 200 : 明細_dgv.Columns(9).FillWeight = 80 : 明細_dgv.Columns(10).Visible = False : 明細_dgv.Columns(11).FillWeight = 190
        明細_dgv.Columns(12).FillWeight = 190 : 明細_dgv.Columns(13).Visible = False : 明細_dgv.Columns(14).Visible = False

        明細_dgv.Columns(1).ReadOnly = True : 明細_dgv.Columns(2).ReadOnly = True : 明細_dgv.Columns(3).ReadOnly = True : 明細_dgv.Columns(4).ReadOnly = True
        明細_dgv.Columns(5).ReadOnly = True : 明細_dgv.Columns(6).ReadOnly = True

        明細_dgv.Columns(4).DefaultCellStyle.Format = "#,##0" : 明細_dgv.Columns(5).DefaultCellStyle.Format = "#,##0" : 明細_dgv.Columns(6).DefaultCellStyle.Format = "#,##0"
        明細_dgv.Columns(7).DefaultCellStyle.Format = "#,##0"
        明細_dgv.Columns(1).DefaultCellStyle.Alignment = DataGridViewContentAlignment.MiddleCenter : 明細_dgv.Columns(1).HeaderCell.Style.Alignment = DataGridViewContentAlignment.MiddleCenter
        明細_dgv.Columns(2).DefaultCellStyle.Alignment = DataGridViewContentAlignment.MiddleCenter : 明細_dgv.Columns(2).HeaderCell.Style.Alignment = DataGridViewContentAlignment.MiddleCenter
        明細_dgv.Columns(4).DefaultCellStyle.Alignment = DataGridViewContentAlignment.MiddleRight : 明細_dgv.Columns(4).HeaderCell.Style.Alignment = DataGridViewContentAlignment.MiddleRight
        明細_dgv.Columns(5).DefaultCellStyle.Alignment = DataGridViewContentAlignment.MiddleRight : 明細_dgv.Columns(5).HeaderCell.Style.Alignment = DataGridViewContentAlignment.MiddleRight
        明細_dgv.Columns(6).DefaultCellStyle.Alignment = DataGridViewContentAlignment.MiddleRight : 明細_dgv.Columns(6).HeaderCell.Style.Alignment = DataGridViewContentAlignment.MiddleRight
        明細_dgv.Columns(7).DefaultCellStyle.Alignment = DataGridViewContentAlignment.MiddleRight : 明細_dgv.Columns(7).HeaderCell.Style.Alignment = DataGridViewContentAlignment.MiddleRight
        明細_dgv.Columns(9).DefaultCellStyle.Alignment = DataGridViewContentAlignment.MiddleCenter : 明細_dgv.Columns(9).HeaderCell.Style.Alignment = DataGridViewContentAlignment.MiddleCenter
        明細_dgv.Columns(10).DefaultCellStyle.Alignment = DataGridViewContentAlignment.MiddleCenter : 明細_dgv.Columns(10).HeaderCell.Style.Alignment = DataGridViewContentAlignment.MiddleCenter
        明細_dgv.Columns(11).DefaultCellStyle.Alignment = DataGridViewContentAlignment.MiddleCenter : 明細_dgv.Columns(11).HeaderCell.Style.Alignment = DataGridViewContentAlignment.MiddleCenter
        明細_dgv.Columns(12).DefaultCellStyle.Alignment = DataGridViewContentAlignment.MiddleCenter : 明細_dgv.Columns(12).HeaderCell.Style.Alignment = DataGridViewContentAlignment.MiddleCenter
        明細_dgv.Columns(13).DefaultCellStyle.Alignment = DataGridViewContentAlignment.MiddleCenter : 明細_dgv.Columns(13).HeaderCell.Style.Alignment = DataGridViewContentAlignment.MiddleCenter
        明細_dgv.Columns(14).DefaultCellStyle.Alignment = DataGridViewContentAlignment.MiddleCenter : 明細_dgv.Columns(14).HeaderCell.Style.Alignment = DataGridViewContentAlignment.MiddleCenter

        明細_dgv.EditMode = DataGridViewEditMode.EditOnEnter

        收現_tb.Text = "0" : 付現_tb.Text = "0" : 合計_tb.Text = "0" : 開票_tb.Text = "0" : 收票_tb.Text = "0"
        For i As Integer = 0 To 明細_dgv.Rows.Count - 1
            收現_tb.Text = Val(收現_tb.Text) + 明細_dgv.Rows(i).Cells("現金").Value : 付現_tb.Text = Val(付現_tb.Text) + 明細_dgv.Rows(i).Cells("支出").Value
            開票_tb.Text = Val(開票_tb.Text) + 明細_dgv.Rows(i).Cells("開票").Value : 收票_tb.Text = Val(收票_tb.Text) + 明細_dgv.Rows(i).Cells("收票").Value
        Next i
        合計_tb.Text = Val(開票_tb.Text) + Val(收現_tb.Text) - Val(付現_tb.Text)
        If Val(合計_tb.Text) > 0 Then : 合計_tb.ForeColor = Color.Blue : Else : 合計_tb.ForeColor = Color.Red : End If
        收現_tb.Text = Format(Val(收現_tb.Text), "#,##0") : 付現_tb.Text = Format(Val(付現_tb.Text), "#,##0") : 合計_tb.Text = Format(Val(合計_tb.Text), "#,##0")
        開票_tb.Text = Format(Val(開票_tb.Text), "#,##0") : 收票_tb.Text = Format(Val(收票_tb.Text), "#,##0")
    End Sub
    Private Sub Set_清單()
        簽名清單_dgv.DataSource = Nothing : ds2.Clear()
        簽名清單_dgv.ColumnHeadersHeightSizeMode = DataGridViewColumnHeadersHeightSizeMode.EnableResizing
        簽名清單_dgv.ColumnHeadersHeight = 25
        簽名清單_dgv.AllowUserToAddRows = False
        SQL_營運成本收支單審核_圖檔編碼()
        da.Fill(ds2) : 簽名清單_dgv.DataSource = ds2.Tables(0) : conn.Close()

        簽名清單_dgv.Columns(0).FillWeight = 173 : 簽名清單_dgv.Columns(1).Visible = False
        If 簽名清單_dgv.Rows.Count = 0 Then : Else
            圖片編碼_tb.Text = 簽名清單_dgv(0, 0).Value.ToString : PA = 圖片編碼_tb.Text
            SQL_使用者權限圖片顯示()
            While dr.Read() = True
                Dim unused As Byte() = New Byte(-1) {}
                Dim bytes As Byte() = DirectCast(dr.Item("簽名檔圖片"), Byte())
                Dim oStream As New MemoryStream(bytes)
                簽名圖_pb.Image = Bitmap.FromStream(oStream)
            End While
            conn.Close() : 簽名圖_pb.SizeMode = 4
            For QAZ = 0 To 999
                QQW(0) = Strings.Right(簽名清單_dgv(0, 0).Value.ToString, 2) : QQW(1) = Strings.Right(Year(Today), 2) : QQW(2) = Strings.Left(Year(Today), 2) : QQW(3) = Month(Today) + 9
                QQW(4) = Strings.Right(QQW(0), 1) : QQW(5) = Strings.Left(QQW(0), 1) : QQW(6) = Strings.Right(QQW(1), 1) : QQW(7) = Strings.Left(QQW(1), 1) : QQW(8) = Strings.Right(QQW(2), 1)
                QQW(9) = Strings.Left(QQW(2), 1) : QQW(10) = Strings.Right(QQW(3), 1) : QQW(11) = Strings.Left(QQW(3), 1)
                For RT = 4 To 11
                    Delay(3)
                    Dim ran = New Random(DateTime.Now.Millisecond) : Dim NUM1 As Integer = ran.Next(1, 4096)
                    For I = 0 To 4096 : If NUM1 > 9 Then : NUM1 -= 9 : ElseIf NUM1 < 9 Then : I = 4096 : End If : Next
                    If NUM1 = 1 Then : II = RT : 轉換() : ElseIf NUM1 = 2 Then : II = RT : 轉換() : ElseIf NUM1 = 3 Then : ElseIf NUM1 = 4 Then : II = RT : 轉換() : ElseIf NUM1 = 5 Then
                    ElseIf NUM1 = 6 Then : II = RT : 轉換() : ElseIf NUM1 = 7 Then : ElseIf NUM1 = 8 Then : II = RT : 轉換() : ElseIf NUM1 = 9 Then : II = RT : 轉換() : End If
                Next

                Dim ran1 = New Random(DateTime.Now.Millisecond) : Dim NUM2 As Integer = ran1.Next(1, 4096)
                For I = 0 To 4096 : If NUM2 > 99 Then : NUM2 -= 49 : ElseIf NUM2 < 99 Then : I = 4096 : End If : Next

                驗證碼_tb.Text = QQW(11) & "2" & QQW(9) & "7" & QQW(7) & "0" & QQW(5) & QQW(4) & "1" & QQW(6) & "3" & QQW(8) & "9" & QQW(10) & NUM2

                SQL_營運成本收支單審核_簽名編碼() : If dr.Read() = True Then : Else : QAZ = 999 : End If : conn.Close()
            Next
        End If
    End Sub
    Private Sub 轉換()
        If QQW(II) = "1" Then : QQW(II) = "A" : ElseIf QQW(II) = "2" Then : QQW(II) = "B" : ElseIf QQW(II) = "3" Then : QQW(II) = "C" : ElseIf QQW(II) = "4" Then : QQW(II) = "D"
        ElseIf QQW(II) = "5" Then : QQW(II) = "E" : ElseIf QQW(II) = "6" Then : QQW(II) = "F" : ElseIf QQW(II) = "7" Then : QQW(II) = "G" : ElseIf QQW(II) = "8" Then : QQW(II) = "H"
        ElseIf QQW(II) = "9" Then : QQW(II) = "I" : ElseIf QQW(II) = "0" Then : QQW(II) = "J" : End If
    End Sub
    Public Sub Delay(ByRef Interval As Double)  'Interval单位为毫秒
        Dim time As DateTime = DateTime.Now : Dim Span As Double = Interval * 1234 : While ((DateTime.Now.Ticks - time.Ticks) < Span) : Application.DoEvents() : End While
    End Sub
    Private Sub 營運費用支付審核_Load(sender As Object, e As EventArgs) Handles MyBase.Load
        Me.MdiParent = MAOJI_ERP_SYS : Me.WindowState = 2 : Me.AutoScroll = True
        未核准的營運成本收支單_rb.Checked = True : 彙總_dgv.Visible = True
    End Sub
    Private Sub 介面開啟_Shown(sender As Object, e As EventArgs) Handles MyBase.Shown
        計算分流.Enabled = True
    End Sub
    Private Sub 計算分流_Tick(sender As Object, e As EventArgs) Handles 計算分流.Tick
        Set_清單1() : Set_清單()
        計算分流.Enabled = False
    End Sub
    Private Sub 介面關閉_Closed(sender As Object, e As EventArgs) Handles MyBase.Closed
        MyModule1.虛擬桌面開啟()
    End Sub
    Private Sub DataGridView2_CellClick(ByVal sender As System.Object, ByVal e As System.Windows.Forms.DataGridViewCellEventArgs) Handles 彙總_dgv.CellClick
        If e.RowIndex = -1 Then : Else
            收支單號_tb.Text = 彙總_dgv(0, e.RowIndex).Value.ToString : 審核日期_dtp.Value = 彙總_dgv(1, e.RowIndex).Value.ToString : Set_費用清單()
            申請人_tb.Text = 彙總_dgv(3, e.RowIndex).Value.ToString
        End If
    End Sub
    Private Sub DataGridView3_CellClick(ByVal sender As System.Object, ByVal e As DataGridViewCellEventArgs) Handles 簽名清單_dgv.CellClick
        If e.RowIndex = -1 Then : Else
            圖片編碼_tb.Text = 簽名清單_dgv(0, e.RowIndex).Value.ToString : PA = 圖片編碼_tb.Text
            SQL_使用者權限圖片顯示()
            While dr.Read() = True
                Dim unused As Byte() = New Byte(-1) {}
                Dim bytes As Byte() = DirectCast(dr.Item("簽名檔圖片"), Byte())
                Dim oStream As New MemoryStream(bytes)
                簽名圖_pb.Image = Bitmap.FromStream(oStream)
            End While
            conn.Close()
            簽名圖_pb.SizeMode = 4
            For QAZ = 0 To 999
                QQW(0) = Strings.Right(簽名清單_dgv(0, e.RowIndex).Value.ToString, 2) : QQW(1) = Strings.Right(Year(Today), 2) : QQW(2) = Strings.Left(Year(Today), 2) : QQW(3) = Month(Today) + 9
                QQW(4) = Strings.Right(QQW(0), 1) : QQW(5) = Strings.Left(QQW(0), 1) : QQW(6) = Strings.Right(QQW(1), 1) : QQW(7) = Strings.Left(QQW(1), 1) : QQW(8) = Strings.Right(QQW(2), 1)
                QQW(9) = Strings.Left(QQW(2), 1) : QQW(10) = Strings.Right(QQW(3), 1) : QQW(11) = Strings.Left(QQW(3), 1)
                For RT = 4 To 11
                    Delay(3)
                    Dim ran = New Random(DateTime.Now.Millisecond) : Dim NUM1 As Integer = ran.Next(1, 4096)
                    For I = 0 To 4096 : If NUM1 > 9 Then : NUM1 -= 9 : ElseIf NUM1 < 9 Then : I = 4096 : End If : Next
                    If NUM1 = 1 Then : II = RT : 轉換() : ElseIf NUM1 = 2 Then : II = RT : 轉換() : ElseIf NUM1 = 3 Then : ElseIf NUM1 = 4 Then : II = RT : 轉換() : ElseIf NUM1 = 5 Then
                    ElseIf NUM1 = 6 Then : II = RT : 轉換() : ElseIf NUM1 = 7 Then : ElseIf NUM1 = 8 Then : II = RT : 轉換() : ElseIf NUM1 = 9 Then : II = RT : 轉換() : End If
                Next

                Dim ran1 = New Random(DateTime.Now.Millisecond) : Dim NUM2 As Integer = ran1.Next(1, 4096)
                For I = 0 To 4096 : If NUM2 > 99 Then : NUM2 -= 49 : ElseIf NUM2 < 99 Then : I = 4096 : End If : Next

                驗證碼_tb.Text = QQW(11) & "2" & QQW(9) & "7" & QQW(7) & "0" & QQW(5) & QQW(4) & "1" & QQW(6) & "3" & QQW(8) & "9" & QQW(10) & NUM2

                SQL_營運成本收支單審核_簽名編碼() : If dr.Read() = True Then : Else : QAZ = 999 : End If : conn.Close()
            Next
        End If
    End Sub
    Private Sub Set_切換格式()
        明細_dgv.DataSource = Nothing : ds.Clear() : 收支單號_tb.Text = "" : 申請人_tb.Text = "" : 收現_tb.Text = "" : 付現_tb.Text = "" : 合計_tb.Text = ""
        開票_tb.Text = "" : 收票_tb.Text = "" : Set_清單1()
    End Sub
    Private Sub RadioButton1_CheckedChanged(sender As Object, e As EventArgs) Handles 未核准的營運成本收支單_rb.Click
        未核准的營運成本收支單_rb.Checked = True : 作廢的營運成本收支單_rb.Checked = False
        明細_dgv.DataSource = Nothing : ds.Clear() : 收支單號_tb.Text = "" : 申請人_tb.Text = "" : 收現_tb.Text = "" : 付現_tb.Text = "" : 合計_tb.Text = ""
        審核通過_bt.Enabled = True : 單據作廢_bt.Enabled = True : Set_切換格式()
    End Sub
    Private Sub RadioButton2_CheckedChanged(sender As Object, e As EventArgs) Handles 作廢的營運成本收支單_rb.Click
        未核准的營運成本收支單_rb.Checked = False : 作廢的營運成本收支單_rb.Checked = True
        明細_dgv.DataSource = Nothing : ds.Clear() : 收支單號_tb.Text = "" : 申請人_tb.Text = "" : 收現_tb.Text = "" : 付現_tb.Text = "" : 合計_tb.Text = ""
        審核通過_bt.Enabled = False : 單據作廢_bt.Enabled = False : Set_切換格式()
    End Sub
    Private Sub Set_日期格式轉換()
        DTP = Format(Today(), "yyyy/MM/dd")
    End Sub
    Private Sub Button1_Click(sender As Object, e As EventArgs) Handles 審核通過_bt.Click
        If 收支單號_tb.Text = "" Then : MsgBox("請選擇需要審核的單據。")
        Else
            If 非當天日期_ch.Checked = False Then : Set_日期格式轉換() : Else : DTP = Format(審核日期_dtp.Value, "yyyy/MM/dd") : End If
            SQL_營運成本收支單審核_控制表修改() : conn.Close()
            SQL_營運成本收支單審核_明細表修改() : conn.Close()
            For i As Integer = 0 To 明細_dgv.Rows.Count - 1
                PA1 = 收支單號_tb.Text : PA2 = 明細_dgv.Rows(i).Cells("項次").Value
                If 明細_dgv.Rows(i).Cells("開票").Value <> 0 Then
                ElseIf 明細_dgv.Rows(i).Cells("現金").Value <> 0 Then : SQL_營運成本收支單審核_明細表_現金確認() : conn.Close()
                ElseIf 明細_dgv.Rows(i).Cells("支出").Value <> 0 Then : SQL_營運成本收支單審核_明細表_公帳確認() : conn.Close() : End If
            Next
            MsgBox("審核完畢。") : 收支單號_tb.Text = "" : 申請人_tb.Text = "" : 明細_dgv.DataSource = Nothing : ds.Clear() : Set_清單1() : Set_清單()
        End If
    End Sub
    Private Sub Button2_Click(sender As Object, e As EventArgs) Handles 單據作廢_bt.Click
        If 收支單號_tb.Text = "" Then : MsgBox("請選擇需要審核的單據。")
        Else
            PA = InputBox("請輸入作廢原因。")
            If PA = "" Then : MsgBox("請輸入作廢原因，不可空白。")
            Else
                If 非當天日期_ch.Checked = False Then : Set_日期格式轉換() : Else : DTP = Format(審核日期_dtp.Value, "yyyy/MM/dd") : End If
                SQL_營運成本收支單審核_控制表作廢() : conn.Close()
                MsgBox("審核完畢。") : PA = "" : 收支單號_tb.Text = "" : 申請人_tb.Text = "" : 明細_dgv.DataSource = Nothing : ds.Clear() : Set_清單1()
            End If
        End If
    End Sub
    '----------------------滑鼠右鍵--------------------------------------------------------------------------------------------------------------------------------------------------------------------
    Private Sub 重新讀取ToolStripMenuItem_Click(sender As Object, e As EventArgs)
        Set_清單1()
    End Sub
    Private Sub 列印產品標籤_bt_MouseEnter(sender As Object, e As EventArgs) Handles 審核通過_bt.MouseEnter
        ToolTip1.SetToolTip(Me.審核通過_bt, "審核通過")
    End Sub
    Private Sub 列印採購單_bt_MouseEnter(sender As Object, e As EventArgs) Handles 單據作廢_bt.MouseEnter
        ToolTip1.SetToolTip(Me.單據作廢_bt, "單據作廢")
    End Sub
End Class