﻿Option Explicit On
Imports System.Net
Imports System.IO
Public Class 簽名檔管理
    Public Property Credentials As ICredentials
    ReadOnly ds As New DataSet : ReadOnly ds1 As New DataSet
    Dim EDR As Integer = 0 : Dim ESTR As String
    Private Sub Set_清單()
        檔案清單_dgv.DataSource = Nothing : ds.Clear()
        檔案清單_dgv.ColumnHeadersHeightSizeMode = DataGridViewColumnHeadersHeightSizeMode.EnableResizing
        檔案清單_dgv.ColumnHeadersHeight = 25 : 檔案清單_dgv.AllowUserToAddRows = False
        SQL_簽名檔管理清單()
        da.Fill(ds) : 檔案清單_dgv.DataSource = ds.Tables(0) : conn.Close()
        檔案清單_dgv.Columns(0).FillWeight = 221 : 檔案清單_dgv.Columns(1).FillWeight = 220
    End Sub
    Private Sub ComboBox1下拉表單資料載入()
        SQL_使用者權限姓名清單() : 簽名檔持有人_cb.Items.Clear() : While (dr.Read()) : 簽名檔持有人_cb.Items.Add(dr("姓名")) : End While : conn.Close()
    End Sub
    Private Sub 簽名檔管理_Load(sender As Object, e As EventArgs) Handles MyBase.Load
        Set_清單() : 檔名讀取_tb.Visible = False
        ComboBox1下拉表單資料載入()
        If FolderBrowserDialog1.ShowDialog = DialogResult.OK Then : 本機資料夾_wb.Navigate(FolderBrowserDialog1.SelectedPath) : End If
    End Sub
    Private Sub 介面關閉_Closed(sender As Object, e As EventArgs) Handles MyBase.Closed
        MyModule1.虛擬桌面開啟()
    End Sub
    Private Sub DataGridView1_CellClick(ByVal sender As System.Object, ByVal e As DataGridViewCellEventArgs) Handles 檔案清單_dgv.CellClick
        If e.RowIndex = -1 Then : Else
            圖檔編號_tb.Text = 檔案清單_dgv(0, e.RowIndex).Value.ToString : 簽名檔持有人_cb.Text = 檔案清單_dgv(1, e.RowIndex).Value.ToString : PA = 圖檔編號_tb.Text
            SQL_使用者權限圖片顯示()
            While dr.Read() = True
                Dim unused As Byte() = New Byte(-1) {}
                Dim bytes As Byte() = DirectCast(dr.Item("簽名檔圖片"), Byte())
                Dim oStream As New MemoryStream(bytes)
                簽名圖_pb.Image = Bitmap.FromStream(oStream)
            End While : conn.Close() : 簽名圖_pb.SizeMode = 4
        End If
    End Sub
    Private Sub Button2_Click(sender As Object, e As EventArgs) Handles 簽名檔入系統_bt.Click
        If 圖檔編號_tb.Text = "" Then : MsgBox("請先將要入庫的編號準備好") : Else
            If 檔案名稱_tb.Text = "" Then : MsgBox("請先確定圖片資料已準備完畢") : Else PA49 = 檔案名稱_tb.Text : SQL_主管簽名檔新增() : conn.Close()
                '----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
                檔案名稱_tb.Text = "" : PA = 圖檔編號_tb.Text : SQL_使用者權限圖片顯示()
                While dr.Read() = True
                    Dim unused As Byte() = New Byte(-1) {}
                    Dim bytes As Byte() = DirectCast(dr.Item("簽名檔圖片"), Byte())
                    Dim oStream As New MemoryStream(bytes)
                    簽名圖_pb.Image = Bitmap.FromStream(oStream)
                End While : conn.Close() : 簽名圖_pb.SizeMode = 4 : Set_清單() : 圖檔編號_tb.Text = ""
            End If
        End If
    End Sub
    Private Sub Button1_Click(sender As Object, e As EventArgs) Handles 生成編號_bt.Click
        SQL_主管簽名檔流水號最後一筆()
        If dr.Read() Then : EDR = Double.Parse(Strings.Right(dr("圖片流水號").ToString, 8)) : Else : EDR = 0 : End If
        conn.Close()
        EDR += 1
        If EDR < 10 Then : ESTR = "PG" & "0000000" & EDR
        ElseIf EDR > 9 And EDR < 100 Then : ESTR = "PG" & "000000" & EDR
        ElseIf EDR > 99 And EDR < 1000 Then : ESTR = "PG" & "00000" & EDR
        ElseIf EDR > 999 And EDR < 10000 Then : ESTR = "PG" & "0000" & EDR
        ElseIf EDR > 9999 And EDR < 100000 Then : ESTR = "PG" & "000" & EDR
        ElseIf EDR > 99999 And EDR < 100000 Then : ESTR = "PG" & "00" & EDR
        ElseIf EDR > 999999 And EDR < 1000000 Then : ESTR = "PG" & "0" & EDR
        ElseIf EDR > 9999999 Then : ESTR = "PG" & EDR
        End If
        圖檔編號_tb.Text = ESTR
    End Sub
    Private Sub TextBox4_DragEnter(sender As Object, e As DragEventArgs) Handles 檔案名稱_tb.DragEnter
        If e.Data.GetDataPresent(DataFormats.FileDrop) Then : Dim files As String()
            Try : files = CType(e.Data.GetData(DataFormats.FileDrop), String()) : 檔案名稱_tb.Text = files(files.Length - 1)
            Catch ex As Exception : MessageBox.Show(ex.Message) : Return : End Try
        End If
    End Sub
    Private Sub Button3_Click(sender As Object, e As EventArgs) Handles 刪除檔案_bt.Click
        Dim aa As MsgBoxResult = MsgBox("確定要刪除該筆資料?", MsgBoxStyle.OkCancel)
        If aa = MsgBoxResult.Ok Then : SQL_主管簽名檔刪除() : conn.Close() : Set_清單() : 圖檔編號_tb.Text = "" : End If
    End Sub
    Private Sub Button14_Click(sender As Object, e As EventArgs) Handles 讀取資料夾路徑_bt.Click
        If FolderBrowserDialog1.ShowDialog = DialogResult.OK Then : 本機資料夾_wb.Navigate(FolderBrowserDialog1.SelectedPath) : End If
    End Sub
End Class